#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1912
#define LARGE_STATE_COUNT 38
#define SYMBOL_COUNT 278
#define ALIAS_COUNT 8
#define TOKEN_COUNT 120
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 36
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 119

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_LF = 2,
  anon_sym_SEMI = 3,
  anon_sym_NULL = 4,
  anon_sym_package = 5,
  anon_sym_import = 6,
  anon_sym_DOT = 7,
  sym_blank_identifier = 8,
  anon_sym_LPAREN = 9,
  anon_sym_RPAREN = 10,
  anon_sym_const = 11,
  anon_sym_COMMA = 12,
  anon_sym_EQ = 13,
  anon_sym_var = 14,
  anon_sym_func = 15,
  anon_sym_LBRACK = 16,
  anon_sym_RBRACK = 17,
  anon_sym_DOT_DOT_DOT = 18,
  anon_sym_type = 19,
  anon_sym_STAR = 20,
  anon_sym_struct = 21,
  anon_sym_PIPE = 22,
  anon_sym_TILDE = 23,
  anon_sym_LBRACE = 24,
  anon_sym_RBRACE = 25,
  anon_sym_interface = 26,
  anon_sym_map = 27,
  anon_sym_chan = 28,
  anon_sym_LT_DASH = 29,
  anon_sym_COLON_EQ = 30,
  anon_sym_PLUS_PLUS = 31,
  anon_sym_DASH_DASH = 32,
  anon_sym_STAR_EQ = 33,
  anon_sym_SLASH_EQ = 34,
  anon_sym_PERCENT_EQ = 35,
  anon_sym_LT_LT_EQ = 36,
  anon_sym_GT_GT_EQ = 37,
  anon_sym_AMP_EQ = 38,
  anon_sym_AMP_CARET_EQ = 39,
  anon_sym_PLUS_EQ = 40,
  anon_sym_DASH_EQ = 41,
  anon_sym_PIPE_EQ = 42,
  anon_sym_CARET_EQ = 43,
  anon_sym_COLON = 44,
  anon_sym_fallthrough = 45,
  anon_sym_break = 46,
  anon_sym_continue = 47,
  anon_sym_goto = 48,
  anon_sym_return = 49,
  anon_sym_go = 50,
  anon_sym_defer = 51,
  anon_sym_if = 52,
  anon_sym_else = 53,
  anon_sym_for = 54,
  anon_sym_range = 55,
  anon_sym_switch = 56,
  anon_sym_case = 57,
  anon_sym_default = 58,
  anon_sym_select = 59,
  anon_sym_new = 60,
  anon_sym_make = 61,
  anon_sym_PLUS = 62,
  anon_sym_DASH = 63,
  anon_sym_BANG = 64,
  anon_sym_CARET = 65,
  anon_sym_AMP = 66,
  anon_sym_SLASH = 67,
  anon_sym_PERCENT = 68,
  anon_sym_LT_LT = 69,
  anon_sym_GT_GT = 70,
  anon_sym_AMP_CARET = 71,
  anon_sym_EQ_EQ = 72,
  anon_sym_BANG_EQ = 73,
  anon_sym_LT = 74,
  anon_sym_LT_EQ = 75,
  anon_sym_GT = 76,
  anon_sym_GT_EQ = 77,
  anon_sym_AMP_AMP = 78,
  anon_sym_PIPE_PIPE = 79,
  sym_raw_string_literal = 80,
  anon_sym_DQUOTE = 81,
  anon_sym_DQUOTE2 = 82,
  sym__interpreted_string_literal_basic_content = 83,
  sym_escape_sequence = 84,
  sym_int_literal = 85,
  sym_float_literal = 86,
  sym_imaginary_literal = 87,
  sym_rune_literal = 88,
  sym_nil = 89,
  sym_true = 90,
  sym_false = 91,
  sym_iota = 92,
  sym_comment = 93,
  anon_sym_templ = 94,
  anon_sym_AT = 95,
  anon_sym_LBRACE_BANG = 96,
  anon_sym_children_DOT_DOT_DOT = 97,
  anon_sym_LT_SLASH = 98,
  anon_sym_SLASH_GT = 99,
  anon_sym_LT_BANG = 100,
  anon_sym_html = 101,
  anon_sym_style = 102,
  anon_sym_if2 = 103,
  anon_sym_else2 = 104,
  anon_sym_css = 105,
  sym_css_property_name = 106,
  anon_sym_script = 107,
  sym_element_identifier = 108,
  sym_attribute_name = 109,
  sym_attribute_value = 110,
  anon_sym_SQUOTE = 111,
  aux_sym_quoted_attribute_value_token1 = 112,
  aux_sym_quoted_attribute_value_token2 = 113,
  sym_css_property_value = 114,
  sym_element_text = 115,
  sym_element_comment = 116,
  sym_style_element_text = 117,
  sym_script_block_text = 118,
  sym_script_element_text = 119,
  sym_source_file = 120,
  sym_package_clause = 121,
  sym_import_declaration = 122,
  sym_import_spec = 123,
  sym_dot = 124,
  sym_import_spec_list = 125,
  sym__declaration = 126,
  sym_const_declaration = 127,
  sym_const_spec = 128,
  sym_var_declaration = 129,
  sym_var_spec = 130,
  sym_function_declaration = 131,
  sym_method_declaration = 132,
  sym_type_parameter_list = 133,
  sym_parameter_list = 134,
  sym_parameter_declaration = 135,
  sym_variadic_parameter_declaration = 136,
  sym_type_alias = 137,
  sym_type_declaration = 138,
  sym_type_spec = 139,
  sym_expression_list = 140,
  sym_parenthesized_type = 141,
  sym__simple_type = 142,
  sym_generic_type = 143,
  sym_type_arguments = 144,
  sym_pointer_type = 145,
  sym_array_type = 146,
  sym_implicit_length_array_type = 147,
  sym_slice_type = 148,
  sym_struct_type = 149,
  sym_union_type = 150,
  sym_negated_type = 151,
  sym_field_declaration_list = 152,
  sym_field_declaration = 153,
  sym_interface_type = 154,
  sym__interface_body = 155,
  sym_struct_elem = 156,
  sym_struct_term = 157,
  sym_method_spec = 158,
  sym_map_type = 159,
  sym_channel_type = 160,
  sym_function_type = 161,
  sym_block = 162,
  sym__statement_list = 163,
  sym__statement = 164,
  sym_empty_statement = 165,
  sym__simple_statement = 166,
  sym_expression_statement = 167,
  sym_send_statement = 168,
  sym_receive_statement = 169,
  sym_inc_statement = 170,
  sym_dec_statement = 171,
  sym_assignment_statement = 172,
  sym_short_var_declaration = 173,
  sym_labeled_statement = 174,
  sym_empty_labeled_statement = 175,
  sym_fallthrough_statement = 176,
  sym_break_statement = 177,
  sym_continue_statement = 178,
  sym_goto_statement = 179,
  sym_return_statement = 180,
  sym_go_statement = 181,
  sym_defer_statement = 182,
  sym_if_statement = 183,
  sym_for_statement = 184,
  sym_for_clause = 185,
  sym_range_clause = 186,
  sym_expression_switch_statement = 187,
  sym_expression_case = 188,
  sym_default_case = 189,
  sym_type_switch_statement = 190,
  sym__type_switch_header = 191,
  sym_type_case = 192,
  sym_select_statement = 193,
  sym_communication_case = 194,
  sym__expression = 195,
  sym_parenthesized_expression = 196,
  sym_call_expression = 197,
  sym_variadic_argument = 198,
  sym_special_argument_list = 199,
  sym_argument_list = 200,
  sym_selector_expression = 201,
  sym_index_expression = 202,
  sym_slice_expression = 203,
  sym_type_assertion_expression = 204,
  sym_type_conversion_expression = 205,
  sym_composite_literal = 206,
  sym_literal_value = 207,
  sym_literal_element = 208,
  sym_keyed_element = 209,
  sym_func_literal = 210,
  sym_unary_expression = 211,
  sym_binary_expression = 212,
  sym_qualified_type = 213,
  sym_interpreted_string_literal = 214,
  sym_expression = 215,
  sym_component_declaration = 216,
  sym_component_block = 217,
  sym__component_node = 218,
  sym_component_if_statement = 219,
  sym_component_for_statement = 220,
  sym_component_switch_statement = 221,
  sym_component_switch_expression_case = 222,
  sym_component_switch_default_case = 223,
  sym_component_import = 224,
  sym_component_render = 225,
  sym_component_children_expression = 226,
  sym_element = 227,
  sym_tag_start = 228,
  sym_tag_end = 229,
  sym_self_closing_tag = 230,
  sym_doctype = 231,
  sym_style_element = 232,
  sym__attribute = 233,
  sym_attribute = 234,
  sym_spread_attributes = 235,
  sym_conditional_attribute_block = 236,
  sym_conditional_attribute_if_statement = 237,
  sym_css_declaration = 238,
  sym__css_block = 239,
  sym_css_property = 240,
  sym_dynamic_class_attribute_value = 241,
  sym_script_declaration = 242,
  sym_script_block = 243,
  sym_script_element = 244,
  sym__component_identifier = 245,
  sym__css_identifier = 246,
  sym__script_identifier = 247,
  sym_quoted_attribute_value = 248,
  aux_sym_source_file_repeat1 = 249,
  aux_sym_import_spec_list_repeat1 = 250,
  aux_sym_const_declaration_repeat1 = 251,
  aux_sym_const_spec_repeat1 = 252,
  aux_sym_var_declaration_repeat1 = 253,
  aux_sym_type_parameter_list_repeat1 = 254,
  aux_sym_parameter_list_repeat1 = 255,
  aux_sym_parameter_declaration_repeat1 = 256,
  aux_sym_type_declaration_repeat1 = 257,
  aux_sym_expression_list_repeat1 = 258,
  aux_sym_type_arguments_repeat1 = 259,
  aux_sym_field_declaration_list_repeat1 = 260,
  aux_sym_field_declaration_repeat1 = 261,
  aux_sym_interface_type_repeat1 = 262,
  aux_sym_struct_elem_repeat1 = 263,
  aux_sym__statement_list_repeat1 = 264,
  aux_sym_expression_switch_statement_repeat1 = 265,
  aux_sym_type_switch_statement_repeat1 = 266,
  aux_sym_select_statement_repeat1 = 267,
  aux_sym_argument_list_repeat1 = 268,
  aux_sym_literal_value_repeat1 = 269,
  aux_sym_interpreted_string_literal_repeat1 = 270,
  aux_sym_component_block_repeat1 = 271,
  aux_sym_component_switch_statement_repeat1 = 272,
  aux_sym_tag_start_repeat1 = 273,
  aux_sym_style_element_repeat1 = 274,
  aux_sym_conditional_attribute_block_repeat1 = 275,
  aux_sym__css_block_repeat1 = 276,
  aux_sym_dynamic_class_attribute_value_repeat1 = 277,
  alias_sym_component_identifier = 278,
  alias_sym_constraint_elem = 279,
  alias_sym_css_identifier = 280,
  alias_sym_field_identifier = 281,
  alias_sym_label_name = 282,
  alias_sym_package_identifier = 283,
  alias_sym_script_identifier = 284,
  alias_sym_type_identifier = 285,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_LF] = "\n",
  [anon_sym_SEMI] = ";",
  [anon_sym_NULL] = "\0",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [sym_blank_identifier] = "blank_identifier",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_const] = "const",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_var] = "var",
  [anon_sym_func] = "func",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_type] = "type",
  [anon_sym_STAR] = "*",
  [anon_sym_struct] = "struct",
  [anon_sym_PIPE] = "|",
  [anon_sym_TILDE] = "~",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_interface] = "interface",
  [anon_sym_map] = "map",
  [anon_sym_chan] = "chan",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_AMP_CARET_EQ] = "&^=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_COLON] = ":",
  [anon_sym_fallthrough] = "fallthrough",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_return] = "return",
  [anon_sym_go] = "go",
  [anon_sym_defer] = "defer",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_range] = "range",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_select] = "select",
  [anon_sym_new] = "identifier",
  [anon_sym_make] = "identifier",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_CARET] = "&^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [sym_raw_string_literal] = "raw_string_literal",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DQUOTE2] = "\"",
  [sym__interpreted_string_literal_basic_content] = "_interpreted_string_literal_basic_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_int_literal] = "int_literal",
  [sym_float_literal] = "float_literal",
  [sym_imaginary_literal] = "imaginary_literal",
  [sym_rune_literal] = "rune_literal",
  [sym_nil] = "nil",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_iota] = "iota",
  [sym_comment] = "comment",
  [anon_sym_templ] = "templ",
  [anon_sym_AT] = "@",
  [anon_sym_LBRACE_BANG] = "{!",
  [anon_sym_children_DOT_DOT_DOT] = "children...",
  [anon_sym_LT_SLASH] = "</",
  [anon_sym_SLASH_GT] = "/>",
  [anon_sym_LT_BANG] = "<!",
  [anon_sym_html] = "html",
  [anon_sym_style] = "style",
  [anon_sym_if2] = "if",
  [anon_sym_else2] = "else",
  [anon_sym_css] = "css",
  [sym_css_property_name] = "css_property_name",
  [anon_sym_script] = "script",
  [sym_element_identifier] = "element_identifier",
  [sym_attribute_name] = "attribute_name",
  [sym_attribute_value] = "attribute_value",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_quoted_attribute_value_token1] = "attribute_value",
  [aux_sym_quoted_attribute_value_token2] = "attribute_value",
  [sym_css_property_value] = "css_property_value",
  [sym_element_text] = "element_text",
  [sym_element_comment] = "element_comment",
  [sym_style_element_text] = "style_element_text",
  [sym_script_block_text] = "script_block_text",
  [sym_script_element_text] = "script_element_text",
  [sym_source_file] = "source_file",
  [sym_package_clause] = "package_clause",
  [sym_import_declaration] = "import_declaration",
  [sym_import_spec] = "import_spec",
  [sym_dot] = "dot",
  [sym_import_spec_list] = "import_spec_list",
  [sym__declaration] = "_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym_const_spec] = "const_spec",
  [sym_var_declaration] = "var_declaration",
  [sym_var_spec] = "var_spec",
  [sym_function_declaration] = "function_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_type_alias] = "type_alias",
  [sym_type_declaration] = "type_declaration",
  [sym_type_spec] = "type_spec",
  [sym_expression_list] = "expression_list",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym__simple_type] = "_simple_type",
  [sym_generic_type] = "generic_type",
  [sym_type_arguments] = "type_arguments",
  [sym_pointer_type] = "pointer_type",
  [sym_array_type] = "array_type",
  [sym_implicit_length_array_type] = "implicit_length_array_type",
  [sym_slice_type] = "slice_type",
  [sym_struct_type] = "struct_type",
  [sym_union_type] = "union_type",
  [sym_negated_type] = "negated_type",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_interface_type] = "interface_type",
  [sym__interface_body] = "_interface_body",
  [sym_struct_elem] = "struct_elem",
  [sym_struct_term] = "struct_term",
  [sym_method_spec] = "method_spec",
  [sym_map_type] = "map_type",
  [sym_channel_type] = "channel_type",
  [sym_function_type] = "function_type",
  [sym_block] = "block",
  [sym__statement_list] = "_statement_list",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym__simple_statement] = "_simple_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_send_statement] = "send_statement",
  [sym_receive_statement] = "receive_statement",
  [sym_inc_statement] = "inc_statement",
  [sym_dec_statement] = "dec_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym_short_var_declaration] = "short_var_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_empty_labeled_statement] = "labeled_statement",
  [sym_fallthrough_statement] = "fallthrough_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_return_statement] = "return_statement",
  [sym_go_statement] = "go_statement",
  [sym_defer_statement] = "defer_statement",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_clause] = "for_clause",
  [sym_range_clause] = "range_clause",
  [sym_expression_switch_statement] = "expression_switch_statement",
  [sym_expression_case] = "expression_case",
  [sym_default_case] = "default_case",
  [sym_type_switch_statement] = "type_switch_statement",
  [sym__type_switch_header] = "_type_switch_header",
  [sym_type_case] = "type_case",
  [sym_select_statement] = "select_statement",
  [sym_communication_case] = "communication_case",
  [sym__expression] = "_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_call_expression] = "call_expression",
  [sym_variadic_argument] = "variadic_argument",
  [sym_special_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym_selector_expression] = "selector_expression",
  [sym_index_expression] = "index_expression",
  [sym_slice_expression] = "slice_expression",
  [sym_type_assertion_expression] = "type_assertion_expression",
  [sym_type_conversion_expression] = "type_conversion_expression",
  [sym_composite_literal] = "composite_literal",
  [sym_literal_value] = "literal_value",
  [sym_literal_element] = "literal_element",
  [sym_keyed_element] = "keyed_element",
  [sym_func_literal] = "func_literal",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_qualified_type] = "qualified_type",
  [sym_interpreted_string_literal] = "interpreted_string_literal",
  [sym_expression] = "expression",
  [sym_component_declaration] = "component_declaration",
  [sym_component_block] = "component_block",
  [sym__component_node] = "_component_node",
  [sym_component_if_statement] = "component_if_statement",
  [sym_component_for_statement] = "component_for_statement",
  [sym_component_switch_statement] = "component_switch_statement",
  [sym_component_switch_expression_case] = "component_switch_expression_case",
  [sym_component_switch_default_case] = "component_switch_default_case",
  [sym_component_import] = "component_import",
  [sym_component_render] = "component_render",
  [sym_component_children_expression] = "component_children_expression",
  [sym_element] = "element",
  [sym_tag_start] = "tag_start",
  [sym_tag_end] = "tag_end",
  [sym_self_closing_tag] = "self_closing_tag",
  [sym_doctype] = "doctype",
  [sym_style_element] = "style_element",
  [sym__attribute] = "_attribute",
  [sym_attribute] = "attribute",
  [sym_spread_attributes] = "spread_attributes",
  [sym_conditional_attribute_block] = "conditional_attribute_block",
  [sym_conditional_attribute_if_statement] = "conditional_attribute_if_statement",
  [sym_css_declaration] = "css_declaration",
  [sym__css_block] = "_css_block",
  [sym_css_property] = "css_property",
  [sym_dynamic_class_attribute_value] = "dynamic_class_attribute_value",
  [sym_script_declaration] = "script_declaration",
  [sym_script_block] = "script_block",
  [sym_script_element] = "script_element",
  [sym__component_identifier] = "_component_identifier",
  [sym__css_identifier] = "_css_identifier",
  [sym__script_identifier] = "_script_identifier",
  [sym_quoted_attribute_value] = "quoted_attribute_value",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_import_spec_list_repeat1] = "import_spec_list_repeat1",
  [aux_sym_const_declaration_repeat1] = "const_declaration_repeat1",
  [aux_sym_const_spec_repeat1] = "const_spec_repeat1",
  [aux_sym_var_declaration_repeat1] = "var_declaration_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_parameter_declaration_repeat1] = "parameter_declaration_repeat1",
  [aux_sym_type_declaration_repeat1] = "type_declaration_repeat1",
  [aux_sym_expression_list_repeat1] = "expression_list_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_interface_type_repeat1] = "interface_type_repeat1",
  [aux_sym_struct_elem_repeat1] = "struct_elem_repeat1",
  [aux_sym__statement_list_repeat1] = "_statement_list_repeat1",
  [aux_sym_expression_switch_statement_repeat1] = "expression_switch_statement_repeat1",
  [aux_sym_type_switch_statement_repeat1] = "type_switch_statement_repeat1",
  [aux_sym_select_statement_repeat1] = "select_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_literal_value_repeat1] = "literal_value_repeat1",
  [aux_sym_interpreted_string_literal_repeat1] = "interpreted_string_literal_repeat1",
  [aux_sym_component_block_repeat1] = "component_block_repeat1",
  [aux_sym_component_switch_statement_repeat1] = "component_switch_statement_repeat1",
  [aux_sym_tag_start_repeat1] = "tag_start_repeat1",
  [aux_sym_style_element_repeat1] = "style_element_repeat1",
  [aux_sym_conditional_attribute_block_repeat1] = "conditional_attribute_block_repeat1",
  [aux_sym__css_block_repeat1] = "_css_block_repeat1",
  [aux_sym_dynamic_class_attribute_value_repeat1] = "dynamic_class_attribute_value_repeat1",
  [alias_sym_component_identifier] = "component_identifier",
  [alias_sym_constraint_elem] = "constraint_elem",
  [alias_sym_css_identifier] = "css_identifier",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_label_name] = "label_name",
  [alias_sym_package_identifier] = "package_identifier",
  [alias_sym_script_identifier] = "script_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_blank_identifier] = sym_blank_identifier,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_func] = anon_sym_func,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_map] = anon_sym_map,
  [anon_sym_chan] = anon_sym_chan,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_AMP_CARET_EQ] = anon_sym_AMP_CARET_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_fallthrough] = anon_sym_fallthrough,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_go] = anon_sym_go,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_range] = anon_sym_range,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_new] = sym_identifier,
  [anon_sym_make] = sym_identifier,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_AMP_CARET] = anon_sym_AMP_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [sym__interpreted_string_literal_basic_content] = sym__interpreted_string_literal_basic_content,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_int_literal] = sym_int_literal,
  [sym_float_literal] = sym_float_literal,
  [sym_imaginary_literal] = sym_imaginary_literal,
  [sym_rune_literal] = sym_rune_literal,
  [sym_nil] = sym_nil,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_iota] = sym_iota,
  [sym_comment] = sym_comment,
  [anon_sym_templ] = anon_sym_templ,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_LBRACE_BANG] = anon_sym_LBRACE_BANG,
  [anon_sym_children_DOT_DOT_DOT] = anon_sym_children_DOT_DOT_DOT,
  [anon_sym_LT_SLASH] = anon_sym_LT_SLASH,
  [anon_sym_SLASH_GT] = anon_sym_SLASH_GT,
  [anon_sym_LT_BANG] = anon_sym_LT_BANG,
  [anon_sym_html] = anon_sym_html,
  [anon_sym_style] = anon_sym_style,
  [anon_sym_if2] = anon_sym_if,
  [anon_sym_else2] = anon_sym_else,
  [anon_sym_css] = anon_sym_css,
  [sym_css_property_name] = sym_css_property_name,
  [anon_sym_script] = anon_sym_script,
  [sym_element_identifier] = sym_element_identifier,
  [sym_attribute_name] = sym_attribute_name,
  [sym_attribute_value] = sym_attribute_value,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_quoted_attribute_value_token1] = sym_attribute_value,
  [aux_sym_quoted_attribute_value_token2] = sym_attribute_value,
  [sym_css_property_value] = sym_css_property_value,
  [sym_element_text] = sym_element_text,
  [sym_element_comment] = sym_element_comment,
  [sym_style_element_text] = sym_style_element_text,
  [sym_script_block_text] = sym_script_block_text,
  [sym_script_element_text] = sym_script_element_text,
  [sym_source_file] = sym_source_file,
  [sym_package_clause] = sym_package_clause,
  [sym_import_declaration] = sym_import_declaration,
  [sym_import_spec] = sym_import_spec,
  [sym_dot] = sym_dot,
  [sym_import_spec_list] = sym_import_spec_list,
  [sym__declaration] = sym__declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym_const_spec] = sym_const_spec,
  [sym_var_declaration] = sym_var_declaration,
  [sym_var_spec] = sym_var_spec,
  [sym_function_declaration] = sym_function_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_type_alias] = sym_type_alias,
  [sym_type_declaration] = sym_type_declaration,
  [sym_type_spec] = sym_type_spec,
  [sym_expression_list] = sym_expression_list,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym__simple_type] = sym__simple_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_pointer_type] = sym_pointer_type,
  [sym_array_type] = sym_array_type,
  [sym_implicit_length_array_type] = sym_implicit_length_array_type,
  [sym_slice_type] = sym_slice_type,
  [sym_struct_type] = sym_struct_type,
  [sym_union_type] = sym_union_type,
  [sym_negated_type] = sym_negated_type,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_interface_type] = sym_interface_type,
  [sym__interface_body] = sym__interface_body,
  [sym_struct_elem] = sym_struct_elem,
  [sym_struct_term] = sym_struct_term,
  [sym_method_spec] = sym_method_spec,
  [sym_map_type] = sym_map_type,
  [sym_channel_type] = sym_channel_type,
  [sym_function_type] = sym_function_type,
  [sym_block] = sym_block,
  [sym__statement_list] = sym__statement_list,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym__simple_statement] = sym__simple_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_send_statement] = sym_send_statement,
  [sym_receive_statement] = sym_receive_statement,
  [sym_inc_statement] = sym_inc_statement,
  [sym_dec_statement] = sym_dec_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_short_var_declaration] = sym_short_var_declaration,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_empty_labeled_statement] = sym_labeled_statement,
  [sym_fallthrough_statement] = sym_fallthrough_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_go_statement] = sym_go_statement,
  [sym_defer_statement] = sym_defer_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_clause] = sym_for_clause,
  [sym_range_clause] = sym_range_clause,
  [sym_expression_switch_statement] = sym_expression_switch_statement,
  [sym_expression_case] = sym_expression_case,
  [sym_default_case] = sym_default_case,
  [sym_type_switch_statement] = sym_type_switch_statement,
  [sym__type_switch_header] = sym__type_switch_header,
  [sym_type_case] = sym_type_case,
  [sym_select_statement] = sym_select_statement,
  [sym_communication_case] = sym_communication_case,
  [sym__expression] = sym__expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_variadic_argument] = sym_variadic_argument,
  [sym_special_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym_selector_expression] = sym_selector_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_slice_expression] = sym_slice_expression,
  [sym_type_assertion_expression] = sym_type_assertion_expression,
  [sym_type_conversion_expression] = sym_type_conversion_expression,
  [sym_composite_literal] = sym_composite_literal,
  [sym_literal_value] = sym_literal_value,
  [sym_literal_element] = sym_literal_element,
  [sym_keyed_element] = sym_keyed_element,
  [sym_func_literal] = sym_func_literal,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_qualified_type] = sym_qualified_type,
  [sym_interpreted_string_literal] = sym_interpreted_string_literal,
  [sym_expression] = sym_expression,
  [sym_component_declaration] = sym_component_declaration,
  [sym_component_block] = sym_component_block,
  [sym__component_node] = sym__component_node,
  [sym_component_if_statement] = sym_component_if_statement,
  [sym_component_for_statement] = sym_component_for_statement,
  [sym_component_switch_statement] = sym_component_switch_statement,
  [sym_component_switch_expression_case] = sym_component_switch_expression_case,
  [sym_component_switch_default_case] = sym_component_switch_default_case,
  [sym_component_import] = sym_component_import,
  [sym_component_render] = sym_component_render,
  [sym_component_children_expression] = sym_component_children_expression,
  [sym_element] = sym_element,
  [sym_tag_start] = sym_tag_start,
  [sym_tag_end] = sym_tag_end,
  [sym_self_closing_tag] = sym_self_closing_tag,
  [sym_doctype] = sym_doctype,
  [sym_style_element] = sym_style_element,
  [sym__attribute] = sym__attribute,
  [sym_attribute] = sym_attribute,
  [sym_spread_attributes] = sym_spread_attributes,
  [sym_conditional_attribute_block] = sym_conditional_attribute_block,
  [sym_conditional_attribute_if_statement] = sym_conditional_attribute_if_statement,
  [sym_css_declaration] = sym_css_declaration,
  [sym__css_block] = sym__css_block,
  [sym_css_property] = sym_css_property,
  [sym_dynamic_class_attribute_value] = sym_dynamic_class_attribute_value,
  [sym_script_declaration] = sym_script_declaration,
  [sym_script_block] = sym_script_block,
  [sym_script_element] = sym_script_element,
  [sym__component_identifier] = sym__component_identifier,
  [sym__css_identifier] = sym__css_identifier,
  [sym__script_identifier] = sym__script_identifier,
  [sym_quoted_attribute_value] = sym_quoted_attribute_value,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_import_spec_list_repeat1] = aux_sym_import_spec_list_repeat1,
  [aux_sym_const_declaration_repeat1] = aux_sym_const_declaration_repeat1,
  [aux_sym_const_spec_repeat1] = aux_sym_const_spec_repeat1,
  [aux_sym_var_declaration_repeat1] = aux_sym_var_declaration_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_parameter_declaration_repeat1] = aux_sym_parameter_declaration_repeat1,
  [aux_sym_type_declaration_repeat1] = aux_sym_type_declaration_repeat1,
  [aux_sym_expression_list_repeat1] = aux_sym_expression_list_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_interface_type_repeat1] = aux_sym_interface_type_repeat1,
  [aux_sym_struct_elem_repeat1] = aux_sym_struct_elem_repeat1,
  [aux_sym__statement_list_repeat1] = aux_sym__statement_list_repeat1,
  [aux_sym_expression_switch_statement_repeat1] = aux_sym_expression_switch_statement_repeat1,
  [aux_sym_type_switch_statement_repeat1] = aux_sym_type_switch_statement_repeat1,
  [aux_sym_select_statement_repeat1] = aux_sym_select_statement_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_literal_value_repeat1] = aux_sym_literal_value_repeat1,
  [aux_sym_interpreted_string_literal_repeat1] = aux_sym_interpreted_string_literal_repeat1,
  [aux_sym_component_block_repeat1] = aux_sym_component_block_repeat1,
  [aux_sym_component_switch_statement_repeat1] = aux_sym_component_switch_statement_repeat1,
  [aux_sym_tag_start_repeat1] = aux_sym_tag_start_repeat1,
  [aux_sym_style_element_repeat1] = aux_sym_style_element_repeat1,
  [aux_sym_conditional_attribute_block_repeat1] = aux_sym_conditional_attribute_block_repeat1,
  [aux_sym__css_block_repeat1] = aux_sym__css_block_repeat1,
  [aux_sym_dynamic_class_attribute_value_repeat1] = aux_sym_dynamic_class_attribute_value_repeat1,
  [alias_sym_component_identifier] = alias_sym_component_identifier,
  [alias_sym_constraint_elem] = alias_sym_constraint_elem,
  [alias_sym_css_identifier] = alias_sym_css_identifier,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_label_name] = alias_sym_label_name,
  [alias_sym_package_identifier] = alias_sym_package_identifier,
  [alias_sym_script_identifier] = alias_sym_script_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_blank_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_func] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_map] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fallthrough] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_go] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_range] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_make] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [sym__interpreted_string_literal_basic_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_imaginary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_rune_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_iota] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_templ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_children_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_html] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_style] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_css] = {
    .visible = true,
    .named = false,
  },
  [sym_css_property_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_script] = {
    .visible = true,
    .named = false,
  },
  [sym_element_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quoted_attribute_value_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_quoted_attribute_value_token2] = {
    .visible = true,
    .named = true,
  },
  [sym_css_property_value] = {
    .visible = true,
    .named = true,
  },
  [sym_element_text] = {
    .visible = true,
    .named = true,
  },
  [sym_element_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_style_element_text] = {
    .visible = true,
    .named = true,
  },
  [sym_script_block_text] = {
    .visible = true,
    .named = true,
  },
  [sym_script_element_text] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_package_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_dot] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_var_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_length_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_type] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_type] = {
    .visible = true,
    .named = true,
  },
  [sym__interface_body] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_elem] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_term] = {
    .visible = true,
    .named = true,
  },
  [sym_method_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_map_type] = {
    .visible = true,
    .named = true,
  },
  [sym_channel_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_list] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_send_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_receive_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_inc_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_dec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_short_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fallthrough_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_go_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_defer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_range_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_case] = {
    .visible = true,
    .named = true,
  },
  [sym_default_case] = {
    .visible = true,
    .named = true,
  },
  [sym_type_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__type_switch_header] = {
    .visible = false,
    .named = true,
  },
  [sym_type_case] = {
    .visible = true,
    .named = true,
  },
  [sym_select_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_communication_case] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_special_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_selector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_conversion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_composite_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_value] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_element] = {
    .visible = true,
    .named = true,
  },
  [sym_keyed_element] = {
    .visible = true,
    .named = true,
  },
  [sym_func_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_interpreted_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_component_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_component_block] = {
    .visible = true,
    .named = true,
  },
  [sym__component_node] = {
    .visible = false,
    .named = true,
  },
  [sym_component_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_component_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_component_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_component_switch_expression_case] = {
    .visible = true,
    .named = true,
  },
  [sym_component_switch_default_case] = {
    .visible = true,
    .named = true,
  },
  [sym_component_import] = {
    .visible = true,
    .named = true,
  },
  [sym_component_render] = {
    .visible = true,
    .named = true,
  },
  [sym_component_children_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_element] = {
    .visible = true,
    .named = true,
  },
  [sym_tag_start] = {
    .visible = true,
    .named = true,
  },
  [sym_tag_end] = {
    .visible = true,
    .named = true,
  },
  [sym_self_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_doctype] = {
    .visible = true,
    .named = true,
  },
  [sym_style_element] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_attribute_block] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_attribute_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_css_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__css_block] = {
    .visible = false,
    .named = true,
  },
  [sym_css_property] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic_class_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym_script_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_script_block] = {
    .visible = true,
    .named = true,
  },
  [sym_script_element] = {
    .visible = true,
    .named = true,
  },
  [sym__component_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__css_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__script_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_quoted_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_spec_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_var_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_elem_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_component_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_component_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tag_start_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_style_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_conditional_attribute_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__css_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dynamic_class_attribute_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_component_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_constraint_elem] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_css_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_label_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_package_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_script_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_arguments = 3,
  field_body = 4,
  field_capacity = 5,
  field_channel = 6,
  field_communication = 7,
  field_condition = 8,
  field_consequence = 9,
  field_element = 10,
  field_end = 11,
  field_expression = 12,
  field_field = 13,
  field_function = 14,
  field_index = 15,
  field_initializer = 16,
  field_key = 17,
  field_label = 18,
  field_left = 19,
  field_length = 20,
  field_name = 21,
  field_operand = 22,
  field_operator = 23,
  field_package = 24,
  field_parameters = 25,
  field_path = 26,
  field_receiver = 27,
  field_result = 28,
  field_right = 29,
  field_start = 30,
  field_tag = 31,
  field_type = 32,
  field_type_arguments = 33,
  field_type_parameters = 34,
  field_update = 35,
  field_value = 36,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_capacity] = "capacity",
  [field_channel] = "channel",
  [field_communication] = "communication",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_element] = "element",
  [field_end] = "end",
  [field_expression] = "expression",
  [field_field] = "field",
  [field_function] = "function",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_package] = "package",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_receiver] = "receiver",
  [field_result] = "result",
  [field_right] = "right",
  [field_start] = "start",
  [field_tag] = "tag",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 2},
  [7] = {.index = 5, .length = 1},
  [9] = {.index = 6, .length = 1},
  [10] = {.index = 7, .length = 2},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 2},
  [16] = {.index = 11, .length = 2},
  [17] = {.index = 9, .length = 2},
  [18] = {.index = 13, .length = 2},
  [19] = {.index = 13, .length = 2},
  [20] = {.index = 15, .length = 2},
  [21] = {.index = 17, .length = 2},
  [22] = {.index = 19, .length = 1},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 2},
  [25] = {.index = 24, .length = 2},
  [26] = {.index = 26, .length = 1},
  [27] = {.index = 17, .length = 2},
  [28] = {.index = 19, .length = 1},
  [29] = {.index = 27, .length = 1},
  [31] = {.index = 28, .length = 1},
  [32] = {.index = 29, .length = 2},
  [33] = {.index = 31, .length = 1},
  [34] = {.index = 32, .length = 1},
  [35] = {.index = 33, .length = 2},
  [36] = {.index = 35, .length = 3},
  [37] = {.index = 38, .length = 2},
  [38] = {.index = 40, .length = 2},
  [39] = {.index = 42, .length = 2},
  [40] = {.index = 44, .length = 3},
  [41] = {.index = 47, .length = 2},
  [42] = {.index = 49, .length = 3},
  [43] = {.index = 52, .length = 1},
  [44] = {.index = 53, .length = 3},
  [45] = {.index = 56, .length = 3},
  [46] = {.index = 59, .length = 3},
  [47] = {.index = 62, .length = 3},
  [48] = {.index = 65, .length = 3},
  [49] = {.index = 68, .length = 1},
  [50] = {.index = 69, .length = 2},
  [51] = {.index = 71, .length = 2},
  [52] = {.index = 73, .length = 3},
  [53] = {.index = 52, .length = 1},
  [54] = {.index = 76, .length = 2},
  [55] = {.index = 17, .length = 2},
  [56] = {.index = 76, .length = 2},
  [57] = {.index = 78, .length = 2},
  [58] = {.index = 80, .length = 1},
  [59] = {.index = 81, .length = 1},
  [60] = {.index = 82, .length = 1},
  [61] = {.index = 83, .length = 3},
  [62] = {.index = 86, .length = 1},
  [63] = {.index = 87, .length = 1},
  [64] = {.index = 88, .length = 2},
  [65] = {.index = 90, .length = 1},
  [66] = {.index = 91, .length = 2},
  [67] = {.index = 93, .length = 3},
  [68] = {.index = 96, .length = 3},
  [69] = {.index = 71, .length = 2},
  [70] = {.index = 99, .length = 3},
  [71] = {.index = 102, .length = 2},
  [72] = {.index = 104, .length = 4},
  [73] = {.index = 108, .length = 4},
  [74] = {.index = 112, .length = 4},
  [75] = {.index = 116, .length = 4},
  [76] = {.index = 120, .length = 4},
  [77] = {.index = 124, .length = 2},
  [78] = {.index = 124, .length = 2},
  [79] = {.index = 87, .length = 1},
  [80] = {.index = 126, .length = 3},
  [81] = {.index = 99, .length = 3},
  [82] = {.index = 129, .length = 3},
  [83] = {.index = 132, .length = 2},
  [84] = {.index = 134, .length = 3},
  [85] = {.index = 137, .length = 3},
  [86] = {.index = 140, .length = 2},
  [87] = {.index = 142, .length = 2},
  [88] = {.index = 144, .length = 2},
  [89] = {.index = 146, .length = 2},
  [90] = {.index = 148, .length = 1},
  [91] = {.index = 149, .length = 1},
  [92] = {.index = 150, .length = 2},
  [93] = {.index = 152, .length = 2},
  [94] = {.index = 154, .length = 2},
  [95] = {.index = 156, .length = 2},
  [96] = {.index = 158, .length = 4},
  [97] = {.index = 162, .length = 5},
  [98] = {.index = 167, .length = 5},
  [99] = {.index = 172, .length = 4},
  [100] = {.index = 176, .length = 3},
  [101] = {.index = 179, .length = 2},
  [102] = {.index = 181, .length = 1},
  [103] = {.index = 182, .length = 3},
  [104] = {.index = 185, .length = 4},
  [105] = {.index = 189, .length = 2},
  [106] = {.index = 191, .length = 2},
  [107] = {.index = 193, .length = 2},
  [108] = {.index = 195, .length = 1},
  [109] = {.index = 196, .length = 3},
  [110] = {.index = 199, .length = 2},
  [111] = {.index = 201, .length = 2},
  [112] = {.index = 203, .length = 2},
  [113] = {.index = 205, .length = 3},
  [114] = {.index = 208, .length = 4},
  [115] = {.index = 212, .length = 3},
  [116] = {.index = 215, .length = 3},
  [117] = {.index = 218, .length = 3},
  [118] = {.index = 221, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_path, 0},
  [1] =
    {field_name, 0},
  [2] =
    {field_parameters, 1},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_value, 1},
  [6] =
    {field_body, 1},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_type, 0},
    {field_type_arguments, 1},
  [11] =
    {field_body, 1},
    {field_type, 0},
  [13] =
    {field_name, 0},
    {field_path, 1},
  [15] =
    {field_name, 0},
    {field_name, 1},
  [17] =
    {field_name, 0},
    {field_type, 1},
  [19] =
    {field_type, 0},
  [20] =
    {field_name, 1},
    {field_parameters, 2},
  [22] =
    {field_parameters, 1},
    {field_result, 2},
  [24] =
    {field_body, 2},
    {field_parameters, 1},
  [26] =
    {field_element, 2},
  [27] =
    {field_label, 0},
  [28] =
    {field_value, 2},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_right, 1},
  [32] =
    {field_body, 2},
  [33] =
    {field_name, 2},
    {field_package, 0},
  [35] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [38] =
    {field_left, 0},
    {field_right, 2},
  [40] =
    {field_field, 2},
    {field_operand, 0},
  [42] =
    {field_channel, 0},
    {field_value, 2},
  [44] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [47] =
    {field_name, 0},
    {field_value, 2},
  [49] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
  [52] =
    {field_type, 1},
  [53] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [56] =
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [59] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [62] =
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
  [65] =
    {field_body, 3},
    {field_parameters, 1},
    {field_result, 2},
  [68] =
    {field_element, 3},
  [69] =
    {field_element, 3},
    {field_length, 1},
  [71] =
    {field_name, 0},
    {field_type, 2},
  [73] =
    {field_name, 0},
    {field_type, 2},
    {field_type_parameters, 1},
  [76] =
    {field_tag, 1},
    {field_type, 0},
  [78] =
    {field_name, 0},
    {field_parameters, 1},
  [80] =
    {field_update, 2},
  [81] =
    {field_condition, 1},
  [82] =
    {field_initializer, 0},
  [83] =
    {field_alias, 1, .inherited = true},
    {field_initializer, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [86] =
    {field_right, 0},
  [87] =
    {field_name, 1},
  [88] =
    {field_operand, 2},
    {field_type, 0},
  [90] =
    {field_operand, 0},
  [91] =
    {field_index, 2},
    {field_operand, 0},
  [93] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 3},
  [96] =
    {field_name, 0},
    {field_name, 1},
    {field_value, 3},
  [99] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
    {field_type, 2},
  [102] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [104] =
    {field_name, 1},
    {field_parameters, 3},
    {field_result, 4},
    {field_type_parameters, 2},
  [108] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [112] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [116] =
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
    {field_result, 4},
  [120] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
  [124] =
    {field_tag, 2},
    {field_type, 1},
  [126] =
    {field_name, 0},
    {field_tag, 2},
    {field_type, 1},
  [129] =
    {field_name, 0},
    {field_parameters, 1},
    {field_result, 2},
  [132] =
    {field_key, 2},
    {field_value, 4},
  [134] =
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [137] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [140] =
    {field_condition, 1},
    {field_update, 3},
  [142] =
    {field_left, 0},
    {field_right, 3},
  [144] =
    {field_initializer, 0},
    {field_update, 3},
  [146] =
    {field_condition, 2},
    {field_initializer, 0},
  [148] =
    {field_initializer, 1},
  [149] =
    {field_communication, 1},
  [150] =
    {field_name, 2},
    {field_receiver, 1},
  [152] =
    {field_operand, 0},
    {field_type, 3},
  [154] =
    {field_end, 3},
    {field_operand, 0},
  [156] =
    {field_operand, 0},
    {field_start, 2},
  [158] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
    {field_value, 4},
  [162] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_result, 4},
    {field_type_parameters, 2},
  [167] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
    {field_result, 4},
  [172] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
    {field_tag, 3},
    {field_type, 2},
  [176] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [179] =
    {field_initializer, 1},
    {field_value, 3},
  [181] =
    {field_value, 0},
  [182] =
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [185] =
    {field_alternative, 6},
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [189] =
    {field_type, 1},
    {field_type, 2},
  [191] =
    {field_arguments, 2},
    {field_name, 1},
  [193] =
    {field_body, 2},
    {field_name, 1},
  [195] =
    {field_expression, 1},
  [196] =
    {field_capacity, 5},
    {field_end, 3},
    {field_operand, 0},
  [199] =
    {field_alias, 0},
    {field_value, 2},
  [201] =
    {field_initializer, 0},
    {field_value, 2},
  [203] =
    {field_name, 3},
    {field_package, 1},
  [205] =
    {field_arguments, 2},
    {field_body, 3},
    {field_name, 1},
  [208] =
    {field_capacity, 6},
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [212] =
    {field_arguments, 4},
    {field_name, 3},
    {field_package, 1},
  [215] =
    {field_body, 4},
    {field_name, 3},
    {field_package, 1},
  [218] =
    {field_alias, 2},
    {field_initializer, 0},
    {field_value, 4},
  [221] =
    {field_arguments, 4},
    {field_body, 5},
    {field_name, 3},
    {field_package, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [1] = alias_sym_package_identifier,
  },
  [8] = {
    [1] = alias_sym_label_name,
  },
  [11] = {
    [0] = alias_sym_type_identifier,
  },
  [12] = {
    [0] = alias_sym_type_identifier,
  },
  [13] = {
    [0] = alias_sym_component_identifier,
  },
  [14] = {
    [0] = alias_sym_css_identifier,
  },
  [15] = {
    [0] = alias_sym_script_identifier,
  },
  [19] = {
    [0] = alias_sym_package_identifier,
  },
  [27] = {
    [0] = alias_sym_type_identifier,
  },
  [28] = {
    [0] = alias_sym_type_identifier,
  },
  [29] = {
    [0] = alias_sym_label_name,
  },
  [30] = {
    [0] = alias_sym_constraint_elem,
  },
  [35] = {
    [0] = alias_sym_package_identifier,
    [2] = alias_sym_type_identifier,
  },
  [38] = {
    [2] = alias_sym_field_identifier,
  },
  [47] = {
    [2] = alias_sym_field_identifier,
  },
  [51] = {
    [0] = alias_sym_type_identifier,
  },
  [52] = {
    [0] = alias_sym_type_identifier,
  },
  [53] = {
    [1] = alias_sym_type_identifier,
  },
  [54] = {
    [0] = alias_sym_type_identifier,
  },
  [55] = {
    [0] = alias_sym_field_identifier,
  },
  [57] = {
    [0] = alias_sym_field_identifier,
  },
  [75] = {
    [2] = alias_sym_field_identifier,
  },
  [76] = {
    [2] = alias_sym_field_identifier,
  },
  [77] = {
    [1] = alias_sym_type_identifier,
  },
  [79] = {
    [1] = alias_sym_field_identifier,
  },
  [80] = {
    [0] = alias_sym_field_identifier,
  },
  [81] = {
    [0] = alias_sym_field_identifier,
  },
  [82] = {
    [0] = alias_sym_field_identifier,
  },
  [98] = {
    [2] = alias_sym_field_identifier,
  },
  [99] = {
    [0] = alias_sym_field_identifier,
  },
  [112] = {
    [1] = alias_sym_package_identifier,
  },
  [115] = {
    [1] = alias_sym_package_identifier,
  },
  [116] = {
    [1] = alias_sym_package_identifier,
  },
  [118] = {
    [1] = alias_sym_package_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__simple_type, 2,
    sym__simple_type,
    alias_sym_constraint_elem,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 12,
  [14] = 12,
  [15] = 12,
  [16] = 12,
  [17] = 12,
  [18] = 12,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 22,
  [24] = 22,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 26,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 26,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 33,
  [37] = 33,
  [38] = 38,
  [39] = 39,
  [40] = 39,
  [41] = 39,
  [42] = 39,
  [43] = 39,
  [44] = 39,
  [45] = 45,
  [46] = 46,
  [47] = 45,
  [48] = 45,
  [49] = 45,
  [50] = 46,
  [51] = 46,
  [52] = 46,
  [53] = 45,
  [54] = 46,
  [55] = 46,
  [56] = 45,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 61,
  [64] = 64,
  [65] = 61,
  [66] = 66,
  [67] = 67,
  [68] = 61,
  [69] = 61,
  [70] = 67,
  [71] = 71,
  [72] = 61,
  [73] = 66,
  [74] = 74,
  [75] = 61,
  [76] = 67,
  [77] = 67,
  [78] = 66,
  [79] = 66,
  [80] = 62,
  [81] = 81,
  [82] = 71,
  [83] = 67,
  [84] = 67,
  [85] = 67,
  [86] = 66,
  [87] = 87,
  [88] = 66,
  [89] = 67,
  [90] = 62,
  [91] = 61,
  [92] = 66,
  [93] = 71,
  [94] = 66,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 98,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 104,
  [106] = 106,
  [107] = 96,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 98,
  [114] = 114,
  [115] = 95,
  [116] = 102,
  [117] = 103,
  [118] = 108,
  [119] = 104,
  [120] = 120,
  [121] = 121,
  [122] = 98,
  [123] = 97,
  [124] = 95,
  [125] = 125,
  [126] = 126,
  [127] = 114,
  [128] = 128,
  [129] = 129,
  [130] = 114,
  [131] = 104,
  [132] = 102,
  [133] = 104,
  [134] = 103,
  [135] = 135,
  [136] = 102,
  [137] = 95,
  [138] = 96,
  [139] = 109,
  [140] = 140,
  [141] = 141,
  [142] = 128,
  [143] = 121,
  [144] = 103,
  [145] = 102,
  [146] = 114,
  [147] = 114,
  [148] = 98,
  [149] = 98,
  [150] = 95,
  [151] = 104,
  [152] = 114,
  [153] = 108,
  [154] = 109,
  [155] = 102,
  [156] = 128,
  [157] = 157,
  [158] = 121,
  [159] = 95,
  [160] = 103,
  [161] = 103,
  [162] = 162,
  [163] = 163,
  [164] = 163,
  [165] = 163,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 163,
  [174] = 174,
  [175] = 170,
  [176] = 176,
  [177] = 167,
  [178] = 171,
  [179] = 179,
  [180] = 174,
  [181] = 176,
  [182] = 182,
  [183] = 169,
  [184] = 168,
  [185] = 185,
  [186] = 182,
  [187] = 169,
  [188] = 188,
  [189] = 163,
  [190] = 163,
  [191] = 191,
  [192] = 171,
  [193] = 169,
  [194] = 182,
  [195] = 195,
  [196] = 169,
  [197] = 170,
  [198] = 182,
  [199] = 182,
  [200] = 200,
  [201] = 201,
  [202] = 174,
  [203] = 203,
  [204] = 179,
  [205] = 166,
  [206] = 171,
  [207] = 171,
  [208] = 172,
  [209] = 185,
  [210] = 174,
  [211] = 167,
  [212] = 179,
  [213] = 167,
  [214] = 168,
  [215] = 179,
  [216] = 182,
  [217] = 188,
  [218] = 172,
  [219] = 201,
  [220] = 171,
  [221] = 201,
  [222] = 174,
  [223] = 167,
  [224] = 182,
  [225] = 169,
  [226] = 166,
  [227] = 166,
  [228] = 163,
  [229] = 169,
  [230] = 230,
  [231] = 168,
  [232] = 188,
  [233] = 163,
  [234] = 174,
  [235] = 167,
  [236] = 236,
  [237] = 201,
  [238] = 179,
  [239] = 174,
  [240] = 179,
  [241] = 166,
  [242] = 170,
  [243] = 179,
  [244] = 201,
  [245] = 188,
  [246] = 246,
  [247] = 171,
  [248] = 171,
  [249] = 249,
  [250] = 169,
  [251] = 170,
  [252] = 191,
  [253] = 182,
  [254] = 174,
  [255] = 166,
  [256] = 170,
  [257] = 179,
  [258] = 176,
  [259] = 168,
  [260] = 260,
  [261] = 201,
  [262] = 185,
  [263] = 167,
  [264] = 167,
  [265] = 188,
  [266] = 168,
  [267] = 172,
  [268] = 172,
  [269] = 269,
  [270] = 191,
  [271] = 171,
  [272] = 188,
  [273] = 236,
  [274] = 170,
  [275] = 171,
  [276] = 170,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 296,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 314,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 314,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 296,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 335,
  [337] = 335,
  [338] = 283,
  [339] = 289,
  [340] = 285,
  [341] = 286,
  [342] = 287,
  [343] = 288,
  [344] = 282,
  [345] = 284,
  [346] = 293,
  [347] = 291,
  [348] = 320,
  [349] = 309,
  [350] = 303,
  [351] = 311,
  [352] = 317,
  [353] = 324,
  [354] = 330,
  [355] = 331,
  [356] = 329,
  [357] = 301,
  [358] = 327,
  [359] = 316,
  [360] = 297,
  [361] = 323,
  [362] = 308,
  [363] = 306,
  [364] = 305,
  [365] = 307,
  [366] = 304,
  [367] = 299,
  [368] = 298,
  [369] = 292,
  [370] = 333,
  [371] = 290,
  [372] = 315,
  [373] = 319,
  [374] = 300,
  [375] = 295,
  [376] = 326,
  [377] = 322,
  [378] = 328,
  [379] = 294,
  [380] = 302,
  [381] = 283,
  [382] = 285,
  [383] = 287,
  [384] = 289,
  [385] = 286,
  [386] = 288,
  [387] = 284,
  [388] = 388,
  [389] = 389,
  [390] = 293,
  [391] = 391,
  [392] = 389,
  [393] = 323,
  [394] = 308,
  [395] = 327,
  [396] = 324,
  [397] = 304,
  [398] = 303,
  [399] = 297,
  [400] = 311,
  [401] = 291,
  [402] = 329,
  [403] = 315,
  [404] = 309,
  [405] = 292,
  [406] = 333,
  [407] = 294,
  [408] = 290,
  [409] = 306,
  [410] = 330,
  [411] = 307,
  [412] = 305,
  [413] = 295,
  [414] = 317,
  [415] = 298,
  [416] = 322,
  [417] = 316,
  [418] = 331,
  [419] = 326,
  [420] = 301,
  [421] = 328,
  [422] = 300,
  [423] = 302,
  [424] = 320,
  [425] = 319,
  [426] = 299,
  [427] = 304,
  [428] = 283,
  [429] = 429,
  [430] = 289,
  [431] = 299,
  [432] = 284,
  [433] = 330,
  [434] = 326,
  [435] = 435,
  [436] = 389,
  [437] = 389,
  [438] = 293,
  [439] = 306,
  [440] = 297,
  [441] = 319,
  [442] = 295,
  [443] = 301,
  [444] = 444,
  [445] = 316,
  [446] = 315,
  [447] = 317,
  [448] = 324,
  [449] = 449,
  [450] = 288,
  [451] = 329,
  [452] = 292,
  [453] = 453,
  [454] = 331,
  [455] = 323,
  [456] = 456,
  [457] = 457,
  [458] = 287,
  [459] = 300,
  [460] = 303,
  [461] = 286,
  [462] = 302,
  [463] = 285,
  [464] = 283,
  [465] = 320,
  [466] = 327,
  [467] = 322,
  [468] = 328,
  [469] = 290,
  [470] = 389,
  [471] = 311,
  [472] = 309,
  [473] = 333,
  [474] = 389,
  [475] = 308,
  [476] = 307,
  [477] = 291,
  [478] = 298,
  [479] = 305,
  [480] = 294,
  [481] = 481,
  [482] = 388,
  [483] = 449,
  [484] = 457,
  [485] = 288,
  [486] = 486,
  [487] = 286,
  [488] = 453,
  [489] = 285,
  [490] = 289,
  [491] = 284,
  [492] = 287,
  [493] = 293,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 496,
  [498] = 495,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 494,
  [503] = 496,
  [504] = 504,
  [505] = 505,
  [506] = 504,
  [507] = 495,
  [508] = 494,
  [509] = 283,
  [510] = 510,
  [511] = 510,
  [512] = 512,
  [513] = 504,
  [514] = 510,
  [515] = 306,
  [516] = 294,
  [517] = 297,
  [518] = 303,
  [519] = 292,
  [520] = 317,
  [521] = 327,
  [522] = 323,
  [523] = 290,
  [524] = 444,
  [525] = 291,
  [526] = 526,
  [527] = 284,
  [528] = 528,
  [529] = 322,
  [530] = 311,
  [531] = 298,
  [532] = 299,
  [533] = 444,
  [534] = 288,
  [535] = 287,
  [536] = 286,
  [537] = 444,
  [538] = 526,
  [539] = 285,
  [540] = 300,
  [541] = 444,
  [542] = 526,
  [543] = 302,
  [544] = 328,
  [545] = 326,
  [546] = 546,
  [547] = 546,
  [548] = 548,
  [549] = 444,
  [550] = 324,
  [551] = 308,
  [552] = 307,
  [553] = 388,
  [554] = 289,
  [555] = 329,
  [556] = 319,
  [557] = 304,
  [558] = 330,
  [559] = 331,
  [560] = 333,
  [561] = 295,
  [562] = 305,
  [563] = 301,
  [564] = 309,
  [565] = 320,
  [566] = 316,
  [567] = 315,
  [568] = 528,
  [569] = 546,
  [570] = 570,
  [571] = 570,
  [572] = 570,
  [573] = 570,
  [574] = 570,
  [575] = 283,
  [576] = 570,
  [577] = 481,
  [578] = 578,
  [579] = 570,
  [580] = 580,
  [581] = 581,
  [582] = 293,
  [583] = 583,
  [584] = 283,
  [585] = 570,
  [586] = 586,
  [587] = 587,
  [588] = 324,
  [589] = 589,
  [590] = 590,
  [591] = 590,
  [592] = 304,
  [593] = 320,
  [594] = 315,
  [595] = 322,
  [596] = 283,
  [597] = 319,
  [598] = 292,
  [599] = 599,
  [600] = 295,
  [601] = 590,
  [602] = 323,
  [603] = 603,
  [604] = 604,
  [605] = 290,
  [606] = 330,
  [607] = 331,
  [608] = 329,
  [609] = 327,
  [610] = 301,
  [611] = 603,
  [612] = 326,
  [613] = 613,
  [614] = 317,
  [615] = 599,
  [616] = 328,
  [617] = 586,
  [618] = 302,
  [619] = 619,
  [620] = 288,
  [621] = 287,
  [622] = 286,
  [623] = 300,
  [624] = 285,
  [625] = 316,
  [626] = 308,
  [627] = 604,
  [628] = 291,
  [629] = 619,
  [630] = 305,
  [631] = 631,
  [632] = 632,
  [633] = 303,
  [634] = 297,
  [635] = 635,
  [636] = 311,
  [637] = 309,
  [638] = 333,
  [639] = 599,
  [640] = 307,
  [641] = 604,
  [642] = 481,
  [643] = 643,
  [644] = 288,
  [645] = 645,
  [646] = 619,
  [647] = 294,
  [648] = 287,
  [649] = 306,
  [650] = 650,
  [651] = 651,
  [652] = 286,
  [653] = 586,
  [654] = 603,
  [655] = 298,
  [656] = 299,
  [657] = 285,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 661,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 667,
  [670] = 670,
  [671] = 388,
  [672] = 664,
  [673] = 673,
  [674] = 659,
  [675] = 658,
  [676] = 667,
  [677] = 666,
  [678] = 678,
  [679] = 679,
  [680] = 664,
  [681] = 658,
  [682] = 661,
  [683] = 673,
  [684] = 666,
  [685] = 685,
  [686] = 660,
  [687] = 687,
  [688] = 659,
  [689] = 667,
  [690] = 662,
  [691] = 512,
  [692] = 658,
  [693] = 693,
  [694] = 662,
  [695] = 661,
  [696] = 666,
  [697] = 658,
  [698] = 388,
  [699] = 659,
  [700] = 700,
  [701] = 667,
  [702] = 658,
  [703] = 664,
  [704] = 704,
  [705] = 667,
  [706] = 666,
  [707] = 679,
  [708] = 659,
  [709] = 709,
  [710] = 660,
  [711] = 661,
  [712] = 664,
  [713] = 673,
  [714] = 664,
  [715] = 659,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 723,
  [731] = 723,
  [732] = 723,
  [733] = 733,
  [734] = 717,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 726,
  [740] = 740,
  [741] = 741,
  [742] = 729,
  [743] = 743,
  [744] = 726,
  [745] = 718,
  [746] = 741,
  [747] = 747,
  [748] = 748,
  [749] = 740,
  [750] = 725,
  [751] = 720,
  [752] = 752,
  [753] = 747,
  [754] = 723,
  [755] = 733,
  [756] = 747,
  [757] = 720,
  [758] = 758,
  [759] = 759,
  [760] = 724,
  [761] = 721,
  [762] = 724,
  [763] = 763,
  [764] = 729,
  [765] = 726,
  [766] = 728,
  [767] = 736,
  [768] = 768,
  [769] = 718,
  [770] = 770,
  [771] = 738,
  [772] = 717,
  [773] = 724,
  [774] = 743,
  [775] = 721,
  [776] = 721,
  [777] = 733,
  [778] = 778,
  [779] = 736,
  [780] = 736,
  [781] = 781,
  [782] = 738,
  [783] = 718,
  [784] = 727,
  [785] = 743,
  [786] = 786,
  [787] = 728,
  [788] = 729,
  [789] = 736,
  [790] = 717,
  [791] = 728,
  [792] = 717,
  [793] = 793,
  [794] = 738,
  [795] = 724,
  [796] = 728,
  [797] = 797,
  [798] = 741,
  [799] = 716,
  [800] = 743,
  [801] = 726,
  [802] = 727,
  [803] = 724,
  [804] = 729,
  [805] = 725,
  [806] = 768,
  [807] = 758,
  [808] = 720,
  [809] = 736,
  [810] = 721,
  [811] = 811,
  [812] = 717,
  [813] = 725,
  [814] = 793,
  [815] = 748,
  [816] = 738,
  [817] = 740,
  [818] = 718,
  [819] = 740,
  [820] = 729,
  [821] = 728,
  [822] = 723,
  [823] = 781,
  [824] = 743,
  [825] = 781,
  [826] = 826,
  [827] = 725,
  [828] = 748,
  [829] = 726,
  [830] = 721,
  [831] = 720,
  [832] = 793,
  [833] = 740,
  [834] = 834,
  [835] = 512,
  [836] = 716,
  [837] = 837,
  [838] = 738,
  [839] = 747,
  [840] = 725,
  [841] = 747,
  [842] = 718,
  [843] = 747,
  [844] = 740,
  [845] = 743,
  [846] = 758,
  [847] = 720,
  [848] = 848,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 852,
  [857] = 853,
  [858] = 851,
  [859] = 850,
  [860] = 853,
  [861] = 850,
  [862] = 852,
  [863] = 851,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 866,
  [868] = 868,
  [869] = 869,
  [870] = 869,
  [871] = 854,
  [872] = 868,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 874,
  [877] = 875,
  [878] = 874,
  [879] = 879,
  [880] = 855,
  [881] = 873,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 889,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 885,
  [918] = 886,
  [919] = 919,
  [920] = 899,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 901,
  [926] = 926,
  [927] = 913,
  [928] = 915,
  [929] = 929,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 947,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 948,
  [961] = 326,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 304,
  [967] = 330,
  [968] = 299,
  [969] = 326,
  [970] = 304,
  [971] = 330,
  [972] = 950,
  [973] = 299,
  [974] = 974,
  [975] = 951,
  [976] = 976,
  [977] = 945,
  [978] = 978,
  [979] = 952,
  [980] = 931,
  [981] = 974,
  [982] = 976,
  [983] = 953,
  [984] = 868,
  [985] = 954,
  [986] = 956,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 957,
  [991] = 958,
  [992] = 959,
  [993] = 962,
  [994] = 994,
  [995] = 933,
  [996] = 989,
  [997] = 963,
  [998] = 964,
  [999] = 946,
  [1000] = 944,
  [1001] = 943,
  [1002] = 1002,
  [1003] = 988,
  [1004] = 942,
  [1005] = 965,
  [1006] = 934,
  [1007] = 935,
  [1008] = 978,
  [1009] = 941,
  [1010] = 987,
  [1011] = 936,
  [1012] = 1012,
  [1013] = 868,
  [1014] = 930,
  [1015] = 940,
  [1016] = 1016,
  [1017] = 939,
  [1018] = 938,
  [1019] = 937,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1022,
  [1025] = 875,
  [1026] = 1026,
  [1027] = 875,
  [1028] = 1023,
  [1029] = 1029,
  [1030] = 1029,
  [1031] = 1022,
  [1032] = 1032,
  [1033] = 1023,
  [1034] = 926,
  [1035] = 897,
  [1036] = 924,
  [1037] = 900,
  [1038] = 907,
  [1039] = 914,
  [1040] = 1040,
  [1041] = 902,
  [1042] = 912,
  [1043] = 893,
  [1044] = 923,
  [1045] = 894,
  [1046] = 898,
  [1047] = 916,
  [1048] = 896,
  [1049] = 929,
  [1050] = 1050,
  [1051] = 1050,
  [1052] = 906,
  [1053] = 904,
  [1054] = 921,
  [1055] = 905,
  [1056] = 908,
  [1057] = 887,
  [1058] = 888,
  [1059] = 910,
  [1060] = 1040,
  [1061] = 922,
  [1062] = 911,
  [1063] = 868,
  [1064] = 1064,
  [1065] = 895,
  [1066] = 919,
  [1067] = 903,
  [1068] = 1068,
  [1069] = 1064,
  [1070] = 868,
  [1071] = 890,
  [1072] = 864,
  [1073] = 865,
  [1074] = 1074,
  [1075] = 875,
  [1076] = 875,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 908,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 887,
  [1090] = 888,
  [1091] = 1091,
  [1092] = 900,
  [1093] = 903,
  [1094] = 890,
  [1095] = 904,
  [1096] = 906,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 895,
  [1101] = 1101,
  [1102] = 907,
  [1103] = 866,
  [1104] = 921,
  [1105] = 910,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 896,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 911,
  [1113] = 912,
  [1114] = 894,
  [1115] = 914,
  [1116] = 893,
  [1117] = 1117,
  [1118] = 869,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 902,
  [1122] = 916,
  [1123] = 905,
  [1124] = 919,
  [1125] = 1125,
  [1126] = 922,
  [1127] = 898,
  [1128] = 923,
  [1129] = 924,
  [1130] = 1101,
  [1131] = 926,
  [1132] = 1109,
  [1133] = 897,
  [1134] = 929,
  [1135] = 1109,
  [1136] = 1136,
  [1137] = 1068,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1068,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1147,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 1156,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1068,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1166,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 873,
  [1187] = 1187,
  [1188] = 1068,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 865,
  [1192] = 1155,
  [1193] = 1157,
  [1194] = 864,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1163,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1164,
  [1203] = 1203,
  [1204] = 1165,
  [1205] = 1200,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1068,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1097,
  [1221] = 1199,
  [1222] = 1222,
  [1223] = 1200,
  [1224] = 1119,
  [1225] = 1225,
  [1226] = 1165,
  [1227] = 1164,
  [1228] = 1199,
  [1229] = 1163,
  [1230] = 1230,
  [1231] = 1110,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1157,
  [1235] = 1155,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1166,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1241,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1206,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1207,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1189,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1245,
  [1270] = 1246,
  [1271] = 1271,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1258,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1247,
  [1280] = 1280,
  [1281] = 1249,
  [1282] = 1282,
  [1283] = 1267,
  [1284] = 1265,
  [1285] = 1257,
  [1286] = 1286,
  [1287] = 1264,
  [1288] = 1263,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 885,
  [1293] = 1255,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1260,
  [1297] = 1263,
  [1298] = 1264,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1289,
  [1302] = 899,
  [1303] = 1267,
  [1304] = 886,
  [1305] = 1260,
  [1306] = 1255,
  [1307] = 1300,
  [1308] = 1265,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1291,
  [1312] = 1258,
  [1313] = 1313,
  [1314] = 1257,
  [1315] = 1315,
  [1316] = 915,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1319,
  [1321] = 1318,
  [1322] = 1322,
  [1323] = 1086,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1329,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1331,
  [1339] = 1319,
  [1340] = 913,
  [1341] = 1331,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1084,
  [1345] = 1117,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1117,
  [1349] = 1084,
  [1350] = 1331,
  [1351] = 1086,
  [1352] = 1319,
  [1353] = 1209,
  [1354] = 1209,
  [1355] = 1347,
  [1356] = 1347,
  [1357] = 1357,
  [1358] = 1357,
  [1359] = 1346,
  [1360] = 1360,
  [1361] = 889,
  [1362] = 978,
  [1363] = 1363,
  [1364] = 1346,
  [1365] = 1347,
  [1366] = 1117,
  [1367] = 1084,
  [1368] = 1331,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 989,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1086,
  [1376] = 1319,
  [1377] = 901,
  [1378] = 1346,
  [1379] = 1379,
  [1380] = 294,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 292,
  [1386] = 915,
  [1387] = 1387,
  [1388] = 1346,
  [1389] = 1347,
  [1390] = 291,
  [1391] = 1117,
  [1392] = 1084,
  [1393] = 1393,
  [1394] = 1331,
  [1395] = 1086,
  [1396] = 1319,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1333,
  [1400] = 1400,
  [1401] = 1383,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 290,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1336,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1334,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1325,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1346,
  [1429] = 1333,
  [1430] = 1357,
  [1431] = 1398,
  [1432] = 1347,
  [1433] = 1117,
  [1434] = 1084,
  [1435] = 1331,
  [1436] = 1436,
  [1437] = 901,
  [1438] = 1438,
  [1439] = 1086,
  [1440] = 1319,
  [1441] = 1398,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1403,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 944,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 915,
  [1457] = 875,
  [1458] = 963,
  [1459] = 1459,
  [1460] = 1280,
  [1461] = 962,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1274,
  [1465] = 1463,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1467,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1278,
  [1472] = 1277,
  [1473] = 1462,
  [1474] = 1276,
  [1475] = 1273,
  [1476] = 959,
  [1477] = 958,
  [1478] = 957,
  [1479] = 865,
  [1480] = 956,
  [1481] = 954,
  [1482] = 1274,
  [1483] = 1273,
  [1484] = 953,
  [1485] = 1462,
  [1486] = 952,
  [1487] = 951,
  [1488] = 950,
  [1489] = 1489,
  [1490] = 1454,
  [1491] = 1272,
  [1492] = 948,
  [1493] = 1276,
  [1494] = 1449,
  [1495] = 1495,
  [1496] = 1451,
  [1497] = 1277,
  [1498] = 1498,
  [1499] = 1278,
  [1500] = 947,
  [1501] = 1501,
  [1502] = 946,
  [1503] = 1503,
  [1504] = 1495,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1501,
  [1508] = 1508,
  [1509] = 1449,
  [1510] = 1282,
  [1511] = 1511,
  [1512] = 1280,
  [1513] = 1513,
  [1514] = 1495,
  [1515] = 1515,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1282,
  [1521] = 943,
  [1522] = 942,
  [1523] = 1519,
  [1524] = 964,
  [1525] = 1519,
  [1526] = 1495,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1513,
  [1530] = 1324,
  [1531] = 941,
  [1532] = 930,
  [1533] = 1511,
  [1534] = 1449,
  [1535] = 864,
  [1536] = 940,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 939,
  [1540] = 1501,
  [1541] = 938,
  [1542] = 1542,
  [1543] = 1326,
  [1544] = 937,
  [1545] = 936,
  [1546] = 935,
  [1547] = 934,
  [1548] = 1335,
  [1549] = 1272,
  [1550] = 933,
  [1551] = 974,
  [1552] = 1449,
  [1553] = 1511,
  [1554] = 1554,
  [1555] = 1511,
  [1556] = 976,
  [1557] = 1449,
  [1558] = 1513,
  [1559] = 1519,
  [1560] = 945,
  [1561] = 1495,
  [1562] = 1495,
  [1563] = 1511,
  [1564] = 1564,
  [1565] = 1363,
  [1566] = 1495,
  [1567] = 931,
  [1568] = 865,
  [1569] = 1569,
  [1570] = 901,
  [1571] = 987,
  [1572] = 1379,
  [1573] = 1400,
  [1574] = 988,
  [1575] = 1402,
  [1576] = 1405,
  [1577] = 1518,
  [1578] = 1513,
  [1579] = 1579,
  [1580] = 965,
  [1581] = 1519,
  [1582] = 1527,
  [1583] = 1408,
  [1584] = 1584,
  [1585] = 1518,
  [1586] = 1527,
  [1587] = 1587,
  [1588] = 1372,
  [1589] = 1513,
  [1590] = 1495,
  [1591] = 1451,
  [1592] = 1449,
  [1593] = 1593,
  [1594] = 1420,
  [1595] = 1421,
  [1596] = 1268,
  [1597] = 1374,
  [1598] = 1422,
  [1599] = 1599,
  [1600] = 1519,
  [1601] = 1601,
  [1602] = 1444,
  [1603] = 1448,
  [1604] = 1445,
  [1605] = 1513,
  [1606] = 1436,
  [1607] = 1449,
  [1608] = 1608,
  [1609] = 1511,
  [1610] = 1418,
  [1611] = 1417,
  [1612] = 1180,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1614,
  [1616] = 1614,
  [1617] = 1617,
  [1618] = 1613,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1614,
  [1625] = 1617,
  [1626] = 1613,
  [1627] = 1627,
  [1628] = 1620,
  [1629] = 1623,
  [1630] = 1630,
  [1631] = 1631,
  [1632] = 1614,
  [1633] = 1633,
  [1634] = 1634,
  [1635] = 1635,
  [1636] = 1617,
  [1637] = 1637,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1640,
  [1641] = 1641,
  [1642] = 1638,
  [1643] = 1621,
  [1644] = 1635,
  [1645] = 1645,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1634,
  [1651] = 1651,
  [1652] = 1614,
  [1653] = 1641,
  [1654] = 1621,
  [1655] = 1655,
  [1656] = 1621,
  [1657] = 1651,
  [1658] = 1658,
  [1659] = 1658,
  [1660] = 1622,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1641,
  [1665] = 1665,
  [1666] = 1646,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 1627,
  [1670] = 1655,
  [1671] = 1630,
  [1672] = 1672,
  [1673] = 1639,
  [1674] = 1641,
  [1675] = 1622,
  [1676] = 1651,
  [1677] = 1621,
  [1678] = 1622,
  [1679] = 1679,
  [1680] = 1641,
  [1681] = 1681,
  [1682] = 1179,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1640,
  [1686] = 1681,
  [1687] = 1622,
  [1688] = 1684,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1649,
  [1692] = 1638,
  [1693] = 1693,
  [1694] = 1638,
  [1695] = 1690,
  [1696] = 1645,
  [1697] = 1697,
  [1698] = 1693,
  [1699] = 1658,
  [1700] = 1651,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1633,
  [1704] = 1651,
  [1705] = 1633,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1623,
  [1709] = 1709,
  [1710] = 1621,
  [1711] = 1649,
  [1712] = 1158,
  [1713] = 1713,
  [1714] = 1622,
  [1715] = 1655,
  [1716] = 1156,
  [1717] = 1631,
  [1718] = 1713,
  [1719] = 1651,
  [1720] = 1707,
  [1721] = 1627,
  [1722] = 1641,
  [1723] = 1630,
  [1724] = 1724,
  [1725] = 1702,
  [1726] = 1627,
  [1727] = 1639,
  [1728] = 1630,
  [1729] = 1630,
  [1730] = 1627,
  [1731] = 1630,
  [1732] = 1638,
  [1733] = 1733,
  [1734] = 1645,
  [1735] = 1637,
  [1736] = 1140,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1627,
  [1741] = 1638,
  [1742] = 1709,
  [1743] = 1637,
  [1744] = 1620,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1751,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1748,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1750,
  [1767] = 1756,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1749,
  [1772] = 1772,
  [1773] = 1757,
  [1774] = 1758,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1750,
  [1778] = 1778,
  [1779] = 1760,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1756,
  [1783] = 1769,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1749,
  [1787] = 1756,
  [1788] = 1788,
  [1789] = 1749,
  [1790] = 1790,
  [1791] = 1757,
  [1792] = 1769,
  [1793] = 1793,
  [1794] = 1785,
  [1795] = 1795,
  [1796] = 1748,
  [1797] = 1748,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1778,
  [1809] = 1747,
  [1810] = 1772,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1812,
  [1814] = 1814,
  [1815] = 1776,
  [1816] = 1816,
  [1817] = 1756,
  [1818] = 1769,
  [1819] = 1819,
  [1820] = 1811,
  [1821] = 1749,
  [1822] = 1754,
  [1823] = 1768,
  [1824] = 1824,
  [1825] = 1751,
  [1826] = 1826,
  [1827] = 1801,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1798,
  [1831] = 1746,
  [1832] = 1804,
  [1833] = 1763,
  [1834] = 1834,
  [1835] = 1745,
  [1836] = 1804,
  [1837] = 1805,
  [1838] = 1807,
  [1839] = 1778,
  [1840] = 1765,
  [1841] = 1811,
  [1842] = 1812,
  [1843] = 1843,
  [1844] = 1756,
  [1845] = 1769,
  [1846] = 1765,
  [1847] = 1847,
  [1848] = 1785,
  [1849] = 1772,
  [1850] = 1807,
  [1851] = 1851,
  [1852] = 1752,
  [1853] = 1853,
  [1854] = 1763,
  [1855] = 1855,
  [1856] = 1814,
  [1857] = 1745,
  [1858] = 1858,
  [1859] = 1746,
  [1860] = 1860,
  [1861] = 1798,
  [1862] = 1862,
  [1863] = 1805,
  [1864] = 1748,
  [1865] = 1865,
  [1866] = 1866,
  [1867] = 1860,
  [1868] = 1868,
  [1869] = 1776,
  [1870] = 1748,
  [1871] = 1868,
  [1872] = 1749,
  [1873] = 1873,
  [1874] = 1754,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1801,
  [1878] = 1851,
  [1879] = 1875,
  [1880] = 1873,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1819,
  [1884] = 1799,
  [1885] = 1885,
  [1886] = 1853,
  [1887] = 1756,
  [1888] = 1780,
  [1889] = 1770,
  [1890] = 1769,
  [1891] = 1860,
  [1892] = 1851,
  [1893] = 1875,
  [1894] = 1873,
  [1895] = 1895,
  [1896] = 1896,
  [1897] = 1799,
  [1898] = 1898,
  [1899] = 1853,
  [1900] = 1759,
  [1901] = 1780,
  [1902] = 1770,
  [1903] = 1760,
  [1904] = 1759,
  [1905] = 1752,
  [1906] = 1829,
  [1907] = 1814,
  [1908] = 1868,
  [1909] = 1868,
  [1910] = 1868,
  [1911] = 1868,
};

static inline bool sym_rune_literal_character_set_1(int32_t c) {
  return (c < 'f'
    ? (c < '\\'
      ? (c < '\''
        ? c == '"'
        : c <= '\'')
      : (c <= '\\' || (c >= 'a' && c <= 'b')))
    : (c <= 'f' || (c < 't'
      ? (c < 'r'
        ? c == 'n'
        : c <= 'r')
      : (c <= 't' || c == 'v'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(82);
      if (!eof && lookahead == 0) ADVANCE(85);
      if (lookahead == '!') ADVANCE(135);
      if (lookahead == '"') ADVANCE(222);
      if (lookahead == '%') ADVANCE(145);
      if (lookahead == '&') ADVANCE(139);
      if (lookahead == '\'') ADVANCE(277);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(143);
      if (lookahead == '0') ADVANCE(208);
      if (lookahead == ':') ADVANCE(124);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == '\\') ADVANCE(40);
      if (lookahead == ']') ADVANCE(94);
      if (lookahead == '^') ADVANCE(137);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead == 'c') ADVANCE(192);
      if (lookahead == 'e') ADVANCE(195);
      if (lookahead == 'i') ADVANCE(190);
      if (lookahead == 's') ADVANCE(183);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(106);
      if (lookahead == '~') ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(175);
      if (('A' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 1:
      if (!eof && lookahead == 0) ADVANCE(85);
      if (lookahead == '\n') ADVANCE(83);
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '%') ADVANCE(145);
      if (lookahead == '&') ADVANCE(139);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(38);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == '^') ADVANCE(137);
      if (lookahead == 'e') ADVANCE(198);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(106);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 2:
      if (!eof && lookahead == 0) ADVANCE(85);
      if (lookahead == '\n') ADVANCE(83);
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '%') ADVANCE(144);
      if (lookahead == '&') ADVANCE(140);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(160);
      if (lookahead == '=') ADVANCE(39);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == '^') ADVANCE(136);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '}') ADVANCE(106);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(32)
      if (lookahead == '"') ADVANCE(222);
      if (lookahead == '/') ADVANCE(223);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(226);
      if (lookahead != 0) ADVANCE(227);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(134);
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '\'') ADVANCE(41);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(22);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == ':') ADVANCE(123);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(21);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == ']') ADVANCE(94);
      if (lookahead == '^') ADVANCE(136);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '}') ADVANCE(106);
      if (lookahead == '~') ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(170);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(134);
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '\'') ADVANCE(41);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(21);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == '^') ADVANCE(136);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '}') ADVANCE(106);
      if (lookahead == '~') ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(170);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(134);
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '\'') ADVANCE(41);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == '<') ADVANCE(21);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == '^') ADVANCE(136);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead == 'c') ADVANCE(192);
      if (lookahead == '}') ADVANCE(106);
      if (lookahead == '~') ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(170);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '%') ADVANCE(144);
      if (lookahead == '&') ADVANCE(140);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == ':') ADVANCE(124);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(158);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == ']') ADVANCE(94);
      if (lookahead == '^') ADVANCE(136);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '}') ADVANCE(106);
      if (lookahead == '~') ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '%') ADVANCE(145);
      if (lookahead == '&') ADVANCE(139);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(38);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == '^') ADVANCE(137);
      if (lookahead == 'i') ADVANCE(46);
      if (lookahead == 's') ADVANCE(43);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(99);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8)
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '%') ADVANCE(145);
      if (lookahead == '&') ADVANCE(139);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(133);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(38);
      if (lookahead == '<') ADVANCE(159);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == '^') ADVANCE(137);
      if (lookahead == 'e') ADVANCE(198);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(106);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '%') ADVANCE(144);
      if (lookahead == '&') ADVANCE(140);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == ':') ADVANCE(124);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(160);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == ']') ADVANCE(94);
      if (lookahead == '^') ADVANCE(136);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(100);
      if (lookahead == '}') ADVANCE(106);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '\'') ADVANCE(277);
      if (lookahead == '/') ADVANCE(273);
      if (lookahead == '{') ADVANCE(105);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11)
      if (lookahead != 0 &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(276);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '/') ADVANCE(285);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(286);
      if (lookahead != 0) ADVANCE(287);
      END_STATE();
    case 13:
      if (lookahead == '\'') ADVANCE(277);
      if (lookahead == '/') ADVANCE(280);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(281);
      if (lookahead != 0) ADVANCE(282);
      END_STATE();
    case 14:
      if (lookahead == '\'') ADVANCE(235);
      END_STATE();
    case 15:
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '<') ADVANCE(154);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '}') ADVANCE(106);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 16:
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '{') ADVANCE(103);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(16)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(241);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(241);
      if (lookahead == '>') ADVANCE(248);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(236);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '-') ADVANCE(108);
      END_STATE();
    case 22:
      if (lookahead == '.') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 23:
      if (lookahead == '.') ADVANCE(95);
      END_STATE();
    case 24:
      if (lookahead == '.') ADVANCE(246);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(24);
      END_STATE();
    case 26:
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '<') ADVANCE(154);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == 'e') ADVANCE(198);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '}') ADVANCE(106);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 27:
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == 'e') ADVANCE(198);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '{') ADVANCE(103);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 28:
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '=') ADVANCE(91);
      if (lookahead == '{') ADVANCE(104);
      if (lookahead == '}') ADVANCE(107);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(272);
      END_STATE();
    case 29:
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == 'i') ADVANCE(45);
      if (lookahead == '{') ADVANCE(102);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(29)
      END_STATE();
    case 30:
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == 's') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30)
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 31:
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '}') ADVANCE(106);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(31)
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(255);
      END_STATE();
    case 32:
      if (lookahead == '/') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(32)
      END_STATE();
    case 33:
      if (lookahead == '/') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33)
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 34:
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '=') ADVANCE(91);
      if (lookahead == '>') ADVANCE(162);
      if (lookahead == 'i') ADVANCE(269);
      if (lookahead == '{') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '<') ADVANCE(272);
      END_STATE();
    case 35:
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '=') ADVANCE(91);
      if (lookahead == '>') ADVANCE(162);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '<') ADVANCE(272);
      END_STATE();
    case 36:
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '>') ADVANCE(162);
      if (lookahead == 'e') ADVANCE(270);
      if (lookahead == 'i') ADVANCE(269);
      if (lookahead == '{') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '<' &&
          lookahead != '=') ADVANCE(272);
      END_STATE();
    case 37:
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 38:
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 39:
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 40:
      if (lookahead == 'U') ADVANCE(76);
      if (lookahead == 'u') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(230);
      if (lookahead != 0) ADVANCE(228);
      END_STATE();
    case 41:
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(14);
      END_STATE();
    case 42:
      if (lookahead == '`') ADVANCE(220);
      if (lookahead != 0) ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == 'c') ADVANCE(50);
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(250);
      END_STATE();
    case 45:
      if (lookahead == 'f') ADVANCE(253);
      END_STATE();
    case 46:
      if (lookahead == 'f') ADVANCE(125);
      END_STATE();
    case 47:
      if (lookahead == 'i') ADVANCE(49);
      END_STATE();
    case 48:
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 49:
      if (lookahead == 'p') ADVANCE(51);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 52:
      if (lookahead == 'y') ADVANCE(48);
      END_STATE();
    case 53:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(231);
      END_STATE();
    case 54:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(53);
      if (lookahead == '_') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 55:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(14);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(56);
      END_STATE();
    case 58:
      if (sym_rune_literal_character_set_1(lookahead)) ADVANCE(14);
      if (lookahead == 'U') ADVANCE(77);
      if (lookahead == 'u') ADVANCE(69);
      if (lookahead == 'x') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(57);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(231);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(228);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(14);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(70);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(71);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(72);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 78:
      if (eof) ADVANCE(82);
      if (!eof && lookahead == 0) ADVANCE(85);
      if (lookahead == '\n') ADVANCE(83);
      if (lookahead == '!') ADVANCE(134);
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '\'') ADVANCE(41);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(21);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == '^') ADVANCE(136);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(98);
      if (lookahead == '}') ADVANCE(106);
      if (lookahead == '~') ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(78)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(170);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 79:
      if (eof) ADVANCE(82);
      if (!eof && lookahead == 0) ADVANCE(85);
      if (lookahead == '\n') ADVANCE(83);
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '%') ADVANCE(145);
      if (lookahead == '&') ADVANCE(139);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(124);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == '^') ADVANCE(137);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(106);
      if (lookahead == '~') ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(79)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 80:
      if (eof) ADVANCE(82);
      if (!eof && lookahead == 0) ADVANCE(85);
      if (lookahead == '!') ADVANCE(135);
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '%') ADVANCE(145);
      if (lookahead == '&') ADVANCE(139);
      if (lookahead == '\'') ADVANCE(277);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(143);
      if (lookahead == '0') ADVANCE(208);
      if (lookahead == ':') ADVANCE(124);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(163);
      if (lookahead == '@') ADVANCE(244);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == ']') ADVANCE(94);
      if (lookahead == '^') ADVANCE(137);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead == 'c') ADVANCE(192);
      if (lookahead == 'e') ADVANCE(195);
      if (lookahead == 'i') ADVANCE(190);
      if (lookahead == 's') ADVANCE(183);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(106);
      if (lookahead == '~') ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(175);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 81:
      if (eof) ADVANCE(82);
      if (lookahead == '!') ADVANCE(134);
      if (lookahead == '"') ADVANCE(221);
      if (lookahead == '&') ADVANCE(138);
      if (lookahead == '\'') ADVANCE(41);
      if (lookahead == '(') ADVANCE(88);
      if (lookahead == ')') ADVANCE(89);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(90);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == ':') ADVANCE(123);
      if (lookahead == ';') ADVANCE(84);
      if (lookahead == '<') ADVANCE(21);
      if (lookahead == '=') ADVANCE(91);
      if (lookahead == '[') ADVANCE(93);
      if (lookahead == ']') ADVANCE(94);
      if (lookahead == '^') ADVANCE(136);
      if (lookahead == '`') ADVANCE(42);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == 's') ADVANCE(184);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(98);
      if (lookahead == '~') ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(81)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(170);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(23);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '|') ADVANCE(167);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(167);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '!') ADVANCE(245);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '/' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(272);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(276);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '/' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(272);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AMP_CARET_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(110);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(166);
      if (lookahead == '=') ADVANCE(117);
      if (lookahead == '^') ADVANCE(151);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(166);
      if (lookahead == '^') ADVANCE(150);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(241);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(241);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(241);
      if (lookahead == '=') ADVANCE(113);
      if (lookahead == '>') ADVANCE(248);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(249);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(249);
      if (lookahead == '-') ADVANCE(108);
      if (lookahead == '/') ADVANCE(247);
      if (lookahead == '<') ADVANCE(147);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(249);
      if (lookahead == '/') ADVANCE(247);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(108);
      if (lookahead == '<') ADVANCE(147);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(108);
      if (lookahead == '<') ADVANCE(146);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(147);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(146);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(165);
      if (lookahead == '>') ADVANCE(149);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(165);
      if (lookahead == '>') ADVANCE(148);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(233);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(181);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(207);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(179);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(173);
      if (lookahead == '_') ADVANCE(211);
      if (lookahead == 'i') ADVANCE(219);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(169);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(233);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(207);
      if (lookahead == '_') ADVANCE(211);
      if (lookahead == 'i') ADVANCE(219);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(169);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(233);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(207);
      if (lookahead == '_') ADVANCE(215);
      if (lookahead == 'i') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(170);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(55);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(207);
      if (lookahead == '_') ADVANCE(218);
      if (lookahead == 'i') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(171);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '_') ADVANCE(218);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(171);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(212);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(174);
      if (lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(175);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(209);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(176);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(217);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(177);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(213);
      if (lookahead == 'i') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      if (lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(213);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      if (lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(210);
      if (lookahead == 'i') ADVANCE(219);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(180);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(210);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(180);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(216);
      if (lookahead == 'i') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(201);
      if (lookahead == 't') ADVANCE(206);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(252);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(253);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(194);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(200);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(204);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(205);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(193);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(189);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(258);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(176);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(174);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(177);
      if (lookahead == '_') ADVANCE(212);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(174);
      if (lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(176);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(180);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(169);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(174);
      if (lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      if (lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(175);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(170);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(177);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(171);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_raw_string_literal);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(225);
      if (lookahead == '/') ADVANCE(227);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(227);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(224);
      if (lookahead == '/') ADVANCE(227);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(225);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(224);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(225);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '/') ADVANCE(223);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(227);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(227);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(228);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(229);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(60);
      if (lookahead == 'i') ADVANCE(234);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(231);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(53);
      if (lookahead == '_') ADVANCE(59);
      if (lookahead == 'i') ADVANCE(234);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(53);
      if (lookahead == 'i') ADVANCE(234);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_imaginary_literal);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_rune_literal);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(282);
      if (lookahead == '\'') ADVANCE(241);
      if (lookahead != 0) ADVANCE(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(287);
      if (lookahead == '"') ADVANCE(241);
      if (lookahead != 0) ADVANCE(238);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          lookahead == '\'' ||
          ('<' <= lookahead && lookahead <= '>')) ADVANCE(241);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(239);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(276);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(241);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(287);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(282);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_LBRACE_BANG);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_children_DOT_DOT_DOT);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_LT_SLASH);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_SLASH_GT);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_LT_BANG);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_style);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_style);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_style);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_if2);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_else2);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_css_property_name);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(255);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_script);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_script);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_script);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(219);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_element_identifier);
      if (lookahead == 'c') ADVANCE(264);
      if (lookahead == 't') ADVANCE(266);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_element_identifier);
      if (lookahead == 'e') ADVANCE(251);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_element_identifier);
      if (lookahead == 'i') ADVANCE(263);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_element_identifier);
      if (lookahead == 'l') ADVANCE(260);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_element_identifier);
      if (lookahead == 'p') ADVANCE(265);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_element_identifier);
      if (lookahead == 'r') ADVANCE(261);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_element_identifier);
      if (lookahead == 't') ADVANCE(257);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_element_identifier);
      if (lookahead == 'y') ADVANCE(262);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_element_identifier);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_attribute_name);
      if (lookahead == 'e') ADVANCE(254);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '/' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(272);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_attribute_name);
      if (lookahead == 'f') ADVANCE(253);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '/' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(272);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_attribute_name);
      if (lookahead == 'l') ADVANCE(271);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '/' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(272);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_attribute_name);
      if (lookahead == 's') ADVANCE(268);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '/' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(272);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_attribute_name);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          lookahead != '/' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(272);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_attribute_value);
      if (lookahead == '*') ADVANCE(275);
      if (lookahead == '/') ADVANCE(239);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(276);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_attribute_value);
      if (lookahead == '*') ADVANCE(274);
      if (lookahead == '/') ADVANCE(240);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          lookahead == '\'' ||
          ('<' <= lookahead && lookahead <= '>')) ADVANCE(20);
      if (lookahead != 0) ADVANCE(275);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_attribute_value);
      if (lookahead == '*') ADVANCE(274);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == '"' ||
          lookahead == '\'' ||
          ('<' <= lookahead && lookahead <= '>')) ADVANCE(20);
      if (lookahead != 0) ADVANCE(275);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_attribute_value);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          (lookahead < '<' || '>' < lookahead)) ADVANCE(276);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead == '\'') ADVANCE(20);
      if (lookahead == '*') ADVANCE(278);
      if (lookahead == '/') ADVANCE(243);
      if (lookahead != 0) ADVANCE(279);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead == '\'') ADVANCE(20);
      if (lookahead == '*') ADVANCE(278);
      if (lookahead != 0) ADVANCE(279);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead == '*') ADVANCE(279);
      if (lookahead == '/') ADVANCE(237);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(282);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead == '/') ADVANCE(280);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(281);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(282);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token1);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(282);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead == '"') ADVANCE(20);
      if (lookahead == '*') ADVANCE(283);
      if (lookahead == '/') ADVANCE(242);
      if (lookahead != 0) ADVANCE(284);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead == '"') ADVANCE(20);
      if (lookahead == '*') ADVANCE(283);
      if (lookahead != 0) ADVANCE(284);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead == '*') ADVANCE(284);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(287);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead == '/') ADVANCE(285);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(286);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(287);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym_quoted_attribute_value_token2);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(287);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'f') ADVANCE(5);
      if (lookahead == 'g') ADVANCE(6);
      if (lookahead == 'h') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'v') ADVANCE(15);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      ACCEPT_TOKEN(sym_blank_identifier);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(16);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(17);
      if (lookahead == 'h') ADVANCE(18);
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 's') ADVANCE(20);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(21);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      if (lookahead == 'u') ADVANCE(24);
      END_STATE();
    case 6:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 7:
      if (lookahead == 't') ADVANCE(26);
      END_STATE();
    case 8:
      if (lookahead == 'm') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(30);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'i') ADVANCE(32);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(33);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(36);
      if (lookahead == 't') ADVANCE(37);
      if (lookahead == 'w') ADVANCE(38);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(39);
      if (lookahead == 'r') ADVANCE(40);
      if (lookahead == 'y') ADVANCE(41);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(42);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(43);
      END_STATE();
    case 17:
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(46);
      END_STATE();
    case 20:
      if (lookahead == 's') ADVANCE(47);
      END_STATE();
    case 21:
      if (lookahead == 'f') ADVANCE(48);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(49);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(50);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_go);
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 26:
      if (lookahead == 'm') ADVANCE(53);
      END_STATE();
    case 27:
      if (lookahead == 'p') ADVANCE(54);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(55);
      END_STATE();
    case 29:
      if (lookahead == 't') ADVANCE(56);
      END_STATE();
    case 30:
      if (lookahead == 'k') ADVANCE(57);
      if (lookahead == 'p') ADVANCE(58);
      END_STATE();
    case 31:
      if (lookahead == 'w') ADVANCE(59);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(60);
      END_STATE();
    case 33:
      if (lookahead == 'c') ADVANCE(61);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(62);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(64);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(65);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(66);
      END_STATE();
    case 39:
      if (lookahead == 'm') ADVANCE(67);
      END_STATE();
    case 40:
      if (lookahead == 'u') ADVANCE(68);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(69);
      END_STATE();
    case 42:
      if (lookahead == 'r') ADVANCE(70);
      END_STATE();
    case 43:
      if (lookahead == 'a') ADVANCE(71);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 45:
      if (lookahead == 'n') ADVANCE(73);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(74);
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_css);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(76);
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 49:
      if (lookahead == 'l') ADVANCE(78);
      if (lookahead == 's') ADVANCE(79);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 51:
      if (lookahead == 'c') ADVANCE(80);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(81);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(82);
      END_STATE();
    case 54:
      if (lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(85);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(86);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_map);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_nil);
      END_STATE();
    case 61:
      if (lookahead == 'k') ADVANCE(87);
      END_STATE();
    case 62:
      if (lookahead == 'g') ADVANCE(88);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(89);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 65:
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 66:
      if (lookahead == 't') ADVANCE(92);
      END_STATE();
    case 67:
      if (lookahead == 'p') ADVANCE(93);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 71:
      if (lookahead == 'k') ADVANCE(96);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_chan);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(98);
      END_STATE();
    case 76:
      if (lookahead == 'u') ADVANCE(99);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(100);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_func);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_html);
      END_STATE();
    case 83:
      if (lookahead == 'r') ADVANCE(103);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(104);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_iota);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_make);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(105);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 89:
      if (lookahead == 'r') ADVANCE(107);
      END_STATE();
    case 90:
      if (lookahead == 'c') ADVANCE(108);
      END_STATE();
    case 91:
      if (lookahead == 'c') ADVANCE(109);
      END_STATE();
    case 92:
      if (lookahead == 'c') ADVANCE(110);
      END_STATE();
    case 93:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 98:
      if (lookahead == 'n') ADVANCE(112);
      END_STATE();
    case 99:
      if (lookahead == 'l') ADVANCE(113);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 101:
      if (lookahead == 'h') ADVANCE(114);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 103:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 104:
      if (lookahead == 'f') ADVANCE(116);
      END_STATE();
    case 105:
      if (lookahead == 'g') ADVANCE(117);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_range);
      END_STATE();
    case 107:
      if (lookahead == 'n') ADVANCE(118);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 109:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 110:
      if (lookahead == 'h') ADVANCE(121);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_templ);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(122);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 114:
      if (lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(125);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 124:
      if (lookahead == 'o') ADVANCE(128);
      END_STATE();
    case 125:
      if (lookahead == 'c') ADVANCE(129);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 128:
      if (lookahead == 'u') ADVANCE(130);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 130:
      if (lookahead == 'g') ADVANCE(132);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 132:
      if (lookahead == 'h') ADVANCE(133);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_fallthrough);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 81},
  [2] = {.lex_state = 81},
  [3] = {.lex_state = 81},
  [4] = {.lex_state = 5},
  [5] = {.lex_state = 5},
  [6] = {.lex_state = 5},
  [7] = {.lex_state = 5},
  [8] = {.lex_state = 5},
  [9] = {.lex_state = 5},
  [10] = {.lex_state = 5},
  [11] = {.lex_state = 5},
  [12] = {.lex_state = 5},
  [13] = {.lex_state = 5},
  [14] = {.lex_state = 5},
  [15] = {.lex_state = 5},
  [16] = {.lex_state = 5},
  [17] = {.lex_state = 5},
  [18] = {.lex_state = 5},
  [19] = {.lex_state = 5},
  [20] = {.lex_state = 5},
  [21] = {.lex_state = 4},
  [22] = {.lex_state = 4},
  [23] = {.lex_state = 4},
  [24] = {.lex_state = 4},
  [25] = {.lex_state = 4},
  [26] = {.lex_state = 4},
  [27] = {.lex_state = 4},
  [28] = {.lex_state = 4},
  [29] = {.lex_state = 4},
  [30] = {.lex_state = 4},
  [31] = {.lex_state = 4},
  [32] = {.lex_state = 4},
  [33] = {.lex_state = 4},
  [34] = {.lex_state = 4},
  [35] = {.lex_state = 4},
  [36] = {.lex_state = 4},
  [37] = {.lex_state = 4},
  [38] = {.lex_state = 78},
  [39] = {.lex_state = 4},
  [40] = {.lex_state = 4},
  [41] = {.lex_state = 4},
  [42] = {.lex_state = 4},
  [43] = {.lex_state = 4},
  [44] = {.lex_state = 4},
  [45] = {.lex_state = 4},
  [46] = {.lex_state = 4},
  [47] = {.lex_state = 4},
  [48] = {.lex_state = 4},
  [49] = {.lex_state = 4},
  [50] = {.lex_state = 4},
  [51] = {.lex_state = 4},
  [52] = {.lex_state = 4},
  [53] = {.lex_state = 4},
  [54] = {.lex_state = 4},
  [55] = {.lex_state = 4},
  [56] = {.lex_state = 4},
  [57] = {.lex_state = 4},
  [58] = {.lex_state = 4},
  [59] = {.lex_state = 4},
  [60] = {.lex_state = 4},
  [61] = {.lex_state = 4},
  [62] = {.lex_state = 6},
  [63] = {.lex_state = 4},
  [64] = {.lex_state = 4},
  [65] = {.lex_state = 4},
  [66] = {.lex_state = 4},
  [67] = {.lex_state = 4},
  [68] = {.lex_state = 4},
  [69] = {.lex_state = 4},
  [70] = {.lex_state = 4},
  [71] = {.lex_state = 4},
  [72] = {.lex_state = 4},
  [73] = {.lex_state = 4},
  [74] = {.lex_state = 4},
  [75] = {.lex_state = 4},
  [76] = {.lex_state = 4},
  [77] = {.lex_state = 4},
  [78] = {.lex_state = 4},
  [79] = {.lex_state = 4},
  [80] = {.lex_state = 6},
  [81] = {.lex_state = 4},
  [82] = {.lex_state = 4},
  [83] = {.lex_state = 4},
  [84] = {.lex_state = 4},
  [85] = {.lex_state = 4},
  [86] = {.lex_state = 4},
  [87] = {.lex_state = 4},
  [88] = {.lex_state = 4},
  [89] = {.lex_state = 4},
  [90] = {.lex_state = 6},
  [91] = {.lex_state = 4},
  [92] = {.lex_state = 4},
  [93] = {.lex_state = 4},
  [94] = {.lex_state = 4},
  [95] = {.lex_state = 4},
  [96] = {.lex_state = 4},
  [97] = {.lex_state = 4},
  [98] = {.lex_state = 4},
  [99] = {.lex_state = 4},
  [100] = {.lex_state = 4},
  [101] = {.lex_state = 4},
  [102] = {.lex_state = 4},
  [103] = {.lex_state = 4},
  [104] = {.lex_state = 4},
  [105] = {.lex_state = 4},
  [106] = {.lex_state = 4},
  [107] = {.lex_state = 4},
  [108] = {.lex_state = 4},
  [109] = {.lex_state = 4},
  [110] = {.lex_state = 4},
  [111] = {.lex_state = 4},
  [112] = {.lex_state = 4},
  [113] = {.lex_state = 4},
  [114] = {.lex_state = 4},
  [115] = {.lex_state = 4},
  [116] = {.lex_state = 4},
  [117] = {.lex_state = 4},
  [118] = {.lex_state = 4},
  [119] = {.lex_state = 4},
  [120] = {.lex_state = 4},
  [121] = {.lex_state = 4},
  [122] = {.lex_state = 4},
  [123] = {.lex_state = 4},
  [124] = {.lex_state = 4},
  [125] = {.lex_state = 4},
  [126] = {.lex_state = 4},
  [127] = {.lex_state = 4},
  [128] = {.lex_state = 4},
  [129] = {.lex_state = 4},
  [130] = {.lex_state = 4},
  [131] = {.lex_state = 4},
  [132] = {.lex_state = 4},
  [133] = {.lex_state = 4},
  [134] = {.lex_state = 4},
  [135] = {.lex_state = 4},
  [136] = {.lex_state = 4},
  [137] = {.lex_state = 4},
  [138] = {.lex_state = 4},
  [139] = {.lex_state = 4},
  [140] = {.lex_state = 4},
  [141] = {.lex_state = 4},
  [142] = {.lex_state = 4},
  [143] = {.lex_state = 4},
  [144] = {.lex_state = 4},
  [145] = {.lex_state = 4},
  [146] = {.lex_state = 4},
  [147] = {.lex_state = 4},
  [148] = {.lex_state = 4},
  [149] = {.lex_state = 4},
  [150] = {.lex_state = 4},
  [151] = {.lex_state = 4},
  [152] = {.lex_state = 4},
  [153] = {.lex_state = 4},
  [154] = {.lex_state = 4},
  [155] = {.lex_state = 4},
  [156] = {.lex_state = 4},
  [157] = {.lex_state = 4},
  [158] = {.lex_state = 4},
  [159] = {.lex_state = 4},
  [160] = {.lex_state = 4},
  [161] = {.lex_state = 4},
  [162] = {.lex_state = 4},
  [163] = {.lex_state = 4},
  [164] = {.lex_state = 4},
  [165] = {.lex_state = 4},
  [166] = {.lex_state = 4},
  [167] = {.lex_state = 4},
  [168] = {.lex_state = 4},
  [169] = {.lex_state = 4},
  [170] = {.lex_state = 4},
  [171] = {.lex_state = 4},
  [172] = {.lex_state = 4},
  [173] = {.lex_state = 4},
  [174] = {.lex_state = 4},
  [175] = {.lex_state = 4},
  [176] = {.lex_state = 4},
  [177] = {.lex_state = 4},
  [178] = {.lex_state = 4},
  [179] = {.lex_state = 4},
  [180] = {.lex_state = 4},
  [181] = {.lex_state = 4},
  [182] = {.lex_state = 4},
  [183] = {.lex_state = 4},
  [184] = {.lex_state = 4},
  [185] = {.lex_state = 4},
  [186] = {.lex_state = 4},
  [187] = {.lex_state = 4},
  [188] = {.lex_state = 4},
  [189] = {.lex_state = 4},
  [190] = {.lex_state = 4},
  [191] = {.lex_state = 4},
  [192] = {.lex_state = 4},
  [193] = {.lex_state = 4},
  [194] = {.lex_state = 4},
  [195] = {.lex_state = 4},
  [196] = {.lex_state = 4},
  [197] = {.lex_state = 4},
  [198] = {.lex_state = 4},
  [199] = {.lex_state = 4},
  [200] = {.lex_state = 4},
  [201] = {.lex_state = 4},
  [202] = {.lex_state = 4},
  [203] = {.lex_state = 4},
  [204] = {.lex_state = 4},
  [205] = {.lex_state = 4},
  [206] = {.lex_state = 4},
  [207] = {.lex_state = 4},
  [208] = {.lex_state = 4},
  [209] = {.lex_state = 4},
  [210] = {.lex_state = 4},
  [211] = {.lex_state = 4},
  [212] = {.lex_state = 4},
  [213] = {.lex_state = 4},
  [214] = {.lex_state = 4},
  [215] = {.lex_state = 4},
  [216] = {.lex_state = 4},
  [217] = {.lex_state = 4},
  [218] = {.lex_state = 4},
  [219] = {.lex_state = 4},
  [220] = {.lex_state = 4},
  [221] = {.lex_state = 4},
  [222] = {.lex_state = 4},
  [223] = {.lex_state = 4},
  [224] = {.lex_state = 4},
  [225] = {.lex_state = 4},
  [226] = {.lex_state = 4},
  [227] = {.lex_state = 4},
  [228] = {.lex_state = 4},
  [229] = {.lex_state = 4},
  [230] = {.lex_state = 4},
  [231] = {.lex_state = 4},
  [232] = {.lex_state = 4},
  [233] = {.lex_state = 4},
  [234] = {.lex_state = 4},
  [235] = {.lex_state = 4},
  [236] = {.lex_state = 4},
  [237] = {.lex_state = 4},
  [238] = {.lex_state = 4},
  [239] = {.lex_state = 4},
  [240] = {.lex_state = 4},
  [241] = {.lex_state = 4},
  [242] = {.lex_state = 4},
  [243] = {.lex_state = 4},
  [244] = {.lex_state = 4},
  [245] = {.lex_state = 4},
  [246] = {.lex_state = 4},
  [247] = {.lex_state = 4},
  [248] = {.lex_state = 4},
  [249] = {.lex_state = 4},
  [250] = {.lex_state = 4},
  [251] = {.lex_state = 4},
  [252] = {.lex_state = 4},
  [253] = {.lex_state = 4},
  [254] = {.lex_state = 4},
  [255] = {.lex_state = 4},
  [256] = {.lex_state = 4},
  [257] = {.lex_state = 4},
  [258] = {.lex_state = 4},
  [259] = {.lex_state = 4},
  [260] = {.lex_state = 4},
  [261] = {.lex_state = 4},
  [262] = {.lex_state = 4},
  [263] = {.lex_state = 4},
  [264] = {.lex_state = 4},
  [265] = {.lex_state = 4},
  [266] = {.lex_state = 4},
  [267] = {.lex_state = 4},
  [268] = {.lex_state = 4},
  [269] = {.lex_state = 4},
  [270] = {.lex_state = 4},
  [271] = {.lex_state = 4},
  [272] = {.lex_state = 4},
  [273] = {.lex_state = 4},
  [274] = {.lex_state = 4},
  [275] = {.lex_state = 4},
  [276] = {.lex_state = 4},
  [277] = {.lex_state = 4},
  [278] = {.lex_state = 81},
  [279] = {.lex_state = 7},
  [280] = {.lex_state = 79},
  [281] = {.lex_state = 79},
  [282] = {.lex_state = 79},
  [283] = {.lex_state = 79},
  [284] = {.lex_state = 79},
  [285] = {.lex_state = 79},
  [286] = {.lex_state = 79},
  [287] = {.lex_state = 79},
  [288] = {.lex_state = 79},
  [289] = {.lex_state = 79},
  [290] = {.lex_state = 79},
  [291] = {.lex_state = 79},
  [292] = {.lex_state = 1},
  [293] = {.lex_state = 79},
  [294] = {.lex_state = 1},
  [295] = {.lex_state = 79},
  [296] = {.lex_state = 8},
  [297] = {.lex_state = 79},
  [298] = {.lex_state = 79},
  [299] = {.lex_state = 79},
  [300] = {.lex_state = 79},
  [301] = {.lex_state = 79},
  [302] = {.lex_state = 79},
  [303] = {.lex_state = 79},
  [304] = {.lex_state = 79},
  [305] = {.lex_state = 79},
  [306] = {.lex_state = 79},
  [307] = {.lex_state = 79},
  [308] = {.lex_state = 79},
  [309] = {.lex_state = 79},
  [310] = {.lex_state = 8},
  [311] = {.lex_state = 79},
  [312] = {.lex_state = 8},
  [313] = {.lex_state = 8},
  [314] = {.lex_state = 8},
  [315] = {.lex_state = 79},
  [316] = {.lex_state = 79},
  [317] = {.lex_state = 79},
  [318] = {.lex_state = 8},
  [319] = {.lex_state = 79},
  [320] = {.lex_state = 79},
  [321] = {.lex_state = 8},
  [322] = {.lex_state = 79},
  [323] = {.lex_state = 79},
  [324] = {.lex_state = 79},
  [325] = {.lex_state = 8},
  [326] = {.lex_state = 79},
  [327] = {.lex_state = 79},
  [328] = {.lex_state = 79},
  [329] = {.lex_state = 79},
  [330] = {.lex_state = 79},
  [331] = {.lex_state = 79},
  [332] = {.lex_state = 8},
  [333] = {.lex_state = 79},
  [334] = {.lex_state = 8},
  [335] = {.lex_state = 8},
  [336] = {.lex_state = 8},
  [337] = {.lex_state = 8},
  [338] = {.lex_state = 8},
  [339] = {.lex_state = 8},
  [340] = {.lex_state = 8},
  [341] = {.lex_state = 8},
  [342] = {.lex_state = 8},
  [343] = {.lex_state = 8},
  [344] = {.lex_state = 8},
  [345] = {.lex_state = 8},
  [346] = {.lex_state = 8},
  [347] = {.lex_state = 8},
  [348] = {.lex_state = 8},
  [349] = {.lex_state = 8},
  [350] = {.lex_state = 8},
  [351] = {.lex_state = 8},
  [352] = {.lex_state = 8},
  [353] = {.lex_state = 8},
  [354] = {.lex_state = 8},
  [355] = {.lex_state = 8},
  [356] = {.lex_state = 8},
  [357] = {.lex_state = 8},
  [358] = {.lex_state = 8},
  [359] = {.lex_state = 8},
  [360] = {.lex_state = 8},
  [361] = {.lex_state = 8},
  [362] = {.lex_state = 8},
  [363] = {.lex_state = 8},
  [364] = {.lex_state = 8},
  [365] = {.lex_state = 8},
  [366] = {.lex_state = 8},
  [367] = {.lex_state = 8},
  [368] = {.lex_state = 8},
  [369] = {.lex_state = 8},
  [370] = {.lex_state = 8},
  [371] = {.lex_state = 8},
  [372] = {.lex_state = 8},
  [373] = {.lex_state = 8},
  [374] = {.lex_state = 8},
  [375] = {.lex_state = 8},
  [376] = {.lex_state = 8},
  [377] = {.lex_state = 8},
  [378] = {.lex_state = 8},
  [379] = {.lex_state = 8},
  [380] = {.lex_state = 8},
  [381] = {.lex_state = 9},
  [382] = {.lex_state = 9},
  [383] = {.lex_state = 9},
  [384] = {.lex_state = 9},
  [385] = {.lex_state = 9},
  [386] = {.lex_state = 9},
  [387] = {.lex_state = 9},
  [388] = {.lex_state = 9},
  [389] = {.lex_state = 79},
  [390] = {.lex_state = 9},
  [391] = {.lex_state = 79},
  [392] = {.lex_state = 79},
  [393] = {.lex_state = 9},
  [394] = {.lex_state = 9},
  [395] = {.lex_state = 9},
  [396] = {.lex_state = 9},
  [397] = {.lex_state = 9},
  [398] = {.lex_state = 9},
  [399] = {.lex_state = 9},
  [400] = {.lex_state = 9},
  [401] = {.lex_state = 9},
  [402] = {.lex_state = 9},
  [403] = {.lex_state = 9},
  [404] = {.lex_state = 9},
  [405] = {.lex_state = 9},
  [406] = {.lex_state = 9},
  [407] = {.lex_state = 9},
  [408] = {.lex_state = 9},
  [409] = {.lex_state = 9},
  [410] = {.lex_state = 9},
  [411] = {.lex_state = 9},
  [412] = {.lex_state = 9},
  [413] = {.lex_state = 9},
  [414] = {.lex_state = 9},
  [415] = {.lex_state = 9},
  [416] = {.lex_state = 9},
  [417] = {.lex_state = 9},
  [418] = {.lex_state = 9},
  [419] = {.lex_state = 9},
  [420] = {.lex_state = 9},
  [421] = {.lex_state = 9},
  [422] = {.lex_state = 9},
  [423] = {.lex_state = 9},
  [424] = {.lex_state = 9},
  [425] = {.lex_state = 9},
  [426] = {.lex_state = 9},
  [427] = {.lex_state = 10},
  [428] = {.lex_state = 10},
  [429] = {.lex_state = 79},
  [430] = {.lex_state = 10},
  [431] = {.lex_state = 10},
  [432] = {.lex_state = 10},
  [433] = {.lex_state = 10},
  [434] = {.lex_state = 10},
  [435] = {.lex_state = 79},
  [436] = {.lex_state = 7},
  [437] = {.lex_state = 7},
  [438] = {.lex_state = 10},
  [439] = {.lex_state = 10},
  [440] = {.lex_state = 10},
  [441] = {.lex_state = 10},
  [442] = {.lex_state = 10},
  [443] = {.lex_state = 10},
  [444] = {.lex_state = 7},
  [445] = {.lex_state = 10},
  [446] = {.lex_state = 10},
  [447] = {.lex_state = 10},
  [448] = {.lex_state = 10},
  [449] = {.lex_state = 79},
  [450] = {.lex_state = 10},
  [451] = {.lex_state = 10},
  [452] = {.lex_state = 10},
  [453] = {.lex_state = 79},
  [454] = {.lex_state = 10},
  [455] = {.lex_state = 10},
  [456] = {.lex_state = 7},
  [457] = {.lex_state = 79},
  [458] = {.lex_state = 10},
  [459] = {.lex_state = 10},
  [460] = {.lex_state = 10},
  [461] = {.lex_state = 10},
  [462] = {.lex_state = 10},
  [463] = {.lex_state = 10},
  [464] = {.lex_state = 2},
  [465] = {.lex_state = 10},
  [466] = {.lex_state = 10},
  [467] = {.lex_state = 10},
  [468] = {.lex_state = 10},
  [469] = {.lex_state = 10},
  [470] = {.lex_state = 79},
  [471] = {.lex_state = 10},
  [472] = {.lex_state = 10},
  [473] = {.lex_state = 10},
  [474] = {.lex_state = 79},
  [475] = {.lex_state = 10},
  [476] = {.lex_state = 10},
  [477] = {.lex_state = 10},
  [478] = {.lex_state = 10},
  [479] = {.lex_state = 10},
  [480] = {.lex_state = 10},
  [481] = {.lex_state = 2},
  [482] = {.lex_state = 2},
  [483] = {.lex_state = 79},
  [484] = {.lex_state = 79},
  [485] = {.lex_state = 2},
  [486] = {.lex_state = 7},
  [487] = {.lex_state = 2},
  [488] = {.lex_state = 79},
  [489] = {.lex_state = 2},
  [490] = {.lex_state = 2},
  [491] = {.lex_state = 2},
  [492] = {.lex_state = 2},
  [493] = {.lex_state = 2},
  [494] = {.lex_state = 7},
  [495] = {.lex_state = 7},
  [496] = {.lex_state = 7},
  [497] = {.lex_state = 7},
  [498] = {.lex_state = 7},
  [499] = {.lex_state = 7},
  [500] = {.lex_state = 2},
  [501] = {.lex_state = 2},
  [502] = {.lex_state = 7},
  [503] = {.lex_state = 7},
  [504] = {.lex_state = 7},
  [505] = {.lex_state = 79},
  [506] = {.lex_state = 7},
  [507] = {.lex_state = 7},
  [508] = {.lex_state = 7},
  [509] = {.lex_state = 7},
  [510] = {.lex_state = 7},
  [511] = {.lex_state = 7},
  [512] = {.lex_state = 2},
  [513] = {.lex_state = 7},
  [514] = {.lex_state = 7},
  [515] = {.lex_state = 2},
  [516] = {.lex_state = 2},
  [517] = {.lex_state = 2},
  [518] = {.lex_state = 2},
  [519] = {.lex_state = 2},
  [520] = {.lex_state = 2},
  [521] = {.lex_state = 2},
  [522] = {.lex_state = 2},
  [523] = {.lex_state = 2},
  [524] = {.lex_state = 7},
  [525] = {.lex_state = 2},
  [526] = {.lex_state = 7},
  [527] = {.lex_state = 7},
  [528] = {.lex_state = 7},
  [529] = {.lex_state = 2},
  [530] = {.lex_state = 2},
  [531] = {.lex_state = 2},
  [532] = {.lex_state = 2},
  [533] = {.lex_state = 7},
  [534] = {.lex_state = 7},
  [535] = {.lex_state = 7},
  [536] = {.lex_state = 7},
  [537] = {.lex_state = 7},
  [538] = {.lex_state = 7},
  [539] = {.lex_state = 7},
  [540] = {.lex_state = 2},
  [541] = {.lex_state = 7},
  [542] = {.lex_state = 7},
  [543] = {.lex_state = 2},
  [544] = {.lex_state = 2},
  [545] = {.lex_state = 2},
  [546] = {.lex_state = 7},
  [547] = {.lex_state = 7},
  [548] = {.lex_state = 7},
  [549] = {.lex_state = 7},
  [550] = {.lex_state = 2},
  [551] = {.lex_state = 2},
  [552] = {.lex_state = 2},
  [553] = {.lex_state = 10},
  [554] = {.lex_state = 7},
  [555] = {.lex_state = 2},
  [556] = {.lex_state = 2},
  [557] = {.lex_state = 2},
  [558] = {.lex_state = 2},
  [559] = {.lex_state = 2},
  [560] = {.lex_state = 2},
  [561] = {.lex_state = 2},
  [562] = {.lex_state = 2},
  [563] = {.lex_state = 2},
  [564] = {.lex_state = 2},
  [565] = {.lex_state = 2},
  [566] = {.lex_state = 2},
  [567] = {.lex_state = 2},
  [568] = {.lex_state = 7},
  [569] = {.lex_state = 7},
  [570] = {.lex_state = 10},
  [571] = {.lex_state = 10},
  [572] = {.lex_state = 10},
  [573] = {.lex_state = 10},
  [574] = {.lex_state = 10},
  [575] = {.lex_state = 10},
  [576] = {.lex_state = 10},
  [577] = {.lex_state = 10},
  [578] = {.lex_state = 7},
  [579] = {.lex_state = 10},
  [580] = {.lex_state = 7},
  [581] = {.lex_state = 7},
  [582] = {.lex_state = 7},
  [583] = {.lex_state = 10},
  [584] = {.lex_state = 10},
  [585] = {.lex_state = 10},
  [586] = {.lex_state = 7},
  [587] = {.lex_state = 15, .external_lex_state = 2},
  [588] = {.lex_state = 7},
  [589] = {.lex_state = 7},
  [590] = {.lex_state = 7},
  [591] = {.lex_state = 7},
  [592] = {.lex_state = 7},
  [593] = {.lex_state = 7},
  [594] = {.lex_state = 7},
  [595] = {.lex_state = 7},
  [596] = {.lex_state = 10},
  [597] = {.lex_state = 7},
  [598] = {.lex_state = 7},
  [599] = {.lex_state = 16, .external_lex_state = 2},
  [600] = {.lex_state = 7},
  [601] = {.lex_state = 7},
  [602] = {.lex_state = 7},
  [603] = {.lex_state = 7},
  [604] = {.lex_state = 16, .external_lex_state = 2},
  [605] = {.lex_state = 7},
  [606] = {.lex_state = 7},
  [607] = {.lex_state = 7},
  [608] = {.lex_state = 7},
  [609] = {.lex_state = 7},
  [610] = {.lex_state = 7},
  [611] = {.lex_state = 7},
  [612] = {.lex_state = 7},
  [613] = {.lex_state = 7},
  [614] = {.lex_state = 7},
  [615] = {.lex_state = 16, .external_lex_state = 2},
  [616] = {.lex_state = 7},
  [617] = {.lex_state = 7},
  [618] = {.lex_state = 7},
  [619] = {.lex_state = 10},
  [620] = {.lex_state = 10},
  [621] = {.lex_state = 10},
  [622] = {.lex_state = 10},
  [623] = {.lex_state = 7},
  [624] = {.lex_state = 10},
  [625] = {.lex_state = 7},
  [626] = {.lex_state = 7},
  [627] = {.lex_state = 16, .external_lex_state = 2},
  [628] = {.lex_state = 7},
  [629] = {.lex_state = 10},
  [630] = {.lex_state = 7},
  [631] = {.lex_state = 10},
  [632] = {.lex_state = 10},
  [633] = {.lex_state = 7},
  [634] = {.lex_state = 7},
  [635] = {.lex_state = 10},
  [636] = {.lex_state = 7},
  [637] = {.lex_state = 7},
  [638] = {.lex_state = 7},
  [639] = {.lex_state = 16, .external_lex_state = 2},
  [640] = {.lex_state = 7},
  [641] = {.lex_state = 16, .external_lex_state = 2},
  [642] = {.lex_state = 10},
  [643] = {.lex_state = 7},
  [644] = {.lex_state = 10},
  [645] = {.lex_state = 7},
  [646] = {.lex_state = 10},
  [647] = {.lex_state = 7},
  [648] = {.lex_state = 10},
  [649] = {.lex_state = 7},
  [650] = {.lex_state = 7},
  [651] = {.lex_state = 15, .external_lex_state = 2},
  [652] = {.lex_state = 10},
  [653] = {.lex_state = 7},
  [654] = {.lex_state = 7},
  [655] = {.lex_state = 7},
  [656] = {.lex_state = 7},
  [657] = {.lex_state = 10},
  [658] = {.lex_state = 10},
  [659] = {.lex_state = 10},
  [660] = {.lex_state = 7},
  [661] = {.lex_state = 15, .external_lex_state = 2},
  [662] = {.lex_state = 10},
  [663] = {.lex_state = 15, .external_lex_state = 2},
  [664] = {.lex_state = 10},
  [665] = {.lex_state = 7},
  [666] = {.lex_state = 15, .external_lex_state = 2},
  [667] = {.lex_state = 10},
  [668] = {.lex_state = 7},
  [669] = {.lex_state = 10},
  [670] = {.lex_state = 7},
  [671] = {.lex_state = 10},
  [672] = {.lex_state = 10},
  [673] = {.lex_state = 7},
  [674] = {.lex_state = 10},
  [675] = {.lex_state = 10},
  [676] = {.lex_state = 10},
  [677] = {.lex_state = 15, .external_lex_state = 2},
  [678] = {.lex_state = 10},
  [679] = {.lex_state = 16, .external_lex_state = 2},
  [680] = {.lex_state = 10},
  [681] = {.lex_state = 10},
  [682] = {.lex_state = 15, .external_lex_state = 2},
  [683] = {.lex_state = 7},
  [684] = {.lex_state = 15, .external_lex_state = 2},
  [685] = {.lex_state = 7},
  [686] = {.lex_state = 7},
  [687] = {.lex_state = 7},
  [688] = {.lex_state = 10},
  [689] = {.lex_state = 10},
  [690] = {.lex_state = 10},
  [691] = {.lex_state = 10},
  [692] = {.lex_state = 10},
  [693] = {.lex_state = 10},
  [694] = {.lex_state = 10},
  [695] = {.lex_state = 15, .external_lex_state = 2},
  [696] = {.lex_state = 15, .external_lex_state = 2},
  [697] = {.lex_state = 10},
  [698] = {.lex_state = 10},
  [699] = {.lex_state = 10},
  [700] = {.lex_state = 7},
  [701] = {.lex_state = 10},
  [702] = {.lex_state = 10},
  [703] = {.lex_state = 10},
  [704] = {.lex_state = 7},
  [705] = {.lex_state = 10},
  [706] = {.lex_state = 15, .external_lex_state = 2},
  [707] = {.lex_state = 15, .external_lex_state = 2},
  [708] = {.lex_state = 10},
  [709] = {.lex_state = 10},
  [710] = {.lex_state = 7},
  [711] = {.lex_state = 15, .external_lex_state = 2},
  [712] = {.lex_state = 10},
  [713] = {.lex_state = 7},
  [714] = {.lex_state = 10},
  [715] = {.lex_state = 10},
  [716] = {.lex_state = 10},
  [717] = {.lex_state = 10},
  [718] = {.lex_state = 7},
  [719] = {.lex_state = 7},
  [720] = {.lex_state = 7},
  [721] = {.lex_state = 7},
  [722] = {.lex_state = 7},
  [723] = {.lex_state = 7},
  [724] = {.lex_state = 7},
  [725] = {.lex_state = 7},
  [726] = {.lex_state = 7},
  [727] = {.lex_state = 7},
  [728] = {.lex_state = 7},
  [729] = {.lex_state = 10},
  [730] = {.lex_state = 7},
  [731] = {.lex_state = 7},
  [732] = {.lex_state = 7},
  [733] = {.lex_state = 7},
  [734] = {.lex_state = 10},
  [735] = {.lex_state = 10},
  [736] = {.lex_state = 7},
  [737] = {.lex_state = 7},
  [738] = {.lex_state = 10},
  [739] = {.lex_state = 7},
  [740] = {.lex_state = 7},
  [741] = {.lex_state = 7},
  [742] = {.lex_state = 10},
  [743] = {.lex_state = 10},
  [744] = {.lex_state = 7},
  [745] = {.lex_state = 7},
  [746] = {.lex_state = 7},
  [747] = {.lex_state = 7},
  [748] = {.lex_state = 10},
  [749] = {.lex_state = 7},
  [750] = {.lex_state = 7},
  [751] = {.lex_state = 7},
  [752] = {.lex_state = 7},
  [753] = {.lex_state = 7},
  [754] = {.lex_state = 7},
  [755] = {.lex_state = 7},
  [756] = {.lex_state = 7},
  [757] = {.lex_state = 7},
  [758] = {.lex_state = 7},
  [759] = {.lex_state = 10},
  [760] = {.lex_state = 7},
  [761] = {.lex_state = 7},
  [762] = {.lex_state = 7},
  [763] = {.lex_state = 7},
  [764] = {.lex_state = 10},
  [765] = {.lex_state = 7},
  [766] = {.lex_state = 7},
  [767] = {.lex_state = 7},
  [768] = {.lex_state = 10},
  [769] = {.lex_state = 7},
  [770] = {.lex_state = 7},
  [771] = {.lex_state = 10},
  [772] = {.lex_state = 10},
  [773] = {.lex_state = 7},
  [774] = {.lex_state = 10},
  [775] = {.lex_state = 7},
  [776] = {.lex_state = 7},
  [777] = {.lex_state = 7},
  [778] = {.lex_state = 10},
  [779] = {.lex_state = 7},
  [780] = {.lex_state = 7},
  [781] = {.lex_state = 10},
  [782] = {.lex_state = 10},
  [783] = {.lex_state = 7},
  [784] = {.lex_state = 7},
  [785] = {.lex_state = 10},
  [786] = {.lex_state = 7},
  [787] = {.lex_state = 7},
  [788] = {.lex_state = 10},
  [789] = {.lex_state = 7},
  [790] = {.lex_state = 10},
  [791] = {.lex_state = 7},
  [792] = {.lex_state = 10},
  [793] = {.lex_state = 10},
  [794] = {.lex_state = 10},
  [795] = {.lex_state = 7},
  [796] = {.lex_state = 7},
  [797] = {.lex_state = 10},
  [798] = {.lex_state = 7},
  [799] = {.lex_state = 10},
  [800] = {.lex_state = 10},
  [801] = {.lex_state = 7},
  [802] = {.lex_state = 7},
  [803] = {.lex_state = 7},
  [804] = {.lex_state = 10},
  [805] = {.lex_state = 7},
  [806] = {.lex_state = 10},
  [807] = {.lex_state = 7},
  [808] = {.lex_state = 7},
  [809] = {.lex_state = 7},
  [810] = {.lex_state = 7},
  [811] = {.lex_state = 10},
  [812] = {.lex_state = 10},
  [813] = {.lex_state = 7},
  [814] = {.lex_state = 10},
  [815] = {.lex_state = 10},
  [816] = {.lex_state = 10},
  [817] = {.lex_state = 7},
  [818] = {.lex_state = 7},
  [819] = {.lex_state = 7},
  [820] = {.lex_state = 10},
  [821] = {.lex_state = 7},
  [822] = {.lex_state = 7},
  [823] = {.lex_state = 10},
  [824] = {.lex_state = 10},
  [825] = {.lex_state = 10},
  [826] = {.lex_state = 7},
  [827] = {.lex_state = 7},
  [828] = {.lex_state = 10},
  [829] = {.lex_state = 7},
  [830] = {.lex_state = 7},
  [831] = {.lex_state = 7},
  [832] = {.lex_state = 10},
  [833] = {.lex_state = 7},
  [834] = {.lex_state = 7},
  [835] = {.lex_state = 10},
  [836] = {.lex_state = 10},
  [837] = {.lex_state = 7},
  [838] = {.lex_state = 10},
  [839] = {.lex_state = 7},
  [840] = {.lex_state = 7},
  [841] = {.lex_state = 7},
  [842] = {.lex_state = 7},
  [843] = {.lex_state = 7},
  [844] = {.lex_state = 7},
  [845] = {.lex_state = 10},
  [846] = {.lex_state = 7},
  [847] = {.lex_state = 7},
  [848] = {.lex_state = 10},
  [849] = {.lex_state = 10},
  [850] = {.lex_state = 79},
  [851] = {.lex_state = 79},
  [852] = {.lex_state = 79},
  [853] = {.lex_state = 79},
  [854] = {.lex_state = 79},
  [855] = {.lex_state = 79},
  [856] = {.lex_state = 7},
  [857] = {.lex_state = 7},
  [858] = {.lex_state = 7},
  [859] = {.lex_state = 7},
  [860] = {.lex_state = 79},
  [861] = {.lex_state = 79},
  [862] = {.lex_state = 79},
  [863] = {.lex_state = 79},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 16, .external_lex_state = 2},
  [867] = {.lex_state = 15, .external_lex_state = 2},
  [868] = {.lex_state = 79},
  [869] = {.lex_state = 15, .external_lex_state = 2},
  [870] = {.lex_state = 16, .external_lex_state = 2},
  [871] = {.lex_state = 7},
  [872] = {.lex_state = 79},
  [873] = {.lex_state = 15, .external_lex_state = 2},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 79},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 79},
  [878] = {.lex_state = 0},
  [879] = {.lex_state = 7},
  [880] = {.lex_state = 7},
  [881] = {.lex_state = 16, .external_lex_state = 2},
  [882] = {.lex_state = 7},
  [883] = {.lex_state = 0},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 15, .external_lex_state = 2},
  [886] = {.lex_state = 16, .external_lex_state = 2},
  [887] = {.lex_state = 79},
  [888] = {.lex_state = 79},
  [889] = {.lex_state = 26, .external_lex_state = 2},
  [890] = {.lex_state = 79},
  [891] = {.lex_state = 7},
  [892] = {.lex_state = 7},
  [893] = {.lex_state = 79},
  [894] = {.lex_state = 79},
  [895] = {.lex_state = 79},
  [896] = {.lex_state = 79},
  [897] = {.lex_state = 79},
  [898] = {.lex_state = 79},
  [899] = {.lex_state = 15, .external_lex_state = 2},
  [900] = {.lex_state = 79},
  [901] = {.lex_state = 26, .external_lex_state = 2},
  [902] = {.lex_state = 79},
  [903] = {.lex_state = 79},
  [904] = {.lex_state = 79},
  [905] = {.lex_state = 79},
  [906] = {.lex_state = 79},
  [907] = {.lex_state = 79},
  [908] = {.lex_state = 79},
  [909] = {.lex_state = 27, .external_lex_state = 2},
  [910] = {.lex_state = 79},
  [911] = {.lex_state = 79},
  [912] = {.lex_state = 79},
  [913] = {.lex_state = 27, .external_lex_state = 2},
  [914] = {.lex_state = 79},
  [915] = {.lex_state = 26, .external_lex_state = 2},
  [916] = {.lex_state = 79},
  [917] = {.lex_state = 16, .external_lex_state = 2},
  [918] = {.lex_state = 15, .external_lex_state = 2},
  [919] = {.lex_state = 79},
  [920] = {.lex_state = 16, .external_lex_state = 2},
  [921] = {.lex_state = 79},
  [922] = {.lex_state = 79},
  [923] = {.lex_state = 79},
  [924] = {.lex_state = 79},
  [925] = {.lex_state = 27, .external_lex_state = 2},
  [926] = {.lex_state = 79},
  [927] = {.lex_state = 26, .external_lex_state = 2},
  [928] = {.lex_state = 27, .external_lex_state = 2},
  [929] = {.lex_state = 79},
  [930] = {.lex_state = 16, .external_lex_state = 2},
  [931] = {.lex_state = 16, .external_lex_state = 2},
  [932] = {.lex_state = 7},
  [933] = {.lex_state = 16, .external_lex_state = 2},
  [934] = {.lex_state = 16, .external_lex_state = 2},
  [935] = {.lex_state = 16, .external_lex_state = 2},
  [936] = {.lex_state = 16, .external_lex_state = 2},
  [937] = {.lex_state = 16, .external_lex_state = 2},
  [938] = {.lex_state = 16, .external_lex_state = 2},
  [939] = {.lex_state = 16, .external_lex_state = 2},
  [940] = {.lex_state = 16, .external_lex_state = 2},
  [941] = {.lex_state = 16, .external_lex_state = 2},
  [942] = {.lex_state = 16, .external_lex_state = 2},
  [943] = {.lex_state = 16, .external_lex_state = 2},
  [944] = {.lex_state = 16, .external_lex_state = 2},
  [945] = {.lex_state = 15, .external_lex_state = 2},
  [946] = {.lex_state = 16, .external_lex_state = 2},
  [947] = {.lex_state = 16, .external_lex_state = 2},
  [948] = {.lex_state = 16, .external_lex_state = 2},
  [949] = {.lex_state = 7},
  [950] = {.lex_state = 16, .external_lex_state = 2},
  [951] = {.lex_state = 16, .external_lex_state = 2},
  [952] = {.lex_state = 16, .external_lex_state = 2},
  [953] = {.lex_state = 16, .external_lex_state = 2},
  [954] = {.lex_state = 16, .external_lex_state = 2},
  [955] = {.lex_state = 15, .external_lex_state = 2},
  [956] = {.lex_state = 16, .external_lex_state = 2},
  [957] = {.lex_state = 16, .external_lex_state = 2},
  [958] = {.lex_state = 16, .external_lex_state = 2},
  [959] = {.lex_state = 16, .external_lex_state = 2},
  [960] = {.lex_state = 15, .external_lex_state = 2},
  [961] = {.lex_state = 16, .external_lex_state = 2},
  [962] = {.lex_state = 16, .external_lex_state = 2},
  [963] = {.lex_state = 16, .external_lex_state = 2},
  [964] = {.lex_state = 16, .external_lex_state = 2},
  [965] = {.lex_state = 15, .external_lex_state = 2},
  [966] = {.lex_state = 16, .external_lex_state = 2},
  [967] = {.lex_state = 16, .external_lex_state = 2},
  [968] = {.lex_state = 16, .external_lex_state = 2},
  [969] = {.lex_state = 15, .external_lex_state = 2},
  [970] = {.lex_state = 15, .external_lex_state = 2},
  [971] = {.lex_state = 15, .external_lex_state = 2},
  [972] = {.lex_state = 15, .external_lex_state = 2},
  [973] = {.lex_state = 15, .external_lex_state = 2},
  [974] = {.lex_state = 15, .external_lex_state = 2},
  [975] = {.lex_state = 15, .external_lex_state = 2},
  [976] = {.lex_state = 16, .external_lex_state = 2},
  [977] = {.lex_state = 16, .external_lex_state = 2},
  [978] = {.lex_state = 16, .external_lex_state = 2},
  [979] = {.lex_state = 15, .external_lex_state = 2},
  [980] = {.lex_state = 15, .external_lex_state = 2},
  [981] = {.lex_state = 16, .external_lex_state = 2},
  [982] = {.lex_state = 15, .external_lex_state = 2},
  [983] = {.lex_state = 15, .external_lex_state = 2},
  [984] = {.lex_state = 7},
  [985] = {.lex_state = 15, .external_lex_state = 2},
  [986] = {.lex_state = 15, .external_lex_state = 2},
  [987] = {.lex_state = 16, .external_lex_state = 2},
  [988] = {.lex_state = 16, .external_lex_state = 2},
  [989] = {.lex_state = 16, .external_lex_state = 2},
  [990] = {.lex_state = 15, .external_lex_state = 2},
  [991] = {.lex_state = 15, .external_lex_state = 2},
  [992] = {.lex_state = 15, .external_lex_state = 2},
  [993] = {.lex_state = 15, .external_lex_state = 2},
  [994] = {.lex_state = 79},
  [995] = {.lex_state = 15, .external_lex_state = 2},
  [996] = {.lex_state = 15, .external_lex_state = 2},
  [997] = {.lex_state = 15, .external_lex_state = 2},
  [998] = {.lex_state = 15, .external_lex_state = 2},
  [999] = {.lex_state = 15, .external_lex_state = 2},
  [1000] = {.lex_state = 15, .external_lex_state = 2},
  [1001] = {.lex_state = 15, .external_lex_state = 2},
  [1002] = {.lex_state = 16, .external_lex_state = 2},
  [1003] = {.lex_state = 15, .external_lex_state = 2},
  [1004] = {.lex_state = 15, .external_lex_state = 2},
  [1005] = {.lex_state = 16, .external_lex_state = 2},
  [1006] = {.lex_state = 15, .external_lex_state = 2},
  [1007] = {.lex_state = 15, .external_lex_state = 2},
  [1008] = {.lex_state = 15, .external_lex_state = 2},
  [1009] = {.lex_state = 15, .external_lex_state = 2},
  [1010] = {.lex_state = 15, .external_lex_state = 2},
  [1011] = {.lex_state = 15, .external_lex_state = 2},
  [1012] = {.lex_state = 16, .external_lex_state = 2},
  [1013] = {.lex_state = 7},
  [1014] = {.lex_state = 15, .external_lex_state = 2},
  [1015] = {.lex_state = 15, .external_lex_state = 2},
  [1016] = {.lex_state = 7},
  [1017] = {.lex_state = 15, .external_lex_state = 2},
  [1018] = {.lex_state = 15, .external_lex_state = 2},
  [1019] = {.lex_state = 15, .external_lex_state = 2},
  [1020] = {.lex_state = 78},
  [1021] = {.lex_state = 34},
  [1022] = {.lex_state = 34},
  [1023] = {.lex_state = 34},
  [1024] = {.lex_state = 34},
  [1025] = {.lex_state = 81},
  [1026] = {.lex_state = 78},
  [1027] = {.lex_state = 81},
  [1028] = {.lex_state = 34},
  [1029] = {.lex_state = 7},
  [1030] = {.lex_state = 7},
  [1031] = {.lex_state = 34},
  [1032] = {.lex_state = 79},
  [1033] = {.lex_state = 34},
  [1034] = {.lex_state = 81},
  [1035] = {.lex_state = 81},
  [1036] = {.lex_state = 81},
  [1037] = {.lex_state = 81},
  [1038] = {.lex_state = 81},
  [1039] = {.lex_state = 81},
  [1040] = {.lex_state = 7},
  [1041] = {.lex_state = 81},
  [1042] = {.lex_state = 81},
  [1043] = {.lex_state = 81},
  [1044] = {.lex_state = 81},
  [1045] = {.lex_state = 81},
  [1046] = {.lex_state = 81},
  [1047] = {.lex_state = 81},
  [1048] = {.lex_state = 81},
  [1049] = {.lex_state = 81},
  [1050] = {.lex_state = 7},
  [1051] = {.lex_state = 7},
  [1052] = {.lex_state = 81},
  [1053] = {.lex_state = 81},
  [1054] = {.lex_state = 81},
  [1055] = {.lex_state = 81},
  [1056] = {.lex_state = 81},
  [1057] = {.lex_state = 81},
  [1058] = {.lex_state = 81},
  [1059] = {.lex_state = 81},
  [1060] = {.lex_state = 7},
  [1061] = {.lex_state = 81},
  [1062] = {.lex_state = 81},
  [1063] = {.lex_state = 79},
  [1064] = {.lex_state = 7},
  [1065] = {.lex_state = 81},
  [1066] = {.lex_state = 81},
  [1067] = {.lex_state = 81},
  [1068] = {.lex_state = 81},
  [1069] = {.lex_state = 7},
  [1070] = {.lex_state = 79},
  [1071] = {.lex_state = 81},
  [1072] = {.lex_state = 79},
  [1073] = {.lex_state = 79},
  [1074] = {.lex_state = 79},
  [1075] = {.lex_state = 78},
  [1076] = {.lex_state = 78},
  [1077] = {.lex_state = 79},
  [1078] = {.lex_state = 7},
  [1079] = {.lex_state = 78},
  [1080] = {.lex_state = 78},
  [1081] = {.lex_state = 78},
  [1082] = {.lex_state = 78},
  [1083] = {.lex_state = 78},
  [1084] = {.lex_state = 81},
  [1085] = {.lex_state = 78},
  [1086] = {.lex_state = 81},
  [1087] = {.lex_state = 79},
  [1088] = {.lex_state = 79},
  [1089] = {.lex_state = 78},
  [1090] = {.lex_state = 78},
  [1091] = {.lex_state = 1},
  [1092] = {.lex_state = 78},
  [1093] = {.lex_state = 78},
  [1094] = {.lex_state = 78},
  [1095] = {.lex_state = 78},
  [1096] = {.lex_state = 78},
  [1097] = {.lex_state = 78},
  [1098] = {.lex_state = 79},
  [1099] = {.lex_state = 1},
  [1100] = {.lex_state = 78},
  [1101] = {.lex_state = 7},
  [1102] = {.lex_state = 78},
  [1103] = {.lex_state = 7},
  [1104] = {.lex_state = 78},
  [1105] = {.lex_state = 78},
  [1106] = {.lex_state = 79},
  [1107] = {.lex_state = 79},
  [1108] = {.lex_state = 78},
  [1109] = {.lex_state = 11},
  [1110] = {.lex_state = 78},
  [1111] = {.lex_state = 79},
  [1112] = {.lex_state = 78},
  [1113] = {.lex_state = 78},
  [1114] = {.lex_state = 78},
  [1115] = {.lex_state = 78},
  [1116] = {.lex_state = 78},
  [1117] = {.lex_state = 81},
  [1118] = {.lex_state = 7},
  [1119] = {.lex_state = 78},
  [1120] = {.lex_state = 79},
  [1121] = {.lex_state = 78},
  [1122] = {.lex_state = 78},
  [1123] = {.lex_state = 78},
  [1124] = {.lex_state = 78},
  [1125] = {.lex_state = 79},
  [1126] = {.lex_state = 78},
  [1127] = {.lex_state = 78},
  [1128] = {.lex_state = 78},
  [1129] = {.lex_state = 78},
  [1130] = {.lex_state = 7},
  [1131] = {.lex_state = 78},
  [1132] = {.lex_state = 11},
  [1133] = {.lex_state = 78},
  [1134] = {.lex_state = 78},
  [1135] = {.lex_state = 11},
  [1136] = {.lex_state = 7},
  [1137] = {.lex_state = 81},
  [1138] = {.lex_state = 79},
  [1139] = {.lex_state = 79},
  [1140] = {.lex_state = 79},
  [1141] = {.lex_state = 81},
  [1142] = {.lex_state = 79},
  [1143] = {.lex_state = 79},
  [1144] = {.lex_state = 79},
  [1145] = {.lex_state = 79},
  [1146] = {.lex_state = 79},
  [1147] = {.lex_state = 79},
  [1148] = {.lex_state = 79},
  [1149] = {.lex_state = 79},
  [1150] = {.lex_state = 79},
  [1151] = {.lex_state = 79},
  [1152] = {.lex_state = 7},
  [1153] = {.lex_state = 7},
  [1154] = {.lex_state = 79},
  [1155] = {.lex_state = 7},
  [1156] = {.lex_state = 79},
  [1157] = {.lex_state = 7},
  [1158] = {.lex_state = 79},
  [1159] = {.lex_state = 7},
  [1160] = {.lex_state = 79},
  [1161] = {.lex_state = 79},
  [1162] = {.lex_state = 79},
  [1163] = {.lex_state = 7},
  [1164] = {.lex_state = 7},
  [1165] = {.lex_state = 7},
  [1166] = {.lex_state = 7},
  [1167] = {.lex_state = 7},
  [1168] = {.lex_state = 78},
  [1169] = {.lex_state = 79},
  [1170] = {.lex_state = 79},
  [1171] = {.lex_state = 7},
  [1172] = {.lex_state = 81},
  [1173] = {.lex_state = 7},
  [1174] = {.lex_state = 79},
  [1175] = {.lex_state = 7},
  [1176] = {.lex_state = 79},
  [1177] = {.lex_state = 7},
  [1178] = {.lex_state = 79},
  [1179] = {.lex_state = 79},
  [1180] = {.lex_state = 79},
  [1181] = {.lex_state = 79},
  [1182] = {.lex_state = 7},
  [1183] = {.lex_state = 79},
  [1184] = {.lex_state = 79},
  [1185] = {.lex_state = 79},
  [1186] = {.lex_state = 7},
  [1187] = {.lex_state = 79},
  [1188] = {.lex_state = 81},
  [1189] = {.lex_state = 78},
  [1190] = {.lex_state = 79},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 7},
  [1193] = {.lex_state = 7},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 79},
  [1196] = {.lex_state = 36},
  [1197] = {.lex_state = 79},
  [1198] = {.lex_state = 7},
  [1199] = {.lex_state = 7},
  [1200] = {.lex_state = 7},
  [1201] = {.lex_state = 79},
  [1202] = {.lex_state = 7},
  [1203] = {.lex_state = 78},
  [1204] = {.lex_state = 7},
  [1205] = {.lex_state = 7},
  [1206] = {.lex_state = 28},
  [1207] = {.lex_state = 28},
  [1208] = {.lex_state = 79},
  [1209] = {.lex_state = 34},
  [1210] = {.lex_state = 78},
  [1211] = {.lex_state = 79},
  [1212] = {.lex_state = 7},
  [1213] = {.lex_state = 7},
  [1214] = {.lex_state = 79},
  [1215] = {.lex_state = 7},
  [1216] = {.lex_state = 79},
  [1217] = {.lex_state = 81},
  [1218] = {.lex_state = 7},
  [1219] = {.lex_state = 79},
  [1220] = {.lex_state = 78},
  [1221] = {.lex_state = 7},
  [1222] = {.lex_state = 7},
  [1223] = {.lex_state = 7},
  [1224] = {.lex_state = 78},
  [1225] = {.lex_state = 7},
  [1226] = {.lex_state = 7},
  [1227] = {.lex_state = 7},
  [1228] = {.lex_state = 7},
  [1229] = {.lex_state = 7},
  [1230] = {.lex_state = 79},
  [1231] = {.lex_state = 78},
  [1232] = {.lex_state = 7},
  [1233] = {.lex_state = 79},
  [1234] = {.lex_state = 7},
  [1235] = {.lex_state = 7},
  [1236] = {.lex_state = 79},
  [1237] = {.lex_state = 78},
  [1238] = {.lex_state = 7},
  [1239] = {.lex_state = 36},
  [1240] = {.lex_state = 79},
  [1241] = {.lex_state = 79},
  [1242] = {.lex_state = 79},
  [1243] = {.lex_state = 79},
  [1244] = {.lex_state = 28},
  [1245] = {.lex_state = 78},
  [1246] = {.lex_state = 78},
  [1247] = {.lex_state = 36},
  [1248] = {.lex_state = 28},
  [1249] = {.lex_state = 36},
  [1250] = {.lex_state = 28},
  [1251] = {.lex_state = 78},
  [1252] = {.lex_state = 34},
  [1253] = {.lex_state = 78},
  [1254] = {.lex_state = 78},
  [1255] = {.lex_state = 78},
  [1256] = {.lex_state = 34},
  [1257] = {.lex_state = 78},
  [1258] = {.lex_state = 78},
  [1259] = {.lex_state = 78},
  [1260] = {.lex_state = 78},
  [1261] = {.lex_state = 78},
  [1262] = {.lex_state = 78},
  [1263] = {.lex_state = 35},
  [1264] = {.lex_state = 35},
  [1265] = {.lex_state = 35},
  [1266] = {.lex_state = 78},
  [1267] = {.lex_state = 35},
  [1268] = {.lex_state = 34},
  [1269] = {.lex_state = 78},
  [1270] = {.lex_state = 78},
  [1271] = {.lex_state = 7},
  [1272] = {.lex_state = 34},
  [1273] = {.lex_state = 34},
  [1274] = {.lex_state = 34},
  [1275] = {.lex_state = 78},
  [1276] = {.lex_state = 34},
  [1277] = {.lex_state = 34},
  [1278] = {.lex_state = 34},
  [1279] = {.lex_state = 34},
  [1280] = {.lex_state = 34},
  [1281] = {.lex_state = 34},
  [1282] = {.lex_state = 34},
  [1283] = {.lex_state = 35},
  [1284] = {.lex_state = 35},
  [1285] = {.lex_state = 78},
  [1286] = {.lex_state = 7},
  [1287] = {.lex_state = 35},
  [1288] = {.lex_state = 35},
  [1289] = {.lex_state = 78},
  [1290] = {.lex_state = 78},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 7},
  [1293] = {.lex_state = 78},
  [1294] = {.lex_state = 78},
  [1295] = {.lex_state = 78},
  [1296] = {.lex_state = 78},
  [1297] = {.lex_state = 35},
  [1298] = {.lex_state = 35},
  [1299] = {.lex_state = 7},
  [1300] = {.lex_state = 78},
  [1301] = {.lex_state = 78},
  [1302] = {.lex_state = 7},
  [1303] = {.lex_state = 35},
  [1304] = {.lex_state = 7},
  [1305] = {.lex_state = 78},
  [1306] = {.lex_state = 78},
  [1307] = {.lex_state = 78},
  [1308] = {.lex_state = 35},
  [1309] = {.lex_state = 35},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 78},
  [1313] = {.lex_state = 7},
  [1314] = {.lex_state = 78},
  [1315] = {.lex_state = 78},
  [1316] = {.lex_state = 78},
  [1317] = {.lex_state = 7},
  [1318] = {.lex_state = 7},
  [1319] = {.lex_state = 3},
  [1320] = {.lex_state = 3},
  [1321] = {.lex_state = 7},
  [1322] = {.lex_state = 78},
  [1323] = {.lex_state = 81},
  [1324] = {.lex_state = 78},
  [1325] = {.lex_state = 78},
  [1326] = {.lex_state = 78},
  [1327] = {.lex_state = 7},
  [1328] = {.lex_state = 7},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 3},
  [1332] = {.lex_state = 78},
  [1333] = {.lex_state = 8},
  [1334] = {.lex_state = 78},
  [1335] = {.lex_state = 78},
  [1336] = {.lex_state = 78},
  [1337] = {.lex_state = 7},
  [1338] = {.lex_state = 3},
  [1339] = {.lex_state = 3},
  [1340] = {.lex_state = 9},
  [1341] = {.lex_state = 3},
  [1342] = {.lex_state = 7},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 81},
  [1345] = {.lex_state = 81},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 81},
  [1349] = {.lex_state = 81},
  [1350] = {.lex_state = 3},
  [1351] = {.lex_state = 81},
  [1352] = {.lex_state = 3},
  [1353] = {.lex_state = 35},
  [1354] = {.lex_state = 28},
  [1355] = {.lex_state = 0},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 0},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 3},
  [1361] = {.lex_state = 9},
  [1362] = {.lex_state = 7},
  [1363] = {.lex_state = 78},
  [1364] = {.lex_state = 0},
  [1365] = {.lex_state = 0},
  [1366] = {.lex_state = 81},
  [1367] = {.lex_state = 81},
  [1368] = {.lex_state = 3},
  [1369] = {.lex_state = 7},
  [1370] = {.lex_state = 7},
  [1371] = {.lex_state = 7},
  [1372] = {.lex_state = 78},
  [1373] = {.lex_state = 31},
  [1374] = {.lex_state = 78},
  [1375] = {.lex_state = 81},
  [1376] = {.lex_state = 3},
  [1377] = {.lex_state = 78},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 78},
  [1380] = {.lex_state = 78},
  [1381] = {.lex_state = 0},
  [1382] = {.lex_state = 78},
  [1383] = {.lex_state = 31},
  [1384] = {.lex_state = 78},
  [1385] = {.lex_state = 78},
  [1386] = {.lex_state = 9},
  [1387] = {.lex_state = 29},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 0},
  [1390] = {.lex_state = 78},
  [1391] = {.lex_state = 81},
  [1392] = {.lex_state = 81},
  [1393] = {.lex_state = 8},
  [1394] = {.lex_state = 3},
  [1395] = {.lex_state = 81},
  [1396] = {.lex_state = 3},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 8},
  [1399] = {.lex_state = 8},
  [1400] = {.lex_state = 78},
  [1401] = {.lex_state = 31},
  [1402] = {.lex_state = 78},
  [1403] = {.lex_state = 31},
  [1404] = {.lex_state = 78},
  [1405] = {.lex_state = 78},
  [1406] = {.lex_state = 8},
  [1407] = {.lex_state = 78},
  [1408] = {.lex_state = 78},
  [1409] = {.lex_state = 78},
  [1410] = {.lex_state = 78},
  [1411] = {.lex_state = 78},
  [1412] = {.lex_state = 78},
  [1413] = {.lex_state = 0},
  [1414] = {.lex_state = 0},
  [1415] = {.lex_state = 78},
  [1416] = {.lex_state = 78},
  [1417] = {.lex_state = 78},
  [1418] = {.lex_state = 78},
  [1419] = {.lex_state = 78},
  [1420] = {.lex_state = 78},
  [1421] = {.lex_state = 78},
  [1422] = {.lex_state = 78},
  [1423] = {.lex_state = 78},
  [1424] = {.lex_state = 78},
  [1425] = {.lex_state = 29},
  [1426] = {.lex_state = 78},
  [1427] = {.lex_state = 78},
  [1428] = {.lex_state = 0},
  [1429] = {.lex_state = 8},
  [1430] = {.lex_state = 0},
  [1431] = {.lex_state = 8},
  [1432] = {.lex_state = 0},
  [1433] = {.lex_state = 81},
  [1434] = {.lex_state = 81},
  [1435] = {.lex_state = 3},
  [1436] = {.lex_state = 78},
  [1437] = {.lex_state = 9},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 81},
  [1440] = {.lex_state = 3},
  [1441] = {.lex_state = 8},
  [1442] = {.lex_state = 0},
  [1443] = {.lex_state = 0},
  [1444] = {.lex_state = 78},
  [1445] = {.lex_state = 78},
  [1446] = {.lex_state = 31},
  [1447] = {.lex_state = 78},
  [1448] = {.lex_state = 78},
  [1449] = {.lex_state = 0},
  [1450] = {.lex_state = 7},
  [1451] = {.lex_state = 0},
  [1452] = {.lex_state = 7},
  [1453] = {.lex_state = 7},
  [1454] = {.lex_state = 7},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 78},
  [1457] = {.lex_state = 0},
  [1458] = {.lex_state = 7},
  [1459] = {.lex_state = 78},
  [1460] = {.lex_state = 28},
  [1461] = {.lex_state = 7},
  [1462] = {.lex_state = 30},
  [1463] = {.lex_state = 81},
  [1464] = {.lex_state = 35},
  [1465] = {.lex_state = 81},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 81},
  [1468] = {.lex_state = 81},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 0},
  [1471] = {.lex_state = 28},
  [1472] = {.lex_state = 28},
  [1473] = {.lex_state = 30},
  [1474] = {.lex_state = 28},
  [1475] = {.lex_state = 35},
  [1476] = {.lex_state = 7},
  [1477] = {.lex_state = 7},
  [1478] = {.lex_state = 7},
  [1479] = {.lex_state = 81},
  [1480] = {.lex_state = 7},
  [1481] = {.lex_state = 7},
  [1482] = {.lex_state = 28},
  [1483] = {.lex_state = 28},
  [1484] = {.lex_state = 7},
  [1485] = {.lex_state = 30},
  [1486] = {.lex_state = 7},
  [1487] = {.lex_state = 7},
  [1488] = {.lex_state = 7},
  [1489] = {.lex_state = 7},
  [1490] = {.lex_state = 7},
  [1491] = {.lex_state = 28},
  [1492] = {.lex_state = 7},
  [1493] = {.lex_state = 35},
  [1494] = {.lex_state = 0},
  [1495] = {.lex_state = 0},
  [1496] = {.lex_state = 0},
  [1497] = {.lex_state = 35},
  [1498] = {.lex_state = 7},
  [1499] = {.lex_state = 35},
  [1500] = {.lex_state = 7},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 7},
  [1503] = {.lex_state = 78},
  [1504] = {.lex_state = 0},
  [1505] = {.lex_state = 7},
  [1506] = {.lex_state = 78},
  [1507] = {.lex_state = 0},
  [1508] = {.lex_state = 7},
  [1509] = {.lex_state = 0},
  [1510] = {.lex_state = 28},
  [1511] = {.lex_state = 0},
  [1512] = {.lex_state = 35},
  [1513] = {.lex_state = 0},
  [1514] = {.lex_state = 0},
  [1515] = {.lex_state = 0},
  [1516] = {.lex_state = 78},
  [1517] = {.lex_state = 7},
  [1518] = {.lex_state = 0},
  [1519] = {.lex_state = 0},
  [1520] = {.lex_state = 35},
  [1521] = {.lex_state = 7},
  [1522] = {.lex_state = 7},
  [1523] = {.lex_state = 0},
  [1524] = {.lex_state = 7},
  [1525] = {.lex_state = 0},
  [1526] = {.lex_state = 0},
  [1527] = {.lex_state = 0},
  [1528] = {.lex_state = 0},
  [1529] = {.lex_state = 0},
  [1530] = {.lex_state = 78},
  [1531] = {.lex_state = 7},
  [1532] = {.lex_state = 7},
  [1533] = {.lex_state = 0},
  [1534] = {.lex_state = 0},
  [1535] = {.lex_state = 81},
  [1536] = {.lex_state = 7},
  [1537] = {.lex_state = 0},
  [1538] = {.lex_state = 0},
  [1539] = {.lex_state = 7},
  [1540] = {.lex_state = 0},
  [1541] = {.lex_state = 7},
  [1542] = {.lex_state = 0},
  [1543] = {.lex_state = 78},
  [1544] = {.lex_state = 7},
  [1545] = {.lex_state = 7},
  [1546] = {.lex_state = 7},
  [1547] = {.lex_state = 7},
  [1548] = {.lex_state = 78},
  [1549] = {.lex_state = 35},
  [1550] = {.lex_state = 7},
  [1551] = {.lex_state = 7},
  [1552] = {.lex_state = 0},
  [1553] = {.lex_state = 0},
  [1554] = {.lex_state = 0},
  [1555] = {.lex_state = 0},
  [1556] = {.lex_state = 7},
  [1557] = {.lex_state = 0},
  [1558] = {.lex_state = 0},
  [1559] = {.lex_state = 0},
  [1560] = {.lex_state = 7},
  [1561] = {.lex_state = 0},
  [1562] = {.lex_state = 0},
  [1563] = {.lex_state = 0},
  [1564] = {.lex_state = 7},
  [1565] = {.lex_state = 78},
  [1566] = {.lex_state = 0},
  [1567] = {.lex_state = 7},
  [1568] = {.lex_state = 0},
  [1569] = {.lex_state = 7},
  [1570] = {.lex_state = 78},
  [1571] = {.lex_state = 7},
  [1572] = {.lex_state = 78},
  [1573] = {.lex_state = 78},
  [1574] = {.lex_state = 7},
  [1575] = {.lex_state = 78},
  [1576] = {.lex_state = 78},
  [1577] = {.lex_state = 0},
  [1578] = {.lex_state = 0},
  [1579] = {.lex_state = 81, .external_lex_state = 3},
  [1580] = {.lex_state = 7},
  [1581] = {.lex_state = 0},
  [1582] = {.lex_state = 0},
  [1583] = {.lex_state = 78},
  [1584] = {.lex_state = 0},
  [1585] = {.lex_state = 0},
  [1586] = {.lex_state = 0},
  [1587] = {.lex_state = 0},
  [1588] = {.lex_state = 78},
  [1589] = {.lex_state = 0},
  [1590] = {.lex_state = 0},
  [1591] = {.lex_state = 0},
  [1592] = {.lex_state = 0},
  [1593] = {.lex_state = 7},
  [1594] = {.lex_state = 78},
  [1595] = {.lex_state = 78},
  [1596] = {.lex_state = 28},
  [1597] = {.lex_state = 78},
  [1598] = {.lex_state = 78},
  [1599] = {.lex_state = 0},
  [1600] = {.lex_state = 0},
  [1601] = {.lex_state = 0},
  [1602] = {.lex_state = 78},
  [1603] = {.lex_state = 78},
  [1604] = {.lex_state = 78},
  [1605] = {.lex_state = 0},
  [1606] = {.lex_state = 78},
  [1607] = {.lex_state = 0},
  [1608] = {.lex_state = 7},
  [1609] = {.lex_state = 0},
  [1610] = {.lex_state = 78},
  [1611] = {.lex_state = 78},
  [1612] = {.lex_state = 81},
  [1613] = {.lex_state = 0, .external_lex_state = 4},
  [1614] = {.lex_state = 0},
  [1615] = {.lex_state = 0},
  [1616] = {.lex_state = 0},
  [1617] = {.lex_state = 0, .external_lex_state = 5},
  [1618] = {.lex_state = 0, .external_lex_state = 4},
  [1619] = {.lex_state = 0},
  [1620] = {.lex_state = 0, .external_lex_state = 5},
  [1621] = {.lex_state = 81},
  [1622] = {.lex_state = 0},
  [1623] = {.lex_state = 0, .external_lex_state = 4},
  [1624] = {.lex_state = 0},
  [1625] = {.lex_state = 0, .external_lex_state = 5},
  [1626] = {.lex_state = 0, .external_lex_state = 4},
  [1627] = {.lex_state = 7},
  [1628] = {.lex_state = 0, .external_lex_state = 5},
  [1629] = {.lex_state = 0, .external_lex_state = 4},
  [1630] = {.lex_state = 0},
  [1631] = {.lex_state = 7},
  [1632] = {.lex_state = 0},
  [1633] = {.lex_state = 81},
  [1634] = {.lex_state = 7},
  [1635] = {.lex_state = 7},
  [1636] = {.lex_state = 0, .external_lex_state = 5},
  [1637] = {.lex_state = 7},
  [1638] = {.lex_state = 0},
  [1639] = {.lex_state = 81},
  [1640] = {.lex_state = 0, .external_lex_state = 6},
  [1641] = {.lex_state = 0},
  [1642] = {.lex_state = 0},
  [1643] = {.lex_state = 81},
  [1644] = {.lex_state = 7},
  [1645] = {.lex_state = 0},
  [1646] = {.lex_state = 81},
  [1647] = {.lex_state = 7},
  [1648] = {.lex_state = 81},
  [1649] = {.lex_state = 13},
  [1650] = {.lex_state = 7},
  [1651] = {.lex_state = 0},
  [1652] = {.lex_state = 0},
  [1653] = {.lex_state = 0},
  [1654] = {.lex_state = 81},
  [1655] = {.lex_state = 7},
  [1656] = {.lex_state = 81},
  [1657] = {.lex_state = 0},
  [1658] = {.lex_state = 12},
  [1659] = {.lex_state = 12},
  [1660] = {.lex_state = 0},
  [1661] = {.lex_state = 81},
  [1662] = {.lex_state = 7},
  [1663] = {.lex_state = 0},
  [1664] = {.lex_state = 0},
  [1665] = {.lex_state = 0},
  [1666] = {.lex_state = 81},
  [1667] = {.lex_state = 0},
  [1668] = {.lex_state = 7},
  [1669] = {.lex_state = 7},
  [1670] = {.lex_state = 7},
  [1671] = {.lex_state = 0},
  [1672] = {.lex_state = 7},
  [1673] = {.lex_state = 81},
  [1674] = {.lex_state = 0},
  [1675] = {.lex_state = 0},
  [1676] = {.lex_state = 0},
  [1677] = {.lex_state = 81},
  [1678] = {.lex_state = 0},
  [1679] = {.lex_state = 0},
  [1680] = {.lex_state = 0},
  [1681] = {.lex_state = 81},
  [1682] = {.lex_state = 81},
  [1683] = {.lex_state = 7},
  [1684] = {.lex_state = 81},
  [1685] = {.lex_state = 0, .external_lex_state = 6},
  [1686] = {.lex_state = 81},
  [1687] = {.lex_state = 0},
  [1688] = {.lex_state = 81},
  [1689] = {.lex_state = 81},
  [1690] = {.lex_state = 81},
  [1691] = {.lex_state = 13},
  [1692] = {.lex_state = 0},
  [1693] = {.lex_state = 0},
  [1694] = {.lex_state = 0},
  [1695] = {.lex_state = 81},
  [1696] = {.lex_state = 0},
  [1697] = {.lex_state = 7},
  [1698] = {.lex_state = 0},
  [1699] = {.lex_state = 12},
  [1700] = {.lex_state = 0},
  [1701] = {.lex_state = 0},
  [1702] = {.lex_state = 0},
  [1703] = {.lex_state = 81},
  [1704] = {.lex_state = 0},
  [1705] = {.lex_state = 81},
  [1706] = {.lex_state = 7},
  [1707] = {.lex_state = 0},
  [1708] = {.lex_state = 0, .external_lex_state = 4},
  [1709] = {.lex_state = 0},
  [1710] = {.lex_state = 81},
  [1711] = {.lex_state = 13},
  [1712] = {.lex_state = 81},
  [1713] = {.lex_state = 0},
  [1714] = {.lex_state = 0},
  [1715] = {.lex_state = 7},
  [1716] = {.lex_state = 81},
  [1717] = {.lex_state = 7},
  [1718] = {.lex_state = 0},
  [1719] = {.lex_state = 0},
  [1720] = {.lex_state = 0},
  [1721] = {.lex_state = 7},
  [1722] = {.lex_state = 0},
  [1723] = {.lex_state = 0},
  [1724] = {.lex_state = 0},
  [1725] = {.lex_state = 0},
  [1726] = {.lex_state = 7},
  [1727] = {.lex_state = 81},
  [1728] = {.lex_state = 0},
  [1729] = {.lex_state = 0},
  [1730] = {.lex_state = 7},
  [1731] = {.lex_state = 0},
  [1732] = {.lex_state = 0},
  [1733] = {.lex_state = 7},
  [1734] = {.lex_state = 0},
  [1735] = {.lex_state = 7},
  [1736] = {.lex_state = 81},
  [1737] = {.lex_state = 0},
  [1738] = {.lex_state = 31},
  [1739] = {.lex_state = 0},
  [1740] = {.lex_state = 7},
  [1741] = {.lex_state = 0},
  [1742] = {.lex_state = 0},
  [1743] = {.lex_state = 7},
  [1744] = {.lex_state = 0, .external_lex_state = 5},
  [1745] = {.lex_state = 0},
  [1746] = {.lex_state = 33},
  [1747] = {.lex_state = 78},
  [1748] = {.lex_state = 0},
  [1749] = {.lex_state = 0},
  [1750] = {.lex_state = 0},
  [1751] = {.lex_state = 0},
  [1752] = {.lex_state = 0},
  [1753] = {.lex_state = 0},
  [1754] = {.lex_state = 0},
  [1755] = {.lex_state = 0},
  [1756] = {.lex_state = 0},
  [1757] = {.lex_state = 7},
  [1758] = {.lex_state = 7},
  [1759] = {.lex_state = 0},
  [1760] = {.lex_state = 0},
  [1761] = {.lex_state = 0},
  [1762] = {.lex_state = 0},
  [1763] = {.lex_state = 0},
  [1764] = {.lex_state = 81},
  [1765] = {.lex_state = 0},
  [1766] = {.lex_state = 0},
  [1767] = {.lex_state = 0},
  [1768] = {.lex_state = 0},
  [1769] = {.lex_state = 7},
  [1770] = {.lex_state = 0},
  [1771] = {.lex_state = 0},
  [1772] = {.lex_state = 0},
  [1773] = {.lex_state = 7},
  [1774] = {.lex_state = 7},
  [1775] = {.lex_state = 81},
  [1776] = {.lex_state = 81},
  [1777] = {.lex_state = 0},
  [1778] = {.lex_state = 8},
  [1779] = {.lex_state = 0},
  [1780] = {.lex_state = 0},
  [1781] = {.lex_state = 0},
  [1782] = {.lex_state = 0},
  [1783] = {.lex_state = 7},
  [1784] = {.lex_state = 0},
  [1785] = {.lex_state = 0},
  [1786] = {.lex_state = 0},
  [1787] = {.lex_state = 0},
  [1788] = {.lex_state = 0},
  [1789] = {.lex_state = 0},
  [1790] = {.lex_state = 0},
  [1791] = {.lex_state = 7},
  [1792] = {.lex_state = 7},
  [1793] = {.lex_state = 81},
  [1794] = {.lex_state = 0},
  [1795] = {.lex_state = 0},
  [1796] = {.lex_state = 0},
  [1797] = {.lex_state = 0},
  [1798] = {.lex_state = 7},
  [1799] = {.lex_state = 0},
  [1800] = {.lex_state = 0},
  [1801] = {.lex_state = 0},
  [1802] = {.lex_state = 0},
  [1803] = {.lex_state = 81},
  [1804] = {.lex_state = 8},
  [1805] = {.lex_state = 8},
  [1806] = {.lex_state = 81},
  [1807] = {.lex_state = 8},
  [1808] = {.lex_state = 8},
  [1809] = {.lex_state = 78},
  [1810] = {.lex_state = 0},
  [1811] = {.lex_state = 8},
  [1812] = {.lex_state = 8},
  [1813] = {.lex_state = 8},
  [1814] = {.lex_state = 0},
  [1815] = {.lex_state = 81},
  [1816] = {.lex_state = 0},
  [1817] = {.lex_state = 0},
  [1818] = {.lex_state = 7},
  [1819] = {.lex_state = 0},
  [1820] = {.lex_state = 8},
  [1821] = {.lex_state = 0},
  [1822] = {.lex_state = 0},
  [1823] = {.lex_state = 0},
  [1824] = {.lex_state = 0},
  [1825] = {.lex_state = 0},
  [1826] = {.lex_state = 0},
  [1827] = {.lex_state = 0},
  [1828] = {.lex_state = 81},
  [1829] = {.lex_state = 7},
  [1830] = {.lex_state = 7},
  [1831] = {.lex_state = 33},
  [1832] = {.lex_state = 8},
  [1833] = {.lex_state = 0},
  [1834] = {.lex_state = 0},
  [1835] = {.lex_state = 0},
  [1836] = {.lex_state = 8},
  [1837] = {.lex_state = 8},
  [1838] = {.lex_state = 8},
  [1839] = {.lex_state = 8},
  [1840] = {.lex_state = 0},
  [1841] = {.lex_state = 8},
  [1842] = {.lex_state = 8},
  [1843] = {.lex_state = 0},
  [1844] = {.lex_state = 0},
  [1845] = {.lex_state = 7},
  [1846] = {.lex_state = 0},
  [1847] = {.lex_state = 81},
  [1848] = {.lex_state = 0},
  [1849] = {.lex_state = 0},
  [1850] = {.lex_state = 8},
  [1851] = {.lex_state = 33},
  [1852] = {.lex_state = 0},
  [1853] = {.lex_state = 0},
  [1854] = {.lex_state = 0},
  [1855] = {.lex_state = 7},
  [1856] = {.lex_state = 0},
  [1857] = {.lex_state = 0},
  [1858] = {.lex_state = 0},
  [1859] = {.lex_state = 33},
  [1860] = {.lex_state = 81},
  [1861] = {.lex_state = 7},
  [1862] = {.lex_state = 7},
  [1863] = {.lex_state = 8},
  [1864] = {.lex_state = 0},
  [1865] = {.lex_state = 81},
  [1866] = {.lex_state = 7},
  [1867] = {.lex_state = 81},
  [1868] = {.lex_state = 0},
  [1869] = {.lex_state = 81},
  [1870] = {.lex_state = 0},
  [1871] = {.lex_state = 0},
  [1872] = {.lex_state = 0},
  [1873] = {.lex_state = 0},
  [1874] = {.lex_state = 0},
  [1875] = {.lex_state = 0},
  [1876] = {.lex_state = 0},
  [1877] = {.lex_state = 0},
  [1878] = {.lex_state = 33},
  [1879] = {.lex_state = 0},
  [1880] = {.lex_state = 0},
  [1881] = {.lex_state = 81},
  [1882] = {.lex_state = 0},
  [1883] = {.lex_state = 0},
  [1884] = {.lex_state = 0},
  [1885] = {.lex_state = 0},
  [1886] = {.lex_state = 0},
  [1887] = {.lex_state = 0},
  [1888] = {.lex_state = 0},
  [1889] = {.lex_state = 0},
  [1890] = {.lex_state = 7},
  [1891] = {.lex_state = 81},
  [1892] = {.lex_state = 33},
  [1893] = {.lex_state = 0},
  [1894] = {.lex_state = 0},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 81},
  [1897] = {.lex_state = 0},
  [1898] = {.lex_state = 0},
  [1899] = {.lex_state = 0},
  [1900] = {.lex_state = 0},
  [1901] = {.lex_state = 0},
  [1902] = {.lex_state = 0},
  [1903] = {.lex_state = 0},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 0},
  [1906] = {.lex_state = 7},
  [1907] = {.lex_state = 0},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 0},
  [1910] = {.lex_state = 0},
  [1911] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_blank_identifier] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_func] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_map] = ACTIONS(1),
    [anon_sym_chan] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_fallthrough] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_go] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_range] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_make] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [sym_raw_string_literal] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_int_literal] = ACTIONS(1),
    [sym_nil] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_iota] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_templ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_LBRACE_BANG] = ACTIONS(1),
    [anon_sym_children_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_LT_SLASH] = ACTIONS(1),
    [anon_sym_SLASH_GT] = ACTIONS(1),
    [anon_sym_LT_BANG] = ACTIONS(1),
    [anon_sym_html] = ACTIONS(1),
    [anon_sym_style] = ACTIONS(1),
    [anon_sym_if2] = ACTIONS(1),
    [anon_sym_else2] = ACTIONS(1),
    [anon_sym_css] = ACTIONS(1),
    [anon_sym_script] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_css_property_value] = ACTIONS(1),
    [sym_element_text] = ACTIONS(1),
    [sym_element_comment] = ACTIONS(1),
    [sym_style_element_text] = ACTIONS(1),
    [sym_script_block_text] = ACTIONS(1),
    [sym_script_element_text] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(1858),
    [sym_package_clause] = STATE(1322),
    [sym_import_declaration] = STATE(1322),
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_function_declaration] = STATE(1322),
    [sym_method_declaration] = STATE(1322),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement] = STATE(1459),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_component_declaration] = STATE(1322),
    [sym_css_declaration] = STATE(1322),
    [sym_script_declaration] = STATE(1322),
    [aux_sym_source_file_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [anon_sym_templ] = ACTIONS(75),
    [anon_sym_css] = ACTIONS(77),
    [anon_sym_script] = ACTIONS(79),
  },
  [2] = {
    [sym_package_clause] = STATE(1459),
    [sym_import_declaration] = STATE(1459),
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_function_declaration] = STATE(1459),
    [sym_method_declaration] = STATE(1459),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement] = STATE(1459),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_component_declaration] = STATE(1459),
    [sym_css_declaration] = STATE(1459),
    [sym_script_declaration] = STATE(1459),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(81),
    [sym_identifier] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(86),
    [anon_sym_package] = ACTIONS(89),
    [anon_sym_import] = ACTIONS(92),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_const] = ACTIONS(98),
    [anon_sym_var] = ACTIONS(101),
    [anon_sym_func] = ACTIONS(104),
    [anon_sym_LBRACK] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(110),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(116),
    [anon_sym_TILDE] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_interface] = ACTIONS(125),
    [anon_sym_map] = ACTIONS(128),
    [anon_sym_chan] = ACTIONS(131),
    [anon_sym_LT_DASH] = ACTIONS(134),
    [anon_sym_fallthrough] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(140),
    [anon_sym_continue] = ACTIONS(143),
    [anon_sym_goto] = ACTIONS(146),
    [anon_sym_return] = ACTIONS(149),
    [anon_sym_go] = ACTIONS(152),
    [anon_sym_defer] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(158),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_switch] = ACTIONS(164),
    [anon_sym_select] = ACTIONS(167),
    [anon_sym_new] = ACTIONS(170),
    [anon_sym_make] = ACTIONS(170),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_CARET] = ACTIONS(173),
    [anon_sym_AMP] = ACTIONS(173),
    [sym_raw_string_literal] = ACTIONS(176),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [sym_int_literal] = ACTIONS(182),
    [sym_float_literal] = ACTIONS(182),
    [sym_imaginary_literal] = ACTIONS(182),
    [sym_rune_literal] = ACTIONS(176),
    [sym_nil] = ACTIONS(182),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_iota] = ACTIONS(182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_templ] = ACTIONS(185),
    [anon_sym_css] = ACTIONS(188),
    [anon_sym_script] = ACTIONS(191),
  },
  [3] = {
    [sym_package_clause] = STATE(1332),
    [sym_import_declaration] = STATE(1332),
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_function_declaration] = STATE(1332),
    [sym_method_declaration] = STATE(1332),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement] = STATE(1459),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_component_declaration] = STATE(1332),
    [sym_css_declaration] = STATE(1332),
    [sym_script_declaration] = STATE(1332),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(194),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
    [anon_sym_templ] = ACTIONS(75),
    [anon_sym_css] = ACTIONS(77),
    [anon_sym_script] = ACTIONS(79),
  },
  [4] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1564),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1564),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(200),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(202),
    [anon_sym_default] = ACTIONS(202),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1489),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1489),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(204),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(206),
    [anon_sym_default] = ACTIONS(206),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1498),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1498),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(208),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(210),
    [anon_sym_default] = ACTIONS(210),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1505),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1505),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(212),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(214),
    [anon_sym_default] = ACTIONS(214),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1569),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1569),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(218),
    [anon_sym_default] = ACTIONS(218),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement] = STATE(1195),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1593),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(220),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(222),
    [anon_sym_default] = ACTIONS(222),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement] = STATE(1195),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1517),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(224),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(226),
    [anon_sym_default] = ACTIONS(226),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement] = STATE(1178),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(230),
    [anon_sym_default] = ACTIONS(230),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1787),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1787),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(232),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1817),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1817),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1767),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1767),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(236),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1756),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1756),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(238),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1844),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1844),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(240),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1782),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1782),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(242),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement_list] = STATE(1887),
    [sym__statement] = STATE(1120),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_empty_labeled_statement] = STATE(1887),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement] = STATE(1195),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__declaration] = STATE(1139),
    [sym_const_declaration] = STATE(1139),
    [sym_var_declaration] = STATE(1139),
    [sym_type_declaration] = STATE(1139),
    [sym_expression_list] = STATE(878),
    [sym_parenthesized_type] = STATE(1652),
    [sym__simple_type] = STATE(1652),
    [sym_generic_type] = STATE(1323),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1323),
    [sym_implicit_length_array_type] = STATE(1654),
    [sym_slice_type] = STATE(1323),
    [sym_struct_type] = STATE(1323),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1323),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1139),
    [sym__statement] = STATE(1178),
    [sym_empty_statement] = STATE(1139),
    [sym__simple_statement] = STATE(1139),
    [sym_expression_statement] = STATE(1140),
    [sym_send_statement] = STATE(1140),
    [sym_inc_statement] = STATE(1140),
    [sym_dec_statement] = STATE(1140),
    [sym_assignment_statement] = STATE(1140),
    [sym_short_var_declaration] = STATE(1140),
    [sym_labeled_statement] = STATE(1139),
    [sym_fallthrough_statement] = STATE(1139),
    [sym_break_statement] = STATE(1139),
    [sym_continue_statement] = STATE(1139),
    [sym_goto_statement] = STATE(1139),
    [sym_return_statement] = STATE(1139),
    [sym_go_statement] = STATE(1139),
    [sym_defer_statement] = STATE(1139),
    [sym_if_statement] = STATE(1139),
    [sym_for_statement] = STATE(1139),
    [sym_expression_switch_statement] = STATE(1139),
    [sym_type_switch_statement] = STATE(1139),
    [sym_select_statement] = STATE(1139),
    [sym__expression] = STATE(282),
    [sym_parenthesized_expression] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_selector_expression] = STATE(322),
    [sym_index_expression] = STATE(322),
    [sym_slice_expression] = STATE(322),
    [sym_type_assertion_expression] = STATE(322),
    [sym_type_conversion_expression] = STATE(322),
    [sym_composite_literal] = STATE(322),
    [sym_func_literal] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_qualified_type] = STATE(1141),
    [sym_interpreted_string_literal] = STATE(322),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(73),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_expression_list] = STATE(883),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym_block] = STATE(1151),
    [sym__simple_statement] = STATE(1800),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym_for_clause] = STATE(1689),
    [sym_range_clause] = STATE(1689),
    [sym__expression] = STATE(313),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_range] = ACTIONS(258),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_expression_list] = STATE(883),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1800),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym_for_clause] = STATE(1633),
    [sym_range_clause] = STATE(1633),
    [sym__expression] = STATE(321),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_component_block] = STATE(1003),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(270),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_range] = ACTIONS(258),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_expression_list] = STATE(883),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1800),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym_for_clause] = STATE(1705),
    [sym_range_clause] = STATE(1705),
    [sym__expression] = STATE(314),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_component_block] = STATE(988),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(272),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_range] = ACTIONS(258),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_expression_list] = STATE(883),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1800),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym_for_clause] = STATE(1703),
    [sym_range_clause] = STATE(1703),
    [sym__expression] = STATE(325),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_component_block] = STATE(1574),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(274),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_range] = ACTIONS(258),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_expression_list] = STATE(884),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1795),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__type_switch_header] = STATE(1793),
    [sym__expression] = STATE(334),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(276),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_expression_list] = STATE(876),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1873),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(335),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(278),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_expression_list] = STATE(874),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1847),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(344),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(280),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_expression_list] = STATE(876),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1894),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(337),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(282),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_expression_list] = STATE(874),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1775),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(344),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(284),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_expression_list] = STATE(874),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1881),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(344),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(286),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_expression_list] = STATE(874),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1803),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(344),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(288),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_expression_list] = STATE(876),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1880),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(336),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(290),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_expression_list] = STATE(876),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1875),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(296),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_expression_list] = STATE(876),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1876),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(318),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_expression_list] = STATE(876),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1802),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(310),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_expression_list] = STATE(876),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1893),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(332),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_expression_list] = STATE(876),
    [sym_parenthesized_type] = STATE(1616),
    [sym__simple_type] = STATE(1616),
    [sym_generic_type] = STATE(1395),
    [sym_pointer_type] = STATE(1034),
    [sym_array_type] = STATE(1395),
    [sym_implicit_length_array_type] = STATE(1621),
    [sym_slice_type] = STATE(1395),
    [sym_struct_type] = STATE(1395),
    [sym_union_type] = STATE(1027),
    [sym_negated_type] = STATE(1027),
    [sym_interface_type] = STATE(1034),
    [sym_map_type] = STATE(1395),
    [sym_channel_type] = STATE(1034),
    [sym_function_type] = STATE(1034),
    [sym__simple_statement] = STATE(1879),
    [sym_expression_statement] = STATE(1736),
    [sym_send_statement] = STATE(1736),
    [sym_inc_statement] = STATE(1736),
    [sym_dec_statement] = STATE(1736),
    [sym_assignment_statement] = STATE(1736),
    [sym_short_var_declaration] = STATE(1736),
    [sym__expression] = STATE(312),
    [sym_parenthesized_expression] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_selector_expression] = STATE(377),
    [sym_index_expression] = STATE(377),
    [sym_slice_expression] = STATE(377),
    [sym_type_assertion_expression] = STATE(377),
    [sym_type_conversion_expression] = STATE(377),
    [sym_composite_literal] = STATE(377),
    [sym_func_literal] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_qualified_type] = STATE(1217),
    [sym_interpreted_string_literal] = STATE(377),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_func] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(260),
    [anon_sym_make] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_AMP] = ACTIONS(262),
    [sym_raw_string_literal] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(266),
    [sym_int_literal] = ACTIONS(268),
    [sym_float_literal] = ACTIONS(268),
    [sym_imaginary_literal] = ACTIONS(268),
    [sym_rune_literal] = ACTIONS(264),
    [sym_nil] = ACTIONS(268),
    [sym_true] = ACTIONS(268),
    [sym_false] = ACTIONS(268),
    [sym_iota] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(294), 1,
      anon_sym_LF,
    ACTIONS(298), 1,
      anon_sym_LPAREN,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(302), 1,
      anon_sym_LBRACK,
    ACTIONS(304), 1,
      anon_sym_STAR,
    ACTIONS(306), 1,
      anon_sym_TILDE,
    ACTIONS(308), 1,
      anon_sym_LT_DASH,
    ACTIONS(316), 1,
      anon_sym_DQUOTE,
    ACTIONS(318), 1,
      sym_comment,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1150), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(296), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(312), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 9,
      sym_raw_string_literal,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [119] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(324), 1,
      anon_sym_COMMA,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(332), 1,
      anon_sym_RBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1378), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1555), 1,
      sym_keyed_element,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [245] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      anon_sym_COMMA,
    ACTIONS(348), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1364), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1563), 1,
      sym_keyed_element,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [371] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(350), 1,
      anon_sym_COMMA,
    ACTIONS(352), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1346), 1,
      sym_literal_element,
    STATE(1533), 1,
      sym_keyed_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [497] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(354), 1,
      anon_sym_COMMA,
    ACTIONS(356), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1388), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1609), 1,
      sym_keyed_element,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [623] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(358), 1,
      anon_sym_COMMA,
    ACTIONS(360), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1359), 1,
      sym_literal_element,
    STATE(1553), 1,
      sym_keyed_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [749] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(362), 1,
      anon_sym_COMMA,
    ACTIONS(364), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1428), 1,
      sym_literal_element,
    STATE(1511), 1,
      sym_keyed_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [875] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(366), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [998] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(368), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1121] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(370), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1244] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(372), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1367] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(374), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1490] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(376), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1613] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(378), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1736] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(380), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1859] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(382), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1982] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(384), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2105] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(386), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2228] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(388), 1,
      anon_sym_RBRACE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2351] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1469), 1,
      sym_literal_element,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1667), 1,
      sym_keyed_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2471] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(635), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1554), 1,
      sym_literal_value,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1663), 1,
      sym_literal_element,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2588] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(390), 1,
      sym_identifier,
    ACTIONS(392), 1,
      anon_sym_LPAREN,
    ACTIONS(394), 1,
      anon_sym_func,
    ACTIONS(396), 1,
      anon_sym_STAR,
    ACTIONS(398), 1,
      anon_sym_LT_DASH,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    STATE(499), 1,
      sym__expression,
    STATE(1172), 1,
      sym_qualified_type,
    STATE(1619), 1,
      sym_expression_list,
    STATE(1710), 1,
      sym_implicit_length_array_type,
    ACTIONS(400), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(404), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1614), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1898), 2,
      sym_send_statement,
      sym_receive_statement,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(402), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1351), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(408), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(595), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2703] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      sym_identifier,
    ACTIONS(412), 1,
      anon_sym_RBRACK,
    ACTIONS(414), 1,
      anon_sym_STAR,
    STATE(771), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1587), 1,
      sym_parameter_declaration,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1381), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2817] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(418), 1,
      anon_sym_RPAREN,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2931] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(426), 1,
      anon_sym_RBRACE,
    ACTIONS(428), 1,
      anon_sym_children_DOT_DOT_DOT,
    STATE(748), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3045] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(430), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3159] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(436), 1,
      anon_sym_LBRACE,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(583), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1895), 1,
      sym_expression_list,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3273] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(442), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3387] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(444), 1,
      anon_sym_RPAREN,
    STATE(585), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1504), 1,
      sym_variadic_argument,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3501] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(446), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3615] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(448), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3729] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(450), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3843] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(452), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3957] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(454), 1,
      anon_sym_COMMA,
    ACTIONS(456), 1,
      anon_sym_RBRACE,
    ACTIONS(458), 1,
      sym_raw_string_literal,
    STATE(629), 1,
      sym__expression,
    STATE(799), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [4075] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(460), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4189] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(462), 1,
      anon_sym_RPAREN,
    STATE(570), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1495), 1,
      sym_variadic_argument,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4303] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(464), 1,
      anon_sym_range,
    STATE(577), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1612), 1,
      sym_expression_list,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4417] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(466), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4531] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(468), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4645] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(470), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4759] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(472), 1,
      anon_sym_RPAREN,
    STATE(574), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1561), 1,
      sym_variadic_argument,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4873] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(474), 1,
      anon_sym_RPAREN,
    STATE(579), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1590), 1,
      sym_variadic_argument,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4987] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(476), 1,
      anon_sym_RBRACE,
    ACTIONS(478), 1,
      anon_sym_children_DOT_DOT_DOT,
    STATE(815), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5101] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(464), 1,
      anon_sym_range,
    STATE(577), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1682), 1,
      sym_expression_list,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5215] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(480), 1,
      anon_sym_COMMA,
    ACTIONS(482), 1,
      anon_sym_RBRACE,
    ACTIONS(484), 1,
      sym_raw_string_literal,
    STATE(619), 1,
      sym__expression,
    STATE(836), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [5333] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(486), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5447] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(488), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5561] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(490), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5675] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(492), 1,
      anon_sym_RPAREN,
    STATE(573), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1514), 1,
      sym_variadic_argument,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5789] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_RBRACK,
    ACTIONS(496), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(782), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5903] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(498), 1,
      anon_sym_RPAREN,
    STATE(571), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1566), 1,
      sym_variadic_argument,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6017] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(500), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6131] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(502), 1,
      anon_sym_RBRACE,
    ACTIONS(504), 1,
      anon_sym_children_DOT_DOT_DOT,
    STATE(828), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6245] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(506), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6359] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(508), 1,
      anon_sym_RPAREN,
    STATE(576), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1562), 1,
      sym_variadic_argument,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6473] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(510), 1,
      anon_sym_COMMA,
    ACTIONS(512), 1,
      anon_sym_RBRACE,
    ACTIONS(514), 1,
      sym_raw_string_literal,
    STATE(646), 1,
      sym__expression,
    STATE(716), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [6591] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(516), 1,
      anon_sym_RPAREN,
    STATE(572), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1526), 1,
      sym_variadic_argument,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6705] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(520), 1,
      anon_sym_COLON,
    STATE(675), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1291), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6816] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(577), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1682), 1,
      sym_expression_list,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6927] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(494), 1,
      anon_sym_RBRACK,
    ACTIONS(518), 1,
      sym_identifier,
    STATE(782), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1291), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7038] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(522), 1,
      anon_sym_RBRACK,
    STATE(664), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7149] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1243), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7260] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1242), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7371] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(536), 1,
      anon_sym_RBRACK,
    STATE(703), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7482] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(538), 1,
      anon_sym_RBRACK,
    STATE(667), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7593] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(540), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7704] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(542), 1,
      anon_sym_RBRACK,
    STATE(838), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7815] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_RBRACK,
    STATE(782), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7926] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(502), 1,
      anon_sym_RBRACE,
    STATE(828), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8037] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(642), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1682), 1,
      sym_expression_list,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8148] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_LBRACE,
    STATE(814), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8259] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(642), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1612), 1,
      sym_expression_list,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8370] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1241), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8481] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1240), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8592] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(546), 1,
      anon_sym_SEMI,
    STATE(811), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8703] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(548), 1,
      anon_sym_RBRACK,
    STATE(680), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8814] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(550), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8925] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(552), 1,
      anon_sym_COLON,
    STATE(697), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1291), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9036] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(554), 1,
      anon_sym_RBRACK,
    STATE(676), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9147] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(556), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9258] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    ACTIONS(558), 1,
      anon_sym_LBRACE,
    STATE(793), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9369] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(560), 1,
      anon_sym_RBRACK,
    STATE(738), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9480] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(577), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1788), 1,
      sym_expression_list,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9591] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(562), 1,
      anon_sym_RBRACE,
    ACTIONS(564), 1,
      sym_raw_string_literal,
    STATE(709), 1,
      sym__expression,
    STATE(849), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [9706] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_RBRACK,
    STATE(712), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9817] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(412), 1,
      anon_sym_RBRACK,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(518), 1,
      sym_identifier,
    STATE(771), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1311), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9928] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(568), 1,
      anon_sym_COLON,
    STATE(658), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1291), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10039] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(631), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1612), 1,
      sym_expression_list,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10150] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(632), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1679), 1,
      sym_variadic_argument,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10261] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(570), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10372] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(564), 1,
      sym_raw_string_literal,
    ACTIONS(572), 1,
      anon_sym_RBRACE,
    STATE(709), 1,
      sym__expression,
    STATE(849), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [10487] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(577), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    STATE(1882), 1,
      sym_expression_list,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10598] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(574), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10709] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(576), 1,
      anon_sym_RBRACK,
    STATE(816), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10820] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(578), 1,
      anon_sym_RBRACK,
    STATE(701), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10931] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(580), 1,
      anon_sym_RBRACK,
    STATE(794), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11042] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(582), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11153] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(584), 1,
      anon_sym_SEMI,
    STATE(759), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11264] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(586), 1,
      anon_sym_RBRACK,
    STATE(689), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11375] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(588), 1,
      anon_sym_COLON,
    STATE(681), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1291), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11486] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1179), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11597] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1180), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11708] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1201), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11819] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1197), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11930] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(564), 1,
      sym_raw_string_literal,
    ACTIONS(590), 1,
      anon_sym_RBRACE,
    STATE(709), 1,
      sym__expression,
    STATE(849), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [12045] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(564), 1,
      sym_raw_string_literal,
    ACTIONS(592), 1,
      anon_sym_RBRACE,
    STATE(709), 1,
      sym__expression,
    STATE(849), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [12160] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(594), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12271] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(596), 1,
      anon_sym_RBRACK,
    STATE(705), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12382] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(598), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12493] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(600), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12604] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(602), 1,
      anon_sym_RBRACK,
    STATE(714), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12715] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      anon_sym_RBRACK,
    STATE(672), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12826] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(606), 1,
      anon_sym_COLON,
    STATE(692), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1291), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12937] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(412), 1,
      anon_sym_RBRACK,
    STATE(771), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13048] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(608), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13159] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_LBRACE,
    STATE(832), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13270] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(577), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1612), 1,
      sym_expression_list,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13381] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(612), 1,
      anon_sym_RBRACK,
    STATE(669), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13492] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(564), 1,
      sym_raw_string_literal,
    ACTIONS(614), 1,
      anon_sym_RBRACE,
    STATE(709), 1,
      sym__expression,
    STATE(849), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [13607] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1187), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13718] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(564), 1,
      sym_raw_string_literal,
    ACTIONS(616), 1,
      anon_sym_RBRACE,
    STATE(709), 1,
      sym__expression,
    STATE(849), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [13833] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(518), 1,
      sym_identifier,
    ACTIONS(618), 1,
      anon_sym_COLON,
    STATE(702), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1291), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13944] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(620), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14055] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(622), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14166] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1184), 1,
      sym_expression_list,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14277] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym_func,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(632), 1,
      anon_sym_LT_DASH,
    ACTIONS(640), 1,
      anon_sym_DQUOTE,
    STATE(386), 1,
      sym__expression,
    STATE(1188), 1,
      sym_qualified_type,
    STATE(1656), 1,
      sym_implicit_length_array_type,
    ACTIONS(634), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(638), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1615), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(636), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1375), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(642), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(416), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14385] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(450), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14493] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(198), 1,
      anon_sym_func,
    ACTIONS(644), 1,
      sym_identifier,
    STATE(288), 1,
      sym__expression,
    STATE(1141), 1,
      sym_qualified_type,
    STATE(1654), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(69), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1652), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1323), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(322), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14601] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(699), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14709] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14817] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(845), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14925] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(492), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15033] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(390), 1,
      sym_identifier,
    ACTIONS(392), 1,
      anon_sym_LPAREN,
    ACTIONS(394), 1,
      anon_sym_func,
    ACTIONS(396), 1,
      anon_sym_STAR,
    ACTIONS(398), 1,
      anon_sym_LT_DASH,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    ACTIONS(646), 1,
      anon_sym_chan,
    STATE(554), 1,
      sym__expression,
    STATE(1172), 1,
      sym_qualified_type,
    STATE(1710), 1,
      sym_implicit_length_array_type,
    ACTIONS(400), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(404), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1614), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(402), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1351), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(408), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(595), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15141] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym_func,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(632), 1,
      anon_sym_LT_DASH,
    ACTIONS(640), 1,
      anon_sym_DQUOTE,
    STATE(384), 1,
      sym__expression,
    STATE(1188), 1,
      sym_qualified_type,
    STATE(1656), 1,
      sym_implicit_length_array_type,
    ACTIONS(634), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(638), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(636), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1375), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(642), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(416), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15249] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(553), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15357] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(485), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15465] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(624), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15573] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym_func,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(632), 1,
      anon_sym_LT_DASH,
    ACTIONS(640), 1,
      anon_sym_DQUOTE,
    ACTIONS(646), 1,
      anon_sym_chan,
    STATE(384), 1,
      sym__expression,
    STATE(1188), 1,
      sym_qualified_type,
    STATE(1656), 1,
      sym_implicit_length_array_type,
    ACTIONS(634), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(638), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1615), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(636), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1375), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(642), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(416), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15681] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(825), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15789] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15897] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16005] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(432), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16113] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(657), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16221] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(823), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16329] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(652), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16437] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(648), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16545] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(824), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16653] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(691), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16761] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(622), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16869] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(621), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16977] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(820), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17085] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(644), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17193] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(620), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17301] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(694), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17409] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17517] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(390), 1,
      sym_identifier,
    ACTIONS(392), 1,
      anon_sym_LPAREN,
    ACTIONS(394), 1,
      anon_sym_func,
    ACTIONS(396), 1,
      anon_sym_STAR,
    ACTIONS(398), 1,
      anon_sym_LT_DASH,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    STATE(535), 1,
      sym__expression,
    STATE(1172), 1,
      sym_qualified_type,
    STATE(1710), 1,
      sym_implicit_length_array_type,
    ACTIONS(400), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(404), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1614), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(402), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1351), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(408), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(595), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17625] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(390), 1,
      sym_identifier,
    ACTIONS(392), 1,
      anon_sym_LPAREN,
    ACTIONS(394), 1,
      anon_sym_func,
    ACTIONS(396), 1,
      anon_sym_STAR,
    ACTIONS(398), 1,
      anon_sym_LT_DASH,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    STATE(536), 1,
      sym__expression,
    STATE(1172), 1,
      sym_qualified_type,
    STATE(1710), 1,
      sym_implicit_length_array_type,
    ACTIONS(400), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(404), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1614), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(402), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1351), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(408), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(595), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17733] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(735), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17841] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym_func,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(632), 1,
      anon_sym_LT_DASH,
    ACTIONS(640), 1,
      anon_sym_DQUOTE,
    STATE(383), 1,
      sym__expression,
    STATE(1188), 1,
      sym_qualified_type,
    STATE(1656), 1,
      sym_implicit_length_array_type,
    ACTIONS(634), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(638), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1615), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(636), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1375), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(642), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(416), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17949] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(646), 1,
      anon_sym_chan,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18057] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym_func,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(632), 1,
      anon_sym_LT_DASH,
    ACTIONS(640), 1,
      anon_sym_DQUOTE,
    STATE(385), 1,
      sym__expression,
    STATE(1188), 1,
      sym_qualified_type,
    STATE(1656), 1,
      sym_implicit_length_array_type,
    ACTIONS(634), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(638), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1615), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(636), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1375), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(642), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(416), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18165] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(198), 1,
      anon_sym_func,
    ACTIONS(644), 1,
      sym_identifier,
    STATE(286), 1,
      sym__expression,
    STATE(1141), 1,
      sym_qualified_type,
    STATE(1654), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(69), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1652), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1323), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(322), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18273] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(848), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18381] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(648), 1,
      anon_sym_STAR,
    STATE(772), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1470), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18489] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym_func,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(632), 1,
      anon_sym_LT_DASH,
    ACTIONS(640), 1,
      anon_sym_DQUOTE,
    STATE(382), 1,
      sym__expression,
    STATE(1188), 1,
      sym_qualified_type,
    STATE(1656), 1,
      sym_implicit_length_array_type,
    ACTIONS(634), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(638), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1615), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(636), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1375), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(642), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(416), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18597] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(340), 1,
      sym_rune_literal,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(564), 1,
      sym_raw_string_literal,
    STATE(709), 1,
      sym__expression,
    STATE(849), 1,
      sym_interpreted_string_literal,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 11,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
  [18709] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym_func,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(632), 1,
      anon_sym_LT_DASH,
    ACTIONS(640), 1,
      anon_sym_DQUOTE,
    STATE(387), 1,
      sym__expression,
    STATE(1188), 1,
      sym_qualified_type,
    STATE(1656), 1,
      sym_implicit_length_array_type,
    ACTIONS(634), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(638), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1615), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(636), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1375), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(642), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(416), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18817] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(674), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18925] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_LPAREN,
    ACTIONS(252), 1,
      anon_sym_func,
    ACTIONS(254), 1,
      anon_sym_STAR,
    ACTIONS(256), 1,
      anon_sym_LT_DASH,
    ACTIONS(266), 1,
      anon_sym_DQUOTE,
    STATE(339), 1,
      sym__expression,
    STATE(1217), 1,
      sym_qualified_type,
    STATE(1621), 1,
      sym_implicit_length_array_type,
    ACTIONS(260), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(264), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(262), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1395), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(268), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(377), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19033] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(414), 1,
      anon_sym_STAR,
    ACTIONS(518), 1,
      sym_identifier,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19141] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(698), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19249] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(512), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19357] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(198), 1,
      anon_sym_func,
    ACTIONS(644), 1,
      sym_identifier,
    STATE(285), 1,
      sym__expression,
    STATE(1141), 1,
      sym_qualified_type,
    STATE(1654), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(69), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1652), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1323), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(322), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19465] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym_func,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(632), 1,
      anon_sym_LT_DASH,
    ACTIONS(640), 1,
      anon_sym_DQUOTE,
    STATE(384), 1,
      sym__expression,
    STATE(1188), 1,
      sym_qualified_type,
    STATE(1656), 1,
      sym_implicit_length_array_type,
    ACTIONS(634), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(638), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1615), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(636), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1375), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(642), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(416), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19573] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(198), 1,
      anon_sym_func,
    ACTIONS(644), 1,
      sym_identifier,
    STATE(284), 1,
      sym__expression,
    STATE(1141), 1,
      sym_qualified_type,
    STATE(1654), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(69), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1652), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1323), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(322), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19681] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19789] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(743), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19897] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(432), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20005] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(487), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20113] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(742), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20221] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym_func,
    ACTIONS(630), 1,
      anon_sym_STAR,
    ACTIONS(632), 1,
      anon_sym_LT_DASH,
    ACTIONS(640), 1,
      anon_sym_DQUOTE,
    STATE(388), 1,
      sym__expression,
    STATE(1188), 1,
      sym_qualified_type,
    STATE(1656), 1,
      sym_implicit_length_array_type,
    ACTIONS(634), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(638), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1615), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(636), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1375), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(642), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(416), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20329] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(648), 1,
      anon_sym_STAR,
    STATE(717), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1470), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20437] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(390), 1,
      sym_identifier,
    ACTIONS(392), 1,
      anon_sym_LPAREN,
    ACTIONS(394), 1,
      anon_sym_func,
    ACTIONS(396), 1,
      anon_sym_STAR,
    ACTIONS(398), 1,
      anon_sym_LT_DASH,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    STATE(554), 1,
      sym__expression,
    STATE(1172), 1,
      sym_qualified_type,
    STATE(1710), 1,
      sym_implicit_length_array_type,
    ACTIONS(400), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(404), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(402), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1351), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(408), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(595), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20545] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(648), 1,
      anon_sym_STAR,
    STATE(734), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1470), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20653] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(463), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20761] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(390), 1,
      sym_identifier,
    ACTIONS(392), 1,
      anon_sym_LPAREN,
    ACTIONS(394), 1,
      anon_sym_func,
    ACTIONS(396), 1,
      anon_sym_STAR,
    ACTIONS(398), 1,
      anon_sym_LT_DASH,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    STATE(554), 1,
      sym__expression,
    STATE(1172), 1,
      sym_qualified_type,
    STATE(1710), 1,
      sym_implicit_length_array_type,
    ACTIONS(400), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(404), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1614), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(402), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1351), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(408), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(595), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20869] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(461), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20977] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(458), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21085] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(688), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21193] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(715), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21301] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(390), 1,
      sym_identifier,
    ACTIONS(392), 1,
      anon_sym_LPAREN,
    ACTIONS(394), 1,
      anon_sym_func,
    ACTIONS(396), 1,
      anon_sym_STAR,
    ACTIONS(398), 1,
      anon_sym_LT_DASH,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    STATE(534), 1,
      sym__expression,
    STATE(1172), 1,
      sym_qualified_type,
    STATE(1710), 1,
      sym_implicit_length_array_type,
    ACTIONS(400), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(404), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1614), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(402), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1351), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(408), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(595), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21409] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(198), 1,
      anon_sym_func,
    ACTIONS(644), 1,
      sym_identifier,
    STATE(287), 1,
      sym__expression,
    STATE(1141), 1,
      sym_qualified_type,
    STATE(1654), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(69), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1652), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1323), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(322), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21517] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(678), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21625] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(785), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21733] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(788), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21841] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_LPAREN,
    ACTIONS(252), 1,
      anon_sym_func,
    ACTIONS(254), 1,
      anon_sym_STAR,
    ACTIONS(256), 1,
      anon_sym_LT_DASH,
    ACTIONS(266), 1,
      anon_sym_DQUOTE,
    STATE(343), 1,
      sym__expression,
    STATE(1217), 1,
      sym_qualified_type,
    STATE(1621), 1,
      sym_implicit_length_array_type,
    ACTIONS(260), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(264), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1616), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(262), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1395), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(268), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(377), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21949] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(489), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22057] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(198), 1,
      anon_sym_func,
    ACTIONS(644), 1,
      sym_identifier,
    STATE(289), 1,
      sym__expression,
    STATE(1141), 1,
      sym_qualified_type,
    STATE(1654), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(69), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1652), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1323), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(322), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22165] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(806), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22273] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(648), 1,
      anon_sym_STAR,
    STATE(790), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1470), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22381] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(390), 1,
      sym_identifier,
    ACTIONS(392), 1,
      anon_sym_LPAREN,
    ACTIONS(394), 1,
      anon_sym_func,
    ACTIONS(396), 1,
      anon_sym_STAR,
    ACTIONS(398), 1,
      anon_sym_LT_DASH,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    STATE(527), 1,
      sym__expression,
    STATE(1172), 1,
      sym_qualified_type,
    STATE(1710), 1,
      sym_implicit_length_array_type,
    ACTIONS(400), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(404), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1614), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(402), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1351), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(408), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(595), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22489] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(390), 1,
      sym_identifier,
    ACTIONS(392), 1,
      anon_sym_LPAREN,
    ACTIONS(394), 1,
      anon_sym_func,
    ACTIONS(396), 1,
      anon_sym_STAR,
    ACTIONS(398), 1,
      anon_sym_LT_DASH,
    ACTIONS(406), 1,
      anon_sym_DQUOTE,
    STATE(539), 1,
      sym__expression,
    STATE(1172), 1,
      sym_qualified_type,
    STATE(1710), 1,
      sym_implicit_length_array_type,
    ACTIONS(400), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(404), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1614), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(402), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1351), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(408), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(595), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22597] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(432), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22705] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(659), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22813] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    ACTIONS(646), 1,
      anon_sym_chan,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22921] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(491), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23029] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(648), 1,
      anon_sym_STAR,
    STATE(792), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1470), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23137] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(804), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23245] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(500), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23353] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23461] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(490), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23569] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(501), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23677] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_LPAREN,
    ACTIONS(252), 1,
      anon_sym_func,
    ACTIONS(254), 1,
      anon_sym_STAR,
    ACTIONS(256), 1,
      anon_sym_LT_DASH,
    ACTIONS(266), 1,
      anon_sym_DQUOTE,
    STATE(342), 1,
      sym__expression,
    STATE(1217), 1,
      sym_qualified_type,
    STATE(1621), 1,
      sym_implicit_length_array_type,
    ACTIONS(260), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(264), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1616), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(262), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1395), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(268), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(377), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23785] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    ACTIONS(646), 1,
      anon_sym_chan,
    STATE(490), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23893] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(662), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24001] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_LPAREN,
    ACTIONS(252), 1,
      anon_sym_func,
    ACTIONS(254), 1,
      anon_sym_STAR,
    ACTIONS(256), 1,
      anon_sym_LT_DASH,
    ACTIONS(266), 1,
      anon_sym_DQUOTE,
    STATE(341), 1,
      sym__expression,
    STATE(1217), 1,
      sym_qualified_type,
    STATE(1621), 1,
      sym_implicit_length_array_type,
    ACTIONS(260), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(264), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1616), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(262), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1395), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(268), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(377), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24109] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_LPAREN,
    ACTIONS(252), 1,
      anon_sym_func,
    ACTIONS(254), 1,
      anon_sym_STAR,
    ACTIONS(256), 1,
      anon_sym_LT_DASH,
    ACTIONS(266), 1,
      anon_sym_DQUOTE,
    STATE(340), 1,
      sym__expression,
    STATE(1217), 1,
      sym_qualified_type,
    STATE(1621), 1,
      sym_implicit_length_array_type,
    ACTIONS(260), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(264), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1616), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(262), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1395), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(268), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(377), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24217] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    STATE(708), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24325] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(198), 1,
      anon_sym_func,
    ACTIONS(644), 1,
      sym_identifier,
    ACTIONS(646), 1,
      anon_sym_chan,
    STATE(289), 1,
      sym__expression,
    STATE(1141), 1,
      sym_qualified_type,
    STATE(1654), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(69), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1652), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1323), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(322), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24433] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_LPAREN,
    ACTIONS(252), 1,
      anon_sym_func,
    ACTIONS(254), 1,
      anon_sym_STAR,
    ACTIONS(256), 1,
      anon_sym_LT_DASH,
    ACTIONS(266), 1,
      anon_sym_DQUOTE,
    STATE(345), 1,
      sym__expression,
    STATE(1217), 1,
      sym_qualified_type,
    STATE(1621), 1,
      sym_implicit_length_array_type,
    ACTIONS(260), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(264), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1616), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(262), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1395), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(268), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(377), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24541] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(781), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24649] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(774), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24757] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(778), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24865] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(648), 1,
      anon_sym_STAR,
    STATE(812), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1470), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [24973] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(835), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [25081] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_LPAREN,
    ACTIONS(252), 1,
      anon_sym_func,
    ACTIONS(254), 1,
      anon_sym_STAR,
    ACTIONS(256), 1,
      anon_sym_LT_DASH,
    ACTIONS(266), 1,
      anon_sym_DQUOTE,
    STATE(339), 1,
      sym__expression,
    STATE(1217), 1,
      sym_qualified_type,
    STATE(1621), 1,
      sym_implicit_length_array_type,
    ACTIONS(260), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(264), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1616), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(262), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1395), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(268), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(377), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [25189] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(490), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [25297] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(729), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [25405] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(800), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [25513] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(671), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [25621] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(524), 1,
      anon_sym_LPAREN,
    ACTIONS(526), 1,
      anon_sym_STAR,
    ACTIONS(528), 1,
      anon_sym_LT_DASH,
    ACTIONS(534), 1,
      anon_sym_DQUOTE,
    STATE(482), 1,
      sym__expression,
    STATE(1137), 1,
      sym_qualified_type,
    STATE(1677), 1,
      sym_implicit_length_array_type,
    ACTIONS(310), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(532), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1624), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(530), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1439), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(314), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(529), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [25729] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(797), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [25837] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(690), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [25945] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(198), 1,
      anon_sym_func,
    ACTIONS(644), 1,
      sym_identifier,
    STATE(289), 1,
      sym__expression,
    STATE(1141), 1,
      sym_qualified_type,
    STATE(1654), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(69), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1323), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(322), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [26053] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(764), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [26161] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(328), 1,
      anon_sym_STAR,
    ACTIONS(334), 1,
      anon_sym_LT_DASH,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    STATE(768), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(338), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [26269] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      sym_identifier,
    ACTIONS(420), 1,
      anon_sym_STAR,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(646), 1,
      anon_sym_chan,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [26377] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(320), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(422), 1,
      anon_sym_LT_DASH,
    ACTIONS(648), 1,
      anon_sym_STAR,
    STATE(430), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1310), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(424), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [26485] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_LPAREN,
    ACTIONS(252), 1,
      anon_sym_func,
    ACTIONS(254), 1,
      anon_sym_STAR,
    ACTIONS(256), 1,
      anon_sym_LT_DASH,
    ACTIONS(266), 1,
      anon_sym_DQUOTE,
    ACTIONS(646), 1,
      anon_sym_chan,
    STATE(339), 1,
      sym__expression,
    STATE(1217), 1,
      sym_qualified_type,
    STATE(1621), 1,
      sym_implicit_length_array_type,
    ACTIONS(260), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(264), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1616), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(262), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1395), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(268), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(377), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [26593] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(322), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(342), 1,
      anon_sym_DQUOTE,
    ACTIONS(432), 1,
      sym_identifier,
    ACTIONS(434), 1,
      anon_sym_STAR,
    ACTIONS(438), 1,
      anon_sym_LT_DASH,
    STATE(693), 1,
      sym__expression,
    STATE(1068), 1,
      sym_qualified_type,
    STATE(1643), 1,
      sym_implicit_length_array_type,
    ACTIONS(336), 2,
      anon_sym_new,
      anon_sym_make,
    ACTIONS(340), 2,
      sym_raw_string_literal,
      sym_rune_literal,
    STATE(1027), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1632), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(440), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1086), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(344), 7,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(467), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [26701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_rune_literal,
    ACTIONS(650), 34,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      sym_identifier,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
      anon_sym_templ,
      anon_sym_css,
      anon_sym_script,
  [26759] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(654), 1,
      anon_sym_DOT,
    ACTIONS(657), 1,
      anon_sym_LPAREN,
    ACTIONS(661), 1,
      anon_sym_COMMA,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(666), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_RBRACK,
    ACTIONS(672), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_PIPE,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    STATE(466), 1,
      sym_literal_value,
    STATE(643), 1,
      aux_sym_parameter_declaration_repeat1,
    STATE(1066), 1,
      sym_type_arguments,
    STATE(1397), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    ACTIONS(682), 4,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(680), 13,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26861] = 10,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(680), 1,
      anon_sym_LF,
    ACTIONS(684), 1,
      anon_sym_DOT,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(690), 1,
      anon_sym_LBRACE,
    ACTIONS(692), 1,
      anon_sym_COLON,
    STATE(327), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(675), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
    ACTIONS(682), 40,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26932] = 10,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(680), 1,
      anon_sym_LF,
    ACTIONS(684), 1,
      anon_sym_DOT,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(690), 1,
      anon_sym_LBRACE,
    ACTIONS(694), 1,
      anon_sym_COLON,
    STATE(327), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(675), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
    ACTIONS(682), 40,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27003] = 19,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(696), 1,
      anon_sym_LF,
    ACTIONS(700), 1,
      anon_sym_DOT,
    ACTIONS(702), 1,
      anon_sym_LPAREN,
    ACTIONS(704), 1,
      anon_sym_COMMA,
    ACTIONS(708), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 1,
      anon_sym_LT_DASH,
    ACTIONS(716), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(718), 1,
      anon_sym_DASH_DASH,
    ACTIONS(722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(724), 1,
      anon_sym_PIPE_PIPE,
    STATE(323), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1728), 1,
      sym_type_arguments,
    ACTIONS(712), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(698), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(720), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(710), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(706), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [27091] = 9,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(680), 1,
      anon_sym_LF,
    ACTIONS(684), 1,
      anon_sym_DOT,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(690), 1,
      anon_sym_LBRACE,
    STATE(327), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(675), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
    ACTIONS(682), 40,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27159] = 8,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_DOT,
    ACTIONS(702), 1,
      anon_sym_LPAREN,
    ACTIONS(708), 1,
      anon_sym_LBRACK,
    ACTIONS(726), 1,
      anon_sym_LF,
    STATE(323), 1,
      sym_argument_list,
    STATE(1728), 1,
      sym_type_arguments,
    ACTIONS(728), 41,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27224] = 9,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_DOT,
    ACTIONS(702), 1,
      anon_sym_LPAREN,
    ACTIONS(708), 1,
      anon_sym_LBRACK,
    ACTIONS(726), 1,
      anon_sym_LF,
    STATE(323), 1,
      sym_argument_list,
    STATE(1728), 1,
      sym_type_arguments,
    ACTIONS(710), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(728), 34,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27291] = 10,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_DOT,
    ACTIONS(702), 1,
      anon_sym_LPAREN,
    ACTIONS(708), 1,
      anon_sym_LBRACK,
    ACTIONS(726), 1,
      anon_sym_LF,
    STATE(323), 1,
      sym_argument_list,
    STATE(1728), 1,
      sym_type_arguments,
    ACTIONS(712), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(710), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(728), 30,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27360] = 11,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_DOT,
    ACTIONS(702), 1,
      anon_sym_LPAREN,
    ACTIONS(708), 1,
      anon_sym_LBRACK,
    ACTIONS(726), 1,
      anon_sym_LF,
    STATE(323), 1,
      sym_argument_list,
    STATE(1728), 1,
      sym_type_arguments,
    ACTIONS(712), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(720), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(710), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(728), 24,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27431] = 12,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_DOT,
    ACTIONS(702), 1,
      anon_sym_LPAREN,
    ACTIONS(708), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(726), 1,
      anon_sym_LF,
    STATE(323), 1,
      sym_argument_list,
    STATE(1728), 1,
      sym_type_arguments,
    ACTIONS(712), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(720), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(710), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(728), 23,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
  [27504] = 8,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_DOT,
    ACTIONS(702), 1,
      anon_sym_LPAREN,
    ACTIONS(708), 1,
      anon_sym_LBRACK,
    ACTIONS(730), 1,
      anon_sym_LF,
    STATE(323), 1,
      sym_argument_list,
    STATE(1728), 1,
      sym_type_arguments,
    ACTIONS(732), 41,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27569] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_LF,
    ACTIONS(736), 45,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27623] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(738), 1,
      anon_sym_LF,
    ACTIONS(740), 45,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27677] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_LF,
    ACTIONS(744), 45,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27731] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(680), 1,
      anon_sym_LF,
    ACTIONS(746), 1,
      anon_sym_LPAREN,
    STATE(323), 1,
      sym_special_argument_list,
    ACTIONS(682), 43,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27789] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(748), 1,
      anon_sym_LF,
    ACTIONS(750), 45,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27843] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_LF,
    ACTIONS(754), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27896] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_LBRACE,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(889), 1,
      sym_component_block,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [27987] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(784), 1,
      anon_sym_LF,
    ACTIONS(786), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28040] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(788), 1,
      anon_sym_LF,
    ACTIONS(790), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28093] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(792), 1,
      anon_sym_LF,
    ACTIONS(794), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28146] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(796), 1,
      anon_sym_LF,
    ACTIONS(798), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28199] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(800), 1,
      anon_sym_LF,
    ACTIONS(802), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28252] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(804), 1,
      anon_sym_LF,
    ACTIONS(806), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28305] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(808), 1,
      anon_sym_LF,
    ACTIONS(810), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28358] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(812), 1,
      anon_sym_LF,
    ACTIONS(814), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28411] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(816), 1,
      anon_sym_LF,
    ACTIONS(818), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28464] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(820), 1,
      anon_sym_LF,
    ACTIONS(822), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28517] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(824), 1,
      anon_sym_LF,
    ACTIONS(826), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28570] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(828), 1,
      anon_sym_LF,
    ACTIONS(830), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28623] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LF,
    ACTIONS(834), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28676] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1099), 1,
      sym_block,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [28767] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(836), 1,
      anon_sym_LF,
    ACTIONS(838), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28820] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(909), 1,
      sym_component_block,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [28911] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1169), 1,
      sym_block,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [29002] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(977), 1,
      sym_component_block,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [29093] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LF,
    ACTIONS(842), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29146] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_LF,
    ACTIONS(846), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29199] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_LF,
    ACTIONS(850), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29252] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(852), 1,
      anon_sym_LBRACE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1196), 1,
      sym_conditional_attribute_block,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [29343] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(854), 1,
      anon_sym_LF,
    ACTIONS(856), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29396] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LF,
    ACTIONS(860), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29449] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_LBRACE,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(945), 1,
      sym_component_block,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [29540] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(680), 1,
      anon_sym_LF,
    ACTIONS(682), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29593] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(862), 1,
      anon_sym_LF,
    ACTIONS(864), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29646] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LF,
    ACTIONS(868), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29699] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1560), 1,
      sym_component_block,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [29790] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(870), 1,
      anon_sym_LF,
    ACTIONS(872), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29843] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_LF,
    ACTIONS(876), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29896] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(878), 1,
      anon_sym_LF,
    ACTIONS(880), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29949] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(882), 1,
      anon_sym_LF,
    ACTIONS(884), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30002] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(886), 1,
      anon_sym_LF,
    ACTIONS(888), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30055] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(890), 1,
      anon_sym_LF,
    ACTIONS(892), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30108] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1361), 1,
      sym_component_block,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [30199] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LF,
    ACTIONS(896), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30252] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(898), 1,
      anon_sym_DOT,
    ACTIONS(900), 1,
      anon_sym_LBRACE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [30340] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(902), 1,
      anon_sym_LBRACE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [30428] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(904), 1,
      anon_sym_LBRACE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [30516] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 1,
      anon_sym_SEMI,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(906), 1,
      anon_sym_LBRACE,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [30604] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_DOT,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(675), 1,
      anon_sym_PIPE,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    STATE(358), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(682), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30667] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    STATE(361), 1,
      sym_argument_list,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(732), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(730), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30728] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    STATE(361), 1,
      sym_argument_list,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(728), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30791] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    STATE(361), 1,
      sym_argument_list,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(728), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30856] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(728), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    STATE(361), 1,
      sym_argument_list,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30925] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(728), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    STATE(361), 1,
      sym_argument_list,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [30996] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(772), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(774), 1,
      anon_sym_DASH_DASH,
    ACTIONS(780), 1,
      anon_sym_AMP_AMP,
    ACTIONS(782), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(911), 1,
      anon_sym_LT_DASH,
    STATE(361), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(776), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(764), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(770), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [31081] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(756), 1,
      anon_sym_DOT,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    STATE(361), 1,
      sym_argument_list,
    STATE(1630), 1,
      sym_type_arguments,
    ACTIONS(728), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(726), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31142] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(913), 1,
      anon_sym_LPAREN,
    STATE(361), 1,
      sym_special_argument_list,
    ACTIONS(682), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 26,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(740), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(738), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(858), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(834), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(832), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(808), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(836), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(848), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(866), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(888), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(886), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(890), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(884), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(882), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(800), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(876), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(874), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(844), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(784), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(862), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(828), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(822), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(820), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(818), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(816), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(824), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(814), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(812), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(794), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(792), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(790), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(788), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(744), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(742), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(734), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(840), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(854), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(798), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(796), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(752), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(870), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(878), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(748), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(804), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32862] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_DOT,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(675), 1,
      anon_sym_PIPE,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    STATE(395), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(682), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32923] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_DOT,
    ACTIONS(919), 1,
      anon_sym_LPAREN,
    ACTIONS(921), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1671), 1,
      sym_type_arguments,
    ACTIONS(728), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(923), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32981] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(728), 1,
      anon_sym_EQ,
    ACTIONS(917), 1,
      anon_sym_DOT,
    ACTIONS(919), 1,
      anon_sym_LPAREN,
    ACTIONS(921), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1671), 1,
      sym_type_arguments,
    ACTIONS(929), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(927), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(923), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 15,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33045] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_DOT,
    ACTIONS(919), 1,
      anon_sym_LPAREN,
    ACTIONS(921), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1671), 1,
      sym_type_arguments,
    ACTIONS(732), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(730), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33101] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_DOT,
    ACTIONS(919), 1,
      anon_sym_LPAREN,
    ACTIONS(921), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1671), 1,
      sym_type_arguments,
    ACTIONS(728), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(923), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33161] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(728), 1,
      anon_sym_EQ,
    ACTIONS(917), 1,
      anon_sym_DOT,
    ACTIONS(919), 1,
      anon_sym_LPAREN,
    ACTIONS(921), 1,
      anon_sym_LBRACK,
    ACTIONS(931), 1,
      anon_sym_AMP_AMP,
    STATE(393), 1,
      sym_argument_list,
    STATE(1671), 1,
      sym_type_arguments,
    ACTIONS(929), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(927), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(923), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 14,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [33227] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_DOT,
    ACTIONS(919), 1,
      anon_sym_LPAREN,
    ACTIONS(921), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1671), 1,
      sym_type_arguments,
    ACTIONS(728), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(726), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33283] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_DOT,
    ACTIONS(919), 1,
      anon_sym_LPAREN,
    ACTIONS(921), 1,
      anon_sym_LBRACK,
    ACTIONS(931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(935), 1,
      anon_sym_EQ,
    ACTIONS(937), 1,
      anon_sym_PIPE_PIPE,
    STATE(393), 1,
      sym_argument_list,
    STATE(1671), 1,
      sym_type_arguments,
    ACTIONS(929), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(925), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(927), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(923), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(933), 13,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [33351] = 19,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_LF,
    ACTIONS(945), 1,
      anon_sym_LPAREN,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(949), 1,
      anon_sym_LBRACK,
    ACTIONS(951), 1,
      anon_sym_STAR,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(955), 1,
      anon_sym_TILDE,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(963), 1,
      anon_sym_LT_DASH,
    STATE(905), 1,
      sym_parameter_list,
    STATE(908), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(943), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [33428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(965), 1,
      anon_sym_LPAREN,
    STATE(393), 1,
      sym_special_argument_list,
    ACTIONS(682), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 21,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33477] = 25,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(955), 1,
      anon_sym_TILDE,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(969), 1,
      anon_sym_LF,
    ACTIONS(973), 1,
      anon_sym_DOT,
    ACTIONS(975), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(981), 1,
      anon_sym_LBRACK,
    ACTIONS(983), 1,
      anon_sym_STAR,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(991), 1,
      anon_sym_LT_DASH,
    ACTIONS(993), 1,
      sym_raw_string_literal,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    STATE(650), 1,
      aux_sym_field_declaration_repeat1,
    STATE(919), 1,
      sym_type_arguments,
    STATE(1382), 1,
      sym_interpreted_string_literal,
    STATE(1081), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(971), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [33566] = 19,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(941), 1,
      anon_sym_LF,
    ACTIONS(945), 1,
      anon_sym_LPAREN,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(955), 1,
      anon_sym_TILDE,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(983), 1,
      anon_sym_STAR,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(991), 1,
      anon_sym_LT_DASH,
    ACTIONS(997), 1,
      anon_sym_LBRACK,
    STATE(905), 1,
      sym_parameter_list,
    STATE(908), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(943), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [33643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(862), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(828), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(876), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(874), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(866), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(814), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(812), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(808), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(784), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(836), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(740), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(738), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(884), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(882), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(840), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(834), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(832), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(744), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(742), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(748), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(734), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(822), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(820), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(888), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(886), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(824), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(818), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(816), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(752), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(848), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(790), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(788), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(844), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(890), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(870), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(800), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(878), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(798), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(796), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(804), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(858), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(854), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(794), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(792), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(814), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(812), 26,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35181] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(675), 1,
      anon_sym_PIPE,
    ACTIONS(684), 1,
      anon_sym_DOT,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    STATE(466), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(669), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(682), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35237] = 20,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(306), 1,
      anon_sym_TILDE,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(999), 1,
      anon_sym_LF,
    ACTIONS(1003), 1,
      anon_sym_LPAREN,
    ACTIONS(1005), 1,
      anon_sym_COMMA,
    ACTIONS(1007), 1,
      anon_sym_EQ,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(1011), 1,
      anon_sym_STAR,
    ACTIONS(1013), 1,
      anon_sym_LT_DASH,
    STATE(854), 1,
      aux_sym_const_spec_repeat1,
    STATE(1665), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    ACTIONS(1001), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [35313] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(732), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(730), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(794), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(792), 26,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35407] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(728), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(726), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(888), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(886), 26,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(870), 26,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35543] = 20,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(306), 1,
      anon_sym_TILDE,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(1003), 1,
      anon_sym_LPAREN,
    ACTIONS(1005), 1,
      anon_sym_COMMA,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(1011), 1,
      anon_sym_STAR,
    ACTIONS(1013), 1,
      anon_sym_LT_DASH,
    ACTIONS(1021), 1,
      anon_sym_LF,
    ACTIONS(1025), 1,
      anon_sym_EQ,
    STATE(429), 1,
      aux_sym_const_spec_repeat1,
    STATE(1737), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    ACTIONS(1023), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [35619] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1041), 1,
      anon_sym_LT_DASH,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1056), 1,
      sym__simple_type,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    ACTIONS(941), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [35690] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1056), 1,
      sym__simple_type,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    ACTIONS(941), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [35761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 1,
      anon_sym_LPAREN,
    STATE(455), 1,
      sym_special_argument_list,
    ACTIONS(682), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 23,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(822), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(820), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(784), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(854), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(752), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(800), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36006] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1049), 1,
      anon_sym_LBRACE,
    STATE(440), 1,
      sym_block,
    STATE(1084), 1,
      sym_parameter_list,
    STATE(1117), 1,
      sym__simple_type,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    ACTIONS(941), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_PIPE,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(844), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(840), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(848), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(866), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36240] = 21,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1061), 1,
      anon_sym_LBRACK,
    ACTIONS(1063), 1,
      anon_sym_STAR,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1067), 1,
      anon_sym_TILDE,
    ACTIONS(1069), 1,
      anon_sym_LBRACE,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1077), 1,
      anon_sym_LT_DASH,
    STATE(1119), 1,
      sym__simple_type,
    STATE(1245), 1,
      sym_parameter_list,
    STATE(1420), 1,
      sym_block,
    STATE(1848), 1,
      sym_parenthesized_type,
    ACTIONS(1051), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1055), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36316] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(728), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
  [36380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(884), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(882), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(744), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(742), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36460] = 21,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1061), 1,
      anon_sym_LBRACK,
    ACTIONS(1063), 1,
      anon_sym_STAR,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1067), 1,
      anon_sym_TILDE,
    ACTIONS(1069), 1,
      anon_sym_LBRACE,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1077), 1,
      anon_sym_LT_DASH,
    STATE(1110), 1,
      sym__simple_type,
    STATE(1189), 1,
      sym_parameter_list,
    STATE(1379), 1,
      sym_block,
    STATE(1848), 1,
      sym_parenthesized_type,
    ACTIONS(1093), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1095), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(890), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(862), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36616] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(661), 1,
      anon_sym_COMMA,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1097), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1103), 1,
      anon_sym_LBRACK,
    ACTIONS(1105), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(643), 1,
      aux_sym_parameter_declaration_repeat1,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE,
    STATE(1397), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36692] = 21,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1061), 1,
      anon_sym_LBRACK,
    ACTIONS(1063), 1,
      anon_sym_STAR,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1067), 1,
      anon_sym_TILDE,
    ACTIONS(1069), 1,
      anon_sym_LBRACE,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1077), 1,
      anon_sym_LT_DASH,
    STATE(1097), 1,
      sym__simple_type,
    STATE(1246), 1,
      sym_parameter_list,
    STATE(1422), 1,
      sym_block,
    STATE(1848), 1,
      sym_parenthesized_type,
    ACTIONS(1107), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1109), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36768] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(728), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(798), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(796), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(808), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36910] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(728), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(804), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37008] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(728), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37062] = 9,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(680), 1,
      anon_sym_LF,
    ACTIONS(684), 1,
      anon_sym_DOT,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(1111), 1,
      anon_sym_LBRACE,
    STATE(521), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(675), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
    ACTIONS(682), 24,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(858), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(876), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(874), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(878), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(734), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37314] = 19,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1061), 1,
      anon_sym_LBRACK,
    ACTIONS(1063), 1,
      anon_sym_STAR,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1067), 1,
      anon_sym_TILDE,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1077), 1,
      anon_sym_LT_DASH,
    STATE(1085), 1,
      sym__simple_type,
    STATE(1123), 1,
      sym_parameter_list,
    STATE(1848), 1,
      sym_parenthesized_type,
    ACTIONS(941), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    ACTIONS(943), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_LBRACE,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [37386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(836), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(834), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(832), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37506] = 19,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1057), 1,
      anon_sym_LPAREN,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1067), 1,
      anon_sym_TILDE,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1117), 1,
      anon_sym_LBRACK,
    ACTIONS(1119), 1,
      anon_sym_STAR,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1125), 1,
      anon_sym_LT_DASH,
    STATE(1085), 1,
      sym__simple_type,
    STATE(1123), 1,
      sym_parameter_list,
    STATE(1848), 1,
      sym_parenthesized_type,
    ACTIONS(941), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    ACTIONS(943), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_LBRACE,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [37578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(828), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(824), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(740), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(738), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(790), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(788), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(818), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(816), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(748), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37818] = 15,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_LF,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1131), 1,
      anon_sym_COMMA,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1143), 1,
      anon_sym_PIPE_PIPE,
    STATE(522), 1,
      sym_argument_list,
    STATE(1072), 1,
      aux_sym_expression_list_repeat1,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(1137), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(706), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1139), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1135), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37882] = 13,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(933), 1,
      anon_sym_LF,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1143), 1,
      anon_sym_PIPE_PIPE,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(1137), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(935), 6,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1139), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1135), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37941] = 21,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_LPAREN,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(955), 1,
      anon_sym_TILDE,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(983), 1,
      anon_sym_STAR,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(991), 1,
      anon_sym_LT_DASH,
    ACTIONS(997), 1,
      anon_sym_LBRACK,
    ACTIONS(1051), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    STATE(1224), 1,
      sym__simple_type,
    STATE(1269), 1,
      sym_parameter_list,
    STATE(1594), 1,
      sym_block,
    STATE(1794), 1,
      sym_parenthesized_type,
    ACTIONS(1055), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38016] = 21,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_LPAREN,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(955), 1,
      anon_sym_TILDE,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(983), 1,
      anon_sym_STAR,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(991), 1,
      anon_sym_LT_DASH,
    ACTIONS(997), 1,
      anon_sym_LBRACK,
    ACTIONS(1107), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    STATE(1220), 1,
      sym__simple_type,
    STATE(1270), 1,
      sym_parameter_list,
    STATE(1598), 1,
      sym_block,
    STATE(1794), 1,
      sym_parenthesized_type,
    ACTIONS(1109), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38091] = 12,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(726), 1,
      anon_sym_LF,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(1137), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1139), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(728), 7,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
    ACTIONS(1135), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38148] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(661), 1,
      anon_sym_COMMA,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1103), 1,
      anon_sym_LBRACK,
    ACTIONS(1147), 1,
      anon_sym_DOT,
    STATE(643), 1,
      aux_sym_parameter_declaration_repeat1,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE,
    STATE(1397), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38221] = 10,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(726), 1,
      anon_sym_LF,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(1137), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1135), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(728), 14,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38274] = 21,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_LPAREN,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(955), 1,
      anon_sym_TILDE,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(983), 1,
      anon_sym_STAR,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(991), 1,
      anon_sym_LT_DASH,
    ACTIONS(997), 1,
      anon_sym_LBRACK,
    ACTIONS(1093), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    STATE(1231), 1,
      sym__simple_type,
    STATE(1266), 1,
      sym_parameter_list,
    STATE(1572), 1,
      sym_block,
    STATE(1794), 1,
      sym_parenthesized_type,
    ACTIONS(1095), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38349] = 9,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(726), 1,
      anon_sym_LF,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(1135), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(728), 18,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38400] = 8,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_LF,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(732), 25,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38449] = 8,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(726), 1,
      anon_sym_LF,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(728), 25,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38498] = 11,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(726), 1,
      anon_sym_LF,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(1137), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1139), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1135), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(728), 8,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38553] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(680), 1,
      anon_sym_LF,
    ACTIONS(1149), 1,
      anon_sym_LPAREN,
    STATE(522), 1,
      sym_special_argument_list,
    ACTIONS(682), 27,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38595] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1153), 1,
      anon_sym_RPAREN,
    ACTIONS(1155), 1,
      anon_sym_COMMA,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1501), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1601), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38665] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1167), 1,
      anon_sym_RBRACE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1427), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38737] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1171), 1,
      anon_sym_RBRACE,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1427), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38809] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1173), 1,
      anon_sym_RBRACE,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1427), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38881] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1175), 1,
      anon_sym_RBRACE,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1427), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38953] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(768), 1,
      anon_sym_LT_DASH,
    ACTIONS(770), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    ACTIONS(1187), 1,
      anon_sym_PIPE,
    ACTIONS(1189), 1,
      anon_sym_COLON,
    ACTIONS(1199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1201), 1,
      anon_sym_PIPE_PIPE,
    STATE(602), 1,
      sym_argument_list,
    STATE(1194), 1,
      aux_sym_expression_list_repeat1,
    STATE(1723), 1,
      sym_type_arguments,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1197), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1191), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1195), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39025] = 13,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1143), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1203), 1,
      anon_sym_LF,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(1137), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1205), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1139), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1135), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39083] = 13,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1143), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1207), 1,
      anon_sym_LF,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(1137), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1209), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1139), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1135), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39141] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_RPAREN,
    ACTIONS(1213), 1,
      anon_sym_COMMA,
    STATE(1540), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1601), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39211] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1215), 1,
      anon_sym_RBRACE,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1427), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39283] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1217), 1,
      anon_sym_RBRACE,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1293), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39355] = 19,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(945), 1,
      anon_sym_LPAREN,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(955), 1,
      anon_sym_TILDE,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(983), 1,
      anon_sym_STAR,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(991), 1,
      anon_sym_LT_DASH,
    ACTIONS(997), 1,
      anon_sym_LBRACK,
    ACTIONS(1219), 1,
      anon_sym_LF,
    STATE(1253), 1,
      sym__simple_type,
    STATE(1426), 1,
      sym_parameter_list,
    STATE(1794), 1,
      sym_parenthesized_type,
    ACTIONS(1221), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39425] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1223), 1,
      anon_sym_RBRACE,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1306), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39497] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1225), 1,
      anon_sym_RBRACE,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1427), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39569] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1227), 1,
      anon_sym_RPAREN,
    ACTIONS(1229), 1,
      anon_sym_COMMA,
    STATE(1507), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1601), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39639] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_DOT,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(675), 1,
      anon_sym_PIPE,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_LBRACE,
    STATE(609), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(682), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39691] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_RPAREN,
    ACTIONS(1213), 1,
      anon_sym_COMMA,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1540), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39761] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1227), 1,
      anon_sym_RPAREN,
    ACTIONS(1229), 1,
      anon_sym_COMMA,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1507), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39831] = 13,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1127), 1,
      anon_sym_DOT,
    ACTIONS(1129), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1143), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1233), 1,
      anon_sym_LF,
    STATE(522), 1,
      sym_argument_list,
    STATE(1731), 1,
      sym_type_arguments,
    ACTIONS(1137), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1235), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1139), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1135), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39889] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1237), 1,
      anon_sym_RBRACE,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1255), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39961] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1153), 1,
      anon_sym_RPAREN,
    ACTIONS(1155), 1,
      anon_sym_COMMA,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1501), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40031] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(820), 1,
      anon_sym_LF,
    ACTIONS(822), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40068] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(748), 1,
      anon_sym_LF,
    ACTIONS(750), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40105] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(784), 1,
      anon_sym_LF,
    ACTIONS(786), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40142] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(808), 1,
      anon_sym_LF,
    ACTIONS(810), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40179] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_LF,
    ACTIONS(744), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40216] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_LF,
    ACTIONS(850), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40253] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_LF,
    ACTIONS(876), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40290] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(862), 1,
      anon_sym_LF,
    ACTIONS(864), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40327] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_LF,
    ACTIONS(736), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40364] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(941), 1,
      anon_sym_PIPE,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1239), 1,
      anon_sym_LBRACE,
    STATE(399), 1,
      sym_block,
    STATE(1366), 1,
      sym__simple_type,
    STATE(1367), 1,
      sym_parameter_list,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40435] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(738), 1,
      anon_sym_LF,
    ACTIONS(740), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40472] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1241), 1,
      anon_sym_RPAREN,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1724), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    STATE(602), 1,
      sym_argument_list,
    STATE(1723), 1,
      sym_type_arguments,
    ACTIONS(728), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(726), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40586] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(941), 1,
      anon_sym_PIPE,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1243), 1,
      sym_identifier,
    STATE(297), 1,
      sym_block,
    STATE(1344), 1,
      sym_parameter_list,
    STATE(1345), 1,
      sym__simple_type,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40657] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(680), 1,
      anon_sym_LF,
    ACTIONS(682), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40694] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(836), 1,
      anon_sym_LF,
    ACTIONS(838), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40731] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(788), 1,
      anon_sym_LF,
    ACTIONS(790), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40768] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(792), 1,
      anon_sym_LF,
    ACTIONS(794), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40805] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(941), 1,
      anon_sym_PIPE,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1245), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_block,
    STATE(1433), 1,
      sym__simple_type,
    STATE(1434), 1,
      sym_parameter_list,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40876] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    ACTIONS(1187), 1,
      anon_sym_PIPE,
    ACTIONS(1199), 1,
      anon_sym_AMP_AMP,
    STATE(602), 1,
      sym_argument_list,
    STATE(1723), 1,
      sym_type_arguments,
    ACTIONS(728), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1197), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1191), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(726), 4,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1195), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40937] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    ACTIONS(1187), 1,
      anon_sym_PIPE,
    STATE(602), 1,
      sym_argument_list,
    STATE(1723), 1,
      sym_type_arguments,
    ACTIONS(728), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1197), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1191), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1195), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(726), 5,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40996] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    ACTIONS(1187), 1,
      anon_sym_PIPE,
    STATE(602), 1,
      sym_argument_list,
    STATE(1723), 1,
      sym_type_arguments,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1191), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(728), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 9,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41051] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(941), 1,
      anon_sym_PIPE,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1247), 1,
      anon_sym_LBRACE,
    STATE(360), 1,
      sym_block,
    STATE(1391), 1,
      sym__simple_type,
    STATE(1392), 1,
      sym_parameter_list,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41122] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1724), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41189] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    STATE(602), 1,
      sym_argument_list,
    STATE(1723), 1,
      sym_type_arguments,
    ACTIONS(1193), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(728), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1185), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 12,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41240] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(796), 1,
      anon_sym_LF,
    ACTIONS(798), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41277] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(941), 1,
      anon_sym_PIPE,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    STATE(297), 1,
      sym_block,
    STATE(1344), 1,
      sym_parameter_list,
    STATE(1345), 1,
      sym__simple_type,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41348] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1251), 1,
      anon_sym_RPAREN,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1724), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41415] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(804), 1,
      anon_sym_LF,
    ACTIONS(806), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41452] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(878), 1,
      anon_sym_LF,
    ACTIONS(880), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41489] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(870), 1,
      anon_sym_LF,
    ACTIONS(872), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41526] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1253), 1,
      anon_sym_RPAREN,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1724), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41593] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1255), 1,
      anon_sym_RPAREN,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1724), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41660] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1159), 1,
      sym_identifier,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1163), 1,
      anon_sym_STAR,
    ACTIONS(1165), 1,
      anon_sym_TILDE,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    STATE(1168), 1,
      sym_struct_term,
    STATE(1294), 1,
      sym_struct_type,
    STATE(1295), 1,
      sym__simple_type,
    STATE(1794), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1427), 3,
      sym__interface_body,
      sym_struct_elem,
      sym_method_spec,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41729] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(941), 1,
      anon_sym_PIPE,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1257), 1,
      anon_sym_LBRACE,
    STATE(634), 1,
      sym_block,
    STATE(1348), 1,
      sym__simple_type,
    STATE(1349), 1,
      sym_parameter_list,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41800] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(866), 1,
      anon_sym_LF,
    ACTIONS(868), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41837] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(828), 1,
      anon_sym_LF,
    ACTIONS(830), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41874] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(824), 1,
      anon_sym_LF,
    ACTIONS(826), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41911] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(935), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(933), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41974] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_DOT,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    ACTIONS(1183), 1,
      anon_sym_LBRACK,
    STATE(602), 1,
      sym_argument_list,
    STATE(1723), 1,
      sym_type_arguments,
    ACTIONS(732), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(730), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42021] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(882), 1,
      anon_sym_LF,
    ACTIONS(884), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42058] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(854), 1,
      anon_sym_LF,
    ACTIONS(856), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42095] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(812), 1,
      anon_sym_LF,
    ACTIONS(814), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42132] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(886), 1,
      anon_sym_LF,
    ACTIONS(888), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42169] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(890), 1,
      anon_sym_LF,
    ACTIONS(892), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42206] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LF,
    ACTIONS(896), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42243] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_LF,
    ACTIONS(754), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42280] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(816), 1,
      anon_sym_LF,
    ACTIONS(818), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42317] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(800), 1,
      anon_sym_LF,
    ACTIONS(802), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42354] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LF,
    ACTIONS(834), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42391] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(858), 1,
      anon_sym_LF,
    ACTIONS(860), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42428] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_LF,
    ACTIONS(846), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42465] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LF,
    ACTIONS(842), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42502] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(941), 1,
      anon_sym_PIPE,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1263), 1,
      sym_identifier,
    STATE(297), 1,
      sym_block,
    STATE(1344), 1,
      sym_parameter_list,
    STATE(1345), 1,
      sym__simple_type,
    STATE(1785), 1,
      sym_parenthesized_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [42573] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1265), 1,
      anon_sym_RPAREN,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1724), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [42640] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1267), 1,
      anon_sym_RPAREN,
    ACTIONS(1269), 1,
      anon_sym_COMMA,
    ACTIONS(1271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1494), 1,
      aux_sym_argument_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42706] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1289), 1,
      anon_sym_RPAREN,
    ACTIONS(1291), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1592), 1,
      aux_sym_argument_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42772] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1293), 1,
      anon_sym_RPAREN,
    ACTIONS(1295), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1509), 1,
      aux_sym_argument_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42838] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1297), 1,
      anon_sym_RPAREN,
    ACTIONS(1299), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1534), 1,
      aux_sym_argument_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42904] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1301), 1,
      anon_sym_RPAREN,
    ACTIONS(1303), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1552), 1,
      aux_sym_argument_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42970] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(654), 1,
      anon_sym_DOT,
    ACTIONS(675), 1,
      anon_sym_PIPE,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    STATE(466), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(669), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(682), 4,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 15,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43022] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1305), 1,
      anon_sym_RPAREN,
    ACTIONS(1307), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1557), 1,
      aux_sym_argument_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43088] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1194), 1,
      aux_sym_expression_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(770), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43152] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1311), 1,
      anon_sym_COMMA,
    ACTIONS(1313), 1,
      anon_sym_EQ,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    STATE(580), 1,
      aux_sym_const_spec_repeat1,
    STATE(1074), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43218] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1607), 1,
      aux_sym_argument_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43284] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1311), 1,
      anon_sym_COMMA,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1323), 1,
      anon_sym_EQ,
    STATE(871), 1,
      aux_sym_const_spec_repeat1,
    STATE(1077), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43350] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1724), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43414] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    STATE(602), 1,
      sym_special_argument_list,
    ACTIONS(682), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 19,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43454] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(1327), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1333), 1,
      anon_sym_LBRACE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1194), 1,
      aux_sym_expression_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43520] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(675), 1,
      anon_sym_PIPE,
    ACTIONS(684), 1,
      anon_sym_DOT,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    STATE(466), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(682), 4,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43570] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1347), 1,
      anon_sym_RPAREN,
    ACTIONS(1349), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1449), 1,
      aux_sym_argument_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43636] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    ACTIONS(1355), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1296), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43703] = 13,
    ACTIONS(1357), 1,
      anon_sym_LBRACE,
    ACTIONS(1361), 1,
      anon_sym_if,
    ACTIONS(1363), 1,
      anon_sym_for,
    ACTIONS(1365), 1,
      anon_sym_switch,
    ACTIONS(1367), 1,
      anon_sym_LT,
    ACTIONS(1371), 1,
      anon_sym_AT,
    ACTIONS(1373), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1375), 1,
      anon_sym_LT_BANG,
    STATE(604), 1,
      sym_tag_start,
    STATE(1580), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1359), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1369), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(1508), 11,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
  [43758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(866), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43793] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1377), 1,
      sym_identifier,
    ACTIONS(1379), 1,
      anon_sym_RBRACK,
    STATE(1739), 1,
      sym_parameter_declaration,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43856] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    ACTIONS(1381), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1424), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43923] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    ACTIONS(1383), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1424), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(814), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(812), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(858), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(840), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44130] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_DOT,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(675), 1,
      anon_sym_PIPE,
    ACTIONS(908), 1,
      anon_sym_LBRACK,
    STATE(466), 1,
      sym_literal_value,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(682), 4,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(854), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(744), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(742), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44247] = 14,
    ACTIONS(1385), 1,
      anon_sym_LBRACE,
    ACTIONS(1387), 1,
      anon_sym_if,
    ACTIONS(1389), 1,
      anon_sym_for,
    ACTIONS(1391), 1,
      anon_sym_switch,
    ACTIONS(1393), 1,
      anon_sym_LT,
    ACTIONS(1397), 1,
      anon_sym_AT,
    ACTIONS(1399), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1401), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1403), 1,
      anon_sym_LT_BANG,
    STATE(627), 1,
      sym_tag_start,
    STATE(1019), 1,
      sym_tag_end,
    STATE(1005), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1395), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(679), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [44304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(752), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44339] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    ACTIONS(1405), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1424), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(862), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44441] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    ACTIONS(1407), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1424), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44508] = 14,
    ACTIONS(1385), 1,
      anon_sym_LBRACE,
    ACTIONS(1387), 1,
      anon_sym_if,
    ACTIONS(1389), 1,
      anon_sym_for,
    ACTIONS(1391), 1,
      anon_sym_switch,
    ACTIONS(1393), 1,
      anon_sym_LT,
    ACTIONS(1397), 1,
      anon_sym_AT,
    ACTIONS(1399), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1403), 1,
      anon_sym_LT_BANG,
    ACTIONS(1411), 1,
      anon_sym_LT_SLASH,
    STATE(627), 1,
      sym_tag_start,
    STATE(1571), 1,
      sym_tag_end,
    STATE(1005), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1409), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(615), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [44565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(736), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(734), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(888), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(886), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(890), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(884), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(882), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(876), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(874), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(800), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44775] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    ACTIONS(1413), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1424), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(870), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44877] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1377), 1,
      sym_identifier,
    ACTIONS(1415), 1,
      anon_sym_RBRACK,
    STATE(1739), 1,
      sym_parameter_declaration,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(848), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44975] = 14,
    ACTIONS(1385), 1,
      anon_sym_LBRACE,
    ACTIONS(1387), 1,
      anon_sym_if,
    ACTIONS(1389), 1,
      anon_sym_for,
    ACTIONS(1391), 1,
      anon_sym_switch,
    ACTIONS(1393), 1,
      anon_sym_LT,
    ACTIONS(1397), 1,
      anon_sym_AT,
    ACTIONS(1399), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1403), 1,
      anon_sym_LT_BANG,
    ACTIONS(1411), 1,
      anon_sym_LT_SLASH,
    STATE(627), 1,
      sym_tag_start,
    STATE(1544), 1,
      sym_tag_end,
    STATE(1005), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1395), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(679), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [45032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(878), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45067] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    ACTIONS(1417), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1260), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [45134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(804), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45169] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1419), 1,
      anon_sym_COMMA,
    ACTIONS(1421), 1,
      anon_sym_RBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1591), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45232] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(726), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45289] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(726), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45344] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(728), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(798), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(796), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45432] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(728), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(844), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(828), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45551] = 14,
    ACTIONS(1385), 1,
      anon_sym_LBRACE,
    ACTIONS(1387), 1,
      anon_sym_if,
    ACTIONS(1389), 1,
      anon_sym_for,
    ACTIONS(1391), 1,
      anon_sym_switch,
    ACTIONS(1393), 1,
      anon_sym_LT,
    ACTIONS(1397), 1,
      anon_sym_AT,
    ACTIONS(1399), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1403), 1,
      anon_sym_LT_BANG,
    ACTIONS(1425), 1,
      anon_sym_LT_SLASH,
    STATE(627), 1,
      sym_tag_start,
    STATE(987), 1,
      sym_tag_end,
    STATE(1005), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1423), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(639), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [45608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(740), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(738), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45643] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1427), 1,
      anon_sym_COMMA,
    ACTIONS(1429), 1,
      anon_sym_RBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1451), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(818), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(816), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45741] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_SEMI,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1431), 1,
      anon_sym_DOT,
    STATE(455), 1,
      sym_argument_list,
    STATE(1194), 1,
      aux_sym_expression_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45804] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1433), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(808), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(784), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45935] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1435), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(836), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(834), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(832), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46099] = 14,
    ACTIONS(1385), 1,
      anon_sym_LBRACE,
    ACTIONS(1387), 1,
      anon_sym_if,
    ACTIONS(1389), 1,
      anon_sym_for,
    ACTIONS(1391), 1,
      anon_sym_switch,
    ACTIONS(1393), 1,
      anon_sym_LT,
    ACTIONS(1397), 1,
      anon_sym_AT,
    ACTIONS(1399), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1403), 1,
      anon_sym_LT_BANG,
    ACTIONS(1425), 1,
      anon_sym_LT_SLASH,
    STATE(627), 1,
      sym_tag_start,
    STATE(937), 1,
      sym_tag_end,
    STATE(1005), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1395), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(679), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [46156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(824), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46191] = 14,
    ACTIONS(1385), 1,
      anon_sym_LBRACE,
    ACTIONS(1387), 1,
      anon_sym_if,
    ACTIONS(1389), 1,
      anon_sym_for,
    ACTIONS(1391), 1,
      anon_sym_switch,
    ACTIONS(1393), 1,
      anon_sym_LT,
    ACTIONS(1397), 1,
      anon_sym_AT,
    ACTIONS(1399), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1401), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1403), 1,
      anon_sym_LT_BANG,
    STATE(627), 1,
      sym_tag_start,
    STATE(1010), 1,
      sym_tag_end,
    STATE(1005), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1437), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(599), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [46248] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 1,
      anon_sym_LBRACE,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1439), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1535), 1,
      aux_sym_expression_list_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46311] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1441), 1,
      anon_sym_COMMA,
    STATE(882), 1,
      aux_sym_parameter_declaration_repeat1,
    STATE(1413), 1,
      sym_parenthesized_type,
    STATE(1414), 1,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46376] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(726), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46433] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1443), 1,
      anon_sym_EQ,
    ACTIONS(1445), 1,
      anon_sym_LBRACK,
    STATE(719), 1,
      sym_type_parameter_list,
    STATE(1111), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46496] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1447), 1,
      anon_sym_COMMA,
    ACTIONS(1449), 1,
      anon_sym_RBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1496), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(748), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46594] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(726), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(822), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(820), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46684] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1451), 1,
      anon_sym_COMMA,
    STATE(879), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1079), 1,
      sym__simple_type,
    STATE(1082), 1,
      sym_parenthesized_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46749] = 13,
    ACTIONS(1357), 1,
      anon_sym_LBRACE,
    ACTIONS(1361), 1,
      anon_sym_if,
    ACTIONS(1363), 1,
      anon_sym_for,
    ACTIONS(1365), 1,
      anon_sym_switch,
    ACTIONS(1367), 1,
      anon_sym_LT,
    ACTIONS(1371), 1,
      anon_sym_AT,
    ACTIONS(1373), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1375), 1,
      anon_sym_LT_BANG,
    STATE(604), 1,
      sym_tag_start,
    STATE(1580), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1453), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1455), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(1608), 11,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
  [46804] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(728), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 9,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46857] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    ACTIONS(1457), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1305), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46924] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    ACTIONS(1459), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1424), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(790), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(788), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(794), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(792), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47061] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(728), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(726), 12,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47110] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1461), 1,
      anon_sym_RBRACK,
    ACTIONS(1463), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [47170] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1465), 1,
      anon_sym_RPAREN,
    ACTIONS(1467), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [47230] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1469), 1,
      anon_sym_RBRACK,
    STATE(1442), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47290] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1473), 1,
      anon_sym_RBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1483), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(706), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [47344] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_LBRACE,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(927), 1,
      sym_component_block,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [47404] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    ACTIONS(1491), 1,
      anon_sym_RBRACE,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1493), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(666), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [47458] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1495), 1,
      anon_sym_RBRACK,
    ACTIONS(1497), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [47518] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1499), 1,
      anon_sym_type,
    STATE(1638), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47578] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    ACTIONS(1501), 1,
      anon_sym_RBRACE,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1503), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(707), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [47632] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1505), 1,
      anon_sym_RBRACK,
    ACTIONS(1507), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [47692] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1509), 1,
      anon_sym_type,
    STATE(1638), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47752] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1511), 1,
      anon_sym_RBRACK,
    ACTIONS(1513), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [47812] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      anon_sym_STAR,
    STATE(1020), 1,
      sym_qualified_type,
    STATE(1083), 1,
      sym_generic_type,
    STATE(1424), 1,
      sym_field_declaration,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47876] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(933), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [47934] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1515), 1,
      anon_sym_RBRACK,
    ACTIONS(1517), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [47994] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1519), 1,
      anon_sym_RBRACK,
    STATE(1442), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48054] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
    ACTIONS(1523), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [48114] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1525), 1,
      anon_sym_RBRACK,
    ACTIONS(1527), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [48174] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1529), 1,
      anon_sym_RBRACK,
    ACTIONS(1531), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [48234] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    ACTIONS(1533), 1,
      anon_sym_RBRACE,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1503), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(707), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [48288] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1091), 1,
      sym_block,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [48348] = 13,
    ACTIONS(1535), 1,
      anon_sym_LBRACE,
    ACTIONS(1538), 1,
      anon_sym_if,
    ACTIONS(1541), 1,
      anon_sym_for,
    ACTIONS(1544), 1,
      anon_sym_switch,
    ACTIONS(1547), 1,
      anon_sym_LT,
    ACTIONS(1553), 1,
      anon_sym_AT,
    ACTIONS(1556), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1559), 1,
      anon_sym_LT_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LT_BANG,
    STATE(627), 1,
      sym_tag_start,
    STATE(1005), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1550), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(679), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [48402] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1564), 1,
      anon_sym_RBRACK,
    ACTIONS(1566), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [48462] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1568), 1,
      anon_sym_RBRACK,
    ACTIONS(1570), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [48522] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    ACTIONS(1572), 1,
      anon_sym_RBRACE,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1574), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(684), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [48576] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1576), 1,
      anon_sym_RBRACK,
    STATE(1442), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48636] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    ACTIONS(1578), 1,
      anon_sym_RBRACE,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1503), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(707), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [48690] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1377), 1,
      sym_identifier,
    STATE(1587), 1,
      sym_parameter_declaration,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48750] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1580), 1,
      anon_sym_RBRACK,
    STATE(1442), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48810] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1582), 1,
      anon_sym_type,
    STATE(1642), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48870] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1584), 1,
      anon_sym_RPAREN,
    ACTIONS(1586), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [48930] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1588), 1,
      anon_sym_RBRACK,
    ACTIONS(1590), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [48990] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(913), 1,
      sym_component_block,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49050] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1233), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49108] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1592), 1,
      anon_sym_RBRACK,
    ACTIONS(1594), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49168] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_LBRACE,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1239), 1,
      sym_conditional_attribute_block,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49228] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1340), 1,
      sym_component_block,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49288] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    ACTIONS(1596), 1,
      anon_sym_RBRACE,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1598), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(677), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [49342] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    ACTIONS(1600), 1,
      anon_sym_RBRACE,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1503), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(707), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [49396] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1602), 1,
      anon_sym_RBRACK,
    ACTIONS(1604), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49456] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(933), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49514] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1606), 1,
      anon_sym_RPAREN,
    ACTIONS(1608), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49574] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1610), 1,
      anon_sym_type,
    STATE(1638), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49634] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1612), 1,
      anon_sym_RBRACK,
    ACTIONS(1614), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49694] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1616), 1,
      anon_sym_RBRACK,
    ACTIONS(1618), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49754] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1620), 1,
      anon_sym_RBRACK,
    ACTIONS(1622), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49814] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1377), 1,
      sym_identifier,
    STATE(1739), 1,
      sym_parameter_declaration,
    STATE(1343), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49874] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1624), 1,
      anon_sym_RBRACK,
    ACTIONS(1626), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [49934] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    ACTIONS(1628), 1,
      anon_sym_RBRACE,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1503), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(707), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [49988] = 13,
    ACTIONS(1559), 1,
      anon_sym_RBRACE,
    ACTIONS(1630), 1,
      anon_sym_LBRACE,
    ACTIONS(1633), 1,
      anon_sym_if,
    ACTIONS(1636), 1,
      anon_sym_for,
    ACTIONS(1639), 1,
      anon_sym_switch,
    ACTIONS(1642), 1,
      anon_sym_LT,
    ACTIONS(1648), 1,
      anon_sym_AT,
    ACTIONS(1651), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1654), 1,
      anon_sym_LT_BANG,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1645), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(707), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [50042] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1657), 1,
      anon_sym_RPAREN,
    ACTIONS(1659), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [50102] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1661), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [50160] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1663), 1,
      anon_sym_RBRACK,
    STATE(1442), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50220] = 13,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    ACTIONS(1477), 1,
      anon_sym_for,
    ACTIONS(1479), 1,
      anon_sym_switch,
    ACTIONS(1481), 1,
      anon_sym_LT,
    ACTIONS(1485), 1,
      anon_sym_AT,
    ACTIONS(1487), 1,
      anon_sym_LBRACE_BANG,
    ACTIONS(1489), 1,
      anon_sym_LT_BANG,
    ACTIONS(1665), 1,
      anon_sym_RBRACE,
    STATE(641), 1,
      sym_tag_start,
    STATE(965), 2,
      sym_self_closing_tag,
      sym_doctype,
    ACTIONS(1667), 3,
      sym_element_text,
      sym_element_comment,
      sym_comment,
    STATE(696), 12,
      sym_expression,
      sym__component_node,
      sym_component_if_statement,
      sym_component_for_statement,
      sym_component_switch_statement,
      sym_component_import,
      sym_component_render,
      sym_component_children_expression,
      sym_element,
      sym_style_element,
      sym_script_element,
      aux_sym_component_block_repeat1,
  [50274] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1669), 1,
      anon_sym_RBRACK,
    ACTIONS(1671), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [50334] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1673), 1,
      anon_sym_RBRACK,
    STATE(1442), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50394] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1675), 1,
      anon_sym_RBRACK,
    ACTIONS(1677), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [50454] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1679), 1,
      anon_sym_RPAREN,
    ACTIONS(1681), 1,
      anon_sym_COMMA,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [50514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1496), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
    ACTIONS(682), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50549] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1683), 1,
      anon_sym_RPAREN,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [50606] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1694), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50663] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    STATE(1106), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50720] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1693), 1,
      anon_sym_LT_DASH,
    STATE(1134), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50777] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1695), 1,
      anon_sym_LT_DASH,
    STATE(1095), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50834] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1442), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50891] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1719), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50948] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1693), 1,
      anon_sym_LT_DASH,
    ACTIONS(1697), 1,
      anon_sym_chan,
    STATE(1096), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51005] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_LT_DASH,
    STATE(887), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51062] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1705), 1,
      anon_sym_LBRACK,
    ACTIONS(1707), 1,
      anon_sym_STAR,
    ACTIONS(1709), 1,
      anon_sym_LT_DASH,
    STATE(1105), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51119] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1041), 1,
      anon_sym_LT_DASH,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1037), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51176] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1705), 1,
      anon_sym_LBRACK,
    ACTIONS(1707), 1,
      anon_sym_STAR,
    ACTIONS(1709), 1,
      anon_sym_LT_DASH,
    STATE(1113), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51233] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [51290] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1657), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51347] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1676), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51404] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1700), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51461] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1041), 1,
      anon_sym_LT_DASH,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1044), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51518] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1713), 1,
      anon_sym_RPAREN,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [51575] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1715), 1,
      anon_sym_COLON,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [51632] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1705), 1,
      anon_sym_LBRACK,
    ACTIONS(1707), 1,
      anon_sym_STAR,
    ACTIONS(1717), 1,
      anon_sym_LT_DASH,
    STATE(1126), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51689] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1542), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51746] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1719), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [51803] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1041), 1,
      anon_sym_LT_DASH,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1059), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51860] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1432), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51917] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1645), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51974] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1721), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [52031] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1723), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [52088] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    STATE(910), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52145] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1741), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52202] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1734), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52259] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1705), 1,
      anon_sym_LBRACK,
    ACTIONS(1707), 1,
      anon_sym_STAR,
    ACTIONS(1709), 1,
      anon_sym_LT_DASH,
    STATE(1127), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52316] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1725), 1,
      anon_sym_RBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [52373] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1389), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52430] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    STATE(887), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52487] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1705), 1,
      anon_sym_LBRACK,
    ACTIONS(1707), 1,
      anon_sym_STAR,
    ACTIONS(1709), 1,
      anon_sym_LT_DASH,
    STATE(1134), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52544] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1584), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52601] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1046), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52658] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1704), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52715] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_LT_DASH,
    STATE(923), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52772] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1693), 1,
      anon_sym_LT_DASH,
    STATE(1127), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52829] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1049), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52886] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1430), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [52943] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1727), 1,
      anon_sym_SEMI,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [53000] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(646), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1052), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53057] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1705), 1,
      anon_sym_LBRACK,
    ACTIONS(1707), 1,
      anon_sym_STAR,
    ACTIONS(1717), 1,
      anon_sym_LT_DASH,
    STATE(1095), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53114] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1705), 1,
      anon_sym_LBRACK,
    ACTIONS(1707), 1,
      anon_sym_STAR,
    ACTIONS(1709), 1,
      anon_sym_LT_DASH,
    ACTIONS(1729), 1,
      anon_sym_chan,
    STATE(1096), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53171] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      sym_identifier,
    STATE(1026), 1,
      sym_qualified_type,
    STATE(1080), 1,
      sym_generic_type,
    STATE(1059), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1457), 2,
      sym_union_type,
      sym_negated_type,
    STATE(1034), 8,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53232] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1733), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [53289] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_LT_DASH,
    STATE(910), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53346] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_LT_DASH,
    STATE(912), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53403] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1735), 1,
      anon_sym_LT_DASH,
    STATE(1061), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53460] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1737), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [53517] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1642), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53574] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1438), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53631] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1739), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [53688] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1741), 1,
      anon_sym_RPAREN,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [53745] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1041), 1,
      anon_sym_LT_DASH,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1743), 1,
      anon_sym_chan,
    STATE(1052), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53802] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1745), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [53859] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1735), 1,
      anon_sym_LT_DASH,
    STATE(1053), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53916] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1747), 1,
      anon_sym_LT_DASH,
    STATE(1053), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [53973] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1693), 1,
      anon_sym_LT_DASH,
    STATE(1128), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [54030] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1749), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [54087] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1751), 1,
      anon_sym_LT_DASH,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [54144] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    ACTIONS(1747), 1,
      anon_sym_LT_DASH,
    STATE(1061), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [54201] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1753), 1,
      anon_sym_RBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [54258] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1755), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [54315] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1732), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [54372] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_LT_DASH,
    STATE(900), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [54429] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1757), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [54486] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1648), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [54543] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1042), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [54600] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1759), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [54657] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1695), 1,
      anon_sym_LT_DASH,
    STATE(1126), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [54714] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1761), 1,
      anon_sym_RPAREN,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [54771] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1041), 1,
      anon_sym_LT_DASH,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1042), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [54828] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1763), 1,
      anon_sym_RPAREN,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [54885] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1765), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [54942] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1767), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [54999] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_LT_DASH,
    ACTIONS(1769), 1,
      anon_sym_chan,
    STATE(906), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55056] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1693), 1,
      anon_sym_LT_DASH,
    STATE(1113), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55113] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1771), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [55170] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1696), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1451), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
    ACTIONS(682), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55262] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1773), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [55319] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1059), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55376] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1693), 1,
      anon_sym_LT_DASH,
    STATE(1092), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55433] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1775), 1,
      anon_sym_chan,
    STATE(906), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55490] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1777), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [55547] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1693), 1,
      anon_sym_LT_DASH,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55604] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_DOT,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1779), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [55661] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1357), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55718] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1041), 1,
      anon_sym_LT_DASH,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1049), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55775] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1781), 1,
      anon_sym_LT_DASH,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55832] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1781), 1,
      anon_sym_LT_DASH,
    STATE(904), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [55889] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1783), 1,
      anon_sym_SEMI,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [55946] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1287), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1785), 1,
      anon_sym_RPAREN,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1279), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1277), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1273), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [56003] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1057), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [56060] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1787), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [56117] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1789), 1,
      anon_sym_RBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [56174] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1791), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [56231] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1365), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [56288] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1692), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [56345] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1347), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [56402] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1793), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [56459] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    STATE(912), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [56516] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1651), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [56573] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1795), 1,
      anon_sym_RBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [56630] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1797), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [56687] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1799), 1,
      anon_sym_RBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [56744] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    STATE(1107), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [56801] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_func,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1073), 1,
      anon_sym_map,
    ACTIONS(1075), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1705), 1,
      anon_sym_LBRACK,
    ACTIONS(1707), 1,
      anon_sym_STAR,
    ACTIONS(1709), 1,
      anon_sym_LT_DASH,
    STATE(1089), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1076), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [56858] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1801), 1,
      anon_sym_RBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [56915] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_struct,
    ACTIONS(1071), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_LBRACK,
    ACTIONS(1689), 1,
      anon_sym_STAR,
    ACTIONS(1691), 1,
      anon_sym_TILDE,
    ACTIONS(1693), 1,
      anon_sym_LT_DASH,
    STATE(1105), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1075), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1131), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [56972] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1751), 1,
      anon_sym_LT_DASH,
    STATE(904), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57029] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    STATE(929), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57086] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1803), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [57143] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1356), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57200] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_LT_DASH,
    STATE(1203), 1,
      sym_struct_type,
    STATE(923), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57259] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1233), 1,
      anon_sym_LBRACE,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1331), 1,
      anon_sym_PIPE,
    ACTIONS(1343), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1345), 1,
      anon_sym_PIPE_PIPE,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1337), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1341), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1335), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1339), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1329), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [57316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1591), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
    ACTIONS(682), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57351] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    STATE(1203), 1,
      sym_struct_type,
    STATE(910), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 8,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57410] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1805), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [57467] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(967), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_func,
    ACTIONS(987), 1,
      anon_sym_map,
    ACTIONS(989), 1,
      anon_sym_chan,
    ACTIONS(1161), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_LT_DASH,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1315), 1,
      anon_sym_STAR,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    STATE(898), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(877), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57524] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1041), 1,
      anon_sym_LT_DASH,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1057), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57581] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      anon_sym_func,
    ACTIONS(1033), 1,
      anon_sym_LBRACK,
    ACTIONS(1035), 1,
      anon_sym_STAR,
    ACTIONS(1037), 1,
      anon_sym_map,
    ACTIONS(1039), 1,
      anon_sym_chan,
    ACTIONS(1041), 1,
      anon_sym_LT_DASH,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1046), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1025), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57638] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1638), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57695] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_LT_DASH,
    STATE(898), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57752] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1355), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57809] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1259), 1,
      anon_sym_DOT,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1807), 1,
      anon_sym_RBRACK,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [57866] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(664), 1,
      anon_sym_func,
    ACTIONS(678), 1,
      anon_sym_LT_DASH,
    ACTIONS(1043), 1,
      anon_sym_LBRACK,
    ACTIONS(1045), 1,
      anon_sym_STAR,
    ACTIONS(1099), 1,
      anon_sym_LPAREN,
    STATE(1358), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1027), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(1034), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57923] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(947), 1,
      anon_sym_func,
    ACTIONS(953), 1,
      anon_sym_struct,
    ACTIONS(957), 1,
      anon_sym_interface,
    ACTIONS(959), 1,
      anon_sym_map,
    ACTIONS(961), 1,
      anon_sym_chan,
    ACTIONS(1309), 1,
      anon_sym_LPAREN,
    ACTIONS(1317), 1,
      anon_sym_TILDE,
    ACTIONS(1699), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_LT_DASH,
    STATE(929), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(875), 3,
      sym_union_type,
      sym_negated_type,
      sym_qualified_type,
    STATE(926), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [57980] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_PIPE,
    ACTIONS(1091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1261), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1809), 1,
      anon_sym_DOT,
    STATE(455), 1,
      sym_argument_list,
    STATE(1729), 1,
      sym_type_arguments,
    ACTIONS(1085), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1089), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1083), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1087), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1079), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [58034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1811), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(682), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 17,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58068] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_LF,
    ACTIONS(1814), 21,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [58098] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_LF,
    ACTIONS(1818), 21,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [58128] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1824), 1,
      anon_sym_LF,
    ACTIONS(1822), 21,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [58158] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LF,
    ACTIONS(1826), 21,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [58188] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_LF,
    ACTIONS(1834), 1,
      anon_sym_COMMA,
    STATE(854), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1830), 17,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [58220] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_LF,
    ACTIONS(1830), 18,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [58247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1822), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1824), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [58273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1828), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [58299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1820), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [58325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1816), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [58351] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1828), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1826), 15,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      sym_identifier,
  [58376] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1816), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1814), 15,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      sym_identifier,
  [58401] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1824), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1822), 15,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      sym_identifier,
  [58426] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1820), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1818), 15,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      sym_identifier,
  [58451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_COMMA,
    STATE(865), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1837), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [58476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1839), 1,
      anon_sym_COMMA,
    STATE(865), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(933), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [58501] = 6,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1844), 1,
      anon_sym_LBRACE,
    ACTIONS(1848), 1,
      anon_sym_LT,
    STATE(917), 1,
      sym_argument_list,
    STATE(935), 1,
      sym_component_block,
    ACTIONS(1846), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [58529] = 6,
    ACTIONS(1848), 1,
      anon_sym_LT,
    ACTIONS(1850), 1,
      anon_sym_LPAREN,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(885), 1,
      sym_argument_list,
    STATE(1007), 1,
      sym_component_block,
    ACTIONS(1846), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [58557] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(973), 1,
      anon_sym_DOT,
    ACTIONS(1101), 1,
      anon_sym_LF,
    ACTIONS(1854), 1,
      anon_sym_LBRACK,
    STATE(919), 1,
      sym_type_arguments,
    ACTIONS(985), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [58585] = 6,
    ACTIONS(1850), 1,
      anon_sym_LPAREN,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    ACTIONS(1858), 1,
      anon_sym_LT,
    STATE(899), 1,
      sym_argument_list,
    STATE(972), 1,
      sym_component_block,
    ACTIONS(1856), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [58613] = 6,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1844), 1,
      anon_sym_LBRACE,
    ACTIONS(1858), 1,
      anon_sym_LT,
    STATE(920), 1,
      sym_argument_list,
    STATE(950), 1,
      sym_component_block,
    ACTIONS(1856), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [58641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_COMMA,
    STATE(871), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1830), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1832), 6,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
  [58667] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(973), 1,
      anon_sym_DOT,
    ACTIONS(1101), 1,
      anon_sym_LF,
    ACTIONS(1863), 1,
      anon_sym_LBRACK,
    STATE(919), 1,
      sym_type_arguments,
    ACTIONS(985), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [58695] = 3,
    ACTIONS(1866), 1,
      anon_sym_DOT,
    ACTIONS(1870), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(1868), 11,
      sym_element_text,
      sym_element_comment,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [58716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1874), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1872), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [58737] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1876), 1,
      anon_sym_LF,
    ACTIONS(1880), 1,
      anon_sym_LBRACK,
    STATE(916), 1,
      sym_type_arguments,
    ACTIONS(1878), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [58762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1883), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [58783] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_LBRACK,
    ACTIONS(1876), 1,
      anon_sym_LF,
    STATE(916), 1,
      sym_type_arguments,
    ACTIONS(1878), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [58808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1887), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [58829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 1,
      anon_sym_COMMA,
    STATE(879), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(1893), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(1891), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [58854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1832), 7,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
  [58875] = 3,
    ACTIONS(1898), 1,
      anon_sym_DOT,
    ACTIONS(1870), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(1868), 11,
      sym_element_text,
      sym_element_comment,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [58896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1904), 1,
      anon_sym_COMMA,
    STATE(882), 1,
      aux_sym_parameter_declaration_repeat1,
    ACTIONS(1902), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(1900), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [58921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_EQ,
    ACTIONS(1909), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1883), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [58944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1911), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1883), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [58965] = 4,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    ACTIONS(1915), 1,
      anon_sym_LT,
    STATE(1004), 1,
      sym_component_block,
    ACTIONS(1913), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [58987] = 2,
    ACTIONS(1870), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(1868), 11,
      sym_element_text,
      sym_element_comment,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59005] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_LF,
    ACTIONS(1919), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59025] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1921), 1,
      anon_sym_LF,
    ACTIONS(1923), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59045] = 3,
    ACTIONS(1929), 1,
      anon_sym_else,
    ACTIONS(1925), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(1927), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [59065] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LF,
    ACTIONS(1933), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1937), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
  [59105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1939), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1941), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
  [59125] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_LF,
    ACTIONS(1945), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59145] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1947), 1,
      anon_sym_LF,
    ACTIONS(1949), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59165] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LF,
    ACTIONS(1953), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59185] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1955), 1,
      anon_sym_LF,
    ACTIONS(1957), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59205] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1959), 1,
      anon_sym_LF,
    ACTIONS(1961), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59225] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LF,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(1965), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59247] = 4,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    ACTIONS(1971), 1,
      anon_sym_LT,
    STATE(986), 1,
      sym_component_block,
    ACTIONS(1969), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [59269] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1973), 1,
      anon_sym_LF,
    ACTIONS(1975), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59289] = 2,
    ACTIONS(1977), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(1979), 11,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [59307] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1981), 1,
      anon_sym_LF,
    ACTIONS(1983), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59327] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1985), 1,
      anon_sym_LF,
    ACTIONS(1987), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59347] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_LF,
    ACTIONS(1919), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59367] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1989), 1,
      anon_sym_LF,
    ACTIONS(1991), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59387] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_LF,
    ACTIONS(1919), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59407] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1993), 1,
      anon_sym_LF,
    ACTIONS(1995), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59427] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(1989), 1,
      anon_sym_LF,
    ACTIONS(1991), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59449] = 3,
    ACTIONS(1997), 1,
      anon_sym_else,
    ACTIONS(1925), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(1927), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59469] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_LF,
    ACTIONS(2001), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59489] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LF,
    ACTIONS(2005), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59509] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2007), 1,
      anon_sym_LF,
    ACTIONS(2009), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59531] = 3,
    ACTIONS(2015), 1,
      anon_sym_else,
    ACTIONS(2011), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2013), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59551] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LF,
    ACTIONS(2019), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59571] = 2,
    ACTIONS(2021), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2023), 11,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [59589] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym_LF,
    ACTIONS(2027), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59609] = 4,
    ACTIONS(1844), 1,
      anon_sym_LBRACE,
    ACTIONS(1915), 1,
      anon_sym_LT,
    STATE(942), 1,
      sym_component_block,
    ACTIONS(1913), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59631] = 2,
    ACTIONS(1870), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(1868), 11,
      sym_element_text,
      sym_element_comment,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [59649] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LF,
    ACTIONS(2031), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59669] = 4,
    ACTIONS(1844), 1,
      anon_sym_LBRACE,
    ACTIONS(1971), 1,
      anon_sym_LT,
    STATE(956), 1,
      sym_component_block,
    ACTIONS(1969), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59691] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LF,
    ACTIONS(2035), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59711] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2037), 1,
      anon_sym_LF,
    ACTIONS(2039), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59731] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2041), 1,
      anon_sym_LF,
    ACTIONS(2043), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59751] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2045), 1,
      anon_sym_LF,
    ACTIONS(2047), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59771] = 2,
    ACTIONS(1977), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(1979), 11,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59789] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1876), 1,
      anon_sym_LF,
    ACTIONS(1878), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59809] = 3,
    ACTIONS(2049), 1,
      anon_sym_else,
    ACTIONS(2011), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2013), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [59829] = 2,
    ACTIONS(2021), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2023), 11,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_else,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59847] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2051), 1,
      anon_sym_LF,
    ACTIONS(2053), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59869] = 2,
    ACTIONS(2055), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2057), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59886] = 2,
    ACTIONS(2059), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2061), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(2063), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [59922] = 2,
    ACTIONS(2067), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2069), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59939] = 2,
    ACTIONS(2071), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2073), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59956] = 2,
    ACTIONS(2075), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2077), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59973] = 2,
    ACTIONS(2079), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2081), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [59990] = 2,
    ACTIONS(2083), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2085), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60007] = 2,
    ACTIONS(2087), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2089), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60024] = 2,
    ACTIONS(2091), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2093), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60041] = 2,
    ACTIONS(2095), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2097), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60058] = 2,
    ACTIONS(2099), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2101), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60075] = 2,
    ACTIONS(2103), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2105), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60092] = 2,
    ACTIONS(2107), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2109), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60109] = 2,
    ACTIONS(2111), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2113), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60126] = 2,
    ACTIONS(2115), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2117), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60143] = 2,
    ACTIONS(2119), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2121), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60160] = 2,
    ACTIONS(2123), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2125), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60177] = 2,
    ACTIONS(2127), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2129), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(2131), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [60213] = 2,
    ACTIONS(2135), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2137), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60230] = 2,
    ACTIONS(2139), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2141), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60247] = 2,
    ACTIONS(2143), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2145), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60264] = 2,
    ACTIONS(2147), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2149), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60281] = 2,
    ACTIONS(2151), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2153), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60298] = 2,
    ACTIONS(2123), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2125), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60315] = 2,
    ACTIONS(2155), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2157), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60332] = 2,
    ACTIONS(2159), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2161), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60349] = 2,
    ACTIONS(2163), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2165), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60366] = 2,
    ACTIONS(2167), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2169), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60383] = 2,
    ACTIONS(2127), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2129), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60400] = 2,
    ACTIONS(872), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(870), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60417] = 2,
    ACTIONS(2171), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2173), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60434] = 2,
    ACTIONS(2175), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2177), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60451] = 2,
    ACTIONS(2179), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2181), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60468] = 2,
    ACTIONS(2183), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2185), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60485] = 2,
    ACTIONS(814), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(812), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60502] = 2,
    ACTIONS(888), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(886), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60519] = 2,
    ACTIONS(794), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(792), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60536] = 2,
    ACTIONS(872), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(870), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60553] = 2,
    ACTIONS(814), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(812), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60570] = 2,
    ACTIONS(888), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(886), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60587] = 2,
    ACTIONS(2135), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2137), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60604] = 2,
    ACTIONS(794), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(792), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60621] = 2,
    ACTIONS(2187), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2189), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60638] = 2,
    ACTIONS(2139), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2141), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60655] = 2,
    ACTIONS(2191), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2193), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60672] = 2,
    ACTIONS(2115), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2117), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60689] = 2,
    ACTIONS(2195), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2197), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60706] = 2,
    ACTIONS(2143), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2145), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60723] = 2,
    ACTIONS(2059), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2061), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60740] = 2,
    ACTIONS(2187), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2189), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60757] = 2,
    ACTIONS(2191), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2193), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60774] = 2,
    ACTIONS(2147), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2149), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_DOT,
    ACTIONS(2199), 1,
      anon_sym_LBRACK,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(1101), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [60814] = 2,
    ACTIONS(2151), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2153), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60831] = 2,
    ACTIONS(2155), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2157), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60848] = 2,
    ACTIONS(2202), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2204), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60865] = 2,
    ACTIONS(2206), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2208), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60882] = 2,
    ACTIONS(2210), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2212), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [60899] = 2,
    ACTIONS(2159), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2161), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60916] = 2,
    ACTIONS(2163), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2165), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60933] = 2,
    ACTIONS(2167), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2169), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60950] = 2,
    ACTIONS(2171), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2173), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [60967] = 10,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(973), 1,
      anon_sym_DOT,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(1854), 1,
      anon_sym_LBRACK,
    ACTIONS(2214), 1,
      anon_sym_LF,
    ACTIONS(2218), 1,
      sym_raw_string_literal,
    STATE(919), 1,
      sym_type_arguments,
    STATE(1423), 1,
      sym_interpreted_string_literal,
    ACTIONS(2216), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [61000] = 2,
    ACTIONS(2067), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2069), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61017] = 2,
    ACTIONS(2210), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2212), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61034] = 2,
    ACTIONS(2175), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2177), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61051] = 2,
    ACTIONS(2179), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2181), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61068] = 2,
    ACTIONS(2119), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2121), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61085] = 2,
    ACTIONS(2111), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2113), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61102] = 2,
    ACTIONS(2107), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2109), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61119] = 2,
    ACTIONS(2220), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2222), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [61136] = 2,
    ACTIONS(2206), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2208), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61153] = 2,
    ACTIONS(2103), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2105), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61170] = 2,
    ACTIONS(2183), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2185), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [61187] = 2,
    ACTIONS(2071), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2073), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61204] = 2,
    ACTIONS(2075), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2077), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61221] = 2,
    ACTIONS(2195), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2197), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61238] = 2,
    ACTIONS(2099), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2101), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61255] = 2,
    ACTIONS(2202), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2204), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61272] = 2,
    ACTIONS(2079), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2081), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61289] = 2,
    ACTIONS(2224), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2226), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_SLASH,
      anon_sym_LT_BANG,
  [61306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_DOT,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(1101), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61329] = 2,
    ACTIONS(2055), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2057), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61346] = 2,
    ACTIONS(2095), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2097), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(2230), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [61382] = 2,
    ACTIONS(2091), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2093), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61399] = 2,
    ACTIONS(2087), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2089), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61416] = 2,
    ACTIONS(2083), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2085), 10,
      sym_element_text,
      sym_element_comment,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      sym_comment,
      anon_sym_AT,
      anon_sym_LBRACE_BANG,
      anon_sym_LT_BANG,
  [61433] = 9,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(1854), 1,
      anon_sym_LBRACK,
    ACTIONS(1878), 1,
      anon_sym_PIPE,
    ACTIONS(2234), 1,
      anon_sym_LF,
    ACTIONS(2238), 1,
      sym_raw_string_literal,
    STATE(916), 1,
      sym_type_arguments,
    STATE(1384), 1,
      sym_interpreted_string_literal,
    ACTIONS(2236), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [61463] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 1,
      anon_sym_LBRACE,
    ACTIONS(2245), 1,
      anon_sym_if2,
    ACTIONS(2248), 1,
      sym_attribute_name,
    ACTIONS(2243), 2,
      anon_sym_GT,
      anon_sym_SLASH_GT,
    STATE(1021), 5,
      sym__attribute,
      sym_attribute,
      sym_spread_attributes,
      sym_conditional_attribute_if_statement,
      aux_sym_tag_start_repeat1,
  [61487] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_LBRACE,
    ACTIONS(2253), 1,
      anon_sym_GT,
    ACTIONS(2255), 1,
      anon_sym_SLASH_GT,
    ACTIONS(2257), 1,
      anon_sym_if2,
    ACTIONS(2259), 1,
      sym_attribute_name,
    STATE(1021), 5,
      sym__attribute,
      sym_attribute,
      sym_spread_attributes,
      sym_conditional_attribute_if_statement,
      aux_sym_tag_start_repeat1,
  [61513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_LBRACE,
    ACTIONS(2257), 1,
      anon_sym_if2,
    ACTIONS(2259), 1,
      sym_attribute_name,
    ACTIONS(2261), 1,
      anon_sym_GT,
    ACTIONS(2263), 1,
      anon_sym_SLASH_GT,
    STATE(1022), 5,
      sym__attribute,
      sym_attribute,
      sym_spread_attributes,
      sym_conditional_attribute_if_statement,
      aux_sym_tag_start_repeat1,
  [61539] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_LBRACE,
    ACTIONS(2253), 1,
      anon_sym_GT,
    ACTIONS(2257), 1,
      anon_sym_if2,
    ACTIONS(2259), 1,
      sym_attribute_name,
    ACTIONS(2265), 1,
      anon_sym_SLASH_GT,
    STATE(1021), 5,
      sym__attribute,
      sym_attribute,
      sym_spread_attributes,
      sym_conditional_attribute_if_statement,
      aux_sym_tag_start_repeat1,
  [61565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      anon_sym_LBRACK,
    STATE(1047), 1,
      sym_type_arguments,
    ACTIONS(1876), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61585] = 9,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(1854), 1,
      anon_sym_LBRACK,
    ACTIONS(1878), 1,
      anon_sym_PIPE,
    ACTIONS(2270), 1,
      anon_sym_LF,
    ACTIONS(2274), 1,
      sym_raw_string_literal,
    STATE(916), 1,
      sym_type_arguments,
    STATE(1315), 1,
      sym_interpreted_string_literal,
    ACTIONS(2272), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [61615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    STATE(1047), 1,
      sym_type_arguments,
    ACTIONS(1876), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_LBRACE,
    ACTIONS(2257), 1,
      anon_sym_if2,
    ACTIONS(2259), 1,
      sym_attribute_name,
    ACTIONS(2261), 1,
      anon_sym_GT,
    ACTIONS(2276), 1,
      anon_sym_SLASH_GT,
    STATE(1024), 5,
      sym__attribute,
      sym_attribute,
      sym_spread_attributes,
      sym_conditional_attribute_if_statement,
      aux_sym_tag_start_repeat1,
  [61661] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 1,
      sym_identifier,
    ACTIONS(2280), 1,
      anon_sym_DOT,
    ACTIONS(2282), 1,
      sym_blank_identifier,
    ACTIONS(2284), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      sym_raw_string_literal,
    ACTIONS(2288), 1,
      anon_sym_DQUOTE,
    STATE(1325), 1,
      sym_interpreted_string_literal,
    STATE(1465), 1,
      sym_dot,
    STATE(1326), 2,
      sym_import_spec,
      sym_import_spec_list,
  [61693] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2280), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      sym_identifier,
    ACTIONS(2292), 1,
      sym_blank_identifier,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2296), 1,
      sym_raw_string_literal,
    STATE(1419), 1,
      sym_interpreted_string_literal,
    STATE(1463), 1,
      sym_dot,
    STATE(1543), 2,
      sym_import_spec,
      sym_import_spec_list,
  [61725] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_LBRACE,
    ACTIONS(2253), 1,
      anon_sym_GT,
    ACTIONS(2257), 1,
      anon_sym_if2,
    ACTIONS(2259), 1,
      sym_attribute_name,
    ACTIONS(2298), 1,
      anon_sym_SLASH_GT,
    STATE(1021), 5,
      sym__attribute,
      sym_attribute,
      sym_spread_attributes,
      sym_conditional_attribute_if_statement,
      aux_sym_tag_start_repeat1,
  [61751] = 8,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(973), 1,
      anon_sym_DOT,
    ACTIONS(1101), 1,
      anon_sym_LF,
    ACTIONS(1854), 1,
      anon_sym_LBRACK,
    ACTIONS(2300), 1,
      anon_sym_LPAREN,
    STATE(505), 1,
      sym_parameter_list,
    STATE(919), 1,
      sym_type_arguments,
    ACTIONS(985), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [61779] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_LBRACE,
    ACTIONS(2257), 1,
      anon_sym_if2,
    ACTIONS(2259), 1,
      sym_attribute_name,
    ACTIONS(2261), 1,
      anon_sym_GT,
    ACTIONS(2302), 1,
      anon_sym_SLASH_GT,
    STATE(1031), 5,
      sym__attribute,
      sym_attribute,
      sym_spread_attributes,
      sym_conditional_attribute_if_statement,
      aux_sym_tag_start_repeat1,
  [61805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1876), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1959), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1973), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61895] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2280), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      sym_identifier,
    ACTIONS(2292), 1,
      sym_blank_identifier,
    ACTIONS(2296), 1,
      sym_raw_string_literal,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
    STATE(1410), 1,
      sym_import_spec,
    STATE(1419), 1,
      sym_interpreted_string_literal,
    STATE(1463), 1,
      sym_dot,
  [61926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1981), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(2007), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2041), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(1963), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(2051), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62067] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2280), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      sym_identifier,
    ACTIONS(2292), 1,
      sym_blank_identifier,
    ACTIONS(2296), 1,
      sym_raw_string_literal,
    ACTIONS(2308), 1,
      anon_sym_RPAREN,
    STATE(1410), 1,
      sym_import_spec,
    STATE(1419), 1,
      sym_interpreted_string_literal,
    STATE(1463), 1,
      sym_dot,
  [62098] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2280), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      sym_identifier,
    ACTIONS(2292), 1,
      sym_blank_identifier,
    ACTIONS(2296), 1,
      sym_raw_string_literal,
    ACTIONS(2310), 1,
      anon_sym_RPAREN,
    STATE(1410), 1,
      sym_import_spec,
    STATE(1419), 1,
      sym_interpreted_string_literal,
    STATE(1463), 1,
      sym_dot,
  [62129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(1989), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1921), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62251] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2280), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      sym_identifier,
    ACTIONS(2292), 1,
      sym_blank_identifier,
    ACTIONS(2296), 1,
      sym_raw_string_literal,
    ACTIONS(2312), 1,
      anon_sym_RPAREN,
    STATE(1410), 1,
      sym_import_spec,
    STATE(1419), 1,
      sym_interpreted_string_literal,
    STATE(1463), 1,
      sym_dot,
  [62282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2037), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62312] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_DOT,
    ACTIONS(2316), 1,
      anon_sym_LBRACK,
    STATE(1124), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(985), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62335] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2280), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      sym_identifier,
    ACTIONS(2292), 1,
      sym_blank_identifier,
    ACTIONS(2296), 1,
      sym_raw_string_literal,
    ACTIONS(2319), 1,
      anon_sym_RPAREN,
    STATE(1300), 1,
      sym_import_spec,
    STATE(1419), 1,
      sym_interpreted_string_literal,
    STATE(1463), 1,
      sym_dot,
  [62366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1985), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    STATE(447), 1,
      sym_literal_value,
    STATE(1047), 1,
      sym_type_arguments,
    ACTIONS(1876), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [62434] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2280), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      sym_identifier,
    ACTIONS(2292), 1,
      sym_blank_identifier,
    ACTIONS(2296), 1,
      sym_raw_string_literal,
    ACTIONS(2321), 1,
      anon_sym_RPAREN,
    STATE(1307), 1,
      sym_import_spec,
    STATE(1419), 1,
      sym_interpreted_string_literal,
    STATE(1463), 1,
      sym_dot,
  [62465] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_DOT,
    ACTIONS(2323), 1,
      anon_sym_LBRACK,
    STATE(1124), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(985), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62503] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1131), 1,
      anon_sym_COMMA,
    ACTIONS(1837), 1,
      anon_sym_LF,
    STATE(1073), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2325), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [62523] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(933), 1,
      anon_sym_LF,
    ACTIONS(2327), 1,
      anon_sym_COMMA,
    STATE(1073), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(935), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [62543] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2330), 1,
      anon_sym_LF,
    ACTIONS(2334), 1,
      anon_sym_EQ,
    ACTIONS(2332), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [62563] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2336), 1,
      anon_sym_LBRACK,
    STATE(1122), 1,
      sym_type_arguments,
    ACTIONS(1876), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1878), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62583] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2323), 1,
      anon_sym_LBRACK,
    STATE(1122), 1,
      sym_type_arguments,
    ACTIONS(1876), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1878), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62603] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2339), 1,
      anon_sym_LF,
    ACTIONS(2343), 1,
      anon_sym_EQ,
    ACTIONS(2341), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [62623] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2280), 1,
      anon_sym_DOT,
    ACTIONS(2290), 1,
      sym_identifier,
    ACTIONS(2292), 1,
      sym_blank_identifier,
    ACTIONS(2296), 1,
      sym_raw_string_literal,
    STATE(1410), 1,
      sym_import_spec,
    STATE(1419), 1,
      sym_interpreted_string_literal,
    STATE(1463), 1,
      sym_dot,
  [62651] = 7,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2345), 1,
      anon_sym_LF,
    ACTIONS(2349), 1,
      sym_raw_string_literal,
    STATE(1409), 1,
      sym_interpreted_string_literal,
    ACTIONS(2347), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [62675] = 7,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(1878), 1,
      anon_sym_PIPE,
    ACTIONS(2270), 1,
      anon_sym_LF,
    ACTIONS(2274), 1,
      sym_raw_string_literal,
    STATE(1315), 1,
      sym_interpreted_string_literal,
    ACTIONS(2272), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [62699] = 7,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2351), 1,
      anon_sym_LF,
    ACTIONS(2355), 1,
      sym_raw_string_literal,
    STATE(1447), 1,
      sym_interpreted_string_literal,
    ACTIONS(2353), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [62723] = 7,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2345), 1,
      anon_sym_LF,
    ACTIONS(2357), 1,
      sym_raw_string_literal,
    STATE(1415), 1,
      sym_interpreted_string_literal,
    ACTIONS(2347), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [62747] = 7,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(1878), 1,
      anon_sym_PIPE,
    ACTIONS(2234), 1,
      anon_sym_LF,
    ACTIONS(2238), 1,
      sym_raw_string_literal,
    STATE(1384), 1,
      sym_interpreted_string_literal,
    ACTIONS(2236), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [62771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 1,
      anon_sym_LBRACE,
    STATE(473), 1,
      sym_block,
    ACTIONS(1989), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [62788] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2359), 1,
      anon_sym_PIPE,
    ACTIONS(1989), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1991), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [62805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym_literal_value,
    ACTIONS(1876), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [62822] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2361), 1,
      sym_identifier,
    ACTIONS(2363), 1,
      anon_sym_LF,
    ACTIONS(2365), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [62839] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2367), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      anon_sym_LF,
    ACTIONS(2371), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [62856] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1917), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1919), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62871] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1921), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1923), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62886] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_LF,
    ACTIONS(2377), 1,
      anon_sym_else,
    ACTIONS(2375), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [62903] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1973), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1975), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62918] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1987), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62933] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1931), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1933), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62948] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1917), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1919), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62963] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1917), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1919), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [62978] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LBRACE,
    ACTIONS(2359), 1,
      anon_sym_PIPE,
    STATE(1417), 1,
      sym_block,
    ACTIONS(2379), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2381), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [62999] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2383), 1,
      anon_sym_LF,
    STATE(1098), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(2386), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    ACTIONS(2389), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63018] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2391), 1,
      anon_sym_LF,
    ACTIONS(2395), 1,
      anon_sym_else,
    ACTIONS(2393), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63035] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1951), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1953), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63050] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_DOT,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    ACTIONS(2397), 1,
      anon_sym_LPAREN,
    STATE(484), 1,
      sym_parameter_list,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63073] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1993), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1995), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63088] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    STATE(1292), 1,
      sym_argument_list,
    STATE(1546), 1,
      sym_component_block,
    ACTIONS(1846), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63109] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2033), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2035), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63124] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1999), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2001), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63139] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2399), 1,
      anon_sym_LF,
    ACTIONS(2401), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63156] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2403), 1,
      anon_sym_LF,
    ACTIONS(2405), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63173] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1955), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1957), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63188] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_LBRACE,
    ACTIONS(2409), 1,
      anon_sym_DQUOTE,
    ACTIONS(2411), 1,
      sym_attribute_value,
    ACTIONS(2413), 1,
      anon_sym_SQUOTE,
    STATE(1491), 3,
      sym_expression,
      sym_dynamic_class_attribute_value,
      sym_quoted_attribute_value,
  [63209] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LBRACE,
    ACTIONS(2359), 1,
      anon_sym_PIPE,
    STATE(1421), 1,
      sym_block,
    ACTIONS(2415), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2417), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [63230] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2419), 1,
      anon_sym_LF,
    ACTIONS(2421), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63247] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2003), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2005), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63262] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2359), 1,
      anon_sym_PIPE,
    ACTIONS(2007), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2009), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [63279] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1947), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1949), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63294] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2017), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2019), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63309] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1943), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1945), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 1,
      anon_sym_LBRACE,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    STATE(473), 1,
      sym_block,
    ACTIONS(1989), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [63343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    STATE(1302), 1,
      sym_argument_list,
    STATE(1488), 1,
      sym_component_block,
    ACTIONS(1856), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63364] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LBRACE,
    ACTIONS(2359), 1,
      anon_sym_PIPE,
    STATE(1418), 1,
      sym_block,
    ACTIONS(2423), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2425), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [63385] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_LF,
    STATE(1125), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(2429), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    ACTIONS(2431), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63404] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1981), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1983), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63419] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2025), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2027), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63434] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1989), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1991), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63449] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2029), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2031), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63464] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2433), 1,
      anon_sym_LF,
    STATE(1098), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(2435), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    ACTIONS(222), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63483] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2037), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2039), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63498] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2359), 1,
      anon_sym_PIPE,
    ACTIONS(1963), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1965), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [63515] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2041), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2043), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63530] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2045), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2047), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63545] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_DOT,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    ACTIONS(2437), 1,
      anon_sym_LPAREN,
    STATE(457), 1,
      sym_parameter_list,
    STATE(1066), 1,
      sym_type_arguments,
    ACTIONS(1101), 2,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63568] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1876), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1878), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63583] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2439), 1,
      anon_sym_LBRACE,
    ACTIONS(2441), 1,
      anon_sym_DQUOTE,
    ACTIONS(2443), 1,
      sym_attribute_value,
    ACTIONS(2445), 1,
      anon_sym_SQUOTE,
    STATE(1549), 3,
      sym_expression,
      sym_dynamic_class_attribute_value,
      sym_quoted_attribute_value,
  [63604] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1959), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1961), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_LBRACE,
  [63619] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2359), 1,
      anon_sym_PIPE,
    ACTIONS(2051), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2053), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [63636] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2447), 1,
      anon_sym_LBRACE,
    ACTIONS(2449), 1,
      anon_sym_DQUOTE,
    ACTIONS(2451), 1,
      sym_attribute_value,
    ACTIONS(2453), 1,
      anon_sym_SQUOTE,
    STATE(1272), 3,
      sym_expression,
      sym_dynamic_class_attribute_value,
      sym_quoted_attribute_value,
  [63657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2455), 1,
      anon_sym_RBRACE,
    ACTIONS(2457), 1,
      anon_sym_case,
    ACTIONS(2459), 1,
      anon_sym_default,
    STATE(1212), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [63675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    ACTIONS(2461), 1,
      anon_sym_LBRACE,
    STATE(520), 1,
      sym_literal_value,
    STATE(1047), 1,
      sym_type_arguments,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [63695] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2463), 1,
      anon_sym_LF,
    ACTIONS(2465), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63709] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2467), 1,
      anon_sym_LF,
    ACTIONS(2469), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63723] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_LF,
    ACTIONS(2473), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63737] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    ACTIONS(2475), 1,
      anon_sym_LBRACE,
    STATE(317), 1,
      sym_literal_value,
    STATE(1047), 1,
      sym_type_arguments,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [63757] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2477), 1,
      anon_sym_LF,
    ACTIONS(2479), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63771] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2481), 1,
      anon_sym_LF,
    ACTIONS(2483), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63785] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_LF,
    ACTIONS(2487), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63799] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2489), 1,
      anon_sym_LF,
    ACTIONS(2491), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63813] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2493), 1,
      anon_sym_LF,
    ACTIONS(2495), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63827] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2497), 1,
      anon_sym_LF,
    ACTIONS(2499), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63841] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2501), 1,
      anon_sym_LF,
    ACTIONS(2503), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63855] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2505), 1,
      anon_sym_LF,
    ACTIONS(2507), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63869] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_LF,
    ACTIONS(2511), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63883] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_LF,
    ACTIONS(2515), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_case,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2517), 1,
      anon_sym_RBRACE,
    STATE(1171), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [63915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2519), 1,
      anon_sym_RBRACE,
    ACTIONS(2521), 1,
      anon_sym_case,
    STATE(1177), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [63933] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2523), 1,
      anon_sym_LF,
    ACTIONS(2525), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 1,
      anon_sym_RBRACE,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [63965] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2533), 1,
      anon_sym_LF,
    ACTIONS(2535), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [63979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2537), 1,
      anon_sym_RBRACE,
    STATE(1221), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [63997] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2539), 1,
      anon_sym_LF,
    ACTIONS(2541), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_RBRACE,
    ACTIONS(2545), 1,
      anon_sym_case,
    ACTIONS(2548), 1,
      anon_sym_default,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64029] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2551), 1,
      anon_sym_LF,
    ACTIONS(2553), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64043] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LF,
    ACTIONS(2557), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64057] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2559), 1,
      anon_sym_LF,
    ACTIONS(2561), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2563), 1,
      anon_sym_RBRACE,
    STATE(1164), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2565), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2567), 1,
      anon_sym_RBRACE,
    STATE(1200), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2569), 1,
      anon_sym_RBRACE,
    STATE(1155), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64143] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_case,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2571), 1,
      anon_sym_RBRACE,
    STATE(1212), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [64161] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_LF,
    ACTIONS(2577), 1,
      anon_sym_PIPE,
    STATE(1210), 1,
      aux_sym_struct_elem_repeat1,
    ACTIONS(2575), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [64179] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2579), 1,
      anon_sym_LF,
    ACTIONS(2581), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64193] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LF,
    ACTIONS(2585), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_case,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2587), 1,
      anon_sym_RBRACE,
    STATE(1212), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [64225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    STATE(614), 1,
      sym_literal_value,
    STATE(1047), 1,
      sym_type_arguments,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [64245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2589), 1,
      anon_sym_RBRACE,
    ACTIONS(2591), 1,
      anon_sym_case,
    STATE(1215), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [64263] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_LF,
    ACTIONS(2595), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_case,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2597), 1,
      anon_sym_RBRACE,
    STATE(1218), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [64295] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_LF,
    ACTIONS(2601), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2521), 1,
      anon_sym_case,
    ACTIONS(2603), 1,
      anon_sym_RBRACE,
    STATE(1222), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [64327] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_LF,
    ACTIONS(2607), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64341] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_LF,
    ACTIONS(2611), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64355] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2613), 1,
      anon_sym_LF,
    ACTIONS(2615), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64369] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2617), 1,
      anon_sym_LF,
    ACTIONS(2619), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2621), 1,
      anon_sym_RBRACE,
    STATE(1192), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64401] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_LF,
    ACTIONS(2625), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64415] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_LF,
    ACTIONS(2629), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64429] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_LF,
    ACTIONS(2633), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_DOT,
    ACTIONS(1868), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64457] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_LF,
    ACTIONS(2639), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64471] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    STATE(414), 1,
      sym_literal_value,
    STATE(1047), 1,
      sym_type_arguments,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [64491] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LBRACE,
    STATE(1421), 1,
      sym_block,
    ACTIONS(2415), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2417), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [64509] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2641), 1,
      anon_sym_LF,
    ACTIONS(2643), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(935), 1,
      anon_sym_COLON,
    ACTIONS(2645), 1,
      anon_sym_COMMA,
    STATE(1191), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(933), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [64541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2648), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2650), 1,
      anon_sym_RBRACE,
    STATE(1199), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 1,
      anon_sym_COMMA,
    ACTIONS(2325), 1,
      anon_sym_COLON,
    STATE(1191), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1837), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [64595] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2652), 1,
      anon_sym_LF,
    ACTIONS(2389), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 1,
      anon_sym_else2,
    ACTIONS(2654), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2656), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [64625] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2660), 1,
      anon_sym_LF,
    ACTIONS(2662), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2664), 1,
      anon_sym_RBRACE,
    STATE(1202), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2666), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2668), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64693] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_LF,
    ACTIONS(2672), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64707] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2674), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64725] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1878), 1,
      anon_sym_LBRACK,
    ACTIONS(2676), 1,
      anon_sym_LF,
    ACTIONS(2678), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [64741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2680), 1,
      anon_sym_RBRACE,
    STATE(1205), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2682), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [64777] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2684), 1,
      anon_sym_LBRACE,
    ACTIONS(2686), 1,
      anon_sym_RBRACE,
    ACTIONS(2688), 1,
      sym_attribute_name,
    STATE(1207), 3,
      sym_attribute,
      sym_spread_attributes,
      aux_sym_conditional_attribute_block_repeat1,
  [64795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2684), 1,
      anon_sym_LBRACE,
    ACTIONS(2688), 1,
      sym_attribute_name,
    ACTIONS(2690), 1,
      anon_sym_RBRACE,
    STATE(1250), 3,
      sym_attribute,
      sym_spread_attributes,
      aux_sym_conditional_attribute_block_repeat1,
  [64813] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_LF,
    ACTIONS(2694), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2696), 1,
      anon_sym_EQ,
    ACTIONS(2698), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2700), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [64843] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_PIPE,
    ACTIONS(2702), 1,
      anon_sym_LF,
    STATE(1237), 1,
      aux_sym_struct_elem_repeat1,
    ACTIONS(2704), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [64861] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2706), 1,
      anon_sym_LF,
    ACTIONS(2708), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2710), 1,
      anon_sym_RBRACE,
    ACTIONS(2712), 1,
      anon_sym_case,
    ACTIONS(2715), 1,
      anon_sym_default,
    STATE(1212), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [64893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_case,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2718), 1,
      anon_sym_RBRACE,
    STATE(1136), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [64911] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2720), 1,
      anon_sym_LF,
    ACTIONS(2722), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2591), 1,
      anon_sym_case,
    ACTIONS(2724), 1,
      anon_sym_RBRACE,
    STATE(1225), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [64943] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_LF,
    ACTIONS(2728), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [64957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2228), 1,
      anon_sym_LBRACK,
    ACTIONS(2730), 1,
      anon_sym_LBRACE,
    STATE(352), 1,
      sym_literal_value,
    STATE(1047), 1,
      sym_type_arguments,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [64977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_case,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2732), 1,
      anon_sym_RBRACE,
    STATE(1212), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [64995] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_LF,
    ACTIONS(2736), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [65009] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2379), 1,
      anon_sym_LF,
    STATE(1611), 1,
      sym_block,
    ACTIONS(2381), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65029] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2738), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [65047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_RBRACE,
    ACTIONS(2742), 1,
      anon_sym_case,
    ACTIONS(2745), 1,
      anon_sym_default,
    STATE(1222), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [65065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2748), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [65083] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2423), 1,
      anon_sym_LF,
    STATE(1610), 1,
      sym_block,
    ACTIONS(2425), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 1,
      anon_sym_RBRACE,
    ACTIONS(2752), 1,
      anon_sym_case,
    ACTIONS(2755), 1,
      anon_sym_default,
    STATE(1225), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [65121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2758), 1,
      anon_sym_RBRACE,
    STATE(1223), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [65139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2760), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [65157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2762), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [65175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2764), 1,
      anon_sym_RBRACE,
    STATE(1227), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [65193] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2766), 1,
      anon_sym_LF,
    ACTIONS(2768), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [65207] = 6,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_LF,
    STATE(1595), 1,
      sym_block,
    ACTIONS(2417), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65227] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_case,
    ACTIONS(2459), 1,
      anon_sym_default,
    ACTIONS(2770), 1,
      anon_sym_RBRACE,
    STATE(1167), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [65245] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LF,
    ACTIONS(2774), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [65259] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2776), 1,
      anon_sym_RBRACE,
    STATE(1228), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [65277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2778), 1,
      anon_sym_RBRACE,
    STATE(1159), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [65295] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2780), 1,
      anon_sym_LF,
    ACTIONS(2782), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [65309] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2784), 1,
      anon_sym_LF,
    ACTIONS(2788), 1,
      anon_sym_PIPE,
    STATE(1237), 1,
      aux_sym_struct_elem_repeat1,
    ACTIONS(2786), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [65327] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_case,
    ACTIONS(2531), 1,
      anon_sym_default,
    ACTIONS(2791), 1,
      anon_sym_RBRACE,
    STATE(1235), 3,
      sym_component_switch_expression_case,
      sym_component_switch_default_case,
      aux_sym_component_switch_statement_repeat1,
  [65345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2797), 1,
      anon_sym_else2,
    ACTIONS(2793), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2795), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65361] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2799), 1,
      anon_sym_LF,
    ACTIONS(2801), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [65375] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_LF,
    ACTIONS(2805), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [65389] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LF,
    ACTIONS(2809), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [65403] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2811), 1,
      anon_sym_LF,
    ACTIONS(2813), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [65417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2684), 1,
      anon_sym_LBRACE,
    ACTIONS(2688), 1,
      sym_attribute_name,
    ACTIONS(2815), 1,
      anon_sym_RBRACE,
    STATE(1248), 3,
      sym_attribute,
      sym_spread_attributes,
      aux_sym_conditional_attribute_block_repeat1,
  [65435] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LBRACE,
    STATE(1418), 1,
      sym_block,
    ACTIONS(2423), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2425), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65453] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LBRACE,
    STATE(1417), 1,
      sym_block,
    ACTIONS(2379), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2381), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2819), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
      anon_sym_else2,
  [65485] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2684), 1,
      anon_sym_LBRACE,
    ACTIONS(2688), 1,
      sym_attribute_name,
    ACTIONS(2821), 1,
      anon_sym_RBRACE,
    STATE(1250), 3,
      sym_attribute,
      sym_spread_attributes,
      aux_sym_conditional_attribute_block_repeat1,
  [65503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2823), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2825), 4,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
      anon_sym_else2,
  [65517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2827), 1,
      anon_sym_LBRACE,
    ACTIONS(2830), 1,
      anon_sym_RBRACE,
    ACTIONS(2832), 1,
      sym_attribute_name,
    STATE(1250), 3,
      sym_attribute,
      sym_spread_attributes,
      aux_sym_conditional_attribute_block_repeat1,
  [65535] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_LF,
    ACTIONS(2841), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2838), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2843), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2845), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65565] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(2847), 1,
      anon_sym_LF,
    ACTIONS(2849), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [65580] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2851), 1,
      anon_sym_LF,
    ACTIONS(2857), 1,
      anon_sym_RBRACE,
    STATE(1254), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2854), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65597] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2859), 1,
      anon_sym_LF,
    ACTIONS(2863), 1,
      anon_sym_RBRACE,
    STATE(1258), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2861), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2865), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2867), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65627] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2869), 1,
      anon_sym_LF,
    ACTIONS(2873), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2871), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65644] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2875), 1,
      anon_sym_LF,
    ACTIONS(2879), 1,
      anon_sym_RBRACE,
    STATE(1254), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2877), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65661] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2881), 1,
      anon_sym_LF,
    ACTIONS(2887), 1,
      anon_sym_RPAREN,
    STATE(1259), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(2884), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65678] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_LF,
    ACTIONS(2893), 1,
      anon_sym_RBRACE,
    STATE(1257), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2891), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65695] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2895), 1,
      anon_sym_LF,
    ACTIONS(2897), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [65708] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2784), 1,
      anon_sym_LF,
    ACTIONS(2786), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [65721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_GT,
    ACTIONS(2901), 1,
      anon_sym_SLASH_GT,
    ACTIONS(2903), 1,
      sym_attribute_name,
    STATE(1265), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [65738] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(2905), 1,
      anon_sym_GT,
    ACTIONS(2907), 1,
      anon_sym_SLASH_GT,
    STATE(1267), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [65755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(2909), 1,
      anon_sym_GT,
    ACTIONS(2911), 1,
      anon_sym_SLASH_GT,
    STATE(1309), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [65772] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    ACTIONS(2415), 1,
      anon_sym_LF,
    STATE(1595), 1,
      sym_block,
    ACTIONS(2417), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65789] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(2913), 1,
      anon_sym_GT,
    ACTIONS(2915), 1,
      anon_sym_SLASH_GT,
    STATE(1309), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [65806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2919), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65819] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    ACTIONS(2423), 1,
      anon_sym_LF,
    STATE(1610), 1,
      sym_block,
    ACTIONS(2425), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65836] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    ACTIONS(2379), 1,
      anon_sym_LF,
    STATE(1611), 1,
      sym_block,
    ACTIONS(2381), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_struct,
    STATE(1261), 1,
      sym_struct_type,
    STATE(1262), 1,
      sym_struct_term,
    ACTIONS(2921), 2,
      anon_sym_STAR,
      anon_sym_TILDE,
  [65870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2212), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2931), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65909] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2933), 1,
      anon_sym_LF,
    ACTIONS(2937), 1,
      anon_sym_RBRACE,
    STATE(1254), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2935), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [65926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2941), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2197), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2945), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2819), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2949), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [65991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2823), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2825), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [66004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 2,
      anon_sym_LBRACE,
      sym_attribute_name,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      anon_sym_if2,
  [66017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(2955), 1,
      anon_sym_GT,
    ACTIONS(2957), 1,
      anon_sym_SLASH_GT,
    STATE(1309), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [66034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(2959), 1,
      anon_sym_GT,
    ACTIONS(2961), 1,
      anon_sym_SLASH_GT,
    STATE(1309), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [66051] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_LF,
    ACTIONS(2967), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2965), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      sym_identifier,
    ACTIONS(2972), 1,
      anon_sym_RPAREN,
    STATE(1286), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1516), 2,
      sym_type_alias,
      sym_type_spec,
  [66085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(2974), 1,
      anon_sym_GT,
    ACTIONS(2976), 1,
      anon_sym_SLASH_GT,
    STATE(1283), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [66102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(2978), 1,
      anon_sym_GT,
    ACTIONS(2980), 1,
      anon_sym_SLASH_GT,
    STATE(1284), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [66119] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_LF,
    ACTIONS(2986), 1,
      anon_sym_RPAREN,
    STATE(1259), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(2984), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66136] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_LF,
    ACTIONS(2678), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [66149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(2988), 1,
      anon_sym_LPAREN,
    ACTIONS(2990), 1,
      anon_sym_COMMA,
    ACTIONS(2992), 1,
      anon_sym_RBRACK,
    STATE(1586), 1,
      aux_sym_type_arguments_repeat1,
  [66168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    STATE(1522), 1,
      sym_component_block,
    ACTIONS(1913), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [66183] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_LF,
    ACTIONS(2998), 1,
      anon_sym_RBRACE,
    STATE(1275), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2996), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66200] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2895), 1,
      anon_sym_LF,
    ACTIONS(2897), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [66213] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_PIPE,
    ACTIONS(3000), 1,
      anon_sym_LF,
    ACTIONS(3002), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [66228] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3004), 1,
      anon_sym_LF,
    ACTIONS(3008), 1,
      anon_sym_RBRACE,
    STATE(1285), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3006), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(3010), 1,
      anon_sym_GT,
    ACTIONS(3012), 1,
      anon_sym_SLASH_GT,
    STATE(1308), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [66262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(3014), 1,
      anon_sym_GT,
    ACTIONS(3016), 1,
      anon_sym_SLASH_GT,
    STATE(1303), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [66279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 1,
      sym_identifier,
    ACTIONS(3020), 1,
      anon_sym_RPAREN,
    STATE(1286), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1516), 2,
      sym_type_alias,
      sym_type_spec,
  [66296] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3022), 1,
      anon_sym_LF,
    ACTIONS(3026), 1,
      anon_sym_RPAREN,
    STATE(1289), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(3024), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66313] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_LF,
    ACTIONS(3032), 1,
      anon_sym_RPAREN,
    STATE(1259), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(3030), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    STATE(1480), 1,
      sym_component_block,
    ACTIONS(1969), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [66345] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(3034), 1,
      anon_sym_GT,
    ACTIONS(3036), 1,
      anon_sym_SLASH_GT,
    STATE(1309), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [66362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1868), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [66373] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_LF,
    ACTIONS(3042), 1,
      anon_sym_RBRACE,
    STATE(1314), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3040), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66390] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_LF,
    ACTIONS(3048), 1,
      anon_sym_RBRACE,
    STATE(1312), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(3046), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66407] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_LF,
    ACTIONS(3054), 1,
      anon_sym_RPAREN,
    STATE(1301), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(3052), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      sym_attribute_name,
    ACTIONS(3056), 1,
      anon_sym_GT,
    ACTIONS(3058), 1,
      anon_sym_SLASH_GT,
    STATE(1309), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [66441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      sym_attribute_name,
    ACTIONS(3060), 2,
      anon_sym_GT,
      anon_sym_SLASH_GT,
    STATE(1309), 2,
      sym_attribute,
      aux_sym_style_element_repeat1,
  [66456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [66467] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(2988), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_COMMA,
    ACTIONS(3067), 1,
      anon_sym_RBRACK,
    STATE(1582), 1,
      aux_sym_type_arguments_repeat1,
  [66486] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_LF,
    ACTIONS(3073), 1,
      anon_sym_RBRACE,
    STATE(1254), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(3071), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 1,
      sym_identifier,
    ACTIONS(3075), 1,
      anon_sym_RPAREN,
    STATE(1299), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1516), 2,
      sym_type_alias,
      sym_type_spec,
  [66520] = 5,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3077), 1,
      anon_sym_LF,
    ACTIONS(3081), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3079), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66537] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_LF,
    ACTIONS(3085), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [66549] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2021), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    ACTIONS(2023), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [66561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 1,
      sym_identifier,
    ACTIONS(3087), 1,
      anon_sym_LPAREN,
    STATE(1145), 2,
      sym_type_alias,
      sym_type_spec,
  [66575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      sym_identifier,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1631), 1,
      sym_parameter_list,
    STATE(1713), 1,
      sym__component_identifier,
  [66591] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3093), 1,
      anon_sym_DQUOTE2,
    STATE(1341), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3095), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [66605] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_DQUOTE2,
    STATE(1331), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3099), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [66619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      sym_identifier,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1717), 1,
      sym_parameter_list,
    STATE(1718), 1,
      sym__component_identifier,
  [66635] = 4,
    ACTIONS(194), 1,
      ts_builtin_sym_end,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3101), 1,
      anon_sym_LF,
    ACTIONS(3103), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2475), 1,
      anon_sym_LBRACE,
    STATE(317), 1,
      sym_literal_value,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [66663] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3105), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3107), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66675] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3109), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3111), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66687] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3113), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3115), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3119), 1,
      anon_sym_RPAREN,
    STATE(1337), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1503), 1,
      sym_const_spec,
  [66715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 1,
      sym_identifier,
    ACTIONS(3123), 1,
      anon_sym_RPAREN,
    STATE(1342), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1506), 1,
      sym_var_spec,
  [66731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_LPAREN,
    ACTIONS(3125), 1,
      anon_sym_LBRACK,
    STATE(488), 1,
      sym_parameter_list,
    STATE(1709), 1,
      sym_type_parameter_list,
  [66747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2437), 1,
      anon_sym_LPAREN,
    ACTIONS(3125), 1,
      anon_sym_LBRACK,
    STATE(453), 1,
      sym_parameter_list,
    STATE(1742), 1,
      sym_type_parameter_list,
  [66763] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3127), 1,
      anon_sym_DQUOTE2,
    STATE(1360), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3129), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [66777] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3101), 1,
      anon_sym_LF,
    ACTIONS(3131), 1,
      ts_builtin_sym_end,
    ACTIONS(3103), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    STATE(999), 2,
      sym_component_block,
      sym_component_if_statement,
  [66805] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3133), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3135), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66817] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3137), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3139), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66829] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3141), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3143), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [66841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3145), 1,
      anon_sym_RPAREN,
    STATE(1369), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1503), 1,
      sym_const_spec,
  [66857] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3147), 1,
      anon_sym_DQUOTE2,
    STATE(1360), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3129), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [66871] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3149), 1,
      anon_sym_DQUOTE2,
    STATE(1338), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3151), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [66885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3153), 1,
      anon_sym_else,
    ACTIONS(2013), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [66897] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_DQUOTE2,
    STATE(1360), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3129), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [66911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 1,
      sym_identifier,
    ACTIONS(3157), 1,
      anon_sym_RPAREN,
    STATE(1370), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1506), 1,
      sym_var_spec,
  [66927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3159), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [66939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    STATE(333), 1,
      sym_block,
    ACTIONS(1989), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [66953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    STATE(333), 1,
      sym_block,
  [66969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 1,
      anon_sym_RBRACE,
    ACTIONS(3165), 1,
      anon_sym_COLON,
    STATE(1513), 1,
      aux_sym_literal_value_repeat1,
  [66985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3167), 1,
      anon_sym_RPAREN,
    ACTIONS(3169), 1,
      anon_sym_COMMA,
    STATE(1519), 1,
      aux_sym_expression_list_repeat1,
  [67001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LBRACE,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    STATE(638), 1,
      sym_block,
  [67017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LBRACE,
    STATE(638), 1,
      sym_block,
    ACTIONS(1989), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [67031] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_DQUOTE2,
    STATE(1360), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3129), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [67045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 1,
      anon_sym_LBRACE,
    STATE(614), 1,
      sym_literal_value,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [67059] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3173), 1,
      anon_sym_DQUOTE2,
    STATE(1350), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3175), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [67073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3177), 1,
      anon_sym_EQ,
    ACTIONS(2700), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_attribute_name,
  [67085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_EQ,
    ACTIONS(2698), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [67097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3181), 1,
      anon_sym_RPAREN,
    ACTIONS(3183), 1,
      anon_sym_COMMA,
    STATE(1523), 1,
      aux_sym_expression_list_repeat1,
  [67113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_RPAREN,
    ACTIONS(3187), 1,
      anon_sym_COMMA,
    STATE(1581), 1,
      aux_sym_expression_list_repeat1,
  [67129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3065), 1,
      anon_sym_COMMA,
    ACTIONS(3067), 1,
      anon_sym_RBRACK,
    STATE(1582), 1,
      aux_sym_type_arguments_repeat1,
  [67145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(2990), 1,
      anon_sym_COMMA,
    ACTIONS(2992), 1,
      anon_sym_RBRACK,
    STATE(1586), 1,
      aux_sym_type_arguments_repeat1,
  [67161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_COLON,
    ACTIONS(3189), 1,
      anon_sym_COMMA,
    ACTIONS(3191), 1,
      anon_sym_RBRACE,
    STATE(1589), 1,
      aux_sym_literal_value_repeat1,
  [67177] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3193), 1,
      anon_sym_DQUOTE2,
    STATE(1360), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3195), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [67191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 1,
      anon_sym_else,
    ACTIONS(1927), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [67203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [67213] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3200), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3202), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_COLON,
    ACTIONS(3204), 1,
      anon_sym_COMMA,
    ACTIONS(3206), 1,
      anon_sym_RBRACE,
    STATE(1558), 1,
      aux_sym_literal_value_repeat1,
  [67241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 1,
      anon_sym_RPAREN,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    STATE(1559), 1,
      aux_sym_expression_list_repeat1,
  [67257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1239), 1,
      anon_sym_LBRACE,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    STATE(406), 1,
      sym_block,
  [67273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1239), 1,
      anon_sym_LBRACE,
    STATE(406), 1,
      sym_block,
    ACTIONS(1989), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [67287] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_DQUOTE2,
    STATE(1360), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3129), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [67301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 1,
      sym_identifier,
    ACTIONS(3217), 1,
      anon_sym_RPAREN,
    STATE(1369), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1503), 1,
      sym_const_spec,
  [67317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      sym_identifier,
    ACTIONS(3222), 1,
      anon_sym_RPAREN,
    STATE(1370), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1506), 1,
      sym_var_spec,
  [67333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [67343] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3224), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3226), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_RBRACE,
    ACTIONS(3230), 1,
      sym_css_property_name,
    STATE(1373), 2,
      sym_css_property,
      aux_sym__css_block_repeat1,
  [67369] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3233), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3235), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    STATE(414), 1,
      sym_literal_value,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [67395] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3237), 1,
      anon_sym_DQUOTE2,
    STATE(1368), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3239), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [67409] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1977), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    ACTIONS(1979), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [67421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_COLON,
    ACTIONS(3241), 1,
      anon_sym_COMMA,
    ACTIONS(3243), 1,
      anon_sym_RBRACE,
    STATE(1578), 1,
      aux_sym_literal_value_repeat1,
  [67437] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3245), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3247), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67449] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(748), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(750), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(2988), 1,
      anon_sym_LPAREN,
    ACTIONS(3159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [67475] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_LF,
    ACTIONS(3251), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [67487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3253), 1,
      anon_sym_RBRACE,
    ACTIONS(3255), 1,
      sym_css_property_name,
    STATE(1403), 2,
      sym_css_property,
      aux_sym__css_block_repeat1,
  [67501] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3257), 1,
      anon_sym_LF,
    ACTIONS(3259), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [67513] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(742), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(744), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 4,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
  [67535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2257), 1,
      anon_sym_if2,
    ACTIONS(3261), 1,
      anon_sym_LBRACE,
    STATE(1256), 2,
      sym_conditional_attribute_block,
      sym_conditional_attribute_if_statement,
  [67549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_COLON,
    ACTIONS(3263), 1,
      anon_sym_COMMA,
    ACTIONS(3265), 1,
      anon_sym_RBRACE,
    STATE(1605), 1,
      aux_sym_literal_value_repeat1,
  [67565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3267), 1,
      anon_sym_RPAREN,
    ACTIONS(3269), 1,
      anon_sym_COMMA,
    STATE(1600), 1,
      aux_sym_expression_list_repeat1,
  [67581] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(738), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(740), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      anon_sym_LBRACE,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    STATE(370), 1,
      sym_block,
  [67609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      anon_sym_LBRACE,
    STATE(370), 1,
      sym_block,
    ACTIONS(1989), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [67623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(3271), 1,
      anon_sym_if,
    STATE(1236), 2,
      sym_block,
      sym_if_statement,
  [67637] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3273), 1,
      anon_sym_DQUOTE2,
    STATE(1360), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3129), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [67651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 1,
      anon_sym_LBRACE,
    STATE(352), 1,
      sym_literal_value,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [67665] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_DQUOTE2,
    STATE(1394), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3277), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [67679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3279), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [67691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    ACTIONS(1361), 1,
      anon_sym_if,
    STATE(1478), 2,
      sym_component_block,
      sym_component_if_statement,
  [67705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    ACTIONS(1361), 1,
      anon_sym_if,
    STATE(1502), 2,
      sym_component_block,
      sym_component_if_statement,
  [67719] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3281), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3283), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3255), 1,
      sym_css_property_name,
    ACTIONS(3285), 1,
      anon_sym_RBRACE,
    STATE(1446), 2,
      sym_css_property,
      aux_sym__css_block_repeat1,
  [67745] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3287), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3289), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3255), 1,
      sym_css_property_name,
    ACTIONS(3291), 1,
      anon_sym_RBRACE,
    STATE(1373), 2,
      sym_css_property,
      aux_sym__css_block_repeat1,
  [67771] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(734), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(736), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67783] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3293), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3295), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(3271), 1,
      anon_sym_if,
    STATE(1144), 2,
      sym_block,
      sym_if_statement,
  [67809] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3141), 1,
      anon_sym_LF,
    ACTIONS(3143), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RPAREN,
  [67821] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3297), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3299), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67833] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3301), 1,
      anon_sym_LF,
    ACTIONS(3303), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [67845] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_LF,
    ACTIONS(2887), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RPAREN,
  [67857] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3301), 1,
      anon_sym_LF,
    ACTIONS(3303), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [67869] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_LF,
    ACTIONS(3135), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RPAREN,
  [67881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3307), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [67893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3307), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [67905] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3301), 1,
      anon_sym_LF,
    ACTIONS(3303), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [67917] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3301), 1,
      anon_sym_LF,
    ACTIONS(3303), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [67929] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3309), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3311), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67941] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3313), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3315), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67953] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3109), 1,
      anon_sym_LF,
    ACTIONS(3111), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RPAREN,
  [67965] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3317), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3319), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67977] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3321), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3323), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [67989] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3325), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3327), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [68001] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3329), 1,
      anon_sym_LF,
    ACTIONS(3331), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [68013] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_LF,
    ACTIONS(2841), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [68025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2257), 1,
      anon_sym_if2,
    ACTIONS(3261), 1,
      anon_sym_LBRACE,
    STATE(1252), 2,
      sym_conditional_attribute_block,
      sym_conditional_attribute_if_statement,
  [68039] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2847), 1,
      anon_sym_LF,
    ACTIONS(2849), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [68051] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3335), 1,
      anon_sym_LF,
    ACTIONS(2857), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [68063] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_COLON,
    ACTIONS(3337), 1,
      anon_sym_COMMA,
    ACTIONS(3339), 1,
      anon_sym_RBRACE,
    STATE(1529), 1,
      aux_sym_literal_value_repeat1,
  [68079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    ACTIONS(1387), 1,
      anon_sym_if,
    STATE(946), 2,
      sym_component_block,
      sym_component_if_statement,
  [68093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3341), 1,
      anon_sym_COMMA,
    ACTIONS(3343), 1,
      anon_sym_RBRACK,
    STATE(1527), 1,
      aux_sym_type_arguments_repeat1,
  [68109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_LBRACE,
    ACTIONS(1475), 1,
      anon_sym_if,
    STATE(990), 2,
      sym_component_block,
      sym_component_if_statement,
  [68123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 1,
      anon_sym_RPAREN,
    ACTIONS(3347), 1,
      anon_sym_COMMA,
    STATE(1525), 1,
      aux_sym_expression_list_repeat1,
  [68139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 1,
      anon_sym_LBRACE,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    STATE(560), 1,
      sym_block,
  [68155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 1,
      anon_sym_LBRACE,
    STATE(560), 1,
      sym_block,
    ACTIONS(1989), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [68169] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_DQUOTE2,
    STATE(1360), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3129), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [68183] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3351), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3353), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [68195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 4,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
  [68205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3355), 1,
      anon_sym_COMMA,
    ACTIONS(3357), 1,
      anon_sym_COLON,
    STATE(1599), 1,
      aux_sym_type_arguments_repeat1,
  [68221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 1,
      anon_sym_LBRACE,
    STATE(520), 1,
      sym_literal_value,
    ACTIONS(1876), 2,
      anon_sym_LPAREN,
      anon_sym_PIPE,
  [68235] = 4,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_DQUOTE2,
    STATE(1435), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(3361), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [68249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    ACTIONS(1387), 1,
      anon_sym_if,
    STATE(957), 2,
      sym_component_block,
      sym_component_if_statement,
  [68263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3363), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [68275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3365), 1,
      anon_sym_COMMA,
    STATE(1443), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3363), 2,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [68289] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3368), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3370), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [68301] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3372), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3374), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [68313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3255), 1,
      sym_css_property_name,
    ACTIONS(3376), 1,
      anon_sym_RBRACE,
    STATE(1373), 2,
      sym_css_property,
      aux_sym__css_block_repeat1,
  [68327] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3378), 1,
      anon_sym_LF,
    ACTIONS(3380), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [68339] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3382), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3384), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [68351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(446), 1,
      anon_sym_RPAREN,
    ACTIONS(3386), 1,
      anon_sym_COMMA,
    STATE(1455), 1,
      aux_sym_argument_list_repeat1,
  [68364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(614), 1,
      anon_sym_RBRACE,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    STATE(1515), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
  [68386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3390), 1,
      anon_sym_LPAREN,
    STATE(1142), 1,
      sym_const_spec,
  [68399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 1,
      sym_identifier,
    ACTIONS(3392), 1,
      anon_sym_LPAREN,
    STATE(1143), 1,
      sym_var_spec,
  [68412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    ACTIONS(3394), 1,
      sym_identifier,
    STATE(528), 1,
      sym_parameter_list,
  [68425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      anon_sym_RPAREN,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    STATE(1455), 1,
      aux_sym_argument_list_repeat1,
  [68438] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_LF,
    ACTIONS(2021), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [68449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1876), 1,
      anon_sym_PIPE,
    ACTIONS(3399), 1,
      anon_sym_LBRACK,
    STATE(916), 1,
      sym_type_arguments,
  [68462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2177), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68471] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3101), 1,
      anon_sym_LF,
    ACTIONS(3103), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [68482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [68491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 1,
      anon_sym_style,
    ACTIONS(3403), 1,
      anon_sym_script,
    ACTIONS(3405), 1,
      sym_element_identifier,
  [68513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(3407), 1,
      sym_raw_string_literal,
    STATE(1412), 1,
      sym_interpreted_string_literal,
  [68526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_attribute_name,
  [68535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 1,
      anon_sym_DQUOTE,
    ACTIONS(3409), 1,
      sym_raw_string_literal,
    STATE(1334), 1,
      sym_interpreted_string_literal,
  [68548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 1,
      anon_sym_COMMA,
    ACTIONS(3414), 1,
      anon_sym_RBRACE,
    STATE(1466), 1,
      aux_sym_literal_value_repeat1,
  [68561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 1,
      anon_sym_DQUOTE,
    ACTIONS(3416), 1,
      sym_raw_string_literal,
    STATE(1336), 1,
      sym_interpreted_string_literal,
  [68574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(3418), 1,
      sym_raw_string_literal,
    STATE(1407), 1,
      sym_interpreted_string_literal,
  [68587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_COLON,
    ACTIONS(3414), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [68598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(2988), 1,
      anon_sym_LPAREN,
    ACTIONS(3420), 1,
      anon_sym_RPAREN,
  [68611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [68620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [68629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_style,
    ACTIONS(3424), 1,
      anon_sym_script,
    ACTIONS(3426), 1,
      sym_element_identifier,
  [68642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [68651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_attribute_name,
  [68660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2169), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(933), 1,
      anon_sym_LBRACE,
    ACTIONS(3428), 1,
      anon_sym_COMMA,
    STATE(1479), 1,
      aux_sym_expression_list_repeat1,
  [68700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [68727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [68736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_style,
    ACTIONS(3433), 1,
      anon_sym_script,
    ACTIONS(3435), 1,
      sym_element_identifier,
  [68758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    ACTIONS(3439), 1,
      sym_identifier,
    STATE(568), 1,
      sym_parameter_list,
  [68807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [68816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2129), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_attribute_name,
  [68834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      anon_sym_RPAREN,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    STATE(1455), 1,
      aux_sym_argument_list_repeat1,
  [68847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 1,
      anon_sym_RPAREN,
    ACTIONS(1269), 1,
      anon_sym_COMMA,
    STATE(1494), 1,
      aux_sym_argument_list_repeat1,
  [68860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 1,
      anon_sym_RBRACE,
    ACTIONS(3443), 1,
      anon_sym_COMMA,
    STATE(1515), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
  [68873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_attribute_name,
  [68882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_attribute_name,
  [68900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2125), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      anon_sym_RPAREN,
    ACTIONS(3449), 1,
      anon_sym_COMMA,
    STATE(1518), 1,
      aux_sym_parameter_list_repeat1,
  [68922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2121), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68931] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_LF,
    ACTIONS(3453), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [68942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 1,
      anon_sym_RPAREN,
    ACTIONS(1349), 1,
      anon_sym_COMMA,
    STATE(1449), 1,
      aux_sym_argument_list_repeat1,
  [68955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68964] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3457), 1,
      anon_sym_LF,
    ACTIONS(3459), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [68975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_RPAREN,
    ACTIONS(3463), 1,
      anon_sym_COMMA,
    STATE(1585), 1,
      aux_sym_parameter_list_repeat1,
  [68988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [68997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(470), 1,
      anon_sym_RPAREN,
    ACTIONS(3467), 1,
      anon_sym_COMMA,
    STATE(1455), 1,
      aux_sym_argument_list_repeat1,
  [69010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [69019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 1,
      anon_sym_COMMA,
    ACTIONS(3339), 1,
      anon_sym_RBRACE,
    STATE(1529), 1,
      aux_sym_literal_value_repeat1,
  [69032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_attribute_name,
  [69041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(366), 1,
      anon_sym_RBRACE,
    ACTIONS(3469), 1,
      anon_sym_COMMA,
    STATE(1466), 1,
      aux_sym_literal_value_repeat1,
  [69054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1297), 1,
      anon_sym_RPAREN,
    ACTIONS(1299), 1,
      anon_sym_COMMA,
    STATE(1534), 1,
      aux_sym_argument_list_repeat1,
  [69067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1661), 1,
      anon_sym_RBRACE,
    ACTIONS(3471), 1,
      anon_sym_COMMA,
    STATE(1515), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
  [69080] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_LF,
    ACTIONS(3476), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    ACTIONS(3480), 1,
      anon_sym_COMMA,
    STATE(1538), 1,
      aux_sym_parameter_list_repeat1,
  [69113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 1,
      anon_sym_RPAREN,
    ACTIONS(3482), 1,
      anon_sym_COMMA,
    STATE(1568), 1,
      aux_sym_expression_list_repeat1,
  [69126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_attribute_name,
  [69135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(574), 1,
      anon_sym_RPAREN,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    STATE(1568), 1,
      aux_sym_expression_list_repeat1,
  [69166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_RPAREN,
    ACTIONS(3486), 1,
      anon_sym_COMMA,
    STATE(1568), 1,
      aux_sym_expression_list_repeat1,
  [69188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 1,
      anon_sym_RPAREN,
    ACTIONS(1295), 1,
      anon_sym_COMMA,
    STATE(1509), 1,
      aux_sym_argument_list_repeat1,
  [69201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_RBRACK,
    ACTIONS(3488), 1,
      anon_sym_COMMA,
    STATE(1443), 1,
      aux_sym_type_arguments_repeat1,
  [69214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 1,
      anon_sym_COMMA,
    ACTIONS(3493), 1,
      anon_sym_RBRACK,
    STATE(1528), 1,
      aux_sym_type_parameter_list_repeat1,
  [69227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(370), 1,
      anon_sym_RBRACE,
    ACTIONS(3495), 1,
      anon_sym_COMMA,
    STATE(1466), 1,
      aux_sym_literal_value_repeat1,
  [69240] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LF,
    ACTIONS(3107), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2101), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2057), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 1,
      anon_sym_RBRACE,
    STATE(1513), 1,
      aux_sym_literal_value_repeat1,
  [69282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(500), 1,
      anon_sym_RPAREN,
    ACTIONS(3497), 1,
      anon_sym_COMMA,
    STATE(1455), 1,
      aux_sym_argument_list_repeat1,
  [69295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 1,
      anon_sym_COMMA,
    ACTIONS(1837), 1,
      anon_sym_LBRACE,
    STATE(1479), 1,
      aux_sym_expression_list_repeat1,
  [69308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2097), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 1,
      anon_sym_RBRACK,
    ACTIONS(3499), 1,
      anon_sym_COMMA,
    STATE(1528), 1,
      aux_sym_type_parameter_list_repeat1,
  [69330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_RPAREN,
    ACTIONS(3503), 1,
      anon_sym_COMMA,
    STATE(1538), 1,
      aux_sym_parameter_list_repeat1,
  [69343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2093), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_RPAREN,
    ACTIONS(3508), 1,
      anon_sym_COMMA,
    STATE(1577), 1,
      aux_sym_parameter_list_repeat1,
  [69365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3510), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [69385] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3113), 1,
      anon_sym_LF,
    ACTIONS(3115), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2085), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2081), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2077), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2073), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69432] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_LF,
    ACTIONS(3139), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 3,
      anon_sym_GT,
      anon_sym_SLASH_GT,
      sym_attribute_name,
  [69452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2069), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2189), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(486), 1,
      anon_sym_RPAREN,
    ACTIONS(3512), 1,
      anon_sym_COMMA,
    STATE(1455), 1,
      aux_sym_argument_list_repeat1,
  [69483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3189), 1,
      anon_sym_COMMA,
    ACTIONS(3191), 1,
      anon_sym_RBRACE,
    STATE(1589), 1,
      aux_sym_literal_value_repeat1,
  [69496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [69505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3241), 1,
      anon_sym_COMMA,
    ACTIONS(3243), 1,
      anon_sym_RBRACE,
    STATE(1578), 1,
      aux_sym_literal_value_repeat1,
  [69518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(452), 1,
      anon_sym_RPAREN,
    ACTIONS(3514), 1,
      anon_sym_COMMA,
    STATE(1455), 1,
      aux_sym_argument_list_repeat1,
  [69540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(382), 1,
      anon_sym_RBRACE,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
    STATE(1466), 1,
      aux_sym_literal_value_repeat1,
  [69553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(550), 1,
      anon_sym_RPAREN,
    ACTIONS(3518), 1,
      anon_sym_COMMA,
    STATE(1568), 1,
      aux_sym_expression_list_repeat1,
  [69566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1301), 1,
      anon_sym_RPAREN,
    ACTIONS(1303), 1,
      anon_sym_COMMA,
    STATE(1552), 1,
      aux_sym_argument_list_repeat1,
  [69588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1305), 1,
      anon_sym_RPAREN,
    ACTIONS(1307), 1,
      anon_sym_COMMA,
    STATE(1557), 1,
      aux_sym_argument_list_repeat1,
  [69601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 1,
      anon_sym_COMMA,
    ACTIONS(3206), 1,
      anon_sym_RBRACE,
    STATE(1558), 1,
      aux_sym_literal_value_repeat1,
  [69614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69623] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3200), 1,
      anon_sym_LF,
    ACTIONS(3202), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      anon_sym_RPAREN,
    ACTIONS(1291), 1,
      anon_sym_COMMA,
    STATE(1592), 1,
      aux_sym_argument_list_repeat1,
  [69647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2061), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(933), 1,
      anon_sym_RPAREN,
    ACTIONS(3522), 1,
      anon_sym_COMMA,
    STATE(1568), 1,
      aux_sym_expression_list_repeat1,
  [69669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3525), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69678] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(1979), 1,
      anon_sym_LF,
    ACTIONS(1977), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2204), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69698] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3245), 1,
      anon_sym_LF,
    ACTIONS(3247), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69709] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3281), 1,
      anon_sym_LF,
    ACTIONS(3283), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69729] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3287), 1,
      anon_sym_LF,
    ACTIONS(3289), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69740] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3293), 1,
      anon_sym_LF,
    ACTIONS(3295), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 1,
      anon_sym_RPAREN,
    ACTIONS(3527), 1,
      anon_sym_COMMA,
    STATE(1538), 1,
      aux_sym_parameter_list_repeat1,
  [69764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(374), 1,
      anon_sym_RBRACE,
    ACTIONS(3529), 1,
      anon_sym_COMMA,
    STATE(1466), 1,
      aux_sym_literal_value_repeat1,
  [69777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_LBRACE,
    ACTIONS(3533), 1,
      sym_css_property_value,
    STATE(1755), 1,
      sym_expression,
  [69790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(570), 1,
      anon_sym_RPAREN,
    ACTIONS(3535), 1,
      anon_sym_COMMA,
    STATE(1568), 1,
      aux_sym_expression_list_repeat1,
  [69812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1663), 1,
      anon_sym_RBRACK,
    ACTIONS(3537), 1,
      anon_sym_COMMA,
    STATE(1443), 1,
      aux_sym_type_arguments_repeat1,
  [69825] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3297), 1,
      anon_sym_LF,
    ACTIONS(3299), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3539), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [69847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 1,
      anon_sym_RPAREN,
    ACTIONS(3541), 1,
      anon_sym_COMMA,
    STATE(1538), 1,
      aux_sym_parameter_list_repeat1,
  [69860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1469), 1,
      anon_sym_RBRACK,
    ACTIONS(3543), 1,
      anon_sym_COMMA,
    STATE(1443), 1,
      aux_sym_type_arguments_repeat1,
  [69873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 1,
      anon_sym_COMMA,
    ACTIONS(3547), 1,
      anon_sym_RBRACK,
    STATE(1537), 1,
      aux_sym_type_parameter_list_repeat1,
  [69886] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3224), 1,
      anon_sym_LF,
    ACTIONS(3226), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(372), 1,
      anon_sym_RBRACE,
    ACTIONS(3549), 1,
      anon_sym_COMMA,
    STATE(1466), 1,
      aux_sym_literal_value_repeat1,
  [69910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    STATE(1607), 1,
      aux_sym_argument_list_repeat1,
  [69923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_RBRACE,
    ACTIONS(3551), 1,
      anon_sym_COMMA,
    STATE(1515), 1,
      aux_sym_dynamic_class_attribute_value_repeat1,
  [69936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(488), 1,
      anon_sym_RPAREN,
    ACTIONS(3553), 1,
      anon_sym_COMMA,
    STATE(1455), 1,
      aux_sym_argument_list_repeat1,
  [69949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(224), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [69958] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_LF,
    ACTIONS(3319), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69969] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_LF,
    ACTIONS(3323), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [69980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_attribute_name,
  [69989] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3233), 1,
      anon_sym_LF,
    ACTIONS(3235), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [70000] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3325), 1,
      anon_sym_LF,
    ACTIONS(3327), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [70011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_COMMA,
    ACTIONS(3555), 1,
      anon_sym_COLON,
    STATE(1443), 1,
      aux_sym_type_arguments_repeat1,
  [70024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(600), 1,
      anon_sym_RPAREN,
    ACTIONS(3557), 1,
      anon_sym_COMMA,
    STATE(1568), 1,
      aux_sym_expression_list_repeat1,
  [70037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3159), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [70048] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3368), 1,
      anon_sym_LF,
    ACTIONS(3370), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [70059] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LF,
    ACTIONS(3384), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [70070] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3372), 1,
      anon_sym_LF,
    ACTIONS(3374), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [70081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(388), 1,
      anon_sym_RBRACE,
    ACTIONS(3559), 1,
      anon_sym_COMMA,
    STATE(1466), 1,
      aux_sym_literal_value_repeat1,
  [70094] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3351), 1,
      anon_sym_LF,
    ACTIONS(3353), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [70105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(490), 1,
      anon_sym_RPAREN,
    ACTIONS(3561), 1,
      anon_sym_COMMA,
    STATE(1455), 1,
      aux_sym_argument_list_repeat1,
  [70118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [70127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3263), 1,
      anon_sym_COMMA,
    ACTIONS(3265), 1,
      anon_sym_RBRACE,
    STATE(1605), 1,
      aux_sym_literal_value_repeat1,
  [70140] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_LF,
    ACTIONS(3315), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [70151] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_LF,
    ACTIONS(3311), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [70162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [70170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3567), 1,
      sym_style_element_text,
  [70180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3569), 1,
      anon_sym_LPAREN,
  [70190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3571), 1,
      anon_sym_LPAREN,
  [70200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3573), 1,
      anon_sym_LPAREN,
  [70210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3577), 1,
      sym_script_element_text,
  [70220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3581), 1,
      sym_style_element_text,
  [70230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3583), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [70238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3587), 1,
      sym_script_element_text,
  [70248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 1,
      anon_sym_LBRACE,
    STATE(352), 1,
      sym_literal_value,
  [70258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_LPAREN,
    STATE(389), 1,
      sym_parameter_list,
  [70268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3591), 1,
      sym_style_element_text,
  [70278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3593), 1,
      anon_sym_LPAREN,
  [70288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3595), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3597), 1,
      sym_script_element_text,
  [70298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3601), 1,
      sym_style_element_text,
  [70308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      sym_identifier,
    ACTIONS(3605), 1,
      anon_sym_LPAREN,
  [70318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3609), 1,
      sym_script_element_text,
  [70328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3613), 1,
      sym_style_element_text,
  [70338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(758), 1,
      anon_sym_LPAREN,
    STATE(365), 1,
      sym_argument_list,
  [70348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      sym_identifier,
    STATE(1698), 1,
      sym__component_identifier,
  [70358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(2988), 1,
      anon_sym_LPAREN,
  [70368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(270), 1,
      anon_sym_LBRACE,
    STATE(945), 1,
      sym_component_block,
  [70378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      sym_identifier,
    STATE(1702), 1,
      sym__script_identifier,
  [70388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3617), 1,
      sym_identifier,
    STATE(1707), 1,
      sym__css_identifier,
  [70398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3621), 1,
      sym_script_element_text,
  [70408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      sym_identifier,
    STATE(1118), 1,
      sym__component_identifier,
  [70418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3623), 1,
      anon_sym_RPAREN,
  [70428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      anon_sym_LBRACE,
    STATE(1036), 1,
      sym_field_declaration_list,
  [70438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3627), 1,
      anon_sym_RBRACE,
    ACTIONS(3629), 1,
      sym_script_block_text,
  [70448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(549), 1,
      sym_parameter_list,
  [70458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3631), 1,
      anon_sym_RPAREN,
  [70468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(330), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym_literal_value,
  [70478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3617), 1,
      sym_identifier,
    STATE(1720), 1,
      sym__css_identifier,
  [70488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3633), 1,
      anon_sym_RPAREN,
  [70498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3635), 1,
      anon_sym_LBRACE,
    STATE(1602), 1,
      sym_component_block,
  [70508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2972), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [70516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3637), 1,
      anon_sym_LBRACE,
  [70526] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3639), 1,
      anon_sym_SQUOTE,
    ACTIONS(3641), 1,
      aux_sym_quoted_attribute_value_token1,
  [70536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      sym_identifier,
    STATE(1725), 1,
      sym__script_identifier,
  [70546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      anon_sym_RBRACK,
  [70556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
  [70566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(524), 1,
      sym_parameter_list,
  [70576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2475), 1,
      anon_sym_LBRACE,
    STATE(317), 1,
      sym_literal_value,
  [70586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3647), 1,
      sym_identifier,
    STATE(867), 1,
      sym__component_identifier,
  [70596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(915), 1,
      anon_sym_LBRACE,
    STATE(414), 1,
      sym_literal_value,
  [70606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3649), 1,
      anon_sym_RBRACK,
  [70616] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3651), 1,
      anon_sym_DQUOTE,
    ACTIONS(3653), 1,
      aux_sym_quoted_attribute_value_token2,
  [70626] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3639), 1,
      anon_sym_DQUOTE,
    ACTIONS(3655), 1,
      aux_sym_quoted_attribute_value_token2,
  [70636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2437), 1,
      anon_sym_LPAREN,
    STATE(470), 1,
      sym_parameter_list,
  [70646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3657), 2,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [70654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [70662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [70670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(537), 1,
      sym_parameter_list,
  [70680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3661), 1,
      anon_sym_EQ,
  [70690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_LBRACE,
    STATE(1444), 1,
      sym_component_block,
  [70700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [70708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      sym_identifier,
    ACTIONS(3667), 1,
      anon_sym_LPAREN,
  [70718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3669), 1,
      sym_identifier,
    ACTIONS(3671), 1,
      anon_sym_LPAREN,
  [70728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 1,
      sym_identifier,
    STATE(866), 1,
      sym__component_identifier,
  [70738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(919), 1,
      anon_sym_LPAREN,
    STATE(411), 1,
      sym_argument_list,
  [70748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3217), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [70756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3675), 1,
      anon_sym_LBRACE,
    STATE(1129), 1,
      sym_field_declaration_list,
  [70766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(444), 1,
      sym_parameter_list,
  [70776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(437), 1,
      sym_parameter_list,
  [70786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3677), 1,
      anon_sym_RBRACK,
  [70796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 1,
      anon_sym_LBRACE,
    STATE(520), 1,
      sym_literal_value,
  [70806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(436), 1,
      sym_parameter_list,
  [70816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [70824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(533), 1,
      sym_parameter_list,
  [70834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 1,
      anon_sym_LBRACE,
    STATE(1576), 1,
      sym_script_block,
  [70844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [70852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      sym_identifier,
    ACTIONS(3681), 1,
      anon_sym_LPAREN,
  [70862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 1,
      anon_sym_LBRACE,
    STATE(1575), 1,
      sym__css_block,
  [70872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3685), 1,
      anon_sym_RBRACE,
    ACTIONS(3687), 1,
      sym_script_block_text,
  [70882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3689), 1,
      anon_sym_LBRACE,
    STATE(1405), 1,
      sym_script_block,
  [70892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_LPAREN,
    STATE(392), 1,
      sym_parameter_list,
  [70902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_LBRACE,
    STATE(1402), 1,
      sym__css_block,
  [70912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    STATE(1169), 1,
      sym_block,
  [70922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_LBRACE,
    STATE(1400), 1,
      sym_component_block,
  [70932] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3651), 1,
      anon_sym_SQUOTE,
    ACTIONS(3693), 1,
      aux_sym_quoted_attribute_value_token1,
  [70942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3695), 1,
      anon_sym_RPAREN,
  [70952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1666), 1,
      sym_parameter_list,
  [70962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3697), 1,
      anon_sym_RPAREN,
  [70972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3635), 1,
      anon_sym_LBRACE,
    STATE(1573), 1,
      sym_component_block,
  [70982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3699), 1,
      anon_sym_RPAREN,
  [70992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      sym_identifier,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
  [71002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1646), 1,
      sym_parameter_list,
  [71012] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3703), 1,
      anon_sym_DQUOTE,
    ACTIONS(3705), 1,
      aux_sym_quoted_attribute_value_token2,
  [71022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3707), 1,
      anon_sym_RBRACK,
  [71032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [71040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1681), 1,
      sym_parameter_list,
  [71050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_LBRACE,
    STATE(1560), 1,
      sym_component_block,
  [71060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3711), 1,
      anon_sym_RBRACK,
  [71070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(272), 1,
      anon_sym_LBRACE,
    STATE(977), 1,
      sym_component_block,
  [71080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      sym_identifier,
    ACTIONS(3713), 1,
      anon_sym_LPAREN,
  [71090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1684), 1,
      sym_parameter_list,
  [71100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3715), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3717), 1,
      sym_style_element_text,
  [71110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_LPAREN,
    STATE(483), 1,
      sym_parameter_list,
  [71120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 1,
      anon_sym_LBRACE,
    STATE(614), 1,
      sym_literal_value,
  [71130] = 3,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3703), 1,
      anon_sym_SQUOTE,
    ACTIONS(3719), 1,
      aux_sym_quoted_attribute_value_token1,
  [71140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2539), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [71148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1695), 1,
      sym_parameter_list,
  [71158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2437), 1,
      anon_sym_LPAREN,
    STATE(474), 1,
      sym_parameter_list,
  [71168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3721), 1,
      sym_identifier,
    STATE(1103), 1,
      sym__component_identifier,
  [71178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [71186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      sym_identifier,
    STATE(1693), 1,
      sym__component_identifier,
  [71196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1690), 1,
      sym_parameter_list,
  [71206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3723), 1,
      anon_sym_RBRACK,
  [71216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1688), 1,
      sym_parameter_list,
  [71226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      sym_identifier,
    ACTIONS(3727), 1,
      anon_sym_LPAREN,
  [71236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(541), 1,
      sym_parameter_list,
  [71246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 1,
      anon_sym_LPAREN,
    STATE(640), 1,
      sym_argument_list,
  [71256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [71264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      anon_sym_LPAREN,
    STATE(1686), 1,
      sym_parameter_list,
  [71274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 1,
      sym_identifier,
    ACTIONS(3731), 1,
      anon_sym_LPAREN,
  [71284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 1,
      anon_sym_LBRACE,
    STATE(924), 1,
      sym_field_declaration_list,
  [71294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3735), 1,
      anon_sym_LPAREN,
    STATE(307), 1,
      sym_argument_list,
  [71304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_LPAREN,
    STATE(476), 1,
      sym_argument_list,
  [71314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3737), 1,
      sym_identifier,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
  [71324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3741), 1,
      anon_sym_LPAREN,
    STATE(552), 1,
      sym_argument_list,
  [71334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3743), 1,
      anon_sym_RPAREN,
  [71344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_struct,
    STATE(1290), 1,
      sym_struct_type,
  [71354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3420), 1,
      anon_sym_RPAREN,
  [71364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 1,
      sym_identifier,
    STATE(870), 1,
      sym__component_identifier,
  [71374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2471), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [71382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3747), 1,
      anon_sym_EQ,
  [71392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 2,
      anon_sym_RBRACE,
      sym_css_property_name,
  [71400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [71408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      sym_identifier,
    ACTIONS(3751), 1,
      anon_sym_LPAREN,
  [71418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
    ACTIONS(3753), 1,
      anon_sym_RPAREN,
  [71428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2437), 1,
      anon_sym_LPAREN,
    STATE(449), 1,
      sym_parameter_list,
  [71438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3755), 1,
      sym_identifier,
    STATE(869), 1,
      sym__component_identifier,
  [71448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3757), 1,
      anon_sym_LT_SLASH,
    ACTIONS(3759), 1,
      sym_script_element_text,
  [71458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3761), 1,
      anon_sym_SQUOTE,
  [71465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      sym_element_identifier,
  [71472] = 2,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3765), 1,
      anon_sym_LF,
  [71479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3767), 1,
      anon_sym_RPAREN,
  [71486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_RBRACE,
  [71493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_RPAREN,
  [71500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_GT,
  [71507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_GT,
  [71514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 1,
      anon_sym_GT,
  [71521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      anon_sym_GT,
  [71528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_SEMI,
  [71535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_RBRACE,
  [71542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 1,
      sym_identifier,
  [71549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3783), 1,
      sym_identifier,
  [71556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3785), 1,
      anon_sym_GT,
  [71563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_GT,
  [71570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 1,
      anon_sym_RPAREN,
  [71577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_RPAREN,
  [71584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_RBRACE,
  [71591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 1,
      anon_sym_LBRACE,
  [71598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_GT,
  [71605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      anon_sym_RPAREN,
  [71612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym_RBRACE,
  [71619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_RBRACE,
  [71626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 1,
      anon_sym_chan,
  [71633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3805), 1,
      anon_sym_LT_SLASH,
  [71640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_RBRACE,
  [71647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3807), 1,
      anon_sym_GT,
  [71654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3809), 1,
      sym_identifier,
  [71661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3811), 1,
      sym_identifier,
  [71668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3813), 1,
      anon_sym_LBRACE,
  [71675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_LBRACE,
  [71682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_RPAREN,
  [71689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3817), 1,
      anon_sym_script,
  [71696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 1,
      anon_sym_GT,
  [71703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3821), 1,
      anon_sym_LT_SLASH,
  [71710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3823), 1,
      anon_sym_LPAREN,
  [71717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_RBRACE,
  [71724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3827), 1,
      anon_sym_chan,
  [71731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3829), 1,
      anon_sym_COLON,
  [71738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_PIPE,
  [71745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3191), 1,
      anon_sym_RBRACE,
  [71752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_RBRACE,
  [71759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3833), 1,
      anon_sym_COLON,
  [71766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3243), 1,
      anon_sym_RBRACE,
  [71773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3835), 1,
      anon_sym_LPAREN,
  [71780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3837), 1,
      sym_identifier,
  [71787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3839), 1,
      anon_sym_chan,
  [71794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3841), 1,
      anon_sym_LBRACE,
  [71801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_PIPE,
  [71808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3845), 1,
      anon_sym_SEMI,
  [71815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_RPAREN,
  [71822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_RPAREN,
  [71829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3851), 1,
      anon_sym_html,
  [71836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_LT_SLASH,
  [71843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3853), 1,
      anon_sym_SEMI,
  [71850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3855), 1,
      anon_sym_RBRACE,
  [71857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3857), 1,
      anon_sym_SEMI,
  [71864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3859), 1,
      anon_sym_LBRACE,
  [71871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3861), 1,
      anon_sym_style,
  [71878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3863), 1,
      anon_sym_script,
  [71885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3865), 1,
      anon_sym_LBRACE,
  [71892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3867), 1,
      anon_sym_style,
  [71899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3869), 1,
      anon_sym_script,
  [71906] = 2,
    ACTIONS(318), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_LF,
  [71913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_GT,
  [71920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_style,
  [71927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_script,
  [71934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3879), 1,
      anon_sym_script,
  [71941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3881), 1,
      anon_sym_GT,
  [71948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3883), 1,
      anon_sym_LBRACE,
  [71955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 1,
      anon_sym_COLON,
  [71962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3887), 1,
      anon_sym_RBRACE,
  [71969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_chan,
  [71976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3891), 1,
      anon_sym_RBRACE,
  [71983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3893), 1,
      anon_sym_style,
  [71990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_RBRACE,
  [71997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 1,
      anon_sym_GT,
  [72004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3897), 1,
      anon_sym_RBRACE,
  [72011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3899), 1,
      anon_sym_RBRACK,
  [72018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3901), 1,
      anon_sym_GT,
  [72025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_RPAREN,
  [72032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_RBRACE,
  [72039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 1,
      anon_sym_LBRACE,
  [72046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 1,
      sym_identifier,
  [72053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3911), 1,
      anon_sym_html,
  [72060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3913), 1,
      sym_element_identifier,
  [72067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3915), 1,
      anon_sym_style,
  [72074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 1,
      anon_sym_RBRACE,
  [72081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3919), 1,
      anon_sym_RPAREN,
  [72088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3921), 1,
      anon_sym_SQUOTE,
  [72095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3923), 1,
      anon_sym_style,
  [72102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3925), 1,
      anon_sym_script,
  [72109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3927), 1,
      anon_sym_style,
  [72116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3929), 1,
      anon_sym_script,
  [72123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3931), 1,
      anon_sym_GT,
  [72130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 1,
      anon_sym_style,
  [72137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3935), 1,
      anon_sym_script,
  [72144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 1,
      anon_sym_RPAREN,
  [72151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3939), 1,
      anon_sym_RBRACE,
  [72158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3941), 1,
      anon_sym_chan,
  [72165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3943), 1,
      anon_sym_GT,
  [72172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3945), 1,
      anon_sym_LBRACE,
  [72179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 1,
      anon_sym_PIPE,
  [72186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3949), 1,
      anon_sym_GT,
  [72193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3951), 1,
      anon_sym_style,
  [72200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3953), 1,
      sym_element_identifier,
  [72207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3955), 1,
      anon_sym_GT,
  [72214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_LT_SLASH,
  [72221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_RBRACE,
  [72228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3959), 1,
      sym_identifier,
  [72235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3961), 1,
      anon_sym_GT,
  [72242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3963), 1,
      anon_sym_SQUOTE,
  [72249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3965), 1,
      ts_builtin_sym_end,
  [72256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3967), 1,
      sym_element_identifier,
  [72263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3921), 1,
      anon_sym_DQUOTE,
  [72270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3969), 1,
      anon_sym_html,
  [72277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3971), 1,
      sym_identifier,
  [72284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_script,
  [72291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3975), 1,
      anon_sym_RPAREN,
  [72298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
  [72305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 1,
      sym_identifier,
  [72312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3963), 1,
      anon_sym_DQUOTE,
  [72319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3981), 1,
      anon_sym_LBRACK,
  [72326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 1,
      anon_sym_LBRACE,
  [72333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3985), 1,
      anon_sym_RPAREN,
  [72340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
  [72347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 1,
      anon_sym_RBRACE,
  [72354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3989), 1,
      anon_sym_SEMI,
  [72361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 1,
      anon_sym_GT,
  [72368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3993), 1,
      anon_sym_SEMI,
  [72375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3995), 1,
      anon_sym_SEMI,
  [72382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3997), 1,
      anon_sym_RBRACE,
  [72389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3999), 1,
      sym_element_identifier,
  [72396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4001), 1,
      anon_sym_SEMI,
  [72403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_SEMI,
  [72410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4005), 1,
      anon_sym_LBRACE,
  [72417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 1,
      anon_sym_COLON,
  [72424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_RBRACE,
  [72431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_LT_SLASH,
  [72438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 1,
      anon_sym_COLON,
  [72445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3595), 1,
      anon_sym_LT_SLASH,
  [72452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_RBRACE,
  [72459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4015), 1,
      anon_sym_LT_SLASH,
  [72466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 1,
      anon_sym_LT_SLASH,
  [72473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 1,
      anon_sym_chan,
  [72480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3761), 1,
      anon_sym_DQUOTE,
  [72487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      sym_element_identifier,
  [72494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_SEMI,
  [72501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4025), 1,
      anon_sym_SEMI,
  [72508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4027), 1,
      anon_sym_COLON_EQ,
  [72515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 1,
      anon_sym_LBRACE,
  [72522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_LT_SLASH,
  [72529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4031), 1,
      anon_sym_COLON,
  [72536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_LT_SLASH,
  [72543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4033), 1,
      anon_sym_GT,
  [72550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_LT_SLASH,
  [72557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 1,
      anon_sym_LT_SLASH,
  [72564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4039), 1,
      anon_sym_GT,
  [72571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4041), 1,
      anon_sym_GT,
  [72578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 1,
      anon_sym_GT,
  [72585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4045), 1,
      sym_identifier,
  [72592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4047), 1,
      anon_sym_GT,
  [72599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4049), 1,
      anon_sym_LBRACK,
  [72606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4051), 1,
      anon_sym_LBRACK,
  [72613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      anon_sym_LBRACK,
  [72620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4055), 1,
      anon_sym_LBRACK,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(38)] = 0,
  [SMALL_STATE(39)] = 119,
  [SMALL_STATE(40)] = 245,
  [SMALL_STATE(41)] = 371,
  [SMALL_STATE(42)] = 497,
  [SMALL_STATE(43)] = 623,
  [SMALL_STATE(44)] = 749,
  [SMALL_STATE(45)] = 875,
  [SMALL_STATE(46)] = 998,
  [SMALL_STATE(47)] = 1121,
  [SMALL_STATE(48)] = 1244,
  [SMALL_STATE(49)] = 1367,
  [SMALL_STATE(50)] = 1490,
  [SMALL_STATE(51)] = 1613,
  [SMALL_STATE(52)] = 1736,
  [SMALL_STATE(53)] = 1859,
  [SMALL_STATE(54)] = 1982,
  [SMALL_STATE(55)] = 2105,
  [SMALL_STATE(56)] = 2228,
  [SMALL_STATE(57)] = 2351,
  [SMALL_STATE(58)] = 2471,
  [SMALL_STATE(59)] = 2588,
  [SMALL_STATE(60)] = 2703,
  [SMALL_STATE(61)] = 2817,
  [SMALL_STATE(62)] = 2931,
  [SMALL_STATE(63)] = 3045,
  [SMALL_STATE(64)] = 3159,
  [SMALL_STATE(65)] = 3273,
  [SMALL_STATE(66)] = 3387,
  [SMALL_STATE(67)] = 3501,
  [SMALL_STATE(68)] = 3615,
  [SMALL_STATE(69)] = 3729,
  [SMALL_STATE(70)] = 3843,
  [SMALL_STATE(71)] = 3957,
  [SMALL_STATE(72)] = 4075,
  [SMALL_STATE(73)] = 4189,
  [SMALL_STATE(74)] = 4303,
  [SMALL_STATE(75)] = 4417,
  [SMALL_STATE(76)] = 4531,
  [SMALL_STATE(77)] = 4645,
  [SMALL_STATE(78)] = 4759,
  [SMALL_STATE(79)] = 4873,
  [SMALL_STATE(80)] = 4987,
  [SMALL_STATE(81)] = 5101,
  [SMALL_STATE(82)] = 5215,
  [SMALL_STATE(83)] = 5333,
  [SMALL_STATE(84)] = 5447,
  [SMALL_STATE(85)] = 5561,
  [SMALL_STATE(86)] = 5675,
  [SMALL_STATE(87)] = 5789,
  [SMALL_STATE(88)] = 5903,
  [SMALL_STATE(89)] = 6017,
  [SMALL_STATE(90)] = 6131,
  [SMALL_STATE(91)] = 6245,
  [SMALL_STATE(92)] = 6359,
  [SMALL_STATE(93)] = 6473,
  [SMALL_STATE(94)] = 6591,
  [SMALL_STATE(95)] = 6705,
  [SMALL_STATE(96)] = 6816,
  [SMALL_STATE(97)] = 6927,
  [SMALL_STATE(98)] = 7038,
  [SMALL_STATE(99)] = 7149,
  [SMALL_STATE(100)] = 7260,
  [SMALL_STATE(101)] = 7371,
  [SMALL_STATE(102)] = 7482,
  [SMALL_STATE(103)] = 7593,
  [SMALL_STATE(104)] = 7704,
  [SMALL_STATE(105)] = 7815,
  [SMALL_STATE(106)] = 7926,
  [SMALL_STATE(107)] = 8037,
  [SMALL_STATE(108)] = 8148,
  [SMALL_STATE(109)] = 8259,
  [SMALL_STATE(110)] = 8370,
  [SMALL_STATE(111)] = 8481,
  [SMALL_STATE(112)] = 8592,
  [SMALL_STATE(113)] = 8703,
  [SMALL_STATE(114)] = 8814,
  [SMALL_STATE(115)] = 8925,
  [SMALL_STATE(116)] = 9036,
  [SMALL_STATE(117)] = 9147,
  [SMALL_STATE(118)] = 9258,
  [SMALL_STATE(119)] = 9369,
  [SMALL_STATE(120)] = 9480,
  [SMALL_STATE(121)] = 9591,
  [SMALL_STATE(122)] = 9706,
  [SMALL_STATE(123)] = 9817,
  [SMALL_STATE(124)] = 9928,
  [SMALL_STATE(125)] = 10039,
  [SMALL_STATE(126)] = 10150,
  [SMALL_STATE(127)] = 10261,
  [SMALL_STATE(128)] = 10372,
  [SMALL_STATE(129)] = 10487,
  [SMALL_STATE(130)] = 10598,
  [SMALL_STATE(131)] = 10709,
  [SMALL_STATE(132)] = 10820,
  [SMALL_STATE(133)] = 10931,
  [SMALL_STATE(134)] = 11042,
  [SMALL_STATE(135)] = 11153,
  [SMALL_STATE(136)] = 11264,
  [SMALL_STATE(137)] = 11375,
  [SMALL_STATE(138)] = 11486,
  [SMALL_STATE(139)] = 11597,
  [SMALL_STATE(140)] = 11708,
  [SMALL_STATE(141)] = 11819,
  [SMALL_STATE(142)] = 11930,
  [SMALL_STATE(143)] = 12045,
  [SMALL_STATE(144)] = 12160,
  [SMALL_STATE(145)] = 12271,
  [SMALL_STATE(146)] = 12382,
  [SMALL_STATE(147)] = 12493,
  [SMALL_STATE(148)] = 12604,
  [SMALL_STATE(149)] = 12715,
  [SMALL_STATE(150)] = 12826,
  [SMALL_STATE(151)] = 12937,
  [SMALL_STATE(152)] = 13048,
  [SMALL_STATE(153)] = 13159,
  [SMALL_STATE(154)] = 13270,
  [SMALL_STATE(155)] = 13381,
  [SMALL_STATE(156)] = 13492,
  [SMALL_STATE(157)] = 13607,
  [SMALL_STATE(158)] = 13718,
  [SMALL_STATE(159)] = 13833,
  [SMALL_STATE(160)] = 13944,
  [SMALL_STATE(161)] = 14055,
  [SMALL_STATE(162)] = 14166,
  [SMALL_STATE(163)] = 14277,
  [SMALL_STATE(164)] = 14385,
  [SMALL_STATE(165)] = 14493,
  [SMALL_STATE(166)] = 14601,
  [SMALL_STATE(167)] = 14709,
  [SMALL_STATE(168)] = 14817,
  [SMALL_STATE(169)] = 14925,
  [SMALL_STATE(170)] = 15033,
  [SMALL_STATE(171)] = 15141,
  [SMALL_STATE(172)] = 15249,
  [SMALL_STATE(173)] = 15357,
  [SMALL_STATE(174)] = 15465,
  [SMALL_STATE(175)] = 15573,
  [SMALL_STATE(176)] = 15681,
  [SMALL_STATE(177)] = 15789,
  [SMALL_STATE(178)] = 15897,
  [SMALL_STATE(179)] = 16005,
  [SMALL_STATE(180)] = 16113,
  [SMALL_STATE(181)] = 16221,
  [SMALL_STATE(182)] = 16329,
  [SMALL_STATE(183)] = 16437,
  [SMALL_STATE(184)] = 16545,
  [SMALL_STATE(185)] = 16653,
  [SMALL_STATE(186)] = 16761,
  [SMALL_STATE(187)] = 16869,
  [SMALL_STATE(188)] = 16977,
  [SMALL_STATE(189)] = 17085,
  [SMALL_STATE(190)] = 17193,
  [SMALL_STATE(191)] = 17301,
  [SMALL_STATE(192)] = 17409,
  [SMALL_STATE(193)] = 17517,
  [SMALL_STATE(194)] = 17625,
  [SMALL_STATE(195)] = 17733,
  [SMALL_STATE(196)] = 17841,
  [SMALL_STATE(197)] = 17949,
  [SMALL_STATE(198)] = 18057,
  [SMALL_STATE(199)] = 18165,
  [SMALL_STATE(200)] = 18273,
  [SMALL_STATE(201)] = 18381,
  [SMALL_STATE(202)] = 18489,
  [SMALL_STATE(203)] = 18597,
  [SMALL_STATE(204)] = 18709,
  [SMALL_STATE(205)] = 18817,
  [SMALL_STATE(206)] = 18925,
  [SMALL_STATE(207)] = 19033,
  [SMALL_STATE(208)] = 19141,
  [SMALL_STATE(209)] = 19249,
  [SMALL_STATE(210)] = 19357,
  [SMALL_STATE(211)] = 19465,
  [SMALL_STATE(212)] = 19573,
  [SMALL_STATE(213)] = 19681,
  [SMALL_STATE(214)] = 19789,
  [SMALL_STATE(215)] = 19897,
  [SMALL_STATE(216)] = 20005,
  [SMALL_STATE(217)] = 20113,
  [SMALL_STATE(218)] = 20221,
  [SMALL_STATE(219)] = 20329,
  [SMALL_STATE(220)] = 20437,
  [SMALL_STATE(221)] = 20545,
  [SMALL_STATE(222)] = 20653,
  [SMALL_STATE(223)] = 20761,
  [SMALL_STATE(224)] = 20869,
  [SMALL_STATE(225)] = 20977,
  [SMALL_STATE(226)] = 21085,
  [SMALL_STATE(227)] = 21193,
  [SMALL_STATE(228)] = 21301,
  [SMALL_STATE(229)] = 21409,
  [SMALL_STATE(230)] = 21517,
  [SMALL_STATE(231)] = 21625,
  [SMALL_STATE(232)] = 21733,
  [SMALL_STATE(233)] = 21841,
  [SMALL_STATE(234)] = 21949,
  [SMALL_STATE(235)] = 22057,
  [SMALL_STATE(236)] = 22165,
  [SMALL_STATE(237)] = 22273,
  [SMALL_STATE(238)] = 22381,
  [SMALL_STATE(239)] = 22489,
  [SMALL_STATE(240)] = 22597,
  [SMALL_STATE(241)] = 22705,
  [SMALL_STATE(242)] = 22813,
  [SMALL_STATE(243)] = 22921,
  [SMALL_STATE(244)] = 23029,
  [SMALL_STATE(245)] = 23137,
  [SMALL_STATE(246)] = 23245,
  [SMALL_STATE(247)] = 23353,
  [SMALL_STATE(248)] = 23461,
  [SMALL_STATE(249)] = 23569,
  [SMALL_STATE(250)] = 23677,
  [SMALL_STATE(251)] = 23785,
  [SMALL_STATE(252)] = 23893,
  [SMALL_STATE(253)] = 24001,
  [SMALL_STATE(254)] = 24109,
  [SMALL_STATE(255)] = 24217,
  [SMALL_STATE(256)] = 24325,
  [SMALL_STATE(257)] = 24433,
  [SMALL_STATE(258)] = 24541,
  [SMALL_STATE(259)] = 24649,
  [SMALL_STATE(260)] = 24757,
  [SMALL_STATE(261)] = 24865,
  [SMALL_STATE(262)] = 24973,
  [SMALL_STATE(263)] = 25081,
  [SMALL_STATE(264)] = 25189,
  [SMALL_STATE(265)] = 25297,
  [SMALL_STATE(266)] = 25405,
  [SMALL_STATE(267)] = 25513,
  [SMALL_STATE(268)] = 25621,
  [SMALL_STATE(269)] = 25729,
  [SMALL_STATE(270)] = 25837,
  [SMALL_STATE(271)] = 25945,
  [SMALL_STATE(272)] = 26053,
  [SMALL_STATE(273)] = 26161,
  [SMALL_STATE(274)] = 26269,
  [SMALL_STATE(275)] = 26377,
  [SMALL_STATE(276)] = 26485,
  [SMALL_STATE(277)] = 26593,
  [SMALL_STATE(278)] = 26701,
  [SMALL_STATE(279)] = 26759,
  [SMALL_STATE(280)] = 26861,
  [SMALL_STATE(281)] = 26932,
  [SMALL_STATE(282)] = 27003,
  [SMALL_STATE(283)] = 27091,
  [SMALL_STATE(284)] = 27159,
  [SMALL_STATE(285)] = 27224,
  [SMALL_STATE(286)] = 27291,
  [SMALL_STATE(287)] = 27360,
  [SMALL_STATE(288)] = 27431,
  [SMALL_STATE(289)] = 27504,
  [SMALL_STATE(290)] = 27569,
  [SMALL_STATE(291)] = 27623,
  [SMALL_STATE(292)] = 27677,
  [SMALL_STATE(293)] = 27731,
  [SMALL_STATE(294)] = 27789,
  [SMALL_STATE(295)] = 27843,
  [SMALL_STATE(296)] = 27896,
  [SMALL_STATE(297)] = 27987,
  [SMALL_STATE(298)] = 28040,
  [SMALL_STATE(299)] = 28093,
  [SMALL_STATE(300)] = 28146,
  [SMALL_STATE(301)] = 28199,
  [SMALL_STATE(302)] = 28252,
  [SMALL_STATE(303)] = 28305,
  [SMALL_STATE(304)] = 28358,
  [SMALL_STATE(305)] = 28411,
  [SMALL_STATE(306)] = 28464,
  [SMALL_STATE(307)] = 28517,
  [SMALL_STATE(308)] = 28570,
  [SMALL_STATE(309)] = 28623,
  [SMALL_STATE(310)] = 28676,
  [SMALL_STATE(311)] = 28767,
  [SMALL_STATE(312)] = 28820,
  [SMALL_STATE(313)] = 28911,
  [SMALL_STATE(314)] = 29002,
  [SMALL_STATE(315)] = 29093,
  [SMALL_STATE(316)] = 29146,
  [SMALL_STATE(317)] = 29199,
  [SMALL_STATE(318)] = 29252,
  [SMALL_STATE(319)] = 29343,
  [SMALL_STATE(320)] = 29396,
  [SMALL_STATE(321)] = 29449,
  [SMALL_STATE(322)] = 29540,
  [SMALL_STATE(323)] = 29593,
  [SMALL_STATE(324)] = 29646,
  [SMALL_STATE(325)] = 29699,
  [SMALL_STATE(326)] = 29790,
  [SMALL_STATE(327)] = 29843,
  [SMALL_STATE(328)] = 29896,
  [SMALL_STATE(329)] = 29949,
  [SMALL_STATE(330)] = 30002,
  [SMALL_STATE(331)] = 30055,
  [SMALL_STATE(332)] = 30108,
  [SMALL_STATE(333)] = 30199,
  [SMALL_STATE(334)] = 30252,
  [SMALL_STATE(335)] = 30340,
  [SMALL_STATE(336)] = 30428,
  [SMALL_STATE(337)] = 30516,
  [SMALL_STATE(338)] = 30604,
  [SMALL_STATE(339)] = 30667,
  [SMALL_STATE(340)] = 30728,
  [SMALL_STATE(341)] = 30791,
  [SMALL_STATE(342)] = 30856,
  [SMALL_STATE(343)] = 30925,
  [SMALL_STATE(344)] = 30996,
  [SMALL_STATE(345)] = 31081,
  [SMALL_STATE(346)] = 31142,
  [SMALL_STATE(347)] = 31196,
  [SMALL_STATE(348)] = 31245,
  [SMALL_STATE(349)] = 31294,
  [SMALL_STATE(350)] = 31343,
  [SMALL_STATE(351)] = 31392,
  [SMALL_STATE(352)] = 31441,
  [SMALL_STATE(353)] = 31490,
  [SMALL_STATE(354)] = 31539,
  [SMALL_STATE(355)] = 31588,
  [SMALL_STATE(356)] = 31637,
  [SMALL_STATE(357)] = 31686,
  [SMALL_STATE(358)] = 31735,
  [SMALL_STATE(359)] = 31784,
  [SMALL_STATE(360)] = 31833,
  [SMALL_STATE(361)] = 31882,
  [SMALL_STATE(362)] = 31931,
  [SMALL_STATE(363)] = 31980,
  [SMALL_STATE(364)] = 32029,
  [SMALL_STATE(365)] = 32078,
  [SMALL_STATE(366)] = 32127,
  [SMALL_STATE(367)] = 32176,
  [SMALL_STATE(368)] = 32225,
  [SMALL_STATE(369)] = 32274,
  [SMALL_STATE(370)] = 32323,
  [SMALL_STATE(371)] = 32372,
  [SMALL_STATE(372)] = 32421,
  [SMALL_STATE(373)] = 32470,
  [SMALL_STATE(374)] = 32519,
  [SMALL_STATE(375)] = 32568,
  [SMALL_STATE(376)] = 32617,
  [SMALL_STATE(377)] = 32666,
  [SMALL_STATE(378)] = 32715,
  [SMALL_STATE(379)] = 32764,
  [SMALL_STATE(380)] = 32813,
  [SMALL_STATE(381)] = 32862,
  [SMALL_STATE(382)] = 32923,
  [SMALL_STATE(383)] = 32981,
  [SMALL_STATE(384)] = 33045,
  [SMALL_STATE(385)] = 33101,
  [SMALL_STATE(386)] = 33161,
  [SMALL_STATE(387)] = 33227,
  [SMALL_STATE(388)] = 33283,
  [SMALL_STATE(389)] = 33351,
  [SMALL_STATE(390)] = 33428,
  [SMALL_STATE(391)] = 33477,
  [SMALL_STATE(392)] = 33566,
  [SMALL_STATE(393)] = 33643,
  [SMALL_STATE(394)] = 33687,
  [SMALL_STATE(395)] = 33731,
  [SMALL_STATE(396)] = 33775,
  [SMALL_STATE(397)] = 33819,
  [SMALL_STATE(398)] = 33863,
  [SMALL_STATE(399)] = 33907,
  [SMALL_STATE(400)] = 33951,
  [SMALL_STATE(401)] = 33995,
  [SMALL_STATE(402)] = 34039,
  [SMALL_STATE(403)] = 34083,
  [SMALL_STATE(404)] = 34127,
  [SMALL_STATE(405)] = 34171,
  [SMALL_STATE(406)] = 34215,
  [SMALL_STATE(407)] = 34259,
  [SMALL_STATE(408)] = 34303,
  [SMALL_STATE(409)] = 34347,
  [SMALL_STATE(410)] = 34391,
  [SMALL_STATE(411)] = 34435,
  [SMALL_STATE(412)] = 34479,
  [SMALL_STATE(413)] = 34523,
  [SMALL_STATE(414)] = 34567,
  [SMALL_STATE(415)] = 34611,
  [SMALL_STATE(416)] = 34655,
  [SMALL_STATE(417)] = 34699,
  [SMALL_STATE(418)] = 34743,
  [SMALL_STATE(419)] = 34787,
  [SMALL_STATE(420)] = 34831,
  [SMALL_STATE(421)] = 34875,
  [SMALL_STATE(422)] = 34919,
  [SMALL_STATE(423)] = 34963,
  [SMALL_STATE(424)] = 35007,
  [SMALL_STATE(425)] = 35051,
  [SMALL_STATE(426)] = 35095,
  [SMALL_STATE(427)] = 35139,
  [SMALL_STATE(428)] = 35181,
  [SMALL_STATE(429)] = 35237,
  [SMALL_STATE(430)] = 35313,
  [SMALL_STATE(431)] = 35365,
  [SMALL_STATE(432)] = 35407,
  [SMALL_STATE(433)] = 35459,
  [SMALL_STATE(434)] = 35501,
  [SMALL_STATE(435)] = 35543,
  [SMALL_STATE(436)] = 35619,
  [SMALL_STATE(437)] = 35690,
  [SMALL_STATE(438)] = 35761,
  [SMALL_STATE(439)] = 35806,
  [SMALL_STATE(440)] = 35846,
  [SMALL_STATE(441)] = 35886,
  [SMALL_STATE(442)] = 35926,
  [SMALL_STATE(443)] = 35966,
  [SMALL_STATE(444)] = 36006,
  [SMALL_STATE(445)] = 36080,
  [SMALL_STATE(446)] = 36120,
  [SMALL_STATE(447)] = 36160,
  [SMALL_STATE(448)] = 36200,
  [SMALL_STATE(449)] = 36240,
  [SMALL_STATE(450)] = 36316,
  [SMALL_STATE(451)] = 36380,
  [SMALL_STATE(452)] = 36420,
  [SMALL_STATE(453)] = 36460,
  [SMALL_STATE(454)] = 36536,
  [SMALL_STATE(455)] = 36576,
  [SMALL_STATE(456)] = 36616,
  [SMALL_STATE(457)] = 36692,
  [SMALL_STATE(458)] = 36768,
  [SMALL_STATE(459)] = 36830,
  [SMALL_STATE(460)] = 36870,
  [SMALL_STATE(461)] = 36910,
  [SMALL_STATE(462)] = 36968,
  [SMALL_STATE(463)] = 37008,
  [SMALL_STATE(464)] = 37062,
  [SMALL_STATE(465)] = 37114,
  [SMALL_STATE(466)] = 37154,
  [SMALL_STATE(467)] = 37194,
  [SMALL_STATE(468)] = 37234,
  [SMALL_STATE(469)] = 37274,
  [SMALL_STATE(470)] = 37314,
  [SMALL_STATE(471)] = 37386,
  [SMALL_STATE(472)] = 37426,
  [SMALL_STATE(473)] = 37466,
  [SMALL_STATE(474)] = 37506,
  [SMALL_STATE(475)] = 37578,
  [SMALL_STATE(476)] = 37618,
  [SMALL_STATE(477)] = 37658,
  [SMALL_STATE(478)] = 37698,
  [SMALL_STATE(479)] = 37738,
  [SMALL_STATE(480)] = 37778,
  [SMALL_STATE(481)] = 37818,
  [SMALL_STATE(482)] = 37882,
  [SMALL_STATE(483)] = 37941,
  [SMALL_STATE(484)] = 38016,
  [SMALL_STATE(485)] = 38091,
  [SMALL_STATE(486)] = 38148,
  [SMALL_STATE(487)] = 38221,
  [SMALL_STATE(488)] = 38274,
  [SMALL_STATE(489)] = 38349,
  [SMALL_STATE(490)] = 38400,
  [SMALL_STATE(491)] = 38449,
  [SMALL_STATE(492)] = 38498,
  [SMALL_STATE(493)] = 38553,
  [SMALL_STATE(494)] = 38595,
  [SMALL_STATE(495)] = 38665,
  [SMALL_STATE(496)] = 38737,
  [SMALL_STATE(497)] = 38809,
  [SMALL_STATE(498)] = 38881,
  [SMALL_STATE(499)] = 38953,
  [SMALL_STATE(500)] = 39025,
  [SMALL_STATE(501)] = 39083,
  [SMALL_STATE(502)] = 39141,
  [SMALL_STATE(503)] = 39211,
  [SMALL_STATE(504)] = 39283,
  [SMALL_STATE(505)] = 39355,
  [SMALL_STATE(506)] = 39425,
  [SMALL_STATE(507)] = 39497,
  [SMALL_STATE(508)] = 39569,
  [SMALL_STATE(509)] = 39639,
  [SMALL_STATE(510)] = 39691,
  [SMALL_STATE(511)] = 39761,
  [SMALL_STATE(512)] = 39831,
  [SMALL_STATE(513)] = 39889,
  [SMALL_STATE(514)] = 39961,
  [SMALL_STATE(515)] = 40031,
  [SMALL_STATE(516)] = 40068,
  [SMALL_STATE(517)] = 40105,
  [SMALL_STATE(518)] = 40142,
  [SMALL_STATE(519)] = 40179,
  [SMALL_STATE(520)] = 40216,
  [SMALL_STATE(521)] = 40253,
  [SMALL_STATE(522)] = 40290,
  [SMALL_STATE(523)] = 40327,
  [SMALL_STATE(524)] = 40364,
  [SMALL_STATE(525)] = 40435,
  [SMALL_STATE(526)] = 40472,
  [SMALL_STATE(527)] = 40539,
  [SMALL_STATE(528)] = 40586,
  [SMALL_STATE(529)] = 40657,
  [SMALL_STATE(530)] = 40694,
  [SMALL_STATE(531)] = 40731,
  [SMALL_STATE(532)] = 40768,
  [SMALL_STATE(533)] = 40805,
  [SMALL_STATE(534)] = 40876,
  [SMALL_STATE(535)] = 40937,
  [SMALL_STATE(536)] = 40996,
  [SMALL_STATE(537)] = 41051,
  [SMALL_STATE(538)] = 41122,
  [SMALL_STATE(539)] = 41189,
  [SMALL_STATE(540)] = 41240,
  [SMALL_STATE(541)] = 41277,
  [SMALL_STATE(542)] = 41348,
  [SMALL_STATE(543)] = 41415,
  [SMALL_STATE(544)] = 41452,
  [SMALL_STATE(545)] = 41489,
  [SMALL_STATE(546)] = 41526,
  [SMALL_STATE(547)] = 41593,
  [SMALL_STATE(548)] = 41660,
  [SMALL_STATE(549)] = 41729,
  [SMALL_STATE(550)] = 41800,
  [SMALL_STATE(551)] = 41837,
  [SMALL_STATE(552)] = 41874,
  [SMALL_STATE(553)] = 41911,
  [SMALL_STATE(554)] = 41974,
  [SMALL_STATE(555)] = 42021,
  [SMALL_STATE(556)] = 42058,
  [SMALL_STATE(557)] = 42095,
  [SMALL_STATE(558)] = 42132,
  [SMALL_STATE(559)] = 42169,
  [SMALL_STATE(560)] = 42206,
  [SMALL_STATE(561)] = 42243,
  [SMALL_STATE(562)] = 42280,
  [SMALL_STATE(563)] = 42317,
  [SMALL_STATE(564)] = 42354,
  [SMALL_STATE(565)] = 42391,
  [SMALL_STATE(566)] = 42428,
  [SMALL_STATE(567)] = 42465,
  [SMALL_STATE(568)] = 42502,
  [SMALL_STATE(569)] = 42573,
  [SMALL_STATE(570)] = 42640,
  [SMALL_STATE(571)] = 42706,
  [SMALL_STATE(572)] = 42772,
  [SMALL_STATE(573)] = 42838,
  [SMALL_STATE(574)] = 42904,
  [SMALL_STATE(575)] = 42970,
  [SMALL_STATE(576)] = 43022,
  [SMALL_STATE(577)] = 43088,
  [SMALL_STATE(578)] = 43152,
  [SMALL_STATE(579)] = 43218,
  [SMALL_STATE(580)] = 43284,
  [SMALL_STATE(581)] = 43350,
  [SMALL_STATE(582)] = 43414,
  [SMALL_STATE(583)] = 43454,
  [SMALL_STATE(584)] = 43520,
  [SMALL_STATE(585)] = 43570,
  [SMALL_STATE(586)] = 43636,
  [SMALL_STATE(587)] = 43703,
  [SMALL_STATE(588)] = 43758,
  [SMALL_STATE(589)] = 43793,
  [SMALL_STATE(590)] = 43856,
  [SMALL_STATE(591)] = 43923,
  [SMALL_STATE(592)] = 43990,
  [SMALL_STATE(593)] = 44025,
  [SMALL_STATE(594)] = 44060,
  [SMALL_STATE(595)] = 44095,
  [SMALL_STATE(596)] = 44130,
  [SMALL_STATE(597)] = 44177,
  [SMALL_STATE(598)] = 44212,
  [SMALL_STATE(599)] = 44247,
  [SMALL_STATE(600)] = 44304,
  [SMALL_STATE(601)] = 44339,
  [SMALL_STATE(602)] = 44406,
  [SMALL_STATE(603)] = 44441,
  [SMALL_STATE(604)] = 44508,
  [SMALL_STATE(605)] = 44565,
  [SMALL_STATE(606)] = 44600,
  [SMALL_STATE(607)] = 44635,
  [SMALL_STATE(608)] = 44670,
  [SMALL_STATE(609)] = 44705,
  [SMALL_STATE(610)] = 44740,
  [SMALL_STATE(611)] = 44775,
  [SMALL_STATE(612)] = 44842,
  [SMALL_STATE(613)] = 44877,
  [SMALL_STATE(614)] = 44940,
  [SMALL_STATE(615)] = 44975,
  [SMALL_STATE(616)] = 45032,
  [SMALL_STATE(617)] = 45067,
  [SMALL_STATE(618)] = 45134,
  [SMALL_STATE(619)] = 45169,
  [SMALL_STATE(620)] = 45232,
  [SMALL_STATE(621)] = 45289,
  [SMALL_STATE(622)] = 45344,
  [SMALL_STATE(623)] = 45397,
  [SMALL_STATE(624)] = 45432,
  [SMALL_STATE(625)] = 45481,
  [SMALL_STATE(626)] = 45516,
  [SMALL_STATE(627)] = 45551,
  [SMALL_STATE(628)] = 45608,
  [SMALL_STATE(629)] = 45643,
  [SMALL_STATE(630)] = 45706,
  [SMALL_STATE(631)] = 45741,
  [SMALL_STATE(632)] = 45804,
  [SMALL_STATE(633)] = 45865,
  [SMALL_STATE(634)] = 45900,
  [SMALL_STATE(635)] = 45935,
  [SMALL_STATE(636)] = 45994,
  [SMALL_STATE(637)] = 46029,
  [SMALL_STATE(638)] = 46064,
  [SMALL_STATE(639)] = 46099,
  [SMALL_STATE(640)] = 46156,
  [SMALL_STATE(641)] = 46191,
  [SMALL_STATE(642)] = 46248,
  [SMALL_STATE(643)] = 46311,
  [SMALL_STATE(644)] = 46376,
  [SMALL_STATE(645)] = 46433,
  [SMALL_STATE(646)] = 46496,
  [SMALL_STATE(647)] = 46559,
  [SMALL_STATE(648)] = 46594,
  [SMALL_STATE(649)] = 46649,
  [SMALL_STATE(650)] = 46684,
  [SMALL_STATE(651)] = 46749,
  [SMALL_STATE(652)] = 46804,
  [SMALL_STATE(653)] = 46857,
  [SMALL_STATE(654)] = 46924,
  [SMALL_STATE(655)] = 46991,
  [SMALL_STATE(656)] = 47026,
  [SMALL_STATE(657)] = 47061,
  [SMALL_STATE(658)] = 47110,
  [SMALL_STATE(659)] = 47170,
  [SMALL_STATE(660)] = 47230,
  [SMALL_STATE(661)] = 47290,
  [SMALL_STATE(662)] = 47344,
  [SMALL_STATE(663)] = 47404,
  [SMALL_STATE(664)] = 47458,
  [SMALL_STATE(665)] = 47518,
  [SMALL_STATE(666)] = 47578,
  [SMALL_STATE(667)] = 47632,
  [SMALL_STATE(668)] = 47692,
  [SMALL_STATE(669)] = 47752,
  [SMALL_STATE(670)] = 47812,
  [SMALL_STATE(671)] = 47876,
  [SMALL_STATE(672)] = 47934,
  [SMALL_STATE(673)] = 47994,
  [SMALL_STATE(674)] = 48054,
  [SMALL_STATE(675)] = 48114,
  [SMALL_STATE(676)] = 48174,
  [SMALL_STATE(677)] = 48234,
  [SMALL_STATE(678)] = 48288,
  [SMALL_STATE(679)] = 48348,
  [SMALL_STATE(680)] = 48402,
  [SMALL_STATE(681)] = 48462,
  [SMALL_STATE(682)] = 48522,
  [SMALL_STATE(683)] = 48576,
  [SMALL_STATE(684)] = 48636,
  [SMALL_STATE(685)] = 48690,
  [SMALL_STATE(686)] = 48750,
  [SMALL_STATE(687)] = 48810,
  [SMALL_STATE(688)] = 48870,
  [SMALL_STATE(689)] = 48930,
  [SMALL_STATE(690)] = 48990,
  [SMALL_STATE(691)] = 49050,
  [SMALL_STATE(692)] = 49108,
  [SMALL_STATE(693)] = 49168,
  [SMALL_STATE(694)] = 49228,
  [SMALL_STATE(695)] = 49288,
  [SMALL_STATE(696)] = 49342,
  [SMALL_STATE(697)] = 49396,
  [SMALL_STATE(698)] = 49456,
  [SMALL_STATE(699)] = 49514,
  [SMALL_STATE(700)] = 49574,
  [SMALL_STATE(701)] = 49634,
  [SMALL_STATE(702)] = 49694,
  [SMALL_STATE(703)] = 49754,
  [SMALL_STATE(704)] = 49814,
  [SMALL_STATE(705)] = 49874,
  [SMALL_STATE(706)] = 49934,
  [SMALL_STATE(707)] = 49988,
  [SMALL_STATE(708)] = 50042,
  [SMALL_STATE(709)] = 50102,
  [SMALL_STATE(710)] = 50160,
  [SMALL_STATE(711)] = 50220,
  [SMALL_STATE(712)] = 50274,
  [SMALL_STATE(713)] = 50334,
  [SMALL_STATE(714)] = 50394,
  [SMALL_STATE(715)] = 50454,
  [SMALL_STATE(716)] = 50514,
  [SMALL_STATE(717)] = 50549,
  [SMALL_STATE(718)] = 50606,
  [SMALL_STATE(719)] = 50663,
  [SMALL_STATE(720)] = 50720,
  [SMALL_STATE(721)] = 50777,
  [SMALL_STATE(722)] = 50834,
  [SMALL_STATE(723)] = 50891,
  [SMALL_STATE(724)] = 50948,
  [SMALL_STATE(725)] = 51005,
  [SMALL_STATE(726)] = 51062,
  [SMALL_STATE(727)] = 51119,
  [SMALL_STATE(728)] = 51176,
  [SMALL_STATE(729)] = 51233,
  [SMALL_STATE(730)] = 51290,
  [SMALL_STATE(731)] = 51347,
  [SMALL_STATE(732)] = 51404,
  [SMALL_STATE(733)] = 51461,
  [SMALL_STATE(734)] = 51518,
  [SMALL_STATE(735)] = 51575,
  [SMALL_STATE(736)] = 51632,
  [SMALL_STATE(737)] = 51689,
  [SMALL_STATE(738)] = 51746,
  [SMALL_STATE(739)] = 51803,
  [SMALL_STATE(740)] = 51860,
  [SMALL_STATE(741)] = 51917,
  [SMALL_STATE(742)] = 51974,
  [SMALL_STATE(743)] = 52031,
  [SMALL_STATE(744)] = 52088,
  [SMALL_STATE(745)] = 52145,
  [SMALL_STATE(746)] = 52202,
  [SMALL_STATE(747)] = 52259,
  [SMALL_STATE(748)] = 52316,
  [SMALL_STATE(749)] = 52373,
  [SMALL_STATE(750)] = 52430,
  [SMALL_STATE(751)] = 52487,
  [SMALL_STATE(752)] = 52544,
  [SMALL_STATE(753)] = 52601,
  [SMALL_STATE(754)] = 52658,
  [SMALL_STATE(755)] = 52715,
  [SMALL_STATE(756)] = 52772,
  [SMALL_STATE(757)] = 52829,
  [SMALL_STATE(758)] = 52886,
  [SMALL_STATE(759)] = 52943,
  [SMALL_STATE(760)] = 53000,
  [SMALL_STATE(761)] = 53057,
  [SMALL_STATE(762)] = 53114,
  [SMALL_STATE(763)] = 53171,
  [SMALL_STATE(764)] = 53232,
  [SMALL_STATE(765)] = 53289,
  [SMALL_STATE(766)] = 53346,
  [SMALL_STATE(767)] = 53403,
  [SMALL_STATE(768)] = 53460,
  [SMALL_STATE(769)] = 53517,
  [SMALL_STATE(770)] = 53574,
  [SMALL_STATE(771)] = 53631,
  [SMALL_STATE(772)] = 53688,
  [SMALL_STATE(773)] = 53745,
  [SMALL_STATE(774)] = 53802,
  [SMALL_STATE(775)] = 53859,
  [SMALL_STATE(776)] = 53916,
  [SMALL_STATE(777)] = 53973,
  [SMALL_STATE(778)] = 54030,
  [SMALL_STATE(779)] = 54087,
  [SMALL_STATE(780)] = 54144,
  [SMALL_STATE(781)] = 54201,
  [SMALL_STATE(782)] = 54258,
  [SMALL_STATE(783)] = 54315,
  [SMALL_STATE(784)] = 54372,
  [SMALL_STATE(785)] = 54429,
  [SMALL_STATE(786)] = 54486,
  [SMALL_STATE(787)] = 54543,
  [SMALL_STATE(788)] = 54600,
  [SMALL_STATE(789)] = 54657,
  [SMALL_STATE(790)] = 54714,
  [SMALL_STATE(791)] = 54771,
  [SMALL_STATE(792)] = 54828,
  [SMALL_STATE(793)] = 54885,
  [SMALL_STATE(794)] = 54942,
  [SMALL_STATE(795)] = 54999,
  [SMALL_STATE(796)] = 55056,
  [SMALL_STATE(797)] = 55113,
  [SMALL_STATE(798)] = 55170,
  [SMALL_STATE(799)] = 55227,
  [SMALL_STATE(800)] = 55262,
  [SMALL_STATE(801)] = 55319,
  [SMALL_STATE(802)] = 55376,
  [SMALL_STATE(803)] = 55433,
  [SMALL_STATE(804)] = 55490,
  [SMALL_STATE(805)] = 55547,
  [SMALL_STATE(806)] = 55604,
  [SMALL_STATE(807)] = 55661,
  [SMALL_STATE(808)] = 55718,
  [SMALL_STATE(809)] = 55775,
  [SMALL_STATE(810)] = 55832,
  [SMALL_STATE(811)] = 55889,
  [SMALL_STATE(812)] = 55946,
  [SMALL_STATE(813)] = 56003,
  [SMALL_STATE(814)] = 56060,
  [SMALL_STATE(815)] = 56117,
  [SMALL_STATE(816)] = 56174,
  [SMALL_STATE(817)] = 56231,
  [SMALL_STATE(818)] = 56288,
  [SMALL_STATE(819)] = 56345,
  [SMALL_STATE(820)] = 56402,
  [SMALL_STATE(821)] = 56459,
  [SMALL_STATE(822)] = 56516,
  [SMALL_STATE(823)] = 56573,
  [SMALL_STATE(824)] = 56630,
  [SMALL_STATE(825)] = 56687,
  [SMALL_STATE(826)] = 56744,
  [SMALL_STATE(827)] = 56801,
  [SMALL_STATE(828)] = 56858,
  [SMALL_STATE(829)] = 56915,
  [SMALL_STATE(830)] = 56972,
  [SMALL_STATE(831)] = 57029,
  [SMALL_STATE(832)] = 57086,
  [SMALL_STATE(833)] = 57143,
  [SMALL_STATE(834)] = 57200,
  [SMALL_STATE(835)] = 57259,
  [SMALL_STATE(836)] = 57316,
  [SMALL_STATE(837)] = 57351,
  [SMALL_STATE(838)] = 57410,
  [SMALL_STATE(839)] = 57467,
  [SMALL_STATE(840)] = 57524,
  [SMALL_STATE(841)] = 57581,
  [SMALL_STATE(842)] = 57638,
  [SMALL_STATE(843)] = 57695,
  [SMALL_STATE(844)] = 57752,
  [SMALL_STATE(845)] = 57809,
  [SMALL_STATE(846)] = 57866,
  [SMALL_STATE(847)] = 57923,
  [SMALL_STATE(848)] = 57980,
  [SMALL_STATE(849)] = 58034,
  [SMALL_STATE(850)] = 58068,
  [SMALL_STATE(851)] = 58098,
  [SMALL_STATE(852)] = 58128,
  [SMALL_STATE(853)] = 58158,
  [SMALL_STATE(854)] = 58188,
  [SMALL_STATE(855)] = 58220,
  [SMALL_STATE(856)] = 58247,
  [SMALL_STATE(857)] = 58273,
  [SMALL_STATE(858)] = 58299,
  [SMALL_STATE(859)] = 58325,
  [SMALL_STATE(860)] = 58351,
  [SMALL_STATE(861)] = 58376,
  [SMALL_STATE(862)] = 58401,
  [SMALL_STATE(863)] = 58426,
  [SMALL_STATE(864)] = 58451,
  [SMALL_STATE(865)] = 58476,
  [SMALL_STATE(866)] = 58501,
  [SMALL_STATE(867)] = 58529,
  [SMALL_STATE(868)] = 58557,
  [SMALL_STATE(869)] = 58585,
  [SMALL_STATE(870)] = 58613,
  [SMALL_STATE(871)] = 58641,
  [SMALL_STATE(872)] = 58667,
  [SMALL_STATE(873)] = 58695,
  [SMALL_STATE(874)] = 58716,
  [SMALL_STATE(875)] = 58737,
  [SMALL_STATE(876)] = 58762,
  [SMALL_STATE(877)] = 58783,
  [SMALL_STATE(878)] = 58808,
  [SMALL_STATE(879)] = 58829,
  [SMALL_STATE(880)] = 58854,
  [SMALL_STATE(881)] = 58875,
  [SMALL_STATE(882)] = 58896,
  [SMALL_STATE(883)] = 58921,
  [SMALL_STATE(884)] = 58944,
  [SMALL_STATE(885)] = 58965,
  [SMALL_STATE(886)] = 58987,
  [SMALL_STATE(887)] = 59005,
  [SMALL_STATE(888)] = 59025,
  [SMALL_STATE(889)] = 59045,
  [SMALL_STATE(890)] = 59065,
  [SMALL_STATE(891)] = 59085,
  [SMALL_STATE(892)] = 59105,
  [SMALL_STATE(893)] = 59125,
  [SMALL_STATE(894)] = 59145,
  [SMALL_STATE(895)] = 59165,
  [SMALL_STATE(896)] = 59185,
  [SMALL_STATE(897)] = 59205,
  [SMALL_STATE(898)] = 59225,
  [SMALL_STATE(899)] = 59247,
  [SMALL_STATE(900)] = 59269,
  [SMALL_STATE(901)] = 59289,
  [SMALL_STATE(902)] = 59307,
  [SMALL_STATE(903)] = 59327,
  [SMALL_STATE(904)] = 59347,
  [SMALL_STATE(905)] = 59367,
  [SMALL_STATE(906)] = 59387,
  [SMALL_STATE(907)] = 59407,
  [SMALL_STATE(908)] = 59427,
  [SMALL_STATE(909)] = 59449,
  [SMALL_STATE(910)] = 59469,
  [SMALL_STATE(911)] = 59489,
  [SMALL_STATE(912)] = 59509,
  [SMALL_STATE(913)] = 59531,
  [SMALL_STATE(914)] = 59551,
  [SMALL_STATE(915)] = 59571,
  [SMALL_STATE(916)] = 59589,
  [SMALL_STATE(917)] = 59609,
  [SMALL_STATE(918)] = 59631,
  [SMALL_STATE(919)] = 59649,
  [SMALL_STATE(920)] = 59669,
  [SMALL_STATE(921)] = 59691,
  [SMALL_STATE(922)] = 59711,
  [SMALL_STATE(923)] = 59731,
  [SMALL_STATE(924)] = 59751,
  [SMALL_STATE(925)] = 59771,
  [SMALL_STATE(926)] = 59789,
  [SMALL_STATE(927)] = 59809,
  [SMALL_STATE(928)] = 59829,
  [SMALL_STATE(929)] = 59847,
  [SMALL_STATE(930)] = 59869,
  [SMALL_STATE(931)] = 59886,
  [SMALL_STATE(932)] = 59903,
  [SMALL_STATE(933)] = 59922,
  [SMALL_STATE(934)] = 59939,
  [SMALL_STATE(935)] = 59956,
  [SMALL_STATE(936)] = 59973,
  [SMALL_STATE(937)] = 59990,
  [SMALL_STATE(938)] = 60007,
  [SMALL_STATE(939)] = 60024,
  [SMALL_STATE(940)] = 60041,
  [SMALL_STATE(941)] = 60058,
  [SMALL_STATE(942)] = 60075,
  [SMALL_STATE(943)] = 60092,
  [SMALL_STATE(944)] = 60109,
  [SMALL_STATE(945)] = 60126,
  [SMALL_STATE(946)] = 60143,
  [SMALL_STATE(947)] = 60160,
  [SMALL_STATE(948)] = 60177,
  [SMALL_STATE(949)] = 60194,
  [SMALL_STATE(950)] = 60213,
  [SMALL_STATE(951)] = 60230,
  [SMALL_STATE(952)] = 60247,
  [SMALL_STATE(953)] = 60264,
  [SMALL_STATE(954)] = 60281,
  [SMALL_STATE(955)] = 60298,
  [SMALL_STATE(956)] = 60315,
  [SMALL_STATE(957)] = 60332,
  [SMALL_STATE(958)] = 60349,
  [SMALL_STATE(959)] = 60366,
  [SMALL_STATE(960)] = 60383,
  [SMALL_STATE(961)] = 60400,
  [SMALL_STATE(962)] = 60417,
  [SMALL_STATE(963)] = 60434,
  [SMALL_STATE(964)] = 60451,
  [SMALL_STATE(965)] = 60468,
  [SMALL_STATE(966)] = 60485,
  [SMALL_STATE(967)] = 60502,
  [SMALL_STATE(968)] = 60519,
  [SMALL_STATE(969)] = 60536,
  [SMALL_STATE(970)] = 60553,
  [SMALL_STATE(971)] = 60570,
  [SMALL_STATE(972)] = 60587,
  [SMALL_STATE(973)] = 60604,
  [SMALL_STATE(974)] = 60621,
  [SMALL_STATE(975)] = 60638,
  [SMALL_STATE(976)] = 60655,
  [SMALL_STATE(977)] = 60672,
  [SMALL_STATE(978)] = 60689,
  [SMALL_STATE(979)] = 60706,
  [SMALL_STATE(980)] = 60723,
  [SMALL_STATE(981)] = 60740,
  [SMALL_STATE(982)] = 60757,
  [SMALL_STATE(983)] = 60774,
  [SMALL_STATE(984)] = 60791,
  [SMALL_STATE(985)] = 60814,
  [SMALL_STATE(986)] = 60831,
  [SMALL_STATE(987)] = 60848,
  [SMALL_STATE(988)] = 60865,
  [SMALL_STATE(989)] = 60882,
  [SMALL_STATE(990)] = 60899,
  [SMALL_STATE(991)] = 60916,
  [SMALL_STATE(992)] = 60933,
  [SMALL_STATE(993)] = 60950,
  [SMALL_STATE(994)] = 60967,
  [SMALL_STATE(995)] = 61000,
  [SMALL_STATE(996)] = 61017,
  [SMALL_STATE(997)] = 61034,
  [SMALL_STATE(998)] = 61051,
  [SMALL_STATE(999)] = 61068,
  [SMALL_STATE(1000)] = 61085,
  [SMALL_STATE(1001)] = 61102,
  [SMALL_STATE(1002)] = 61119,
  [SMALL_STATE(1003)] = 61136,
  [SMALL_STATE(1004)] = 61153,
  [SMALL_STATE(1005)] = 61170,
  [SMALL_STATE(1006)] = 61187,
  [SMALL_STATE(1007)] = 61204,
  [SMALL_STATE(1008)] = 61221,
  [SMALL_STATE(1009)] = 61238,
  [SMALL_STATE(1010)] = 61255,
  [SMALL_STATE(1011)] = 61272,
  [SMALL_STATE(1012)] = 61289,
  [SMALL_STATE(1013)] = 61306,
  [SMALL_STATE(1014)] = 61329,
  [SMALL_STATE(1015)] = 61346,
  [SMALL_STATE(1016)] = 61363,
  [SMALL_STATE(1017)] = 61382,
  [SMALL_STATE(1018)] = 61399,
  [SMALL_STATE(1019)] = 61416,
  [SMALL_STATE(1020)] = 61433,
  [SMALL_STATE(1021)] = 61463,
  [SMALL_STATE(1022)] = 61487,
  [SMALL_STATE(1023)] = 61513,
  [SMALL_STATE(1024)] = 61539,
  [SMALL_STATE(1025)] = 61565,
  [SMALL_STATE(1026)] = 61585,
  [SMALL_STATE(1027)] = 61615,
  [SMALL_STATE(1028)] = 61635,
  [SMALL_STATE(1029)] = 61661,
  [SMALL_STATE(1030)] = 61693,
  [SMALL_STATE(1031)] = 61725,
  [SMALL_STATE(1032)] = 61751,
  [SMALL_STATE(1033)] = 61779,
  [SMALL_STATE(1034)] = 61805,
  [SMALL_STATE(1035)] = 61820,
  [SMALL_STATE(1036)] = 61835,
  [SMALL_STATE(1037)] = 61850,
  [SMALL_STATE(1038)] = 61865,
  [SMALL_STATE(1039)] = 61880,
  [SMALL_STATE(1040)] = 61895,
  [SMALL_STATE(1041)] = 61926,
  [SMALL_STATE(1042)] = 61941,
  [SMALL_STATE(1043)] = 61958,
  [SMALL_STATE(1044)] = 61973,
  [SMALL_STATE(1045)] = 61988,
  [SMALL_STATE(1046)] = 62003,
  [SMALL_STATE(1047)] = 62020,
  [SMALL_STATE(1048)] = 62035,
  [SMALL_STATE(1049)] = 62050,
  [SMALL_STATE(1050)] = 62067,
  [SMALL_STATE(1051)] = 62098,
  [SMALL_STATE(1052)] = 62129,
  [SMALL_STATE(1053)] = 62144,
  [SMALL_STATE(1054)] = 62159,
  [SMALL_STATE(1055)] = 62174,
  [SMALL_STATE(1056)] = 62189,
  [SMALL_STATE(1057)] = 62206,
  [SMALL_STATE(1058)] = 62221,
  [SMALL_STATE(1059)] = 62236,
  [SMALL_STATE(1060)] = 62251,
  [SMALL_STATE(1061)] = 62282,
  [SMALL_STATE(1062)] = 62297,
  [SMALL_STATE(1063)] = 62312,
  [SMALL_STATE(1064)] = 62335,
  [SMALL_STATE(1065)] = 62366,
  [SMALL_STATE(1066)] = 62381,
  [SMALL_STATE(1067)] = 62396,
  [SMALL_STATE(1068)] = 62411,
  [SMALL_STATE(1069)] = 62434,
  [SMALL_STATE(1070)] = 62465,
  [SMALL_STATE(1071)] = 62488,
  [SMALL_STATE(1072)] = 62503,
  [SMALL_STATE(1073)] = 62523,
  [SMALL_STATE(1074)] = 62543,
  [SMALL_STATE(1075)] = 62563,
  [SMALL_STATE(1076)] = 62583,
  [SMALL_STATE(1077)] = 62603,
  [SMALL_STATE(1078)] = 62623,
  [SMALL_STATE(1079)] = 62651,
  [SMALL_STATE(1080)] = 62675,
  [SMALL_STATE(1081)] = 62699,
  [SMALL_STATE(1082)] = 62723,
  [SMALL_STATE(1083)] = 62747,
  [SMALL_STATE(1084)] = 62771,
  [SMALL_STATE(1085)] = 62788,
  [SMALL_STATE(1086)] = 62805,
  [SMALL_STATE(1087)] = 62822,
  [SMALL_STATE(1088)] = 62839,
  [SMALL_STATE(1089)] = 62856,
  [SMALL_STATE(1090)] = 62871,
  [SMALL_STATE(1091)] = 62886,
  [SMALL_STATE(1092)] = 62903,
  [SMALL_STATE(1093)] = 62918,
  [SMALL_STATE(1094)] = 62933,
  [SMALL_STATE(1095)] = 62948,
  [SMALL_STATE(1096)] = 62963,
  [SMALL_STATE(1097)] = 62978,
  [SMALL_STATE(1098)] = 62999,
  [SMALL_STATE(1099)] = 63018,
  [SMALL_STATE(1100)] = 63035,
  [SMALL_STATE(1101)] = 63050,
  [SMALL_STATE(1102)] = 63073,
  [SMALL_STATE(1103)] = 63088,
  [SMALL_STATE(1104)] = 63109,
  [SMALL_STATE(1105)] = 63124,
  [SMALL_STATE(1106)] = 63139,
  [SMALL_STATE(1107)] = 63156,
  [SMALL_STATE(1108)] = 63173,
  [SMALL_STATE(1109)] = 63188,
  [SMALL_STATE(1110)] = 63209,
  [SMALL_STATE(1111)] = 63230,
  [SMALL_STATE(1112)] = 63247,
  [SMALL_STATE(1113)] = 63262,
  [SMALL_STATE(1114)] = 63279,
  [SMALL_STATE(1115)] = 63294,
  [SMALL_STATE(1116)] = 63309,
  [SMALL_STATE(1117)] = 63324,
  [SMALL_STATE(1118)] = 63343,
  [SMALL_STATE(1119)] = 63364,
  [SMALL_STATE(1120)] = 63385,
  [SMALL_STATE(1121)] = 63404,
  [SMALL_STATE(1122)] = 63419,
  [SMALL_STATE(1123)] = 63434,
  [SMALL_STATE(1124)] = 63449,
  [SMALL_STATE(1125)] = 63464,
  [SMALL_STATE(1126)] = 63483,
  [SMALL_STATE(1127)] = 63498,
  [SMALL_STATE(1128)] = 63515,
  [SMALL_STATE(1129)] = 63530,
  [SMALL_STATE(1130)] = 63545,
  [SMALL_STATE(1131)] = 63568,
  [SMALL_STATE(1132)] = 63583,
  [SMALL_STATE(1133)] = 63604,
  [SMALL_STATE(1134)] = 63619,
  [SMALL_STATE(1135)] = 63636,
  [SMALL_STATE(1136)] = 63657,
  [SMALL_STATE(1137)] = 63675,
  [SMALL_STATE(1138)] = 63695,
  [SMALL_STATE(1139)] = 63709,
  [SMALL_STATE(1140)] = 63723,
  [SMALL_STATE(1141)] = 63737,
  [SMALL_STATE(1142)] = 63757,
  [SMALL_STATE(1143)] = 63771,
  [SMALL_STATE(1144)] = 63785,
  [SMALL_STATE(1145)] = 63799,
  [SMALL_STATE(1146)] = 63813,
  [SMALL_STATE(1147)] = 63827,
  [SMALL_STATE(1148)] = 63841,
  [SMALL_STATE(1149)] = 63855,
  [SMALL_STATE(1150)] = 63869,
  [SMALL_STATE(1151)] = 63883,
  [SMALL_STATE(1152)] = 63897,
  [SMALL_STATE(1153)] = 63915,
  [SMALL_STATE(1154)] = 63933,
  [SMALL_STATE(1155)] = 63947,
  [SMALL_STATE(1156)] = 63965,
  [SMALL_STATE(1157)] = 63979,
  [SMALL_STATE(1158)] = 63997,
  [SMALL_STATE(1159)] = 64011,
  [SMALL_STATE(1160)] = 64029,
  [SMALL_STATE(1161)] = 64043,
  [SMALL_STATE(1162)] = 64057,
  [SMALL_STATE(1163)] = 64071,
  [SMALL_STATE(1164)] = 64089,
  [SMALL_STATE(1165)] = 64107,
  [SMALL_STATE(1166)] = 64125,
  [SMALL_STATE(1167)] = 64143,
  [SMALL_STATE(1168)] = 64161,
  [SMALL_STATE(1169)] = 64179,
  [SMALL_STATE(1170)] = 64193,
  [SMALL_STATE(1171)] = 64207,
  [SMALL_STATE(1172)] = 64225,
  [SMALL_STATE(1173)] = 64245,
  [SMALL_STATE(1174)] = 64263,
  [SMALL_STATE(1175)] = 64277,
  [SMALL_STATE(1176)] = 64295,
  [SMALL_STATE(1177)] = 64309,
  [SMALL_STATE(1178)] = 64327,
  [SMALL_STATE(1179)] = 64341,
  [SMALL_STATE(1180)] = 64355,
  [SMALL_STATE(1181)] = 64369,
  [SMALL_STATE(1182)] = 64383,
  [SMALL_STATE(1183)] = 64401,
  [SMALL_STATE(1184)] = 64415,
  [SMALL_STATE(1185)] = 64429,
  [SMALL_STATE(1186)] = 64443,
  [SMALL_STATE(1187)] = 64457,
  [SMALL_STATE(1188)] = 64471,
  [SMALL_STATE(1189)] = 64491,
  [SMALL_STATE(1190)] = 64509,
  [SMALL_STATE(1191)] = 64523,
  [SMALL_STATE(1192)] = 64541,
  [SMALL_STATE(1193)] = 64559,
  [SMALL_STATE(1194)] = 64577,
  [SMALL_STATE(1195)] = 64595,
  [SMALL_STATE(1196)] = 64609,
  [SMALL_STATE(1197)] = 64625,
  [SMALL_STATE(1198)] = 64639,
  [SMALL_STATE(1199)] = 64657,
  [SMALL_STATE(1200)] = 64675,
  [SMALL_STATE(1201)] = 64693,
  [SMALL_STATE(1202)] = 64707,
  [SMALL_STATE(1203)] = 64725,
  [SMALL_STATE(1204)] = 64741,
  [SMALL_STATE(1205)] = 64759,
  [SMALL_STATE(1206)] = 64777,
  [SMALL_STATE(1207)] = 64795,
  [SMALL_STATE(1208)] = 64813,
  [SMALL_STATE(1209)] = 64827,
  [SMALL_STATE(1210)] = 64843,
  [SMALL_STATE(1211)] = 64861,
  [SMALL_STATE(1212)] = 64875,
  [SMALL_STATE(1213)] = 64893,
  [SMALL_STATE(1214)] = 64911,
  [SMALL_STATE(1215)] = 64925,
  [SMALL_STATE(1216)] = 64943,
  [SMALL_STATE(1217)] = 64957,
  [SMALL_STATE(1218)] = 64977,
  [SMALL_STATE(1219)] = 64995,
  [SMALL_STATE(1220)] = 65009,
  [SMALL_STATE(1221)] = 65029,
  [SMALL_STATE(1222)] = 65047,
  [SMALL_STATE(1223)] = 65065,
  [SMALL_STATE(1224)] = 65083,
  [SMALL_STATE(1225)] = 65103,
  [SMALL_STATE(1226)] = 65121,
  [SMALL_STATE(1227)] = 65139,
  [SMALL_STATE(1228)] = 65157,
  [SMALL_STATE(1229)] = 65175,
  [SMALL_STATE(1230)] = 65193,
  [SMALL_STATE(1231)] = 65207,
  [SMALL_STATE(1232)] = 65227,
  [SMALL_STATE(1233)] = 65245,
  [SMALL_STATE(1234)] = 65259,
  [SMALL_STATE(1235)] = 65277,
  [SMALL_STATE(1236)] = 65295,
  [SMALL_STATE(1237)] = 65309,
  [SMALL_STATE(1238)] = 65327,
  [SMALL_STATE(1239)] = 65345,
  [SMALL_STATE(1240)] = 65361,
  [SMALL_STATE(1241)] = 65375,
  [SMALL_STATE(1242)] = 65389,
  [SMALL_STATE(1243)] = 65403,
  [SMALL_STATE(1244)] = 65417,
  [SMALL_STATE(1245)] = 65435,
  [SMALL_STATE(1246)] = 65453,
  [SMALL_STATE(1247)] = 65471,
  [SMALL_STATE(1248)] = 65485,
  [SMALL_STATE(1249)] = 65503,
  [SMALL_STATE(1250)] = 65517,
  [SMALL_STATE(1251)] = 65535,
  [SMALL_STATE(1252)] = 65552,
  [SMALL_STATE(1253)] = 65565,
  [SMALL_STATE(1254)] = 65580,
  [SMALL_STATE(1255)] = 65597,
  [SMALL_STATE(1256)] = 65614,
  [SMALL_STATE(1257)] = 65627,
  [SMALL_STATE(1258)] = 65644,
  [SMALL_STATE(1259)] = 65661,
  [SMALL_STATE(1260)] = 65678,
  [SMALL_STATE(1261)] = 65695,
  [SMALL_STATE(1262)] = 65708,
  [SMALL_STATE(1263)] = 65721,
  [SMALL_STATE(1264)] = 65738,
  [SMALL_STATE(1265)] = 65755,
  [SMALL_STATE(1266)] = 65772,
  [SMALL_STATE(1267)] = 65789,
  [SMALL_STATE(1268)] = 65806,
  [SMALL_STATE(1269)] = 65819,
  [SMALL_STATE(1270)] = 65836,
  [SMALL_STATE(1271)] = 65853,
  [SMALL_STATE(1272)] = 65870,
  [SMALL_STATE(1273)] = 65883,
  [SMALL_STATE(1274)] = 65896,
  [SMALL_STATE(1275)] = 65909,
  [SMALL_STATE(1276)] = 65926,
  [SMALL_STATE(1277)] = 65939,
  [SMALL_STATE(1278)] = 65952,
  [SMALL_STATE(1279)] = 65965,
  [SMALL_STATE(1280)] = 65978,
  [SMALL_STATE(1281)] = 65991,
  [SMALL_STATE(1282)] = 66004,
  [SMALL_STATE(1283)] = 66017,
  [SMALL_STATE(1284)] = 66034,
  [SMALL_STATE(1285)] = 66051,
  [SMALL_STATE(1286)] = 66068,
  [SMALL_STATE(1287)] = 66085,
  [SMALL_STATE(1288)] = 66102,
  [SMALL_STATE(1289)] = 66119,
  [SMALL_STATE(1290)] = 66136,
  [SMALL_STATE(1291)] = 66149,
  [SMALL_STATE(1292)] = 66168,
  [SMALL_STATE(1293)] = 66183,
  [SMALL_STATE(1294)] = 66200,
  [SMALL_STATE(1295)] = 66213,
  [SMALL_STATE(1296)] = 66228,
  [SMALL_STATE(1297)] = 66245,
  [SMALL_STATE(1298)] = 66262,
  [SMALL_STATE(1299)] = 66279,
  [SMALL_STATE(1300)] = 66296,
  [SMALL_STATE(1301)] = 66313,
  [SMALL_STATE(1302)] = 66330,
  [SMALL_STATE(1303)] = 66345,
  [SMALL_STATE(1304)] = 66362,
  [SMALL_STATE(1305)] = 66373,
  [SMALL_STATE(1306)] = 66390,
  [SMALL_STATE(1307)] = 66407,
  [SMALL_STATE(1308)] = 66424,
  [SMALL_STATE(1309)] = 66441,
  [SMALL_STATE(1310)] = 66456,
  [SMALL_STATE(1311)] = 66467,
  [SMALL_STATE(1312)] = 66486,
  [SMALL_STATE(1313)] = 66503,
  [SMALL_STATE(1314)] = 66520,
  [SMALL_STATE(1315)] = 66537,
  [SMALL_STATE(1316)] = 66549,
  [SMALL_STATE(1317)] = 66561,
  [SMALL_STATE(1318)] = 66575,
  [SMALL_STATE(1319)] = 66591,
  [SMALL_STATE(1320)] = 66605,
  [SMALL_STATE(1321)] = 66619,
  [SMALL_STATE(1322)] = 66635,
  [SMALL_STATE(1323)] = 66649,
  [SMALL_STATE(1324)] = 66663,
  [SMALL_STATE(1325)] = 66675,
  [SMALL_STATE(1326)] = 66687,
  [SMALL_STATE(1327)] = 66699,
  [SMALL_STATE(1328)] = 66715,
  [SMALL_STATE(1329)] = 66731,
  [SMALL_STATE(1330)] = 66747,
  [SMALL_STATE(1331)] = 66763,
  [SMALL_STATE(1332)] = 66777,
  [SMALL_STATE(1333)] = 66791,
  [SMALL_STATE(1334)] = 66805,
  [SMALL_STATE(1335)] = 66817,
  [SMALL_STATE(1336)] = 66829,
  [SMALL_STATE(1337)] = 66841,
  [SMALL_STATE(1338)] = 66857,
  [SMALL_STATE(1339)] = 66871,
  [SMALL_STATE(1340)] = 66885,
  [SMALL_STATE(1341)] = 66897,
  [SMALL_STATE(1342)] = 66911,
  [SMALL_STATE(1343)] = 66927,
  [SMALL_STATE(1344)] = 66939,
  [SMALL_STATE(1345)] = 66953,
  [SMALL_STATE(1346)] = 66969,
  [SMALL_STATE(1347)] = 66985,
  [SMALL_STATE(1348)] = 67001,
  [SMALL_STATE(1349)] = 67017,
  [SMALL_STATE(1350)] = 67031,
  [SMALL_STATE(1351)] = 67045,
  [SMALL_STATE(1352)] = 67059,
  [SMALL_STATE(1353)] = 67073,
  [SMALL_STATE(1354)] = 67085,
  [SMALL_STATE(1355)] = 67097,
  [SMALL_STATE(1356)] = 67113,
  [SMALL_STATE(1357)] = 67129,
  [SMALL_STATE(1358)] = 67145,
  [SMALL_STATE(1359)] = 67161,
  [SMALL_STATE(1360)] = 67177,
  [SMALL_STATE(1361)] = 67191,
  [SMALL_STATE(1362)] = 67203,
  [SMALL_STATE(1363)] = 67213,
  [SMALL_STATE(1364)] = 67225,
  [SMALL_STATE(1365)] = 67241,
  [SMALL_STATE(1366)] = 67257,
  [SMALL_STATE(1367)] = 67273,
  [SMALL_STATE(1368)] = 67287,
  [SMALL_STATE(1369)] = 67301,
  [SMALL_STATE(1370)] = 67317,
  [SMALL_STATE(1371)] = 67333,
  [SMALL_STATE(1372)] = 67343,
  [SMALL_STATE(1373)] = 67355,
  [SMALL_STATE(1374)] = 67369,
  [SMALL_STATE(1375)] = 67381,
  [SMALL_STATE(1376)] = 67395,
  [SMALL_STATE(1377)] = 67409,
  [SMALL_STATE(1378)] = 67421,
  [SMALL_STATE(1379)] = 67437,
  [SMALL_STATE(1380)] = 67449,
  [SMALL_STATE(1381)] = 67461,
  [SMALL_STATE(1382)] = 67475,
  [SMALL_STATE(1383)] = 67487,
  [SMALL_STATE(1384)] = 67501,
  [SMALL_STATE(1385)] = 67513,
  [SMALL_STATE(1386)] = 67525,
  [SMALL_STATE(1387)] = 67535,
  [SMALL_STATE(1388)] = 67549,
  [SMALL_STATE(1389)] = 67565,
  [SMALL_STATE(1390)] = 67581,
  [SMALL_STATE(1391)] = 67593,
  [SMALL_STATE(1392)] = 67609,
  [SMALL_STATE(1393)] = 67623,
  [SMALL_STATE(1394)] = 67637,
  [SMALL_STATE(1395)] = 67651,
  [SMALL_STATE(1396)] = 67665,
  [SMALL_STATE(1397)] = 67679,
  [SMALL_STATE(1398)] = 67691,
  [SMALL_STATE(1399)] = 67705,
  [SMALL_STATE(1400)] = 67719,
  [SMALL_STATE(1401)] = 67731,
  [SMALL_STATE(1402)] = 67745,
  [SMALL_STATE(1403)] = 67757,
  [SMALL_STATE(1404)] = 67771,
  [SMALL_STATE(1405)] = 67783,
  [SMALL_STATE(1406)] = 67795,
  [SMALL_STATE(1407)] = 67809,
  [SMALL_STATE(1408)] = 67821,
  [SMALL_STATE(1409)] = 67833,
  [SMALL_STATE(1410)] = 67845,
  [SMALL_STATE(1411)] = 67857,
  [SMALL_STATE(1412)] = 67869,
  [SMALL_STATE(1413)] = 67881,
  [SMALL_STATE(1414)] = 67893,
  [SMALL_STATE(1415)] = 67905,
  [SMALL_STATE(1416)] = 67917,
  [SMALL_STATE(1417)] = 67929,
  [SMALL_STATE(1418)] = 67941,
  [SMALL_STATE(1419)] = 67953,
  [SMALL_STATE(1420)] = 67965,
  [SMALL_STATE(1421)] = 67977,
  [SMALL_STATE(1422)] = 67989,
  [SMALL_STATE(1423)] = 68001,
  [SMALL_STATE(1424)] = 68013,
  [SMALL_STATE(1425)] = 68025,
  [SMALL_STATE(1426)] = 68039,
  [SMALL_STATE(1427)] = 68051,
  [SMALL_STATE(1428)] = 68063,
  [SMALL_STATE(1429)] = 68079,
  [SMALL_STATE(1430)] = 68093,
  [SMALL_STATE(1431)] = 68109,
  [SMALL_STATE(1432)] = 68123,
  [SMALL_STATE(1433)] = 68139,
  [SMALL_STATE(1434)] = 68155,
  [SMALL_STATE(1435)] = 68169,
  [SMALL_STATE(1436)] = 68183,
  [SMALL_STATE(1437)] = 68195,
  [SMALL_STATE(1438)] = 68205,
  [SMALL_STATE(1439)] = 68221,
  [SMALL_STATE(1440)] = 68235,
  [SMALL_STATE(1441)] = 68249,
  [SMALL_STATE(1442)] = 68263,
  [SMALL_STATE(1443)] = 68275,
  [SMALL_STATE(1444)] = 68289,
  [SMALL_STATE(1445)] = 68301,
  [SMALL_STATE(1446)] = 68313,
  [SMALL_STATE(1447)] = 68327,
  [SMALL_STATE(1448)] = 68339,
  [SMALL_STATE(1449)] = 68351,
  [SMALL_STATE(1450)] = 68364,
  [SMALL_STATE(1451)] = 68373,
  [SMALL_STATE(1452)] = 68386,
  [SMALL_STATE(1453)] = 68399,
  [SMALL_STATE(1454)] = 68412,
  [SMALL_STATE(1455)] = 68425,
  [SMALL_STATE(1456)] = 68438,
  [SMALL_STATE(1457)] = 68449,
  [SMALL_STATE(1458)] = 68462,
  [SMALL_STATE(1459)] = 68471,
  [SMALL_STATE(1460)] = 68482,
  [SMALL_STATE(1461)] = 68491,
  [SMALL_STATE(1462)] = 68500,
  [SMALL_STATE(1463)] = 68513,
  [SMALL_STATE(1464)] = 68526,
  [SMALL_STATE(1465)] = 68535,
  [SMALL_STATE(1466)] = 68548,
  [SMALL_STATE(1467)] = 68561,
  [SMALL_STATE(1468)] = 68574,
  [SMALL_STATE(1469)] = 68587,
  [SMALL_STATE(1470)] = 68598,
  [SMALL_STATE(1471)] = 68611,
  [SMALL_STATE(1472)] = 68620,
  [SMALL_STATE(1473)] = 68629,
  [SMALL_STATE(1474)] = 68642,
  [SMALL_STATE(1475)] = 68651,
  [SMALL_STATE(1476)] = 68660,
  [SMALL_STATE(1477)] = 68669,
  [SMALL_STATE(1478)] = 68678,
  [SMALL_STATE(1479)] = 68687,
  [SMALL_STATE(1480)] = 68700,
  [SMALL_STATE(1481)] = 68709,
  [SMALL_STATE(1482)] = 68718,
  [SMALL_STATE(1483)] = 68727,
  [SMALL_STATE(1484)] = 68736,
  [SMALL_STATE(1485)] = 68745,
  [SMALL_STATE(1486)] = 68758,
  [SMALL_STATE(1487)] = 68767,
  [SMALL_STATE(1488)] = 68776,
  [SMALL_STATE(1489)] = 68785,
  [SMALL_STATE(1490)] = 68794,
  [SMALL_STATE(1491)] = 68807,
  [SMALL_STATE(1492)] = 68816,
  [SMALL_STATE(1493)] = 68825,
  [SMALL_STATE(1494)] = 68834,
  [SMALL_STATE(1495)] = 68847,
  [SMALL_STATE(1496)] = 68860,
  [SMALL_STATE(1497)] = 68873,
  [SMALL_STATE(1498)] = 68882,
  [SMALL_STATE(1499)] = 68891,
  [SMALL_STATE(1500)] = 68900,
  [SMALL_STATE(1501)] = 68909,
  [SMALL_STATE(1502)] = 68922,
  [SMALL_STATE(1503)] = 68931,
  [SMALL_STATE(1504)] = 68942,
  [SMALL_STATE(1505)] = 68955,
  [SMALL_STATE(1506)] = 68964,
  [SMALL_STATE(1507)] = 68975,
  [SMALL_STATE(1508)] = 68988,
  [SMALL_STATE(1509)] = 68997,
  [SMALL_STATE(1510)] = 69010,
  [SMALL_STATE(1511)] = 69019,
  [SMALL_STATE(1512)] = 69032,
  [SMALL_STATE(1513)] = 69041,
  [SMALL_STATE(1514)] = 69054,
  [SMALL_STATE(1515)] = 69067,
  [SMALL_STATE(1516)] = 69080,
  [SMALL_STATE(1517)] = 69091,
  [SMALL_STATE(1518)] = 69100,
  [SMALL_STATE(1519)] = 69113,
  [SMALL_STATE(1520)] = 69126,
  [SMALL_STATE(1521)] = 69135,
  [SMALL_STATE(1522)] = 69144,
  [SMALL_STATE(1523)] = 69153,
  [SMALL_STATE(1524)] = 69166,
  [SMALL_STATE(1525)] = 69175,
  [SMALL_STATE(1526)] = 69188,
  [SMALL_STATE(1527)] = 69201,
  [SMALL_STATE(1528)] = 69214,
  [SMALL_STATE(1529)] = 69227,
  [SMALL_STATE(1530)] = 69240,
  [SMALL_STATE(1531)] = 69251,
  [SMALL_STATE(1532)] = 69260,
  [SMALL_STATE(1533)] = 69269,
  [SMALL_STATE(1534)] = 69282,
  [SMALL_STATE(1535)] = 69295,
  [SMALL_STATE(1536)] = 69308,
  [SMALL_STATE(1537)] = 69317,
  [SMALL_STATE(1538)] = 69330,
  [SMALL_STATE(1539)] = 69343,
  [SMALL_STATE(1540)] = 69352,
  [SMALL_STATE(1541)] = 69365,
  [SMALL_STATE(1542)] = 69374,
  [SMALL_STATE(1543)] = 69385,
  [SMALL_STATE(1544)] = 69396,
  [SMALL_STATE(1545)] = 69405,
  [SMALL_STATE(1546)] = 69414,
  [SMALL_STATE(1547)] = 69423,
  [SMALL_STATE(1548)] = 69432,
  [SMALL_STATE(1549)] = 69443,
  [SMALL_STATE(1550)] = 69452,
  [SMALL_STATE(1551)] = 69461,
  [SMALL_STATE(1552)] = 69470,
  [SMALL_STATE(1553)] = 69483,
  [SMALL_STATE(1554)] = 69496,
  [SMALL_STATE(1555)] = 69505,
  [SMALL_STATE(1556)] = 69518,
  [SMALL_STATE(1557)] = 69527,
  [SMALL_STATE(1558)] = 69540,
  [SMALL_STATE(1559)] = 69553,
  [SMALL_STATE(1560)] = 69566,
  [SMALL_STATE(1561)] = 69575,
  [SMALL_STATE(1562)] = 69588,
  [SMALL_STATE(1563)] = 69601,
  [SMALL_STATE(1564)] = 69614,
  [SMALL_STATE(1565)] = 69623,
  [SMALL_STATE(1566)] = 69634,
  [SMALL_STATE(1567)] = 69647,
  [SMALL_STATE(1568)] = 69656,
  [SMALL_STATE(1569)] = 69669,
  [SMALL_STATE(1570)] = 69678,
  [SMALL_STATE(1571)] = 69689,
  [SMALL_STATE(1572)] = 69698,
  [SMALL_STATE(1573)] = 69709,
  [SMALL_STATE(1574)] = 69720,
  [SMALL_STATE(1575)] = 69729,
  [SMALL_STATE(1576)] = 69740,
  [SMALL_STATE(1577)] = 69751,
  [SMALL_STATE(1578)] = 69764,
  [SMALL_STATE(1579)] = 69777,
  [SMALL_STATE(1580)] = 69790,
  [SMALL_STATE(1581)] = 69799,
  [SMALL_STATE(1582)] = 69812,
  [SMALL_STATE(1583)] = 69825,
  [SMALL_STATE(1584)] = 69836,
  [SMALL_STATE(1585)] = 69847,
  [SMALL_STATE(1586)] = 69860,
  [SMALL_STATE(1587)] = 69873,
  [SMALL_STATE(1588)] = 69886,
  [SMALL_STATE(1589)] = 69897,
  [SMALL_STATE(1590)] = 69910,
  [SMALL_STATE(1591)] = 69923,
  [SMALL_STATE(1592)] = 69936,
  [SMALL_STATE(1593)] = 69949,
  [SMALL_STATE(1594)] = 69958,
  [SMALL_STATE(1595)] = 69969,
  [SMALL_STATE(1596)] = 69980,
  [SMALL_STATE(1597)] = 69989,
  [SMALL_STATE(1598)] = 70000,
  [SMALL_STATE(1599)] = 70011,
  [SMALL_STATE(1600)] = 70024,
  [SMALL_STATE(1601)] = 70037,
  [SMALL_STATE(1602)] = 70048,
  [SMALL_STATE(1603)] = 70059,
  [SMALL_STATE(1604)] = 70070,
  [SMALL_STATE(1605)] = 70081,
  [SMALL_STATE(1606)] = 70094,
  [SMALL_STATE(1607)] = 70105,
  [SMALL_STATE(1608)] = 70118,
  [SMALL_STATE(1609)] = 70127,
  [SMALL_STATE(1610)] = 70140,
  [SMALL_STATE(1611)] = 70151,
  [SMALL_STATE(1612)] = 70162,
  [SMALL_STATE(1613)] = 70170,
  [SMALL_STATE(1614)] = 70180,
  [SMALL_STATE(1615)] = 70190,
  [SMALL_STATE(1616)] = 70200,
  [SMALL_STATE(1617)] = 70210,
  [SMALL_STATE(1618)] = 70220,
  [SMALL_STATE(1619)] = 70230,
  [SMALL_STATE(1620)] = 70238,
  [SMALL_STATE(1621)] = 70248,
  [SMALL_STATE(1622)] = 70258,
  [SMALL_STATE(1623)] = 70268,
  [SMALL_STATE(1624)] = 70278,
  [SMALL_STATE(1625)] = 70288,
  [SMALL_STATE(1626)] = 70298,
  [SMALL_STATE(1627)] = 70308,
  [SMALL_STATE(1628)] = 70318,
  [SMALL_STATE(1629)] = 70328,
  [SMALL_STATE(1630)] = 70338,
  [SMALL_STATE(1631)] = 70348,
  [SMALL_STATE(1632)] = 70358,
  [SMALL_STATE(1633)] = 70368,
  [SMALL_STATE(1634)] = 70378,
  [SMALL_STATE(1635)] = 70388,
  [SMALL_STATE(1636)] = 70398,
  [SMALL_STATE(1637)] = 70408,
  [SMALL_STATE(1638)] = 70418,
  [SMALL_STATE(1639)] = 70428,
  [SMALL_STATE(1640)] = 70438,
  [SMALL_STATE(1641)] = 70448,
  [SMALL_STATE(1642)] = 70458,
  [SMALL_STATE(1643)] = 70468,
  [SMALL_STATE(1644)] = 70478,
  [SMALL_STATE(1645)] = 70488,
  [SMALL_STATE(1646)] = 70498,
  [SMALL_STATE(1647)] = 70508,
  [SMALL_STATE(1648)] = 70516,
  [SMALL_STATE(1649)] = 70526,
  [SMALL_STATE(1650)] = 70536,
  [SMALL_STATE(1651)] = 70546,
  [SMALL_STATE(1652)] = 70556,
  [SMALL_STATE(1653)] = 70566,
  [SMALL_STATE(1654)] = 70576,
  [SMALL_STATE(1655)] = 70586,
  [SMALL_STATE(1656)] = 70596,
  [SMALL_STATE(1657)] = 70606,
  [SMALL_STATE(1658)] = 70616,
  [SMALL_STATE(1659)] = 70626,
  [SMALL_STATE(1660)] = 70636,
  [SMALL_STATE(1661)] = 70646,
  [SMALL_STATE(1662)] = 70654,
  [SMALL_STATE(1663)] = 70662,
  [SMALL_STATE(1664)] = 70670,
  [SMALL_STATE(1665)] = 70680,
  [SMALL_STATE(1666)] = 70690,
  [SMALL_STATE(1667)] = 70700,
  [SMALL_STATE(1668)] = 70708,
  [SMALL_STATE(1669)] = 70718,
  [SMALL_STATE(1670)] = 70728,
  [SMALL_STATE(1671)] = 70738,
  [SMALL_STATE(1672)] = 70748,
  [SMALL_STATE(1673)] = 70756,
  [SMALL_STATE(1674)] = 70766,
  [SMALL_STATE(1675)] = 70776,
  [SMALL_STATE(1676)] = 70786,
  [SMALL_STATE(1677)] = 70796,
  [SMALL_STATE(1678)] = 70806,
  [SMALL_STATE(1679)] = 70816,
  [SMALL_STATE(1680)] = 70824,
  [SMALL_STATE(1681)] = 70834,
  [SMALL_STATE(1682)] = 70844,
  [SMALL_STATE(1683)] = 70852,
  [SMALL_STATE(1684)] = 70862,
  [SMALL_STATE(1685)] = 70872,
  [SMALL_STATE(1686)] = 70882,
  [SMALL_STATE(1687)] = 70892,
  [SMALL_STATE(1688)] = 70902,
  [SMALL_STATE(1689)] = 70912,
  [SMALL_STATE(1690)] = 70922,
  [SMALL_STATE(1691)] = 70932,
  [SMALL_STATE(1692)] = 70942,
  [SMALL_STATE(1693)] = 70952,
  [SMALL_STATE(1694)] = 70962,
  [SMALL_STATE(1695)] = 70972,
  [SMALL_STATE(1696)] = 70982,
  [SMALL_STATE(1697)] = 70992,
  [SMALL_STATE(1698)] = 71002,
  [SMALL_STATE(1699)] = 71012,
  [SMALL_STATE(1700)] = 71022,
  [SMALL_STATE(1701)] = 71032,
  [SMALL_STATE(1702)] = 71040,
  [SMALL_STATE(1703)] = 71050,
  [SMALL_STATE(1704)] = 71060,
  [SMALL_STATE(1705)] = 71070,
  [SMALL_STATE(1706)] = 71080,
  [SMALL_STATE(1707)] = 71090,
  [SMALL_STATE(1708)] = 71100,
  [SMALL_STATE(1709)] = 71110,
  [SMALL_STATE(1710)] = 71120,
  [SMALL_STATE(1711)] = 71130,
  [SMALL_STATE(1712)] = 71140,
  [SMALL_STATE(1713)] = 71148,
  [SMALL_STATE(1714)] = 71158,
  [SMALL_STATE(1715)] = 71168,
  [SMALL_STATE(1716)] = 71178,
  [SMALL_STATE(1717)] = 71186,
  [SMALL_STATE(1718)] = 71196,
  [SMALL_STATE(1719)] = 71206,
  [SMALL_STATE(1720)] = 71216,
  [SMALL_STATE(1721)] = 71226,
  [SMALL_STATE(1722)] = 71236,
  [SMALL_STATE(1723)] = 71246,
  [SMALL_STATE(1724)] = 71256,
  [SMALL_STATE(1725)] = 71264,
  [SMALL_STATE(1726)] = 71274,
  [SMALL_STATE(1727)] = 71284,
  [SMALL_STATE(1728)] = 71294,
  [SMALL_STATE(1729)] = 71304,
  [SMALL_STATE(1730)] = 71314,
  [SMALL_STATE(1731)] = 71324,
  [SMALL_STATE(1732)] = 71334,
  [SMALL_STATE(1733)] = 71344,
  [SMALL_STATE(1734)] = 71354,
  [SMALL_STATE(1735)] = 71364,
  [SMALL_STATE(1736)] = 71374,
  [SMALL_STATE(1737)] = 71382,
  [SMALL_STATE(1738)] = 71392,
  [SMALL_STATE(1739)] = 71400,
  [SMALL_STATE(1740)] = 71408,
  [SMALL_STATE(1741)] = 71418,
  [SMALL_STATE(1742)] = 71428,
  [SMALL_STATE(1743)] = 71438,
  [SMALL_STATE(1744)] = 71448,
  [SMALL_STATE(1745)] = 71458,
  [SMALL_STATE(1746)] = 71465,
  [SMALL_STATE(1747)] = 71472,
  [SMALL_STATE(1748)] = 71479,
  [SMALL_STATE(1749)] = 71486,
  [SMALL_STATE(1750)] = 71493,
  [SMALL_STATE(1751)] = 71500,
  [SMALL_STATE(1752)] = 71507,
  [SMALL_STATE(1753)] = 71514,
  [SMALL_STATE(1754)] = 71521,
  [SMALL_STATE(1755)] = 71528,
  [SMALL_STATE(1756)] = 71535,
  [SMALL_STATE(1757)] = 71542,
  [SMALL_STATE(1758)] = 71549,
  [SMALL_STATE(1759)] = 71556,
  [SMALL_STATE(1760)] = 71563,
  [SMALL_STATE(1761)] = 71570,
  [SMALL_STATE(1762)] = 71577,
  [SMALL_STATE(1763)] = 71584,
  [SMALL_STATE(1764)] = 71591,
  [SMALL_STATE(1765)] = 71598,
  [SMALL_STATE(1766)] = 71605,
  [SMALL_STATE(1767)] = 71612,
  [SMALL_STATE(1768)] = 71619,
  [SMALL_STATE(1769)] = 71626,
  [SMALL_STATE(1770)] = 71633,
  [SMALL_STATE(1771)] = 71640,
  [SMALL_STATE(1772)] = 71647,
  [SMALL_STATE(1773)] = 71654,
  [SMALL_STATE(1774)] = 71661,
  [SMALL_STATE(1775)] = 71668,
  [SMALL_STATE(1776)] = 71675,
  [SMALL_STATE(1777)] = 71682,
  [SMALL_STATE(1778)] = 71689,
  [SMALL_STATE(1779)] = 71696,
  [SMALL_STATE(1780)] = 71703,
  [SMALL_STATE(1781)] = 71710,
  [SMALL_STATE(1782)] = 71717,
  [SMALL_STATE(1783)] = 71724,
  [SMALL_STATE(1784)] = 71731,
  [SMALL_STATE(1785)] = 71738,
  [SMALL_STATE(1786)] = 71745,
  [SMALL_STATE(1787)] = 71752,
  [SMALL_STATE(1788)] = 71759,
  [SMALL_STATE(1789)] = 71766,
  [SMALL_STATE(1790)] = 71773,
  [SMALL_STATE(1791)] = 71780,
  [SMALL_STATE(1792)] = 71787,
  [SMALL_STATE(1793)] = 71794,
  [SMALL_STATE(1794)] = 71801,
  [SMALL_STATE(1795)] = 71808,
  [SMALL_STATE(1796)] = 71815,
  [SMALL_STATE(1797)] = 71822,
  [SMALL_STATE(1798)] = 71829,
  [SMALL_STATE(1799)] = 71836,
  [SMALL_STATE(1800)] = 71843,
  [SMALL_STATE(1801)] = 71850,
  [SMALL_STATE(1802)] = 71857,
  [SMALL_STATE(1803)] = 71864,
  [SMALL_STATE(1804)] = 71871,
  [SMALL_STATE(1805)] = 71878,
  [SMALL_STATE(1806)] = 71885,
  [SMALL_STATE(1807)] = 71892,
  [SMALL_STATE(1808)] = 71899,
  [SMALL_STATE(1809)] = 71906,
  [SMALL_STATE(1810)] = 71913,
  [SMALL_STATE(1811)] = 71920,
  [SMALL_STATE(1812)] = 71927,
  [SMALL_STATE(1813)] = 71934,
  [SMALL_STATE(1814)] = 71941,
  [SMALL_STATE(1815)] = 71948,
  [SMALL_STATE(1816)] = 71955,
  [SMALL_STATE(1817)] = 71962,
  [SMALL_STATE(1818)] = 71969,
  [SMALL_STATE(1819)] = 71976,
  [SMALL_STATE(1820)] = 71983,
  [SMALL_STATE(1821)] = 71990,
  [SMALL_STATE(1822)] = 71997,
  [SMALL_STATE(1823)] = 72004,
  [SMALL_STATE(1824)] = 72011,
  [SMALL_STATE(1825)] = 72018,
  [SMALL_STATE(1826)] = 72025,
  [SMALL_STATE(1827)] = 72032,
  [SMALL_STATE(1828)] = 72039,
  [SMALL_STATE(1829)] = 72046,
  [SMALL_STATE(1830)] = 72053,
  [SMALL_STATE(1831)] = 72060,
  [SMALL_STATE(1832)] = 72067,
  [SMALL_STATE(1833)] = 72074,
  [SMALL_STATE(1834)] = 72081,
  [SMALL_STATE(1835)] = 72088,
  [SMALL_STATE(1836)] = 72095,
  [SMALL_STATE(1837)] = 72102,
  [SMALL_STATE(1838)] = 72109,
  [SMALL_STATE(1839)] = 72116,
  [SMALL_STATE(1840)] = 72123,
  [SMALL_STATE(1841)] = 72130,
  [SMALL_STATE(1842)] = 72137,
  [SMALL_STATE(1843)] = 72144,
  [SMALL_STATE(1844)] = 72151,
  [SMALL_STATE(1845)] = 72158,
  [SMALL_STATE(1846)] = 72165,
  [SMALL_STATE(1847)] = 72172,
  [SMALL_STATE(1848)] = 72179,
  [SMALL_STATE(1849)] = 72186,
  [SMALL_STATE(1850)] = 72193,
  [SMALL_STATE(1851)] = 72200,
  [SMALL_STATE(1852)] = 72207,
  [SMALL_STATE(1853)] = 72214,
  [SMALL_STATE(1854)] = 72221,
  [SMALL_STATE(1855)] = 72228,
  [SMALL_STATE(1856)] = 72235,
  [SMALL_STATE(1857)] = 72242,
  [SMALL_STATE(1858)] = 72249,
  [SMALL_STATE(1859)] = 72256,
  [SMALL_STATE(1860)] = 72263,
  [SMALL_STATE(1861)] = 72270,
  [SMALL_STATE(1862)] = 72277,
  [SMALL_STATE(1863)] = 72284,
  [SMALL_STATE(1864)] = 72291,
  [SMALL_STATE(1865)] = 72298,
  [SMALL_STATE(1866)] = 72305,
  [SMALL_STATE(1867)] = 72312,
  [SMALL_STATE(1868)] = 72319,
  [SMALL_STATE(1869)] = 72326,
  [SMALL_STATE(1870)] = 72333,
  [SMALL_STATE(1871)] = 72340,
  [SMALL_STATE(1872)] = 72347,
  [SMALL_STATE(1873)] = 72354,
  [SMALL_STATE(1874)] = 72361,
  [SMALL_STATE(1875)] = 72368,
  [SMALL_STATE(1876)] = 72375,
  [SMALL_STATE(1877)] = 72382,
  [SMALL_STATE(1878)] = 72389,
  [SMALL_STATE(1879)] = 72396,
  [SMALL_STATE(1880)] = 72403,
  [SMALL_STATE(1881)] = 72410,
  [SMALL_STATE(1882)] = 72417,
  [SMALL_STATE(1883)] = 72424,
  [SMALL_STATE(1884)] = 72431,
  [SMALL_STATE(1885)] = 72438,
  [SMALL_STATE(1886)] = 72445,
  [SMALL_STATE(1887)] = 72452,
  [SMALL_STATE(1888)] = 72459,
  [SMALL_STATE(1889)] = 72466,
  [SMALL_STATE(1890)] = 72473,
  [SMALL_STATE(1891)] = 72480,
  [SMALL_STATE(1892)] = 72487,
  [SMALL_STATE(1893)] = 72494,
  [SMALL_STATE(1894)] = 72501,
  [SMALL_STATE(1895)] = 72508,
  [SMALL_STATE(1896)] = 72515,
  [SMALL_STATE(1897)] = 72522,
  [SMALL_STATE(1898)] = 72529,
  [SMALL_STATE(1899)] = 72536,
  [SMALL_STATE(1900)] = 72543,
  [SMALL_STATE(1901)] = 72550,
  [SMALL_STATE(1902)] = 72557,
  [SMALL_STATE(1903)] = 72564,
  [SMALL_STATE(1904)] = 72571,
  [SMALL_STATE(1905)] = 72578,
  [SMALL_STATE(1906)] = 72585,
  [SMALL_STATE(1907)] = 72592,
  [SMALL_STATE(1908)] = 72599,
  [SMALL_STATE(1909)] = 72606,
  [SMALL_STATE(1910)] = 72613,
  [SMALL_STATE(1911)] = 72620,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [81] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [83] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(281),
  [86] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1154),
  [89] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1829),
  [92] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1030),
  [95] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(219),
  [98] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1452),
  [101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1453),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1490),
  [107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(87),
  [110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1317),
  [113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(271),
  [116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1639),
  [119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(733),
  [122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(13),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1869),
  [128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1868),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(780),
  [134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(256),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1138),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1087),
  [143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1088),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1866),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(38),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(249),
  [155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(246),
  [158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(35),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(21),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(25),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1865),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(293),
  [173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(235),
  [176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(322),
  [179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1320),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(322),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1318),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1635),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1634),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 3, .production_id = 43),
  [202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 3, .production_id = 43),
  [204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 2),
  [206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_case, 2),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, .production_id = 105),
  [210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 4, .production_id = 105),
  [212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 3, .production_id = 91),
  [214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_communication_case, 3, .production_id = 91),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 3, .production_id = 7),
  [218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_case, 3, .production_id = 7),
  [220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 2),
  [222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 2),
  [224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 3),
  [226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 3),
  [228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_labeled_statement, 2, .production_id = 29),
  [230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_labeled_statement, 2, .production_id = 29),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 60),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 59),
  [286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 89),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(1791),
  [657] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1), SHIFT(746),
  [661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(1855),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(97),
  [669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1),
  [672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(801),
  [675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(1791),
  [687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(846),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 1),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 36),
  [728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 36),
  [730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 3),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 3),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 2),
  [740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 2),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 5),
  [754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 5),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 1),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 3, .production_id = 25),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 3, .production_id = 25),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector_expression, 3, .production_id = 38),
  [790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector_expression, 3, .production_id = 38),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 8, .production_id = 114),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 8, .production_id = 114),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 4),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 4),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 7, .production_id = 109),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 7, .production_id = 109),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion_expression, 5, .production_id = 93),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion_expression, 5, .production_id = 93),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 2),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 2),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 40),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 40),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 5, .dynamic_precedence = -1, .production_id = 64),
  [830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 5, .dynamic_precedence = -1, .production_id = 64),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 3),
  [834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 3),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 3),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 3),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, .production_id = 95),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, .production_id = 95),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 4),
  [846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 4),
  [848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, .production_id = 16),
  [850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, .production_id = 16),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 5),
  [856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 5),
  [858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, .production_id = 94),
  [860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, .production_id = 94),
  [862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 4, .dynamic_precedence = -1, .production_id = 64),
  [868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 4, .dynamic_precedence = -1, .production_id = 64),
  [870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, .production_id = 12),
  [876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, .production_id = 12),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 6, .production_id = 103),
  [880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 6, .production_id = 103),
  [882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, .production_id = 66),
  [884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, .production_id = 66),
  [886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 4, .production_id = 65),
  [892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 4, .production_id = 65),
  [894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 4, .production_id = 48),
  [896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 4, .production_id = 48),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(846),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 5),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, .production_id = 28),
  [971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, .production_id = 28),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 2, .production_id = 20),
  [1001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 2, .production_id = 20),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 1, .production_id = 4),
  [1023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 1, .production_id = 4),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 44),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 44),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, .production_id = 23),
  [1095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, .production_id = 23),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [1101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 47),
  [1109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 4, .production_id = 47),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receive_statement, 1, .production_id = 62),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer_statement, 2),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defer_statement, 2),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_go_statement, 2),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_go_statement, 2),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec, 2, .production_id = 57),
  [1221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec, 2, .production_id = 57),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_send_statement, 3, .production_id = 39),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_send_statement, 3, .production_id = 39),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_expression_case, 3, .production_id = 7),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [1433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_element, 1),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [1453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_default_case, 2),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(80),
  [1538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(37),
  [1541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(23),
  [1544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(32),
  [1547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(1485),
  [1550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(679),
  [1553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(1670),
  [1556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(258),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2),
  [1561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(1878),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [1630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(62),
  [1633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(33),
  [1636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(22),
  [1639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(26),
  [1642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(1462),
  [1645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(707),
  [1648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(1655),
  [1651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(181),
  [1654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_block_repeat1, 2), SHIFT_REPEAT(1851),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [1661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dynamic_class_attribute_value_repeat1, 2),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receive_statement, 3, .production_id = 37),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 4, .production_id = 87),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [1771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 2, .production_id = 33),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [1811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(aux_sym_dynamic_class_attribute_value_repeat1, 2),
  [1814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4),
  [1816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [1818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3),
  [1820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [1822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 5),
  [1824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 5),
  [1826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2),
  [1828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [1830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2),
  [1832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2),
  [1834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2), SHIFT_REPEAT(1758),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [1839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(218),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_import, 2, .production_id = 63),
  [1848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_import, 2, .production_id = 63),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [1856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_import, 4, .production_id = 112),
  [1858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_import, 4, .production_id = 112),
  [1860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2), SHIFT_REPEAT(1774),
  [1863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(807),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [1868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__component_identifier, 1, .production_id = 13),
  [1870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__component_identifier, 1, .production_id = 13),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1),
  [1878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1),
  [1880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1), SHIFT(807),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 71),
  [1893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 71),
  [1895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 71), SHIFT_REPEAT(1862),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [1900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 71),
  [1902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 71),
  [1904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 71), SHIFT_REPEAT(1855),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_import, 3, .production_id = 106),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_import, 3, .production_id = 106),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 3, .production_id = 31),
  [1919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 3, .production_id = 31),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 4),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 4),
  [1925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_if_statement, 3, .production_id = 32),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_if_statement, 3, .production_id = 32),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, .dynamic_precedence = 2),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, .dynamic_precedence = 2),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 63),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 63),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 79),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 79),
  [1943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5),
  [1945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5),
  [1947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 6),
  [1949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 6),
  [1951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, .dynamic_precedence = 2),
  [1957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, .dynamic_precedence = 2),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 5),
  [1961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 5),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_type, 5, .production_id = 83),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_type, 5, .production_id = 83),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_import, 5, .production_id = 115),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_import, 5, .production_id = 115),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_block, 3),
  [1979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_block, 3),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, .dynamic_precedence = 2),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, .dynamic_precedence = 2),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, .production_id = 35),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type, 3, .production_id = 35),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 24),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 24),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 3),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 3),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_type, 3, .production_id = 26),
  [2009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_type, 3, .production_id = 26),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_if_statement, 5, .production_id = 84),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_if_statement, 5, .production_id = 84),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [2021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_block, 2),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_block, 2),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 17),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 17),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 11),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 11),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [2035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 2, .production_id = 7),
  [2039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 2, .production_id = 7),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negated_type, 2),
  [2043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_type, 2),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 2),
  [2047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 2),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [2051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4, .production_id = 50),
  [2053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4, .production_id = 50),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 4, .production_id = 63),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 4, .production_id = 63),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_children_expression, 3),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_children_expression, 3),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 3),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 3, .production_id = 63),
  [2069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 3, .production_id = 63),
  [2071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_tag, 3, .production_id = 63),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_tag, 3, .production_id = 63),
  [2075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_import, 3, .production_id = 107),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_import, 3, .production_id = 107),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_render, 3, .production_id = 108),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_render, 3, .production_id = 108),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 3),
  [2085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 3),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_switch_statement, 4),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_statement, 4),
  [2091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_switch_statement, 4, .production_id = 7),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_statement, 4, .production_id = 7),
  [2095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 4, .production_id = 63),
  [2097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 4, .production_id = 63),
  [2099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self_closing_tag, 4, .production_id = 63),
  [2101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_closing_tag, 4, .production_id = 63),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_import, 4, .production_id = 113),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_import, 4, .production_id = 113),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_doctype, 4, .production_id = 63),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_doctype, 4, .production_id = 63),
  [2111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tag_end, 3, .production_id = 63),
  [2113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tag_end, 3, .production_id = 63),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_for_statement, 3, .production_id = 34),
  [2117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_for_statement, 3, .production_id = 34),
  [2119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_if_statement, 5, .production_id = 85),
  [2121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_if_statement, 5, .production_id = 85),
  [2123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_switch_statement, 5, .production_id = 90),
  [2125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_statement, 5, .production_id = 90),
  [2127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_switch_statement, 5, .production_id = 7),
  [2129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_statement, 5, .production_id = 7),
  [2131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 4),
  [2133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4),
  [2135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_import, 5, .production_id = 116),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_import, 5, .production_id = 116),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_switch_statement, 6, .production_id = 90),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_statement, 6, .production_id = 90),
  [2143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_switch_statement, 6, .production_id = 101),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_statement, 6, .production_id = 101),
  [2147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 6, .production_id = 63),
  [2149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 6, .production_id = 63),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 6, .production_id = 63),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 6, .production_id = 63),
  [2155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_import, 6, .production_id = 118),
  [2157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_import, 6, .production_id = 118),
  [2159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_if_statement, 7, .production_id = 104),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_if_statement, 7, .production_id = 104),
  [2163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_switch_statement, 7, .production_id = 101),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_statement, 7, .production_id = 101),
  [2167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 7, .production_id = 63),
  [2169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 7, .production_id = 63),
  [2171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 7, .production_id = 63),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 7, .production_id = 63),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 8, .production_id = 63),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 8, .production_id = 63),
  [2179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_element, 8, .production_id = 63),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_element, 8, .production_id = 63),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 1),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 1),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_style_element, 3, .production_id = 63),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_style_element, 3, .production_id = 63),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_switch_statement, 3),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_statement, 3),
  [2195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 3),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 3),
  [2199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(846),
  [2202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element, 2),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element, 2),
  [2206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_for_statement, 2, .production_id = 9),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_for_statement, 2, .production_id = 9),
  [2210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 2),
  [2212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 2),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 53),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 53),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tag_start, 3, .production_id = 63),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tag_start, 3, .production_id = 63),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tag_start, 4, .production_id = 63),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tag_start, 4, .production_id = 63),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 5),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 5),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, .production_id = 22),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, .production_id = 22),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [2240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tag_start_repeat1, 2), SHIFT_REPEAT(273),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tag_start_repeat1, 2),
  [2245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tag_start_repeat1, 2), SHIFT_REPEAT(34),
  [2248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tag_start_repeat1, 2), SHIFT_REPEAT(1209),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [2267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1), SHIFT(846),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 43),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 43),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [2278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [2316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(758),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [2325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2),
  [2327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(268),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 2, .production_id = 21),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 2, .production_id = 21),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [2336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1), SHIFT(758),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, .production_id = 42),
  [2341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, .production_id = 42),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [2345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 81),
  [2347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 81),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 55),
  [2353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 55),
  [2355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [2363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [2365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 1),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [2369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [2371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 1),
  [2373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 84),
  [2375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 84),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [2379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 75),
  [2381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 75),
  [2383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(19),
  [2386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(19),
  [2389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [2391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 32),
  [2393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 32),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 3, .production_id = 52),
  [2401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_spec, 3, .production_id = 52),
  [2403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 3, .production_id = 51),
  [2405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 3, .production_id = 51),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [2415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 45),
  [2417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 45),
  [2419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 2, .production_id = 27),
  [2421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_spec, 2, .production_id = 27),
  [2423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 72),
  [2425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 72),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [2431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 1),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [2463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallthrough_statement, 1),
  [2465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallthrough_statement, 1),
  [2467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [2469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statement, 1),
  [2473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statement, 1),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 2),
  [2479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 2),
  [2481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 2),
  [2483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 2),
  [2485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 104),
  [2487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 104),
  [2489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 2),
  [2491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 2),
  [2493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 7, .production_id = 101),
  [2495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 7, .production_id = 101),
  [2497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, .production_id = 8),
  [2499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, .production_id = 8),
  [2501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, .production_id = 8),
  [2503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, .production_id = 8),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2, .production_id = 8),
  [2507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2, .production_id = 8),
  [2509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 2, .production_id = 9),
  [2515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 2, .production_id = 9),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inc_statement, 2),
  [2535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inc_statement, 2),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [2539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dec_statement, 2),
  [2541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dec_statement, 2),
  [2543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_switch_statement_repeat1, 2),
  [2545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_switch_statement_repeat1, 2), SHIFT_REPEAT(120),
  [2548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_switch_statement_repeat1, 2), SHIFT_REPEAT(1816),
  [2551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 3),
  [2553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 3),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 3),
  [2557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 3),
  [2559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 3),
  [2561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 3),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_elem, 1),
  [2575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_elem, 1),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [2579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, .production_id = 34),
  [2581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, .production_id = 34),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 3),
  [2585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 3),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 101),
  [2595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 101),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [2599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 3),
  [2601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 3),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 29),
  [2607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 29),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, .production_id = 36),
  [2611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, .production_id = 36),
  [2613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_var_declaration, 3, .production_id = 37),
  [2615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_var_declaration, 3, .production_id = 37),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 90),
  [2619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 90),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [2623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 4),
  [2625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 4),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 3, .production_id = 41),
  [2629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 3, .production_id = 41),
  [2631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 4),
  [2633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 4),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, .production_id = 41),
  [2639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, .production_id = 41),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 4),
  [2643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 4),
  [2645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(172),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [2654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_attribute_if_statement, 3, .production_id = 32),
  [2656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_attribute_if_statement, 3, .production_id = 32),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 5, .production_id = 96),
  [2662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 5, .production_id = 96),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 5, .production_id = 96),
  [2672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 5, .production_id = 96),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_term, 2),
  [2678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_term, 2),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [2692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 7),
  [2694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 7),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [2698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 1, .production_id = 4),
  [2700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, .production_id = 4),
  [2702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_elem, 2),
  [2704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_elem, 2),
  [2706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4),
  [2708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4),
  [2710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2),
  [2712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2), SHIFT_REPEAT(129),
  [2715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2), SHIFT_REPEAT(1784),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [2720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 4, .production_id = 61),
  [2722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 4, .production_id = 61),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4, .production_id = 7),
  [2728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4, .production_id = 7),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [2734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 4),
  [2736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 4),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2),
  [2742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2), SHIFT_REPEAT(59),
  [2745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2), SHIFT_REPEAT(1784),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [2750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2),
  [2752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2), SHIFT_REPEAT(770),
  [2755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2), SHIFT_REPEAT(1784),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [2766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 5, .production_id = 61),
  [2768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 5, .production_id = 61),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 90),
  [2774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 90),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [2780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 85),
  [2782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 85),
  [2784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_elem_repeat1, 2),
  [2786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_elem_repeat1, 2),
  [2788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_elem_repeat1, 2), SHIFT_REPEAT(1271),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [2793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_attribute_if_statement, 5, .production_id = 84),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_attribute_if_statement, 5, .production_id = 84),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, .production_id = 67),
  [2801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, .production_id = 67),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, .production_id = 68),
  [2805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, .production_id = 68),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, .production_id = 67),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, .production_id = 67),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, .production_id = 68),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, .production_id = 68),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [2817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_attribute_block, 3),
  [2819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_attribute_block, 3),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [2823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_attribute_block, 4),
  [2825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_attribute_block, 4),
  [2827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_conditional_attribute_block_repeat1, 2), SHIFT_REPEAT(236),
  [2830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_conditional_attribute_block_repeat1, 2),
  [2832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_conditional_attribute_block_repeat1, 2), SHIFT_REPEAT(1354),
  [2835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(670),
  [2838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(670),
  [2841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [2843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_attribute_if_statement, 7, .production_id = 104),
  [2845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_attribute_if_statement, 7, .production_id = 104),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec, 3, .production_id = 82),
  [2849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec, 3, .production_id = 82),
  [2851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_repeat1, 2), SHIFT_REPEAT(548),
  [2854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_type_repeat1, 2), SHIFT_REPEAT(548),
  [2857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interface_type_repeat1, 2),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [2865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_attribute_if_statement, 5, .production_id = 85),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_attribute_if_statement, 5, .production_id = 85),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [2873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [2879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [2881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1078),
  [2884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1078),
  [2887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [2893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_term, 1),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_term, 1),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [2917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_spread_attributes, 4, .production_id = 63),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_attributes, 4, .production_id = 63),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, .production_id = 41),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 41),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_attribute_value, 2),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_attribute_value, 2),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [2939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_class_attribute_value, 3),
  [2941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_class_attribute_value, 3),
  [2943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_attribute_value, 3),
  [2945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_attribute_value, 3),
  [2947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_class_attribute_value, 4),
  [2949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_class_attribute_value, 4),
  [2951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_class_attribute_value, 5),
  [2953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_class_attribute_value, 5),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [2967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [2969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2), SHIFT_REPEAT(645),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [2984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [2998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [3000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interface_body, 1, .production_id = 30),
  [3002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interface_body, 1, .production_id = 30),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [3008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [3040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [3046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [3048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [3052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [3054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [3060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_style_element_repeat1, 2),
  [3062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_style_element_repeat1, 2), SHIFT_REPEAT(1353),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 78),
  [3085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 78),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [3105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_clause, 2, .production_id = 2),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_clause, 2, .production_id = 2),
  [3109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [3111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [3113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 2),
  [3115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 2),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, .production_id = 18),
  [3135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, .production_id = 18),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 2),
  [3139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 2),
  [3141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, .production_id = 19),
  [3143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, .production_id = 19),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [3159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 22),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2),
  [3195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2), SHIFT_REPEAT(1360),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [3200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 3),
  [3202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 3),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2), SHIFT_REPEAT(435),
  [3217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2),
  [3219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2), SHIFT_REPEAT(578),
  [3222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_block, 3),
  [3226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_block, 3),
  [3228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__css_block_repeat1, 2),
  [3230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__css_block_repeat1, 2), SHIFT_REPEAT(1885),
  [3233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__css_block, 3),
  [3235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__css_block, 3),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 46),
  [3247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 46),
  [3249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 54),
  [3251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 54),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [3257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 56),
  [3259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 56),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 21),
  [3281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 63),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 63),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_css_declaration, 4, .production_id = 63),
  [3289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_css_declaration, 4, .production_id = 63),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_declaration, 4, .production_id = 63),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_declaration, 4, .production_id = 63),
  [3297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 4),
  [3299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 4),
  [3301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 99),
  [3303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 99),
  [3305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, .production_id = 70),
  [3309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 98),
  [3311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 98),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 97),
  [3315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 97),
  [3317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 73),
  [3319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 73),
  [3321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 74),
  [3323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 74),
  [3325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 76),
  [3327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 76),
  [3329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 77),
  [3331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 77),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_type_repeat1, 2),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [3351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 5),
  [3353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 5),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [3357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [3365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(722),
  [3368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 92),
  [3370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 92),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_block, 2),
  [3374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_block, 2),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 80),
  [3380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 80),
  [3382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__css_block, 2),
  [3384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__css_block, 2),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [3396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(126),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [3401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [3403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [3405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [3411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2), SHIFT_REPEAT(57),
  [3414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [3422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [3424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [3426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [3428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(267),
  [3431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [3435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 3),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [3445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 5, .production_id = 105),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [3455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 4, .production_id = 91),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_expression_case, 4, .production_id = 7),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [3471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dynamic_class_attribute_value_repeat1, 2), SHIFT_REPEAT(203),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [3478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 4),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [3490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2), SHIFT_REPEAT(704),
  [3493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [3503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(581),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 3, .production_id = 69),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [3520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, .production_id = 43),
  [3522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(208),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 4, .production_id = 7),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, .production_id = 43),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_switch_default_case, 3),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [3637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_length_array_type, 4, .production_id = 49),
  [3639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [3641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [3651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [3653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [3655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot, 1),
  [3659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyed_element, 3),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [3693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [3703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [3705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_argument, 2),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [3719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_css_property, 4, .production_id = 41),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, .production_id = 111),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [3813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 86),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [3823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__css_identifier, 1, .production_id = 14),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__script_identifier, 1, .production_id = 15),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [3859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5, .production_id = 100),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [3865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, .production_id = 110),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [3907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 9, .production_id = 117),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [3945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 88),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [3965] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [4005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 58),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [4029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 5, .production_id = 102),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_css_property_value = 0,
  ts_external_token_element_text = 1,
  ts_external_token_element_comment = 2,
  ts_external_token_style_element_text = 3,
  ts_external_token_script_block_text = 4,
  ts_external_token_script_element_text = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_css_property_value] = sym_css_property_value,
  [ts_external_token_element_text] = sym_element_text,
  [ts_external_token_element_comment] = sym_element_comment,
  [ts_external_token_style_element_text] = sym_style_element_text,
  [ts_external_token_script_block_text] = sym_script_block_text,
  [ts_external_token_script_element_text] = sym_script_element_text,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_css_property_value] = true,
    [ts_external_token_element_text] = true,
    [ts_external_token_element_comment] = true,
    [ts_external_token_style_element_text] = true,
    [ts_external_token_script_block_text] = true,
    [ts_external_token_script_element_text] = true,
  },
  [2] = {
    [ts_external_token_element_text] = true,
    [ts_external_token_element_comment] = true,
  },
  [3] = {
    [ts_external_token_css_property_value] = true,
  },
  [4] = {
    [ts_external_token_style_element_text] = true,
  },
  [5] = {
    [ts_external_token_script_element_text] = true,
  },
  [6] = {
    [ts_external_token_script_block_text] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_templ_external_scanner_create(void);
void tree_sitter_templ_external_scanner_destroy(void *);
bool tree_sitter_templ_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_templ_external_scanner_serialize(void *, char *);
void tree_sitter_templ_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_templ(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_templ_external_scanner_create,
      tree_sitter_templ_external_scanner_destroy,
      tree_sitter_templ_external_scanner_scan,
      tree_sitter_templ_external_scanner_serialize,
      tree_sitter_templ_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
